<?php

if (! defined ( 'BASEPATH' ))
	exit ( 'No direct script access allowed' );
/**
 * CodeIgniter
 *
 * An open source application development framework for PHP 5.1.6 or newer
 *
 * @package CodeIgniter
 * @author EllisLab Dev Team
 * @copyright Copyright (c) 2008 - 2014, EllisLab, Inc.
 * @copyright Copyright (c) 2014 - 2015, British Columbia Institute of Technology (http://bcit.ca/)
 * @license http://codeigniter.com/user_guide/license.html
 * @link http://codeigniter.com
 * @since Version 1.0
 * @filesource
 *
 */
	
// ------------------------------------------------------------------------

/**
 * SQLSRV Utility Class
 *
 * @category Database
 * @author EllisLab Dev Team
 * @link http://codeigniter.com/user_guide/database/
 */
class CI_DB_sqlsrv_utility extends CI_DB_utility {
	
	/**
	 * List databases
	 *
	 * @access private
	 * @return bool
	 */
	function _list_databases() {
		return "EXEC sp_helpdb"; // Can also be: EXEC sp_databases
	}
	
	// --------------------------------------------------------------------
	
	/**
	 * Optimize table query
	 *
	 * Generates a platform-specific query so that a table can be optimized
	 *
	 * @access private
	 * @param
	 *        	string the table name
	 * @return object
	 */
	function _optimize_table($table) {
		return FALSE; // Is this supported in MS SQL?
	}
	
	// --------------------------------------------------------------------
	
	/**
	 * Repair table query
	 *
	 * Generates a platform-specific query so that a table can be repaired
	 *
	 * @access private
	 * @param
	 *        	string the table name
	 * @return object
	 */
	function _repair_table($table) {
		return FALSE; // Is this supported in MS SQL?
	}
	
	// --------------------------------------------------------------------
	
	/**
	 * MSSQL Export
	 *
	 * @access private
	 * @param
	 *        	array Preferences
	 * @return mixed
	 */
	function _backup($params = array()) {
		// Currently unsupported
		return $this->db->display_error ( 'db_unsuported_feature' );
	}
}

/* End of file mssql_utility.php */
/* Location: ./system/database/drivers/mssql/mssql_utility.php */