<?php
class Admin extends CI_Controller {
	public function __construct() {
		parent::__construct ();
		
		$this->load->helper ( 'url' );
		$this->load->library ( 'grocery_CRUD' );
	}
	public function _master_output($output = null) {
		$this->load->view ( 'adminMaster', $output );
	}
	public function cases() {
		$user = $this->session->userdata ( 'user' );
		
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'cases' )->set_subject ( 'Cases' );
			// $crud->set_relation('created_by','user','Email_Address');
			
			// $crud->set_relation('relation','relation_master','name');
			$crud->set_relation ( 'specialization', 'doctor_specialization_master', 'name' );
			
			$crud->field_type ( 'patient_gender', 'dropdown', array (
					'1' => 'Male',
					'2' => 'Female' 
			) );
			
			$crud->field_type ( 'terms', 'true_false' );
			$crud->display_as ( 'terms', 'Terms & Conditions and Privacy Policy' );
			
			$crud->fields ( 'relation', 'patient_country', 'patient_first_name', 'patient_last_name', 'patient_gender', 'patient_birth_date', 'patient_contact_number', 'patient_email', 'subject', 'medical_query', 'promo_code', 'specialization', 'terms', 'created_by' );
			$crud->field_type ( 'created_by', 'invisible' );
			
			$crud->callback_before_insert ( array (
					$this,
					'before_create_case' 
			) );
			
			$crud->callback_after_insert ( array (
					$this,
					'after_create_case' 
			) );
			
			$crud->callback_after_update ( array (
					$this,
					'after_update_case' 
			) );
			
			$crud->unset_delete ();
			
			$crud->columns ( 'patient_first_name', 'patient_last_name', 'patient_contact_number', 'patient_email', 'subject', 'relation' );
			
			$crud->add_action ( 'Documents', '', '', 'ui-icon-image', array (
					$this,
					'case_document_action' 
			) );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	function before_create_case($post_array) {
		$post_array ['created_by'] = $this->session->userdata ( 'user' )->User_Id;
		return $post_array;
	}
	function after_create_case($post_array, $primary_key) {
		// send message to user
		$this->load->library ( 'email', $config );
		$this->email->set_newline ( "\r\n" );
		
		$this->email->to ( $post_array ['patient_email'] );
		
		$title = "GrandOpinion case created: #" . $primary_key;
		$this->email->subject ( $title );
		
		$message = "This is a <b>secure message</b>. <br/>Please login to your grandopinion account to see the message details.";
		$message .= "<br/>Case created with case id: " . $primary_key;
		
		$this->email->message ( $message );
		$this->email->send ();
		
		return true;
	}
	function after_update_case($post_array, $primary_key) {
		// send message to user or doc
		$this->load->library ( 'email', $config );
		$this->email->set_newline ( "\r\n" );
		
		$this->email->to ( $post_array ['patient_email'] );
		
		$title = "GrandOpinion case updated: #" . $primary_key;
		$this->email->subject ( $title );
		
		$message = "This is a <b>secure message</b>. <br/>Please login to your grandopinion account to see the message details.";
		$message .= "<br/>Case #" . $primary_key . " has been updated by " . $this->session->userdata ( 'user_name' );
		
		$this->email->message ( $message );
		$this->email->send ();
		return true;
	}
	function case_document_action($primary_key, $row) {
		return site_url ( 'master/documents' ) . '?case=' . $primary_key;
	}
	public function relations() {
		$user = $this->session->userdata ( 'user' );
		
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'relation_master' )->set_subject ( 'Relations' );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	public function specializations() {
		$user = $this->session->userdata ( 'user' );
		
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'doctor_specialization_master' )->set_subject ( 'Specialization' );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	public function queries() {
		$user = $this->session->userdata ( 'user' );
		
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'query' )->set_subject ( 'Query' );
			$crud->set_relation ( 'case_id', 'cases', 'subject' );
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	public function opportunities() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != SALES && $this->session->userdata ( 'user_type' ) != ADMINUSER)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'opportunities' )->set_subject ( 'Opportunity' );
			$crud->set_relation ( 'created_by', 'user', 'Email_Address' );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	public function documents() {
		$user = $this->session->userdata ( 'user' );
		
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'document' )->set_subject ( 'Documents' );
			$crud->set_field_upload ( 'document_detail', 'documents/uploads' );
			
			$crud->display_as ( 'document_title', 'Title' );
			$crud->display_as ( 'document_detail', 'Document' );
			$crud->field_type ( 'created_by', 'invisible' );
			$crud->field_type ( 'created_on', 'invisible' );
			
			$crud->columns ( 'document_title', 'document_detail', 'created_on' );
			
			$crud->callback_before_insert ( array (
					$this,
					'before_create_document' 
			) );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	function before_create_document($post_array) {
		$post_array ['created_by'] = $this->session->userdata ( 'user' )->User_Id;
		$post_array ['created_on'] = date ( DATETIMEFORMAT );
		return $post_array;
	}
	public function messages() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'messages' )->set_subject ( 'Messages' );
			
			$crud->set_relation ( 'to', 'user', 'email' );
			
			$crud->set_relation ( 'from', 'user', 'email' );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	public function reports() {
		$user = $this->session->userdata ( 'user' );
		
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'report' )->set_subject ( 'Reports' );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	public function users() {
		$user = $this->session->userdata ( 'user' );
		
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'flexigrid' );
			
			$crud->set_table ( 'user' )->set_subject ( 'Users' );
			
			$this->session->set_userdata ( 'activeMenu', "usermgt" );
			
			$crud->columns ( 'First_name', 'Last_Name', 'email', 'Mobile_Number', 'User_Type', 'Creator' );
			
			$crud->display_as('First_name','First Name');
			$crud->display_as('Last_Name','Last Name');
			$crud->display_as('email','Email');
			$crud->display_as('Mobile_Number','Mobile');
			$crud->display_as('User_Type',' User Type');
			
			$crud->set_rules ( 'First_name', 'First Name', 'trim|required|xss_clean' );
			$crud->set_rules ( 'Last_Name', 'Last Name', 'trim|required|xss_clean' );
			$crud->set_rules ( 'Birth_Date', 'Birth Date', 'trim|required|xss_clean' );
			$crud->set_rules ( 'Mobile_Number', 'Mobile Number', 'trim|required|xss_clean|numeric' );
			$crud->set_rules ( 'email', 'Email', 'trim|required|xss_clean|valid_email' );
			$crud->set_rules ( 'Country', 'Country', 'trim|required|xss_clean' );
			$crud->set_rules ( 'Password', 'Password', 'trim|required|xss_clean' );
			
			if ($user->User_Type == ADMIN) {
				$FinalArray = array (
						'0' => 'Customer',
						'1' => 'Admin',
						'2' => 'Sales',
						'3' => 'Partner',
						'4' => 'Doctors',
						'5' => 'Customer Care',
						'6' => 'Corporate Admin' 
				);
			} else {
				$FinalArray = array (
						'0' => 'Customer',
						'2' => 'Sales',
						'3' => 'Partner',
						'4' => 'Doctors',
						'5' => 'Customer Care',
						'6' => 'Corporate Admin' 
				);
			}
			
			$crud->field_type ( 'User_Type', 'dropdown', $FinalArray );
			
			$crud->field_type ( 'Gender', 'dropdown', array (
					"Male" => "Male",
					"Female" => "Female" 
			) );
			
			$state_info = $crud->getStateInfo ();
			$crud->field_type ( 'Created_By', 'invisible' );
			//$crud->set_relation ( 'Created_By', 'user', '{First_name} {Last_Name}' );
			$crud->order_by ( 'User_Id', 'desc' );
			
			$crud->callback_before_insert ( array (
					$this,
					'before_create_encrypt_password' 
			) );
			
			$crud->callback_after_update ( array (
					$this,
					'after_update_insert_doctor' 
			) );
			// $crud->field_type('Password', 'invisible');
			
			$output = $crud->render ();
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	function before_create_encrypt_password($post_array) {
		$this->load->helper ( 'security' );
		$PasswordHash = do_hash ( $post_array ['Password'], 'md5' );
		$post_array ['Password'] = $PasswordHash;
		return $post_array;
	}
	function after_update_insert_doctor($post_array, $primary_key) {
		$this->load->model ( 'DoctorMaster' );
		
		if ($post_array ['User_Type'] == DOCTORS) {
			$Result = $this->DoctorMaster->addDoctorByAdmin ( $post_array, $primary_key );
			
			if ($Result > 0) {
				// Send Email To Doctor
				$TodayDate = date ( DATETIMEFORMAT );
				$Body = array (
						'Name' => $post_array ["First_name"] . ' ' . $post_array ["Last_Name"],
						'Doctor_Id' => $Result1,
						'Email' => $post_array ["email"],
						'Password' => '(Use Ur Same Password)',
						'TimeStamp'=>  date ( DATEFORMAT, strtotime ( $TodayDate ) )
				);
				
				$this->load->helper ( 'secureemail' );
				$CC = '';
				$EmailAddresTo = $this->input->post ( 'email' );
				$EmailAddressFrom = INFOEMAIL;
				$SubjectEmail = 'Welcome to GrandOpinion';
				$EmailNotification = array (
						'To' => $EmailAddresTo,
						'FROM' => $EmailAddressFrom,
						'CC' => $CC,
						'Subject' => $SubjectEmail,
						'Body' => $Body,
						'Type' => 'Email_NewDoctor',
						'Attach' => '' 
				);
				$ResultEmail = send_secured_email ( $EmailNotification );
			}
		}
		return true;
	}
	public function hospitalAdmission() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'hospital_admission' )->set_subject ( 'Hospital Admission Records' );
			
			$crud->fields ( 'Admit_Date', 'Reason', 'Patient_Id', 'User_id', 'Created_By' );
			$crud->field_type ( 'Created_By', 'invisible' );
			$crud->field_type ( 'User_id', 'invisible' );
			
			$crud->callback_before_insert ( array (
					$this,
					'before_create_hospitalAdmission' 
			) );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	function before_create_hospitalAdmission($post_array) {
		$post_array ['Created_By'] = $this->session->userdata ( 'user' )->User_Id;
		$post_array ['User_id'] = $this->session->userdata ( 'user' )->User_Id;
		return $post_array;
	}
	public function FamilyMedicHistory() {
		$user = $this->session->userdata ( 'user' );
		
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'family_medical_history' )->set_subject ( 'Family Medical History' );
			
			// $crud->field_type('illness','multiselect',
			// array("Epilepsy" => "Epilepsy","Asthma" => "Asthma","Hypertension" => "Hypertension","Migraine" => "Migraine"));
			
			// $crud->field_type('Allergies','multiselect',
			// array("Fish" => "Fish","Soy" => "Soy","Eggs" => "Eggs","Peanuts" => "Peanuts","Milk" => "Milk"));
			
			// $crud->fields('Member_Id', 'illness', 'Allergies', 'User_Id','Created_By');
			$crud->field_type ( 'Created_By', 'invisible' );
			
			$crud->callback_before_insert ( array (
					$this,
					'before_create_FamilyMedicHistory' 
			) );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	function before_create_FamilyMedicHistory($post_array) {
		$post_array ['Created_By'] = $this->session->userdata ( 'user' )->User_Id;
		return $post_array;
	}
	public function PaymentDetails() {
		$user = $this->session->userdata ( 'user' );
		
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'payment_details' )->set_subject ( 'Payment Details' );
			
			$crud->field_type ( 'PaymentMode', 'dropdown', array (
					'Credit Card' => 'Credit Card',
					'Debit Card' => 'Debit Card',
					'Internet Banking' => 'Internet Banking' 
			) );
			
			$crud->fields ( 'LastName', 'PromoCode', 'Currency', 'PaymentMode', 'CardNumber', 'CardName', 'ExpiryDate', 'CVC', 'Created_By' );
			$crud->field_type ( 'Created_By', 'invisible' );
			
			$crud->callback_before_insert ( array (
					$this,
					'before_create_PaymentDetails' 
			) );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	function before_create_PaymentDetails($post_array) {
		$post_array ['Created_By'] = $this->session->userdata ( 'user' )->User_Id;
		return $post_array;
	}
	public function PromoCodeDetails() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'promocodes' )->set_subject ( 'Promo-Codes' );
			
			$crud->fields ( 'Product_Id', 'PromoCode', 'Price', 'PromoCode_Status' );
			$crud->field_type ( 'PromoCode_Status', 'invisible' );
			
			$crud->callback_before_insert ( array (
					$this,
					'before_create_PromoCode' 
			) );
			
			$output = $crud->render ();
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	function before_create_PromoCode($post_array) {
		$post_array ['PromoCode_Status'] = true;
		return $post_array;
	}
	public function PatientDetails() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'patients' )->set_subject ( 'Patients Records' );
			
			$crud->field_type ( 'Gender', 'dropdown', array (
					"M" => "Male",
					"F" => "Female",
					"Other" => "Other" 
			) );
			
			$crud->field_type ( 'Relation', 'dropdown', array (
					"Self" => "Self",
					"Spouse" => "Spouse",
					"Son" => "Son",
					"Daughter" => "Daughter",
					"Father" => "Father",
					"Mother" => "Mother" 
			) );
			
			$crud->fields ( 'FName', 'LName', 'Phone', 'Email', 'DOB', 'Gender', 'Relation', 'Created_By' );
			$crud->field_type ( 'Created_By', 'invisible' );
			
			$crud->callback_before_insert ( array (
					$this,
					'before_create_PatientDetails' 
			) );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	function before_create_PatientDetails($post_array) {
		$post_array ['Created_By'] = $this->session->userdata ( 'user' )->User_Id;
		return $post_array;
	}
	public function DoctorDetails() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'doctors' )->set_subject ( 'Doctor Records' );
			
			$crud->field_type ( 'Speciality', 'multiselect', array (
					"1" => "Neurology",
					"2" => "Cardiologist",
					"3" => "Surgeon" 
			) );
			
			$crud->fields ( 'DName', 'Qualification', 'Speciality', 'DImagePath', 'Created_By' );
			$crud->field_type ( 'Created_By', 'invisible' );
			
			$crud->callback_before_insert ( array (
					$this,
					'before_create_DoctorDetails' 
			) );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	function before_create_DoctorDetails($post_array) {
		$post_array ['Created_By'] = $this->session->userdata ( 'user' )->User_Id;
		return $post_array;
	}
	public function MedicalCondition() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'condition_medical_history' )->set_subject ( 'Medical Conditions' );
			
			$crud->set_rules ( 'ConditionName', 'Condition Name', 'trim|required|xss_clean' );
			$crud->set_rules ( 'ConditionType', 'Condition Type', 'trim|required|xss_clean' );
			$crud->required_fields('ConditionName','ConditionType');
			
			
			$crud->field_type ( 'ConditionType', 'dropdown', array (
					1 => "Family" ,
					2 => "Personal",
					0 => "Both" 
			) );
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	public function AlergyHistroy() {
		$user = $this->session->userdata ( 'user' );
		
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'alergy_history' )->set_subject ( 'Alergies History' );
			
			$crud->field_type ( 'Created_By', 'invisible' );
			$crud->callback_before_insert ( array (
					$this,
					'before_create_AlergyHistroy' 
			) );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	function before_create_AlergyHistroy($post_array) {
		$post_array ['Created_By'] = $this->session->userdata ( 'user' )->User_Id;
		return $post_array;
	}
	public function Alergies() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'alergies' )->set_subject ( 'Alergies' );
			
			$crud->set_rules ( 'AlegryType', 'Alegry Type', 'trim|required|xss_clean' );
			$crud->set_rules ( 'AlergyName', 'Alergy Name', 'trim|required|xss_clean' );
			$crud->required_fields('AlegryType','AlergyName');
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	public function GoEmpDetails() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'goemployeesmaster' )->set_subject ( 'GO Employees' );
			
			$crud->field_type ( 'Gender', 'dropdown', array (
					"Male" => "Male",
					"Female" => "Female",
					"Other" => "Other" 
			) );
			
			$crud->field_type ( 'Country', 'dropdown', array (
					"India" => "India",
					"US" => "US",
					"UK" => "UK" 
			) );
			
			$crud->fields ( 'FName', 'LName', 'Address', 'City', 'Country', 'Gender', 'DOB', 'Designation', 'Phone', 'Email', 'Created_By' );
			$crud->field_type ( 'Created_By', 'invisible' );
			$crud->callback_before_insert ( array (
					$this,
					'before_create_goEmp' 
			) );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	function before_create_goEmp($post_array) {
		$post_array ['Created_By'] = $this->session->userdata ( 'user' )->User_Id;
		return $post_array;
	}
	public function PartnerDetails() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER && $this->session->userdata ( 'user_type' ) != SALES)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'partners' )->set_subject ( 'GO Partners' );
			
			$crud->fields ( 'PartnerName', 'Phone', 'Email', 'KeyPerson1', 'KeyPerson1_Phone', 'KeyPerson1_Email', 'KeyPerson1_Designation', 'KeyPerson2', 'KeyPerson2_Phone', 'KeyPerson2_Email', 'KeyPerson2_Designation', 'Created_By' );
			$crud->field_type ( 'Created_By', 'invisible' );
			
			$crud->set_rules ( 'PartnerName', 'Partner Name', 'trim|required|xss_clean' );
			$crud->set_rules ( 'Phone', 'Phone', 'trim|required|xss_clean|max_length[20]' );
			$crud->set_rules ( 'Email', 'Email', 'trim|required|xss_clean|valid_email' );
			$crud->set_rules ( 'KeyPerson1', 'Primary Contact Name', 'trim|required|xss_clean' );
			$crud->set_rules ( 'KeyPerson1_Phone', 'Primary Contact Phone', 'trim|required|xss_clean|max_length[20]' );
			
			$crud->set_rules ( 'KeyPerson1_Email', 'Primary Contact Email', 'trim|xss_clean|valid_email' );
			
			$crud->set_rules ( 'KeyPerson2', 'Secondary Contact Name', 'trim|xss_clean' );
			$crud->set_rules ( 'KeyPerson2_Phone', 'Secondary Contact Phone', 'trim|xss_clean|max_length[20]' );
			$crud->set_rules ( 'KeyPerson2_Email', 'Secondary Contact Email', 'trim|xss_clean|valid_email' );
			
			$crud->required_fields('PartnerName','Phone','Email','KeyPerson1','KeyPerson1_Phone');
			
			$crud->columns ( 'PartnerName', 'Phone', 'Email', 'KeyPerson1', 'KeyPerson1_Phone' );
				
			$crud->display_as('PartnerName','Partner Name');
			
			$crud->display_as('KeyPerson1','Primary Contact Name');
			$crud->display_as('KeyPerson1_Phone','Primary Contact Phone');
			$crud->display_as('KeyPerson1_Email','Primary Contact Email');
			$crud->display_as('KeyPerson1_Designation','Primary Contact Designation');
			
			$crud->display_as('KeyPerson2','Secondary Contact Name');
			$crud->display_as('KeyPerson2_Phone','Secondary Contact Phone');
			$crud->display_as('KeyPerson2_Email','Secondary Contact Email');
			$crud->display_as('KeyPerson2_Designation','Secondary Contact Designation');
			
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER)
				$crud->where ( 'Created_By = ' . $this->session->userdata ( 'user' )->User_Id );
			
			$crud->callback_before_insert ( array (
					$this,
					'before_create_partner' 
			) );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	function before_create_partner($post_array) {
		$post_array ['Created_By'] = $this->session->userdata ( 'user' )->User_Id;
		return $post_array;
	}
	public function LadiesMedicalHistory() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'ladies_medical_history' )->set_subject ( 'Ladies Medical History' );
			
			$crud->field_type ( 'Created_By', 'invisible' );
			$crud->callback_before_insert ( array (
					$this,
					'before_create_LadiesMedicalHistory' 
			) );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	function before_create_LadiesMedicalHistory($post_array) {
		$post_array ['Created_By'] = $this->session->userdata ( 'user' )->User_Id;
		return $post_array;
	}
	public function LadiesMedicCondition() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'ladies_medical_condition' )->set_subject ( 'Medical Condition for Ladies' );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	public function NotificationDetails() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'notification' )->set_subject ( 'User Notification' );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	public function PlanFeatureDetails() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'plan_features' )->set_subject ( 'Plan Features' );
			
			$crud->display_as('Plan_Id','Plan Name');
			$crud->display_as('Disc_Dollar','Discount  Dollar Amount');
			$crud->display_as('Disc_Rupee','Discount  Rupees Amount');
			
			
			$crud->set_rules ( 'Plan_Id', 'Plan Name', 'trim|required|xss_clean' );
			$crud->set_rules ( 'Service', 'Service', 'trim|required|xss_clean' );
			$crud->set_rules ( 'Amount_Dollar', 'Amount Dollar Price', 'trim|required|xss_clean|numeric' );
			$crud->set_rules ( 'Amount_Rupee', 'Amount Rupee Price', 'trim|required|xss_clean|numeric' );
			$crud->set_rules ( 'Disc_Dollar', 'Discount Dollar Price', 'trim|xss_clean|numeric' );
			$crud->set_rules ( 'Disc_Rupee', 'Discount Rupee Price', 'trim|xss_clean|numeric' );
			
			$crud->required_fields('Plan_Id','Service','Amount_Dollar','Amount_Rupee');
			
			$crud->set_relation ( 'Plan_Id', 'plan', 'Plan_Name' );
			$crud->columns ( 'Plan_Id', 'Service', 'Amount_Dollar', 'Amount_Rupee' ,'Promocode');
			
			$crud->field_type ( 'Created_By', 'invisible' );
			$crud->field_type ( 'Company', 'invisible' );
			$crud->callback_before_insert ( array (
					$this,
					'before_create_PlanFeatureDetails' 
			) );
			
			$crud->field_type ( 'Service', 'dropdown', array (
					"1" => "Opinion",
					"2" => "Tele-Consult" 
			) );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	function before_create_PlanFeatureDetails($post_array) {
		$post_array ['Created_By'] = $this->session->userdata ( 'user' )->User_Id;
		return $post_array;
	}
	public function PlanDetails() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'plan' )->set_subject ( 'GO Plans' );
			
			$crud->columns ( 'Plan_Name', 'Plan_Price_Dollar', 'Plan_Price_Rupee', 'Plan_Type' );
			

			$crud->display_as('Plan_Name','Plan Name');
			$crud->display_as('Plan_Price_Dollar','Amount Dollar');
			$crud->display_as('Plan_Price_Rupee','Amount Rupees');
			$crud->display_as('Plan_Type','Type (General/Corporate ID)');
			
			
			$crud->set_rules ( 'Plan_Name', 'Plan Name', 'trim|required|xss_clean' );
			$crud->set_rules ( 'Plan_Price_Dollar', 'Dollar Price', 'trim|required|xss_clean|numeric' );
			$crud->set_rules ( 'Plan_Price_Rupee', 'Rupee Price', 'trim|required|xss_clean|numeric' );
			$crud->set_rules ( 'Plan_Type', 'Type', 'trim|required|xss_clean' );
			
			$crud->required_fields('Plan_Name','Plan_Price_Dollar','Plan_Price_Rupee','Plan_Type');
			
			// $crud->columns('Plan_Name','Service','Amount_Dollar','Amount_Rupee');
			$crud->field_type ( 'Created_By', 'invisible' );
			$crud->callback_before_insert ( array (
					$this,
					'before_create_PlanDetails' 
			) );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	function before_create_PlanDetails($post_array) {
		$post_array ['Created_By'] = $this->session->userdata ( 'user' )->User_Id;
		return $post_array;
	}
	public function CasesComments() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN ) //&& $this->session->userdata ( 'user_type' ) != ADMINUSER
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'case_comments' )->set_subject ( 'Doctor Comments for Cases' );
			
			$crud->columns ( 'Case_Id', 'Doctor_Id', 'Comment', 'Recommendation' ,'TimeStamp');
				
			$crud->set_relation ( 'Doctor_Id', 'doctors', 'DName' );
			
			$crud->display_as('Case_Id','CaseID');
			$crud->display_as('Doctor_Id','Doctor Name');
			$crud->display_as('Comment','Opinion');
			$crud->display_as('TimeStamp','Date');
				
				
			$crud->set_rules ( 'Case_Id', 'Case Id', 'trim|required|xss_clean' );
			$crud->set_rules ( 'Doctor_Id', 'Doctor Name', 'trim|required|xss_clean' );
			$crud->set_rules ( 'Comment', 'Opinion', 'trim|required|xss_clean' );
			
				
			$crud->required_fields('Case_Id','Doctor_Id','Comment');
			
			$crud->field_type ( 'TimeStamp', 'invisible' );
			$crud->callback_before_insert ( array (
					$this,
					'before_create_CasesComments'
			) );
				
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	
	function before_create_CasesComments($post_array) {
		$TodayDate = date ( DATEFORMAT );
		$post_array ['TimeStamp'] = $TodayDate;
		return $post_array;
	}
	
	
	public function QuestionAnswers() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'followup_case_questions' )->set_subject ( 'Case Q&A' );
			
			$crud->fields ( 'Question', 'QByUserId', 'QByUserType', 'Case_Id', 'Answer', 'AByUserId', 'AByUserType' );
			
			$crud->field_type ( 'QByUserType', 'dropdown', array (
					'0' => 'Customer',
					'1' => 'Admin',
					'2' => 'Sales',
					'3' => 'Partner',
					'4' => 'Doctors' 
			) );
			
			$crud->field_type ( 'AByUserType', 'dropdown', array (
					'0' => 'Customer',
					'1' => 'Admin',
					'2' => 'Sales',
					'3' => 'Partner',
					'4' => 'Doctors' 
			) );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	public function DoctorBankDetails() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER && $this->session->userdata ( 'user_type' ) != DOCTORS)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'doctor_payment_info' )->set_subject ( 'Doctor Bank Details' );
			
			$crud->fields ( 'Account_Number', 'IFSC', 'MICR', 'Bank_Name', 'Doctor_Id' );
			
			if ($this->session->userdata ( 'user_type' ) != ADMIN) {
				$crud->where ( 'Doctor_Id = ' . $this->session->userdata ( 'Doctor_Id' ) );
			}
			// $crud->field_type('Doctor_Id', 'invisible');
			// $crud->callback_before_insert(array($this, 'before_create_DoctorBankDetails'));
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	function before_create_DoctorBankDetails($post_array) {
		$post_array ['Doctor_Id'] = $this->session->userdata ( 'Doctor_Id' );
		return $post_array;
	}
	public function DoctorPayoutHistory() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != DOCTORS && $this->session->userdata ( 'user_type' ) != ADMINUSER)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'doctor_payment_history' )->set_subject ( 'Doctor Payment History' );
			
			$crud->fields ( 'Case_Id', 'Doctor_Id', 'Amount', 'TimeStamp' );
			
			$crud->field_type ( 'TimeStamp', 'invisible' );
			$crud->callback_before_insert ( array (
					$this,
					'before_create_DoctorPayoutHistory' 
			) );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	function before_create_DoctorPayoutHistory($post_array) {
		$post_array ['TimeStamp'] = date ( DATETIMEFORMAT );
		return $post_array;
	}
	public function CorporateDetails() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER && $this->session->userdata ( 'user_type' ) != CORPADMIN)
				redirect ( 'home/', 'location' );
			
			$this->session->set_userdata ( 'activeMenu', "planmgt" );
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'corporate_details' )->set_subject ( 'Corporate Details' );
			
			$crud->fields ( 'Company_Name', 'Plan_Id', 'Address', 'Phone' );
			
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER) {
				$crud->where ( 'corporate_details.User_Id = ' . $user->User_Id );
			}
			
			$crud->set_relation ( 'Plan_Id', 'plan', 'Plan_Name' ); //,array('Plan_Type' => $user->Corp_Code)
			
			$crud->callback_before_insert ( array (
					$this,
					'before_create_CorporateDetails' 
			) );
			
			$crud->callback_after_insert ( array (
					$this,
					'after_create_CorporateDetails' 
			) );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	function before_create_CorporateDetails($post_array) {
		$post_array ['User_Id'] = $this->session->userdata ( 'user' )->User_Id;
		return $post_array;
	}
	function after_create_CorporateDetails($post_array, $primary_key) {
		$UniqueId = 'CorpId' . $primary_key;
		$post_array ["Corp_Unique_Id"] = $UniqueId;
		
		$this->db->update ( 'corporate_details', $post_array, array (
				'Corp_Id' => $primary_key 
		) );
		
		return true;
	}
	public function CorporateEmployees() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != CORPADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'corporate_employees' )->set_subject ( 'Employees' );
			
			$this->session->set_userdata ( 'activeMenu', "empmgt" );
			
			if ($user->User_Type != ADMIN && $user->User_Type != ADMINUSER) {
				$FilterUser = array (
						'user.created_by' => $user->User_Id 
				);
				$FilterCorp = array (
						'corporate_details.User_Id' => $user->User_Id 
				);
			} else {
				$FilterUser = NULL;
				$FilterCorp = NULL;
			}
			
			$crud->set_relation ( 'User_Id', 'user', '{First_name} {Last_Name}', $FilterUser );
			$crud->set_relation ( 'Corp_Id', 'corporate_details', 'Company_Name', $FilterCorp );
			
			$crud->fields ( 'Corp_Id', 'Designation', 'User_Id', 'Created_By' );
			
			$crud->field_type ( 'Created_By', 'invisible' );
			$crud->callback_before_insert ( array (
					$this,
					'before_create_CorporateEmployees' 
			) );
			
			if ($user->User_Type != ADMIN && $user->User_Type != ADMINUSER) {
				$crud->where ( 'corporate_employees.Created_By = ' . $user->User_Id );
			}
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	function before_create_CorporateEmployees($post_array) {
		$post_array ['Created_By'] = $this->session->userdata ( 'user' )->User_Id;
		return $post_array;
	}
	public function LeadManagement() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			$this->session->set_userdata ( 'activeMenu', "leadmgt" );
			
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != SALES && $this->session->userdata ( 'user_type' ) != ADMINUSER && $this->session->userdata ( 'user_type' ) != PARTNERS)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'leads' )->set_subject ( 'Lead' );
			
			$crud->fields ( 'query', 'FName', 'LName', 'Email', 'Phone', 'created_By', 'created' );
			
			$crud->field_type ( 'created_By', 'invisible' );
			$crud->field_type ( 'created', 'invisible' );
			
			$crud->columns ( 'FName', 'LName', 'Email', 'Phone', 'created' );
			
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER) {
				$crud->where ( 'created_By = ' . $this->session->userdata ( 'user' )->User_Id );
			}
			
			$crud->callback_before_insert ( array (
					$this,
					'before_create_LeadManagement' 
			) );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	function before_create_LeadManagement($post_array) {
		$UserId = $this->session->userdata ( 'user' )->User_Id;
		$post_array ['created_By'] = $UserId;
		$TodayDate = date ( DATEFORMAT );
		$post_array ['created'] = $TodayDate;
		return $post_array;
	}
	public function ActivityLog() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != SALES && $this->session->userdata ( 'user_type' ) != ADMINUSER)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'activity_log' )->set_subject ( 'Activity' );
			
			$this->session->set_userdata ( 'activeMenu', "actlog" );
			
			$crud->fields ( 'Reference_Id', 'Message', 'Created_By', 'TimeStamp' );
			
			$crud->columns ( 'Reference_Id', 'Message', 'TimeStamp');
			
			$crud->field_type ( 'Created_By', 'invisible' );
			
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER) {
				$crud->where ( 'Created_By = ' . $this->session->userdata ( 'user' )->User_Id );
			}
			
			$crud->callback_before_insert ( array (
					$this,
					'before_create_ActivityLog' 
			) );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			$this->load->view ( 'login' );
		}
	}
	function before_create_ActivityLog($post_array) {
		$post_array ['Created_By'] = $this->session->userdata ( 'user' )->User_Id;
		return $post_array;
	}
}
?>