<?php
class Master extends CI_Controller {
	public function __construct() {
		parent::__construct ();
		
		$this->load->helper ( 'url' );
		$this->load->library ( 'grocery_CRUD' );
	}
	public function _master_output($output = null) {
		session_start ();
		$this->load->view ( 'master', $output );
	}
	public function cases() {
		$crud = new grocery_CRUD ();
		$crud->set_theme ( 'rest' );
		
		$crud->set_table ( 'case_detail' )->set_subject ( 'Cases' );
		$crud->set_relation ( 'created_by', 'user', 'User_Id' );
		
		$output = $crud->render ();
		
		echo $output->output;
	}
	public function documents() {
		$crud = new grocery_CRUD ();
		$crud->set_theme ( 'rest' );
		
		$crud->set_table ( 'document' )->set_subject ( 'Documents' );
		$crud->set_relation ( 'case_id', 'case_detail', 'case_id' );
		$crud->set_field_upload ( 'document_detail', 'documents/uploads' );
		
		$output = $crud->render ();
		
		$this->_master_output ( $output );
	}
	public function reports() {
		$crud = new grocery_CRUD ();
		$crud->set_theme ( 'rest' );
		
		$crud->set_table ( 'report' )->set_subject ( 'Reports' );
		
		$output = $crud->render ();
		
		$this->_master_output ( $output );
	}
	public function users() {
		$crud = new grocery_CRUD ();
		$crud->set_theme ( 'rest' );
		
		$crud->set_table ( 'user' )->set_subject ( 'Users' );
		
		$output = $crud->render ();
		$this->_master_output ( $output );
	}
}
?>