<?php
class Cases extends CI_Controller {
	public function index($offset = NULL) {
		 
		$user = $this->session->userdata ( 'user' );
		
		if ($user != null) {
			$this->session->set_userdata ( 'activeMenu', "case" );
			$this->load->model ( 'CaseMaster' );
			$this->load->model ( 'PatientMaster' );
			$casesArray = array ();
			
			$searchdata = $this->input->get ( 'searchtext', TRUE );
			
			// If Searched Then else normal code
			if ($searchdata != FALSE && $searchdata != '' && $searchdata != NULL) {
				$casesArray = $this->Search ( $searchdata );
			} else {
				if ($this->session->userdata ( 'user_type' ) == ADMIN || $this->session->userdata ( 'user_type' ) == ADMINUSER)
				 {
					$patientRecords = $this->PatientMaster->getAllPatients ();
				}
				 else if ($this->session->userdata ( 'user_type' ) == CORPADMIN) 
				 {
					$CorporateDetails = $this->CaseMaster->getCorpDetailsById ( $this->session->userdata ( 'user' )->User_Id );
					if ($CorporateDetails != NULL) 
					{
						$PatientList = $this->CaseMaster->getCasesPatientsByCorporateCode ( $CorporateDetails->Corp_Unique_Id );
						if ($PatientList != NULL) 
						{
							$CorpEmppatientRecords = $this->PatientMaster->getCorpPatientsByIds ( $PatientList );
						}
						$CorpUserPatientsRecords = $this->CaseMaster->getPatientsByUser ( $this->session->userdata ( 'user' )->User_Id );
						 $patientRecords=$CorpEmppatientRecords; //array_merge($CorpUserPatientsRecords,$CorpEmppatientRecords);
						//$patientRecords =  $CorpUserPatientsRecords + $CorpEmppatientRecords; 
					}
				} 
				else
				 {
					$patientRecords = $this->CaseMaster->getPatientsByUser ( $this->session->userdata ( 'user' )->User_Id );
				}
				
				// User Other than Admin and CC
				if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER) {
					$patientRecords = $this->getUserSpecificCase ( $patientRecords );
				}
				
				foreach ( $patientRecords as $patient ) 
				{
					$CaseList = $this->CaseMaster->getCasesByPatientId ( $patient->Patient_Id );
					
					foreach ($CaseList as $CaseDetail)
					{
						if ($CaseDetail != NULL) {
							// Add Amount And Date Tool Tip
							$Case_Amount = "";
							$Payment_Date = "";
						
							if ($CaseDetail->is_paid == 1) {
								$PaymentDetails = $this->getAmtDateOfPaidCase ( $CaseDetail->id );
								$Case_Amount = $PaymentDetails ["Amount"];
								$Payment_Date = $PaymentDetails ["PDate"];
							}
						
							if ($CaseDetail->status == 4) {
								$Status = $this->ToMarkCloseCase ( $CaseDetail );
							} else {
								$Status = $CaseDetail->status;
							}
						
							$casesArray [] = array (
									'patient_first_name' => $patient->FName,
									'patient_last_name' => $patient->LName,
									'patient_contact_number' => $patient->Phone,
									'id' => $CaseDetail->id,
									'type' => $CaseDetail->type,
									'Case_Date' => date ( DATEFORMAT, strtotime ( $CaseDetail->Case_Date ) ),
									'status' => $Status,
									'plan' => $CaseDetail->plan,
									'is_paid' => $CaseDetail->is_paid,
									'Case_Amount' => $Case_Amount,
									'Paid_Date' => $Payment_Date
							);
						}
					}
					
				}
			}
			
			// Get Payment Message
			$MessageDetails = $this->session->flashdata ( 'TransMsgSuccess' );
			
			if ($MessageDetails == NUll) {
				$UpdtMsg = array (
						'CaseId' => '',
						'Message' => '',
						'ErrorBit' => '' 
				);
			} else {
				$UpdtMsg = array (
						'CaseId' => $MessageDetails ['CaseId'],
						'Message' => $MessageDetails ['Message'],
						'ErrorBit' => $MessageDetails ['ErrorBit'] 
				);
			}
			
			$data ['CaseMessage'] = $UpdtMsg;
			$data ['cases'] = $casesArray;
			$this->load->view ( 'caselist', $data );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	private function ToMarkCloseCase($CaseDetail) {
		$TodayDate = date ( DATEFORMAT );
		
		if ($CaseDetail->Case_Expiry == $TodayDate) {
			// marks status
			$this->load->model ( 'CaseMaster' );
			$ResultUpdateStatus = $this->CaseMaster->UpdateCaseCloseStatus ( $CaseDetail->id );
			return $Status = 5;
		} else {
			return $Status = $CaseDetail->status;
		}
	}
	private function Search($SearchText) {
		$this->load->model ( 'CaseMaster' );
		$this->load->model ( 'PatientMaster' );
		$this->load->model ( 'DoctorMaster' );
		// Search in Case
		$UserId = $this->session->userdata ( 'user' )->User_Id;
		
		if ($this->session->userdata ( 'user_type' ) == ADMIN || $this->session->userdata ( 'user_type' ) == ADMINUSER) {
			$CasesResult = $this->CaseMaster->getCasesSearchAll ( $SearchText );
			$PatientResult = $this->PatientMaster->getPatientsSearchAll ( $SearchText );
		} else {
			$CasesResult = $this->CaseMaster->getCasesSearchByUser ( $SearchText, $this->session->userdata ( 'user' )->User_Id );
			$PatientResult = $this->PatientMaster->getPatientsSearchByUser ( $SearchText, $this->session->userdata ( 'user' )->User_Id );
		}
		
		// Loop for Cases Records
		$CasesArray = array ();
		foreach ( $CasesResult as $SingleCase ) {
			$patientDetail = $this->PatientMaster->getPatientById ( $SingleCase->Patient_Id );
			if ($patientDetail != NULL) {
				$Case_Amount = "";
				$Payment_Date = "";
				
				if ($SingleCase->is_paid == 1) {
					$PaymentDetails = $this->getAmtDateOfPaidCase ( $SingleCase->id );
					$Case_Amount = $PaymentDetails ["Amount"];
					$Payment_Date = $PaymentDetails ["PDate"];
				}
				
				$CasesArray [] = array (
						'patient_first_name' => $patientDetail->FName,
						'patient_last_name' => $patientDetail->LName,
						'patient_contact_number' => $patientDetail->Phone,
						'id' => $SingleCase->id,
						'type' => $SingleCase->type,
						'Case_Date' => date ( DATEFORMAT, strtotime ( $SingleCase->Case_Date ) ),
						'status' => $SingleCase->status,
						'plan' => $SingleCase->plan,
						'is_paid' => $SingleCase->is_paid,
						'Case_Amount' => $Case_Amount,
						'Paid_Date' => $Payment_Date 
				);
			}
		}
		
		// Loop from Patient Table
		$PatientCasesArray = array ();
		foreach ( $PatientResult as $Patient ) {
			//$CaseDetail = $this->CaseMaster->getCasesDetailByPatientId ( $Patient->Patient_Id );
			if ($CaseDetail != NULL) {
				// Add Amount And Date Tool Tip
				$Case_Amount = "";
				$Payment_Date = "";
				
				if ($CaseDetail->is_paid == 1) {
					$PaymentDetails = $this->getAmtDateOfPaidCase ( $CaseDetail->id );
					$Case_Amount = $PaymentDetails ["Amount"];
					$Payment_Date = $PaymentDetails ["PDate"];
				}
				
				$PatientCasesArray [] = array (
						'patient_first_name' => $Patient->FName,
						'patient_last_name' => $Patient->LName,
						'patient_contact_number' => $Patient->Phone,
						'id' => $CaseDetail->id,
						'type' => $CaseDetail->type,
						'Case_Date' => date ( DATEFORMAT, strtotime ( $CaseDetail->Case_Date ) ),
						'status' => $CaseDetail->status,
						'plan' => $CaseDetail->plan,
						'is_paid' => $CaseDetail->is_paid,
						'Case_Amount' => $Case_Amount,
						'Paid_Date' => $Payment_Date 
				);
			}
		}
		
		// Search in Dcotors
		$DoctorsCasesArray = array ();
		
		if ($this->session->userdata ( 'user_type' ) == DOCTORS) {
			$DoctorResult = $this->DoctorMaster->getDoctorsByUserId ( $UserId );
		} else {
			$DoctorResult = $this->DoctorMaster->getDoctorsSearchByUser ( $SearchText );
		}
		
		foreach ( $DoctorResult as $doctor ) {
			if ($this->session->userdata ( 'user_type' ) == ADMIN || $this->session->userdata ( 'user_type' ) == ADMINUSER || $this->session->userdata ( 'user_type' ) == DOCTORS) {
				$DoctorsCases = $this->CaseMaster->getCasesByDoctorId ( $doctor->Doctor_Id );
			} else {
				$DoctorsCases = $this->CaseMaster->getCasesByDoctorByUserId ( $doctor->Doctor_Id, $UserId );
			}
			
			foreach ( $DoctorsCases as $sinlgeCase ) {
				$patientDetail = $this->PatientMaster->getPatientById ( $sinlgeCase->Patient_Id );
				if ($patientDetail != NULL) {
					// Add Amount And Date Tool Tip
					$Case_Amount = "";
					$Payment_Date = "";
					
					if ($sinlgeCase->is_paid == 1) {
						$PaymentDetails = $this->getAmtDateOfPaidCase ( $sinlgeCase->id );
						$Case_Amount = $PaymentDetails ["Amount"];
						$Payment_Date = $PaymentDetails ["PDate"];
					}
					
					$DoctorsCasesArray [] = array (
							'patient_first_name' => $patientDetail->FName,
							'patient_last_name' => $patientDetail->LName,
							'patient_contact_number' => $patientDetail->Phone,
							'id' => $sinlgeCase->id,
							'type' => $sinlgeCase->type,
							'Case_Date' => date ( DATEFORMAT, strtotime ( $sinlgeCase->Case_Date ) ),
							'status' => $sinlgeCase->status,
							'plan' => $sinlgeCase->plan,
							'is_paid' => $sinlgeCase->is_paid,
							'Case_Amount' => $Case_Amount,
							'Paid_Date' => $Payment_Date 
					);
				}
			}
		}
		
		$Allrecords = $CasesArray + $PatientCasesArray + $DoctorsCasesArray;
		
		return $Allrecords;
	}
	
	// To Get Date and Amount Of Paid Case
	private function getAmtDateOfPaidCase($caseId) 
	{
		$this->load->model ( 'PaymentMaster' );
		$PaymentDetails = $this->PaymentMaster->getPaymentByCase ( $caseId );
		
		if ($PaymentDetails != NULL && $PaymentDetails != '') {
			$PaymentsArray = array (
					'Amount' => $PaymentDetails->Currency.'-'.$PaymentDetails->Amount,  //$PaymentDetails->Currency.'-'.
					'PDate' => date ( DATEFORMAT, strtotime ( $PaymentDetails->TimeStamp ) ) 
			);
		} else {
			$PaymentsArray = array (
					'Amount' => '',
					'PDate' => '' 
			);
		}
		
		return $PaymentsArray;
	}
	
	// Get UserSpecific Records if created by any other user for Him
	private function getUserSpecificCase($patientRecords) {
		$this->load->model ( 'PatientMaster' );
		$UserEmail = $this->session->userdata ( 'user' )->email;
		$PatientNewRecords = $this->PatientMaster->getPatientByEmail ( $UserEmail );
		
		if ($PatientNewRecords != NULL) 
		{
			// Merge two Record
			//$patientRecords=array_merge($PatientNewRecords,$patientRecords);
			//$patientRecords =  $PatientNewRecords + $patientRecords ;
			
			foreach($PatientNewRecords as $SinglePatient)
			{
				$RecordBit=true;
				
				foreach($patientRecords as $MainRecord)
				{
					if($MainRecord->Patient_Id  == $SinglePatient->Patient_Id)
					{
						$RecordBit=false;
						break;
					}
				}
				
				if($RecordBit)
				{
					array_push ( $patientRecords, $SinglePatient );
				}
			}
		}
		
		return $patientRecords;
	}
	public function detail($id) {
		 
		$user = $this->session->userdata ( 'user' );
		
		if ($user != null) {
			$this->load->model ( 'CaseMaster' );
			$this->load->model ( 'NoteMaster' );
			$this->load->model ( 'PatientMaster' );
			$this->load->model ( 'DoctorMaster' );
			$this->session->set_userdata ( 'activeMenu', "case" );
			
			$CaseDetail = $this->CaseMaster->getCasesById ( $id );
			$patientDetails = $this->PatientMaster->getPatientById ( $CaseDetail->Patient_Id );
			
			$UserId = $this->session->userdata ( 'user_id' );
			$UserType = $this->session->userdata ( 'user_type' );
			$CurrentUserEmail = strtolower($this->session->userdata ( 'user' )->email);
			$UserAccess = FALSE;
			$OwnwerAccess=FALSE;
			
			if ($CurrentUserEmail == strtolower($patientDetails->Email)) {
				$UserAccess = TRUE;
			}
			
			$CorporatePromocode = '';
			if ($UserType == CORPADMIN) {
				$CorporateDetails = $this->CaseMaster->getCorpDetailsById ( $this->session->userdata ( 'user' )->User_Id );
				$CorporatePromocode = $CorporateDetails->Corp_Unique_Id;
			}
			
			if ($CaseDetail->created_by == $UserId || $UserType == ADMIN || $UserType == ADMINUSER || $UserType == DOCTORS || ($CorporatePromocode == $CaseDetail->Corp_Code && $CorporatePromocode != NULL && $CorporatePromocode != '') || $UserAccess == TRUE) {
				$this->session->set_userdata ( 'case', $CaseDetail );
				
				//Set owner of Case
				if ($CaseDetail->created_by == $UserId || $UserType == ADMIN || $UserType == ADMINUSER || $UserType == DOCTORS ||  $UserAccess == TRUE) 
				{
					$OwnwerAccess=TRUE;
				}
				
				$relation = $this->CaseMaster->getRelationsById ( $patientDetails->Relation );
				
				$doctorName = '';
				$doctorId = '';
				$doctorUserId = '';
				
				if ($CaseDetail->Doctor_Id != NULL && $CaseDetail->Doctor_Id != '' && $CaseDetail->Doctor_Id > 0) {
					$doctor = $this->DoctorMaster->getDoctorById ( $CaseDetail->Doctor_Id );
					
					$doctorId = $doctor->Doctor_Id;
					$doctorName = $doctor->DName;
					$doctorUserId = $doctor->User_Id;
				}
				
				// Doctor Differentiate His case
				$DifferentiateCase = FALSE; // To Show The Payment Button
				If ($UserType == DOCTORS) {
					if ($CaseDetail->created_by != $UserId) {
						$DifferentiateCase = TRUE; // To Hide the Payment Button
					}
				}
				
				// TO Get Case Amount
				$CaseAmount = '';
				$CaseAmountDetails = $this->getAmtDateOfPaidCase ( $id );
				if ($CaseAmountDetails != NULL && $CaseAmountDetails != '') {
					$CaseAmount = $CaseAmountDetails ["Amount"];
				}
				
				// To get Plan Details
				$PlanName = 'NA';
				if ($CaseDetail->plan != NUll && $CaseDetail->plan != '' && $CaseDetail->plan > 0) {
					$this->load->model ( 'UserMaster' );
					$PlanDetails = $this->UserMaster->getPlanName ( $CaseDetail->plan );
					$PlanName = $PlanDetails->Plan_Name;
				}
				
				$RelationName='';
				if($relation!= NULL)
				{
					if($relation->name != NULL)
					{
						$RelationName=$relation->name;
					}
				}
					
				
				$case = array (
						'patient_first_name' => $patientDetails->FName,
						'patient_last_name' => $patientDetails->LName,
						'Patient_Id' => $CaseDetail->Patient_Id,
						'patient_contact_number' => $patientDetails->Phone,
						'relation' => $RelationName,
						'patient_gender' => $patientDetails->Gender,
						'patient_birth_date' => (strtotime ( $patientDetails->DOB )?(strtotime ( $patientDetails->DOB )?date ( DATEFORMAT, strtotime ( $patientDetails->DOB ) ):""):""),
						'patient_email' => $patientDetails->Email,
						'patient_country' => $patientDetails->Country,
						'id' => $CaseDetail->id,
						'medical_query' => $CaseDetail->medical_query,
						'type' => $CaseDetail->type,
						'Case_Date' => date ( DATEFORMAT, strtotime ( $CaseDetail->Case_Date ) ),
						'status' => $CaseDetail->status,
						'plan' => $CaseDetail->plan,
						'is_paid' => $CaseDetail->is_paid,
						'UserType' => $UserType,
						'Doctor_Id' => $doctorId,
						'DName' => $doctorName,
						'Case_Owner' => $DifferentiateCase,
						'Amount' => $CaseAmount,
						'OwnerAccess'=> $OwnwerAccess
				)
				;
				
				// To Pull List Of Documents
				$CaseDocuments = $this->CaseMaster->getCaseDocuments ( $id );
				$PHREnable = FALSE;
				$DocumentList = NUll;
				
				if ($CaseDocuments != NULL && $CaseDocuments != '') {
					$DocIdList = array ();
					$CaseDocumentCreator='';
					
					foreach ( $CaseDocuments as $SingleDoc ) {
						
						array_push ( $DocIdList, $SingleDoc ["Document_Id"] );
						
						$CaseDocumentCreator=$SingleDoc ["Created_By"];
						if ($PHREnable != TRUE) {
							if ($SingleDoc ["Patient_Id"] != NULL && $SingleDoc ["Patient_Id"] != '' && $SingleDoc ["Patient_Id"] > 0) {
								$PHREnable = TRUE;
							}
						}
					}
					
					// Gettin Documents from Doc table
					$DocumentList = $this->CaseMaster->getCaseDocumentsDeatils ( $CaseDocumentCreator, $DocIdList );
				}
				
				$data ["DocumentList"] = $DocumentList;
				$data ["PHRStatus"] = $PHREnable;
				
				if ($CaseDetail->status >= 3 || $UserType == ADMIN || $UserType == ADMINUSER) {
					$comments = $this->DoctorMaster->getAllCommentsOnCase ( $id );
					
					$CommentsArray = array ();
					if ($comments != NULL && $comments != '') {
						foreach ( $comments as $com ) {
							$DocDetails = $this->DoctorMaster->getDoctorById ( $com ["Doctor_Id"] );
							
							if ($DocDetails != NULL) {
								$CommentsArray [] = array (
										'Comment' => $com ["Comment"],
										'Recommendation' => $com ["Recommendation"],
										'Doctor_Id' => $com ["Doctor_Id"],
										'DocName' => $DocDetails->DName 
								)
								;
							}
						}
					}
					
					$data ['Casecomments'] = $CommentsArray;
				}
				$data ['case'] = $case;
				$data ['PlanName'] = $PlanName;
				
				// Send the Message
				$Message = array (
						'Patient_Id' => $CaseDetail->Patient_Id,
						'User_Id' => $CaseDetail->created_by,
						'CaseId' => $CaseDetail->id,
						'Doctor_Id' => $doctorId,
						'Doc_UserId' => $doctorUserId 
				);
				
				$this->session->set_flashdata ( 'Msg', $Message );
				
				// Get Case Update Message
				$MessageDetails = $this->session->flashdata ( 'CaseUpdateMsg' );
				
				if ($MessageDetails == NUll) {
					$UpdtMsg = array (
							'CaseId' => '',
							'Message' => '',
							'ErrorBit' => '' 
					);
				} else {
					$UpdtMsg = array (
							'CaseId' => $MessageDetails ['CaseId'],
							'Message' => $MessageDetails ['Message'],
							'ErrorBit' => $MessageDetails ['ErrorBit'] 
					);
				}
				
				
				$data ['notes'] = $this->NoteMaster->getNotesByCase ( $id );
				$data ['CaseMessage'] = $UpdtMsg;
				$this->load->view ( 'casedetail', $data );
				// print_r($case);
			} else {
				$this->load->view ( 'accessdenied' );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function add() {
		redirect ( 'cases/queryadd', 'location' );
	}
	public function queryadd() {
		 
		$user = $this->session->userdata ( 'user' );
		
		if ($user != null) {
			if($user->User_Type == CUSTOMER)
			{
				$this->session->set_userdata ( 'activeMenu', "request" );
			}
			else 
			{
				$this->session->set_userdata ( 'activeMenu', "case");
			}
			$this->load->helper ( 'form' );
			$this->load->library ( 'form_validation' );
				$this->load->model ( 'CaseMaster' );
			$this->load->model ( 'DoctorMaster' );
			$data ['Specializations'] = $this->DoctorMaster->getAllSpecialities ();
			$data ["Type"] = '';			
				
				$UserPatientId='';				

				
				
				$data ['Relations'] = $this->CaseMaster->getRelations ();
				
				$CorpUsers=NULL;
				$PatientArray = array ();
				$PatientArrayCheck=array();
				
				if ($user->User_Type== ADMIN || $user->User_Type== ADMINUSER)
				{
					$PatientList = $this->CaseMaster->getAllPatients();					
					$UserList = $this->CaseMaster->getExistingUsers();		
				}
				else 
				{
					$PatientList = $this->CaseMaster->getPatientsByUser ( $user->User_Id );
				}

				
				$Count = 0;
				if ($PatientList != NULL && $PatientList != '') {
					foreach ( $PatientList as $SingPatient ) 
					{
						if($SingPatient->Relation == 1 )
						{
							$UserPatientId=$SingPatient->Patient_Id;
						}
						
						$PatientArray [] = array (
								'DropdownId' => $Count,
								'FName' => $SingPatient->FName,
								'LName' => $SingPatient->LName,
								'Phone' => $SingPatient->Phone,
								'Email' => $SingPatient->Email,
								'DOB' => date ( DATEFORMAT, strtotime ( $SingPatient->DOB ) ),
								'Gender' => $SingPatient->Gender,
								'Relation' => $SingPatient->Relation,
								'Country' => $SingPatient->Country ,
								'Patient_Id' =>$SingPatient->Patient_Id,
								'Created_By' =>$SingPatient->Created_By
						
						);
						
						$Count ++;
					}
				} else {
					$PatientArray = NULL;
				}
				
				if ($user->User_Type== ADMIN || $user->User_Type== ADMINUSER)
				{
					 $FinalArray = $this->FilterExistingUserArray($UserList, $PatientArray);
				}
				else 
				{
					$FinalArray = $PatientArray;
				}
				
				
				$ActiveStyle = array (
						'ActiveCase' => 'active case',
						'ActivePatient' => 'user',
						'HideQuery' => 'style="display: none; transform: scale(0.8); opacity: 0;"',
						'ShowQuery' => 'style="display: block; transform: scale(1); opacity: 1;"',
						'HidePatient' => 'style="display: none; left: 50%; opacity: 0;"',
						'ShowPatient' => 'style="display: block; left: 0%; opacity: 1;"',
						'Medic' => true 
				);
				
				$UserDOB = date ( DATEFORMAT, strtotime ( $user->Birth_Date ) );
				$UserDetails = array (
						'UserId' => $user->User_Id,
						'First_name' => $user->First_name,
						'Last_Name' => $user->Last_Name,
						'Gender' => $user->Gender,
						'Birth_Date' => $UserDOB,
						'email' => $user->email,
						'Mobile_Number' => $user->Mobile_Number,
						'Country' => $user->Country,
						'Patient_Id' => $UserPatientId,
						'UserType' => $user->User_Type
				);
				
				$data ['Style'] = $ActiveStyle;
				$data ['Patients'] = $FinalArray;
				$data ['UserDetails'] = $UserDetails;
				$data ['CaseDetails'] = $CaseQueryDetails;
				
				// $data['Specializations']=$this->DoctorMaster->getAllSpecialities();
				// print_r($PatientArray);
				if($user->User_Type==CORPADMIN) {
					
					$this->load->model ( 'CorporateMaster' );
					$CorpUsers = $this->CorporateMaster->getUsersCreatedBy($user->User_Id);
					$data['CorpUsers'] = $CorpUsers;
					$this->load->view ( 'corp_caseadd', $data );
				} else {
					$this->load->view ( 'caseadd', $data );
				}

		} else {
			redirect ( 'users/login', 'location' );
		}
	}

	
	public function addpost() {
		 
		$user = $this->session->userdata ( 'user' );
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		$this->load->helper ( 'secureemail' );
		//$this->load->helper ( 'geo_location_pi' );
		$this->load->helper ( 'notification_check' );
		
		
		$this->form_validation->set_rules ( 'query', 'Medical Query', 'trim|required|xss_clean|max_length[5000]' );
		$this->form_validation->set_rules ( 'email', 'Email', 'trim|required|xss_clean|valid_email' );
		$this->form_validation->set_rules ( 'dob', 'Date of Birth', 'trim|required|xss_clean|callback__validate_dateofbirth' );
		$this->form_validation->set_rules ( 'fname', 'First Name', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'lname', 'Last Name', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'agreePrivacy', 'privacy policy', 'required|min_length[3]' );
		$this->form_validation->set_rules ( 'phone', 'Phone Number', 'trim|required|xss_clean|max_length[20]' );
		$this->form_validation->set_message ( 'min_length', 'Please agree to the %s' );
		$this->form_validation->set_rules ( 'country', 'Country', 'trim|required|xss_clean' );
		
		if ($user != NULL && $user != '') 
		{
			$this->load->model ( 'CaseMaster' );
			$this->load->model ( 'DoctorMaster' );
			
			if($user->User_Type != ADMIN && $user->User_Type != ADMINUSER )
			{
				$this->form_validation->set_rules ( 'relation', 'Relation', 'trim|required|xss_clean|callback__validate_relation' );
			}
			
			$CaseQueryDetails = array (
					'Query' => $this->input->post ( 'query' ),
					'Specaility' => $this->input->post ( 'specialization' ),
					'Type' => $this->input->post ( 'type' ),
					'SpecialityText' => $this->input->post ( 'sptype' ) 
			);
			
			$SpecialityList = $this->DoctorMaster->getAllSpecialities ();
			$data ['Specializations'] = $SpecialityList;
			
			
			if ($this->form_validation->run () == FALSE) {
				$data ['Relations'] = $this->CaseMaster->getRelations ();
				
				
				$UserPatientId='';
				$PatientArray = array ();
				
				if ($user->User_Type== ADMIN || $user->User_Type== ADMINUSER) // to allow ADMIN and ADMINUSER create case for exisiting users and patients // Added by sarell @23/11/15 19:00hr
				{
					$PatientList = $this->CaseMaster->getAllPatients();					
					$UserList = $this->CaseMaster->getExistingUsers();		
				}
				else 
				{
					$PatientList = $this->CaseMaster->getPatientsByUser ( $user->User_Id );
				}
				
				$Count = 0;
				if ($PatientList != NULL && $PatientList != '') {
					foreach ( $PatientList as $SingPatient ) 
					{
						if($SingPatient->Relation == 1 )
						{
							$UserPatientId=$SingPatient->Patient_Id;
						}
						
						$PatientArray [] = array (
								'DropdownId' => $Count,
								'FName' => $SingPatient->FName,
								'LName' => $SingPatient->LName,
								'Phone' => $SingPatient->Phone,
								'Email' => $SingPatient->Email,
								'DOB' => date ( DATEFORMAT, strtotime ( $SingPatient->DOB ) ),
								'Gender' => $SingPatient->Gender,
								'Relation' => $SingPatient->Relation,
								'Country' => $SingPatient->Country ,
								'Patient_Id' =>$SingPatient->Patient_Id,
								'Created_By' =>$SingPatient->Created_By
						
						);
						
						$Count ++;
					}
				} else {
					$PatientArray = NULL;
				}
				
				if ($user->User_Type== ADMIN || $user->User_Type== ADMINUSER)//code to merge array of existing user and patient
				{
					$FinalArray = $this->FilterExistingUserArray($UserList, $PatientArray);
				}
				else
				{
					$FinalArray = $PatientArray;
				}
				
				
				
				
				$UserDOB = date ( DATEFORMAT, strtotime ( $user->Birth_Date ) );
				
				$UserDetails = array (
						'UserId' => $user->User_Id,
						'First_name' => $user->First_name,
						'Last_Name' => $user->Last_Name,
						'Gender' => $user->Gender,
						'Birth_Date' => $UserDOB,
						'email' => $user->email,
						'Mobile_Number' => $user->Mobile_Number,
						'Country' => $user->Country,
						'Patient_Id' => $UserPatientId,
						'UserType' => $user->User_Type
				)
				;
				
				/*
				 * //Validation Setting Not yet Done
				 * $MedicQuery=form_error('query');
				 *
				 * if($MedicQuery != NULL && $MedicQuery !='')
				 * {
				 * $Set=true;
				 * }
				 * else
				 * {
				 * $Set=false;
				 * }
				 *
				 * $ActiveStyle=array(
				 * 'ActiveCase' =>'active case',
				 * 'ActivePatient' =>'user',
				 * 'HideQuery' =>'style="display: none; transform: scale(0.8); opacity: 0;"',
				 * 'ShowQuery' =>'style="display: block; transform: scale(1); opacity: 1;"',
				 * 'HidePatient' =>'style="display: none; left: 50%; opacity: 0;"',
				 * 'ShowPatient' =>'style="display: block; left: 0%; opacity: 1;"',
				 * 'Medic' => $Set
				 * );
				 *
				 * $data['Style']=$ActiveStyle;
				 */
				$data ['CaseDetails'] = $CaseQueryDetails;
				$data ['Patients'] = $FinalArray;
				$data ['UserDetails'] = $UserDetails;
				
				if($user->User_Type==CORPADMIN) {
					$this->load->model ( 'CorporateMaster' );
					$CorpUsers = $this->CorporateMaster->getUsersCreatedBy($user->User_Id);
					$data['CorpUsers'] = $CorpUsers;
					$this->load->view ( 'corp_caseadd', $data );
				} else {
					$this->load->view ( 'caseadd', $data );
				}

				return;
			}
			
			
			$caseId = $this->CaseMaster->add ();
			
			// Add Audit Trail
			$this->load->model ( 'AuditTrailMaster' );
			$ControllerData = array (
					'Controller' => $this->router->class,
					'Action' => 'Case Created with case number- '.$caseId.'   by user-'.$user->First_name.' '.$user->Last_Name.'  who is  type-'.$user->User_Type //$this->router->method' 
			)
			;
			$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
			
			// To Check if User present with Same Email
			$this->load->model ( 'UserMaster' );
			$PatientEmail = $this->input->post ( 'email' );
			$UsersDetails = $this->UserMaster->get_user_by_email ( $PatientEmail );
			
			If ($UsersDetails == NULL) 
			{
				$this->load->helper ( 'security' );
				// Add User
				$FName = $this->input->post ( 'fname' );
				$SamplePwd = $FName . '#123';
				$PasswordHash = do_hash ( $SamplePwd, 'md5' );
				$PatientNewUser = $this->CaseMaster->ToAddPatientAsUser ( $PasswordHash );
				
				$AppendToBody = '<br/> Your Login Details is your Current Email-' . $this->input->post ( 'email' ) . ' and Password -' . $SamplePwd . '. Please Change Password as soon as you Login.';
				
				$CC = '';
				$EmailAddresTo = $this->input->post ( 'email' );
				$Subject = 'New Case ID ' . $caseId;
				$BaseUrl = base_url ( 'cases/detail/' . $caseId );
				$TodayDate1 = date ( DATETIMEFORMAT );
				$Body = array (
						'Name' => $FName,
						'User_Id' => '',
						'Email' => $this->input->post ( 'email' ),
						'Password' => $SamplePwd,
						'TimeStamp' => $TodayDate1 
				);
				
				// Mail to New User
				$NotificationsNewUser = array (
						'To' => $EmailAddresTo,
						'FROM' => INFOEMAIL,
						'CC' => $CC,
						'Subject' => $Subject,
						'Body' => $Body,
						'Type' => 'Email_NewUser',
						'Attach' => '' 
				);
				$ResultNotifyNewUser = send_secured_email ( $NotificationsNewUser );
			}
			
			// Send Email
			$CC = '';
			$EmailAddresTo = $user->email;
			$Subject = 'New Case ID ' . $caseId;
			$BaseUrl = base_url ( 'cases/detail/' . $caseId );
			$Body = array (
					'Name' => $user->First_name . ' ' . $user->Last_Name,
					'User_Id' => $user->User_Id,
					'Case_Id' => $caseId,
					'Link' => $BaseUrl 
			);
			
			// Mail to User
			$Notifications = array (
					'To' => $EmailAddresTo,
					'FROM' => INFOEMAIL,
					'CC' => $CC,
					'Subject' => $Subject,
					'Body' => $Body,
					'Type' => "Email_User_NewCase",
					'Attach' => '' 
			);
			
			if(get_notification_status_user($user->User_Id))
			{
				$ResultNotify = send_secured_email ( $Notifications );
			}
			
			// Mail to Support
			$this->load->model ( 'PatientMaster' );
			$CaseDetail = $this->CaseMaster->getCasesById ( $caseId );
			$PatientDetailsofCase = $this->PatientMaster->getPatientById ( $CaseDetail->Patient_Id );
			$BodySupport = array (
					'Speciality' => $this->getSpeciality($SpecialityList, $CaseDetail->specialization),
					'Case_Date' => $CaseDetail->Case_Date,
					'Name' => $PatientDetailsofCase->FName . ' ' . $PatientDetailsofCase->LName,
					'Created_By' => $user->User_Id,
					'Email' => $PatientDetailsofCase->Email,
					'Mobile' => $PatientDetailsofCase->Phone,
					'City' => $user->City,
					'Country' => $PatientDetailsofCase->Country,
					'query' => $CaseDetail->medical_query,
					'Case_Id' => $caseId,
					'Link' => $BaseUrl 
			);
			$NotificationsEmail = array (
					'To' => SUPPORTEMAIL,
					'FROM' => SYSTEMEMAIL,
					'CC' => $CC,
					'Subject' => $Subject,
					'Body' => $BodySupport,
					'Type' => "Email_CC_NewCase",
					'Attach' => '' 
			);
			$ResultNotifyAdmin = send_secured_email ( $NotificationsEmail );
			
			// Send Notification Admin
			$SubjectNotification = 'New Case ID ' . $caseId.' by ' . $user->First_name . ' ' . $user->Last_Name;
			$Bodynoti = 'User-' . $this->session->userdata ( 'user_name' ) . ' has created Case-' . $caseId . '. The Url to Case is - <a target="_blank" href="' . $BaseUrl . '">Case Detail -' . $caseId . '</a>';
			$Notifications1 = array (
					'ToRole' => ADMINUSER,
					'Subject' => $SubjectNotification,
					'Body' => $Bodynoti,
					'ToUser' => '',
					'QuestionId' => '' 
			);
			$ResultNotify = send_notification_for_user ( $Notifications1 );
			
			// Send Notification User
			$Notifications2 = array (
					'ToUser' => $user->User_Id,
					'Subject' => $SubjectNotification,
					'Body' => $Bodynoti,
					'QuestionId' => '',
					'ToRole' => '' 
			);
			$ResultNotify = send_notification_for_user ( $Notifications2 );
			
			// Set Flash Message
			if ($caseId == NULL || $caseId == '' || $caseId == 0) {
				$FinalMsg = 'The Case was not Created Properly';
				$MsgBit = "Error";
			} else {
				$FinalMsg = 'The case was created sucessfully. You would receive email shortly.';
				$MsgBit = "Success";
			}
			
			$Message = array (
					'CaseId' => $caseId,
					'Message' => $FinalMsg,
					'ErrorBit' => $MsgBit 
			);
			
			$this->session->set_flashdata ( 'CaseAddMsg', $Message );
			
			/*
			 * echo "<script>alert('The Case has been Created Successfully !');
			 * </script>"; //window.location.href='payments/add/".$caseId."';
			 */
			
			redirect ( 'payments/add/' . $caseId, 'location' );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	public function _validate_relation($RelationId) {
		if ($this->session->userdata ( 'user' ) != null) {
			if ("select" == $RelationId) {
				$this->form_validation->set_message ( '_validate_relation', 'Invalid Relation' );
				return FALSE;
			}
			
			return TRUE;
		} else {
			$this->form_validation->set_message ( '_validate_relation', 'Invalid Relation' );
			return FALSE;
		}
	}
	
	public function _validate_dateofbirth($DateOfBirth) {
		if ($this->session->userdata ( 'user' ) != null) 
		{
			$TodayDate = date ( DATEFORMAT );
			
			if (strtotime($DateOfBirth) > strtotime($TodayDate) ) {
				$this->form_validation->set_message ( '_validate_dateofbirth', 'Invalid Date of Birth' );
				return FALSE;
			}
				
			return TRUE;
		} else {
			$this->form_validation->set_message ( '_validate_dateofbirth', 'Invalid Date of Birth' );
			return FALSE;
		}
	}
	
	
	private  function getSpeciality($SpecilaityList , $SpecialityId)
	{
		$SpecialityText=$SpecialityId;
		foreach($SpecilaityList as $SingleSpecial)
		{
			if($SingleSpecial["id"] == $SpecialityId)
			{
				$SpecialityText=$SingleSpecial["name"];
				break;
			}
		}
		
		return $SpecialityText;
	}
	
	public function addnote() {
		 
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		$this->form_validation->set_rules ( 'note', 'First Name', 'trim|required|xss_clean' );
		
		$user = $this->session->userdata ( 'user' );
		
		if ($user != NULL) {
			
			if ($this->form_validation->run () == FALSE) {
				return;
			}
			$this->load->model ( 'NoteMaster' );
			return $this->NoteMaster->add ();
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function deletenote() {
		$this->load->model ( 'NoteMaster' );
		return $this->NoteMaster->delete ();
	}
	public function create() {
		 
		
		$this->load->model ( 'UserMaster' );
		$userId = $this->UserMaster->register ();
	}
	public function editCase($id) {
		 
		
		$user = $this->session->userdata ( 'user' );
		
		if ($user != null) {
			$this->load->helper ( 'form' );
			$this->load->library ( 'form_validation' );
			$this->load->model ( 'CaseMaster' );
			$this->load->model ( 'NoteMaster' );
			$this->load->model ( 'PatientMaster' );
			$this->load->model ( 'DoctorMaster' );
			
			$CaseDetail = $this->CaseMaster->getCasesById ( $id );
			$this->session->set_userdata ( 'case', $CaseDetail );
			// Get User Type
			$UserType = $this->session->userdata ( 'user_type' );
			
			If ($UserType == ADMIN || $UserType == ADMINUSER) {
				$data ["Relations"] = $this->CaseMaster->getRelations ();
				$data ["PlanDetails"] = $this->CaseMaster->getPlans ();
			}
			
			$doctorName = '';
			$doctorId = '';
			if ($CaseDetail->Doctor_Id != NULL && $CaseDetail->Doctor_Id != '' && $CaseDetail->Doctor_Id > 0) {
				$doctor = $this->DoctorMaster->getDoctorById ( $CaseDetail->Doctor_Id );
				
				$doctorId = $doctor->Doctor_Id;
				$doctorName = $doctor->DName;
			}
			
			// TO Get Case Amount
			$CaseAmount = '';
			$CaseAmountDetails = $this->getAmtDateOfPaidCase ( $id );
			if ($CaseAmountDetails != NULL && $CaseAmountDetails != '') {
				$CaseAmount = $CaseAmountDetails ["Amount"];
			}
			
			$doctorList = $this->DoctorMaster->getAllDoctorsAlphabetically ();
			$patientDetails = $this->PatientMaster->getPatientById ( $CaseDetail->Patient_Id );
			$relation = $this->CaseMaster->getRelationsById ( $patientDetails->Relation );
			
			$case = array (
					'patient_first_name' => $patientDetails->FName,
					'patient_last_name' => $patientDetails->LName,
					'Patient_Id' => $CaseDetail->Patient_Id,
					'patient_contact_number' => $patientDetails->Phone,
					'relation' => $relation->name,
					'patient_gender' => $patientDetails->Gender,
					'patient_birth_date' => (strtotime ( $patientDetails->DOB )?(strtotime ( $patientDetails->DOB )?date ( DATEFORMAT, strtotime ( $patientDetails->DOB ) ):""):""),
					'patient_email' => $patientDetails->Email,
					'patient_country' => $patientDetails->Country,
					'id' => $CaseDetail->id,
					'medical_query' => $CaseDetail->medical_query,
					'type' => $CaseDetail->type,
					'Case_Date' => date ( DATEFORMAT, strtotime ( $CaseDetail->Case_Date ) ),
					'status' => $CaseDetail->status,
					'plan' => $CaseDetail->plan,
					'is_paid' => $CaseDetail->is_paid,
					'UserType' => $UserType,
					'Doctor_Id' => $doctorId,
					'DName' => $doctorName,
					'Amount' => $CaseAmount 
			)
			;
			
			$data ['case'] = $case;
			$data ['Doctors'] = $doctorList;
			$data ['notes'] = $this->NoteMaster->getNotesByCase ( $id );
			$this->load->view ( 'caseedit', $data );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	
	private function DoctorArray()
	{
		$this->load->model ( 'DoctorMaster' );
		$doctorList = $this->DoctorMaster->getAllDoctorsAlphabetically ();
		
		$DoctorsList= array();
		
		foreach ($doctorList as $SingleDoctor)
		{
			$DoctorsList [] = array (
					'label' => $SingleDoctor ["DName"].' -('.$SingleDoctor["Doctor_Id"].')',
					'value' => $SingleDoctor ["Doctor_Id"]
			);
		}
		
		return  $DoctorsList;
	}
	
	public function caseEditSubmit($id) 
	{
		 
		$user = $this->session->userdata ( 'user' );
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		$this->load->helper ( 'secureemail' );
		$this->load->helper ( 'notification_check' );
		
		$SubmitValue = $this->input->post ( 'back' );
		if ($SubmitValue != NULL && $SubmitValue != '')
		 {
			redirect ( 'cases/detail/' . $id, 'location' );
		}
		
		$this->form_validation->set_rules ( 'mquery', 'Medical Query', 'trim|required|xss_clean' );
		
		if ($user != null)
		 {
			$UserType = $this->session->userdata ( 'user' )->User_Type;
			
			$this->load->model ( 'CaseMaster' );
			$this->load->model ( 'NoteMaster' );
			$this->load->model ( 'PatientMaster' );
			$CaseDetail = $this->CaseMaster->getCasesById ( $id );
			$patientDetails = $this->PatientMaster->getPatientById ( $CaseDetail->Patient_Id );
			$newStatus=$this->input->post ( 'caseStatus' );
			$newStatusAction="updated";
			switch($newStatus) {
				case "2": $newStatusAction="has been assigned a doctor"; break;
				case "3": $newStatusAction="has been reviewed by a specialist"; break;
				case "4": $newStatusAction="has a report submitted against it"; break;
				case "5": $newStatusAction="has been closed"; break;
				case "6": $newStatusAction="has been dismissed"; break;
			}
			
			if ($this->form_validation->run () == FALSE) 
			{
				
				$relation = $this->CaseMaster->getRelationsById ( $patientDetails->Relation );
				
				If ($UserType == ADMIN || $UserType == ADMINUSER) {
					$data ["Relations"] = $this->CaseMaster->getRelations ();
					$data ["PlanDetails"] = $this->CaseMaster->getPlans ();
				}
				
				$case = array (
						'patient_first_name' => $patientDetails->FName,
						'patient_last_name' => $patientDetails->LName,
						'Patient_Id' => $CaseDetail->Patient_Id,
						'patient_contact_number' => $patientDetails->Phone,
						'relation' => $relation->name,
						'patient_gender' => $patientDetails->Gender,
						'patient_birth_date' => (strtotime ( $patientDetails->DOB )?(strtotime ( $patientDetails->DOB )?date ( DATEFORMAT, strtotime ( $patientDetails->DOB ) ):""):""),
						'patient_email' => $patientDetails->Email,
						'patient_country' => $patientDetails->Country,
						'id' => $CaseDetail->id,
						// 'medical_query' => $CaseDetail->medical_query,
						'type' => $CaseDetail->type,
						'Case_Date' => $CaseDetail->Case_Date,
						'status' => $CaseDetail->status,
						'plan' => $CaseDetail->plan,
						'is_paid' => $CaseDetail->is_paid 
				)
				;
				
				$data ['case'] = $case;
				$data ['notes'] = $this->NoteMaster->getNotesByCase ( $id );
				$this->load->view ( 'caseedit', $data );
				return;
			}
			
			If ($UserType == ADMIN || $UserType == ADMINUSER) 
			{
				$CaseDetailArray = array (
						'status' => $CaseDetail->status,
						'Patient_Id' => $CaseDetail->Patient_Id,
						'CaseId' => $id 
				)
				;
				$Result = $this->CaseMaster->EditCaseDetailAdmin ( $CaseDetailArray );
				
				$DoctorId = $this->input->post ( 'doctorname' );
				
				if ($CaseDetail->status <= 1 && $DoctorId != NUll) {
					$this->load->model ( 'DoctorMaster' );
					$doctor = $this->DoctorMaster->getDoctorById ( $DoctorId );
					
					// Send Notification To Doctor
					$BaseUrl = base_url ( 'cases/detail/' . $id );
					$Subject = 'Case ID ' . $id . ' assigned to you';
					$Body = 'Assigned Case ID ' . $id . ' to Doctor ID '.$DoctorId.' <a target="_blank" href="' . $BaseUrl . '">Click here to view Case ID ' . $id . '</a>';
					$Notifications = array (
							'ToRole' => ADMINUSER,
							'Subject' => $Subject,
							'Body' => $Body,
							'ToUser' => '',
							'QuestionId' => '' 
					);
					$ResultNotify = send_notification_for_user ( $Notifications );
					
					// Send Email To Doctor
					$CC = '';
					$EmailAddresTo = $doctor->Email;
					$EmailAddressFrom = INFOEMAIL;
					$SubjectEmail = $Subject;
					
					$BodyEmail = array (
							'DName' => $doctor->DName,
							'Patient_Id' => $CaseDetail->Patient_Id,
							'Case_Id' => $id,
							'City' => '',
							'Country' => $patientDetails->Country,
							'Link' => $BaseUrl 
					);
					
					$EmailNotification1 = array (
							'To' => $EmailAddresTo,
							'FROM' => $EmailAddressFrom,
							'CC' => $CC,
							'Subject' => $SubjectEmail,
							'Body' => $BodyEmail,
							'Type' => "Email_NewCase_Doctor",
							'Attach' => '' 
					);
					
					if(get_notification_status_user($doctor->User_Id))
					{
						$ResultEmail1 = send_secured_email ( $EmailNotification1 );
					}
					
				}
			} else {
				$Result = $this->CaseMaster->EditCaseDetail ( $id );
			}
			
			// Send Notification To User
			$BaseUrl = base_url ( 'cases/detail/' . $id );
			$Subject = 'Case ID ' . $id . ' '.$newStatusAction;
			$Body = 'User-' . $this->session->userdata ( 'user_name' ) . ' Updated Case-' . $id . ' . The Url to Case is - <a target="_blank" href="' . $BaseUrl . '">Case Detail -' . $id . '</a>';
			$Notifications = array (
					'ToRole' => ADMINUSER,
					'Subject' => $Subject,
					'Body' => $Body,
					'ToUser' => '',
					'QuestionId' => '' 
			);
			$ResultNotify = send_notification_for_user ( $Notifications );
			
			// Send Email to User
			$this->load->model ( 'UserMaster' );
			$UserDetails = $this->UserMaster->get_singleuser ( $CaseDetail->created_by );
			$CC = '';
			$EmailAddresTo = $UserDetails->email;
			$EmailAddressFrom = INFOEMAIL;
			$SubjectEmail = 'Case ID ' . $id . ' '.$newStatusAction;
			
			$BodyEmailUser = array (
					'Name' => $UserDetails->First_name . ' ' . $UserDetails->Last_Name,
					'Link' => $BaseUrl,
					'Case_Id' => $id 
			);
			
			$EmailNotification = array (
					'To' => $EmailAddresTo,
					'FROM' => $EmailAddressFrom,
					'CC' => $CC,
					'Subject' => $SubjectEmail,
					'Body' => $BodyEmailUser,
					'Type' => "Email_User_UpdateCase",
					'Attach' => '' 
			);
			
			if(get_notification_status_user($UserDetails->User_Id))
			{
				$ResultEmail = send_secured_email ( $EmailNotification );
			}
			
			
			// Send Email to Admin
			$CC = '';
			$EmailAddresTo = SUPPORTEMAIL;
			$EmailAddressFrom = SYSTEMEMAIL;
			$SubjectEmail = 'Case ID ' . $id . ' '.$newStatusAction;
			
			$BodyEmailAdmin = array (
					'Name' => $UserDetails->First_name . ' ' . $UserDetails->Last_Name,
					'User_Id' => $UserDetails->User_Id,
					'Link' => $BaseUrl,
					'Case_Id' => $id 
			);
			
			$EmailNotificationAdmin = array (
					'To' => $EmailAddresTo,
					'FROM' => $EmailAddressFrom,
					'CC' => $CC,
					'Subject' => $SubjectEmail,
					'Body' => $BodyEmailAdmin,
					'Type' => "Email_CC_UpdateCase",
					'Attach' => '' 
			);
			$ResultEmail = send_secured_email ( $EmailNotificationAdmin );
			
			// Add Audit Trail
			$this->load->model ( 'AuditTrailMaster' );
			$ControllerData = array (
					'Controller' => $this->router->class,
					'Action' => 'Case '.$id.'  edited by user-'.$user->First_name.' '.$user->Last_Name.'  who is  type-'.$user->User_Type //$this->router->method 
			)
			;
			$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
			
			// Set Measage
			$FinalMsg = 'The Case was Updated Successfully.';
			$MsgBit = "Success";
			$Message = array (
					'CaseId' => $caseId,
					'Message' => $FinalMsg,
					'ErrorBit' => $MsgBit 
			);
			
			$this->session->set_flashdata ( 'CaseUpdateMsg', $Message );
			
			redirect ( 'cases/detail/' . $id, 'location' );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function addfollowupquery($caseid) {
		 
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		$user = $this->session->userdata ( 'user' );
		
		if ($user != null) {
			$UserType = $this->session->userdata ( 'user_type' );
			$this->load->model ( 'CaseMaster' );
			$this->load->model ( 'DoctorMaster' );
			$this->load->model ( 'PatientMaster' );
			
			$CaseDetail = $this->CaseMaster->getCasesById ( $caseid );
			$patientDetails = $this->PatientMaster->getPatientById ( $CaseDetail->Patient_Id );
			$DoctorDetails = $this->DoctorMaster->getDoctorById ( $CaseDetail->Doctor_Id );
			$case = array (
					'Patient_Id' => $CaseDetail->Patient_Id,
					'Case_Id' => $caseid,
					'Doctor_Id' => $CaseDetail->Doctor_Id,
					'DName' => $DoctorDetails->DName,
					'FName' => $patientDetails->FName,
					'LName' => $patientDetails->LName 
			);
			
			$data ['case'] = $case;
			$data ['UserType'] = $UserType;
			$this->load->view ( 'followupquery', $data );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function addfollowupquerypost($caseid) {
		 
		$user = $this->session->userdata ( 'user' );
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		$SubmitValue = $this->input->post ( 'back' );
		if ($SubmitValue != NULL && $SubmitValue != '')
		{
			redirect ( 'cases/detail/' . $caseid, 'location' );
		}
		
		$this->form_validation->set_rules ( 'question', 'Query', 'trim|required|xss_clean' );
		
		if ($user != null) {
			$UserType = $this->session->userdata ( 'user_type' );
			$this->load->model ( 'CaseMaster' );
			$this->load->model ( 'DoctorMaster' );
			$this->load->model ( 'PatientMaster' );
			
			$CaseDetail = $this->CaseMaster->getCasesById ( $caseid );
			$patientDetails = $this->PatientMaster->getPatientById ( $CaseDetail->Patient_Id );
			$DoctorDetails = $this->DoctorMaster->getDoctorById ( $CaseDetail->Doctor_Id );
			$case = array (
					'Patient_Id' => $CaseDetail->Patient_Id,
					'Case_Id' => $caseid,
					'Doctor_Id' => $CaseDetail->Doctor_Id,
					'DName' => $DoctorDetails->DName,
					'FName' => $patientDetails->FName,
					'LName' => $patientDetails->LName 
			);
			
			if ($this->form_validation->run () == FALSE) {
				$data ['case'] = $case;
				$data ['UserType'] = $UserType;
				$this->load->view ( 'followupquery', $data );
				return;
			}
			
			$QuestionId = $this->CaseMaster->addFollowupQuery ( $case );
			
			// Send Notification
			if ($UserType == DOCTORS) {
				$Towhom = $patientDetails->Created_By; // Patient's Users
				$UserFrom = $DoctorDetails->DName;
				$UserTo = $patientDetails->FName . ' ' . $patientDetails->LName;
			} else {
				$Towhom = $DoctorDetails->User_Id; // Doctor
				$UserFrom = $patientDetails->FName . ' ' . $patientDetails->LName;
				$UserTo = $DoctorDetails->DName;
				
			}
			
			$BaseUrl = base_url ( 'cases/detail/' . $caseid );
			$Subject = $UserFrom . ' has asked '.$UserTo.' a query related to Case ID ' . $caseid;
			$Body = 'Click <a target="_blank" href="' . $BaseUrl . '">this link to open Case ID ' . $caseid . '</a> . <br><br>' . $this->input->post ( 'question' );
			
			$Notifications = array (
					'ToUser' => '',//$Towhom,
					'Subject' => $Subject,
					'Body' => $Body,
					'QuestionId' => $QuestionId,
					'ToRole' => ADMINUSER 
			);
			
			$ResultNotify = send_notification_for_user ( $Notifications );
			
			/*
			$NotificationsAdmin = array (
					'ToUser' => '',
					'Subject' => $Subject,
					'Body' => $Body,
					'QuestionId' => $QuestionId,
					'ToRole' => ADMINUSER
					
			);
				
			$ResultNotify = send_notification_for_user ( $NotificationsAdmin );*/
			
			/*
			 * if($UserType == DOCTORS)
			 * {
			 * $EmailAddressFrom=$DoctorDetails->Email;
			 * }
			 * else
			 * {
			 * $EmailAddressFrom=$patientDetails->Email;
			 * }
			 */
			// Send Email
			$this->load->helper ( 'secureemail' );
			$CC = '';
			$EmailAddresTo = SUPPORTEMAIL;
			$EmailAddressFrom = SYSTEMEMAIL;
			$SubjectEmail = $Subject;
			
			$BodyEmail = $Body . '. The Url is -' . $BaseUrl;
			$EmailNotification = array (
					'To' => $EmailAddresTo,
					'FROM' => $EmailAddressFrom,
					'CC' => $CC,
					'Subject' => $SubjectEmail,
					'Body' => $BodyEmail,
					'Type' => "",
					'Attach' => '' 
			)
			;
			$ResultEmail = send_secured_email ( $EmailNotification );
			
			// Add Audit Trail
			$this->load->model ( 'AuditTrailMaster' );
			$ControllerData = array (
					'Controller' => $this->router->class,
					'Action' => 'Query related with case number- '.$caseid.'  raised by user-'.$user->First_name.' '.$user->Last_Name.'  who is  type-'.$user->User_Type //$this->router->method' 
			)
			;
			$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
			
			// Set Message
			if ($QuestionId == NULL || $QuestionId == '') {
				$FinalMsg = 'Query Not Submitted.Some Internal Error.Contact GO.';
				$MsgBit = "Error";
			} else {
				$FinalMsg = 'The Query Raised Successfully.';
				$MsgBit = "Success";
			}
			
			$Message = array (
					'CaseId' => $QuestionId,
					'Message' => $FinalMsg,
					'ErrorBit' => $MsgBit 
			);
			
			$this->session->set_flashdata ( 'CaseUpdateMsg', $Message );
			
			redirect ( 'cases/detail/' . $caseid, 'location' );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function editCaseReferalDoctor($id) {
		 
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		$user = $this->session->userdata ( 'user' );
		
		if ($user != null) {
			$UserType = $user->User_Type;
			
			If ($UserType == ADMIN || $UserType == ADMINUSER) {
				
				$this->load->model ( 'CaseMaster' );
				$this->load->model ( 'NoteMaster' );
				$this->load->model ( 'PatientMaster' );
				$this->load->model ( 'DoctorMaster' );
				
				$CaseDetail = $this->CaseMaster->getCasesById ( $id );
				// Get User Type
				
				$doctorName = '';
				$doctorId = '';
				if ($CaseDetail->Doctor_Id != NULL && $CaseDetail->Doctor_Id != '' && $CaseDetail->Doctor_Id > 0) {
					$doctor = $this->DoctorMaster->getDoctorById ( $CaseDetail->Doctor_Id );
					
					$doctorId = $doctor->Doctor_Id;
					$doctorName = $doctor->DName;
				}
				
				// TO Get Case Amount
				$CaseAmount = '';
				$CaseAmountDetails = $this->getAmtDateOfPaidCase ( $id );
				if ($CaseAmountDetails != NULL && $CaseAmountDetails != '') {
					$CaseAmount = $CaseAmountDetails ["Amount"];
				}
				
				$doctorList = $this->DoctorMaster->getAllDoctors ();
				$patientDetails = $this->PatientMaster->getPatientById ( $CaseDetail->Patient_Id );
				$relation = $this->CaseMaster->getRelationsById ( $patientDetails->Relation );
				
				$case = array (
						'patient_first_name' => $patientDetails->FName,
						'patient_last_name' => $patientDetails->LName,
						'Patient_Id' => $CaseDetail->Patient_Id,
						'patient_contact_number' => $patientDetails->Phone,
						'relation' => $relation->name,
						'patient_gender' => $patientDetails->Gender,
						'patient_birth_date' => (strtotime ( $patientDetails->DOB )?date ( DATEFORMAT, strtotime ( $patientDetails->DOB ) ):""),
						'patient_email' => $patientDetails->Email,
						'patient_country' => $patientDetails->Country,
						'id' => $CaseDetail->id,
						'medical_query' => $CaseDetail->medical_query,
						'type' => $CaseDetail->type,
						'Case_Date' => date ( DATEFORMAT, strtotime ( $CaseDetail->Case_Date ) ),
						'status' => $CaseDetail->status,
						'plan' => $CaseDetail->plan,
						'is_paid' => $CaseDetail->is_paid,
						'UserType' => $UserType,
						'Doctor_Id' => $doctorId,
						'DName' => $doctorName,
						'Amount' => $CaseAmount 
				)
				;
				
				$data ['case'] = $case;
				$data ['Doctors'] = $doctorList;
				// $data['notes'] = $this->NoteMaster->getNotesByCase($id);
				$this->load->view ( 'caseeditdoctorref', $data );
			} else {
				$this->load->view ( 'accessdenied' );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function editCaseReferalDoctorSubmit($id) {
		 
		$user = $this->session->userdata ( 'user' );
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		$SubmitValue = $this->input->post ( 'back' );
		if ($SubmitValue != NULL && $SubmitValue != '')
		{
			redirect ( 'cases/detail/' . $id, 'location' );
		}
		
		$this->form_validation->set_rules ( 'doctorname', 'Doctor Name', 'trim|required|xss_clean|callback__validate_doctor' );
		
		if ($user != null) {
			$UserType = $user->User_Type;
			
			If ($UserType == ADMIN || $UserType == ADMINUSER) {
				$this->load->model ( 'CaseMaster' );
				$this->load->model ( 'PatientMaster' );
				$this->load->model ( 'DoctorMaster' );
				
				$CaseDetail = $this->CaseMaster->getCasesById ( $id );
				$patientDetails = $this->PatientMaster->getPatientById ( $CaseDetail->Patient_Id );
				
				if ($this->form_validation->run () == FALSE) {
					$doctorName = '';
					$doctorId = '';
					if ($CaseDetail->Doctor_Id != NULL && $CaseDetail->Doctor_Id != '' && $CaseDetail->Doctor_Id > 0) {
						$doctor = $this->DoctorMaster->getDoctorById ( $CaseDetail->Doctor_Id );
						
						$doctorId = $doctor->Doctor_Id;
						$doctorName = $doctor->DName;
					}
					
					// TO Get Case Amount
					$CaseAmount = '';
					$CaseAmountDetails = $this->getAmtDateOfPaidCase ( $id );
					if ($CaseAmountDetails != NULL && $CaseAmountDetails != '') {
						$CaseAmount = $CaseAmountDetails ["Amount"];
					}
					
					$doctorList = $this->DoctorMaster->getAllDoctors ();
					
					$relation = $this->CaseMaster->getRelationsById ( $patientDetails->Relation );
					
					$case = array (
							'patient_first_name' => $patientDetails->FName,
							'patient_last_name' => $patientDetails->LName,
							'Patient_Id' => $CaseDetail->Patient_Id,
							'patient_contact_number' => $patientDetails->Phone,
							'relation' => $relation->name,
							'patient_gender' => $patientDetails->Gender,
							'patient_birth_date' => (strtotime ( $patientDetails->DOB )?date ( DATEFORMAT, strtotime ( $patientDetails->DOB ) ):""),
							'patient_email' => $patientDetails->Email,
							'patient_country' => $patientDetails->Country,
							'id' => $CaseDetail->id,
							'medical_query' => $CaseDetail->medical_query,
							'type' => $CaseDetail->type,
							'Case_Date' => date ( DATEFORMAT, strtotime ( $CaseDetail->Case_Date ) ),
							'status' => $CaseDetail->status,
							'plan' => $CaseDetail->plan,
							'is_paid' => $CaseDetail->is_paid,
							'UserType' => $UserType,
							'Doctor_Id' => $doctorId,
							'DName' => $doctorName,
							'Amount' => $CaseAmount 
					)
					;
					
					$data ['case'] = $case;
					$data ['Doctors'] = $doctorList;
					// $data['notes'] = $this->NoteMaster->getNotesByCase($id);
					$this->load->view ( 'caseeditdoctorref', $data );
					return;
				}
				
				$SelectedDoctorId = $this->input->post ( 'doctorname' );
				
				if ($SelectedDoctorId != NUll && $SelectedDoctorId != '') {
					$DoctorDetails = $this->DoctorMaster->getDoctorById ( $SelectedDoctorId );
					
					$CaseDetailArray = array (
							'DoctorId' => $SelectedDoctorId,
							'UserId' => $user->User_Id,
							'CaseId' => $id 
					);
					
					$Result = $this->CaseMaster->addreferaldoctor ( $CaseDetailArray );
					
					// Send Notification
					$BaseUrl = base_url ( 'cases/detail/' . $id );
					$Subject = 'Case ID ' . $id . ' assigned to you';
					$Body = ' Dear Doctor, you are assigned  Case-' . $id . 'The Url for it is - <a target="_blank" href="' . $BaseUrl . '">Case Detail -' . $id . '</a>';
					$Notifications = array (
							'ToUser' => $DoctorDetails->User_Id,
							'Subject' => $Subject,
							'Body' => $Body,
							'QuestionId' => '',
							'ToRole' => '' 
					);
					
					$this->load->helper ( 'notification_check' );
					if(get_notification_status_user($DoctorDetails->User_Id))
					{
						$ResultNotify = send_notification_for_user ( $Notifications );
					}
					
					
					// Send Email
					$this->load->helper ( 'secureemail' );
					$CC = SUPPORTEMAIL;
					$EmailAddresTo = $DoctorDetails->Email;
					$EmailAddressFrom = SYSTEMEMAIL;
					$SubjectEmail = 'Case ID ' . $id . ' assigned to you';
					
					// $BodyEmail=' Doctor you are assigned Case-'.$id .'The Url for it is '.$BaseUrl;
					$BodyEmail = array (
							'DName' => $DoctorDetails->DName,
							'Patient_Id' => $CaseDetail->Patient_Id,
							'Case_Id' => $id,
							'City' => '',
							'Country' => $patientDetails->Country,
							'Link' => $BaseUrl 
					);
					
					$EmailNotification = array (
							'To' => $EmailAddresTo,
							'FROM' => $EmailAddressFrom,
							'CC' => $CC,
							'Subject' => $SubjectEmail,
							'Body' => $BodyEmail,
							'Type' => "Email_NewCase_Doctor",
							'Attach' => '' 
					);
					$ResultEmail = send_secured_email ( $EmailNotification );
					
					// Add Audit Trail
					$this->load->model ( 'AuditTrailMaster' );
					$ControllerData = array (
							'Controller' => $this->router->class,
							'Action' => 'Referal Doctor Suggested for case number- '.$id.'   by user-'.$user->First_name.' '.$user->Last_Name.'  who is  type-'.$user->User_Type //$this->router->method' 
					)
					;
					$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
					
					// Set Message
					$FinalMsg = 'The Doctor ' . $DoctorDetails->DName . ' has been assigned to Case-' . $id . ' Successfully.';
					$MsgBit = "Success";
					$Message = array (
							'CaseId' => $QuestionId,
							'Message' => $FinalMsg,
							'ErrorBit' => $MsgBit 
					);
					
					$this->session->set_flashdata ( 'CaseUpdateMsg', $Message );
				}
				
				redirect ( 'cases/detail/' . $id, 'location' );
			} else {
				$this->load->view ( 'accessdenied' );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function _validate_doctor($DoctorId) {
		if ($this->session->userdata ( 'user' ) != null) {
			if ("select" == $DoctorId) {
				$this->form_validation->set_message ( '_validate_doctor', 'Invalid Doctor' );
				return FALSE;
			}
			
			return TRUE;
		} else {
			$this->form_validation->set_message ( '_validate_doctor', 'Invalid Doctor' );
			return FALSE;
		}
	}
	
	// Add the Travel Insurance Case
	public function addTravelCase() {
		 
		//$this->load->helper ( 'geo_location_pi' );
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		$user = $this->session->userdata ( 'user' );
		
		if ($user != NULL) {
			$this->load->model ( 'CaseMaster' );
			$data ['Relations'] = $this->CaseMaster->getRelations ();
			$this->load->view ( 'travelcaseadd', $data );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function addTravelCasePost() {
		 
		$user = $this->session->userdata ( 'user' );
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		//$this->load->helper ( 'geo_location_pi' );
		$this->load->helper ( 'secureemail' );
		
		$this->form_validation->set_rules ( 'Homecountry', 'Your Country', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'address', 'Address', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'Desticountry', 'Destination Country', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'ArivalDate', 'Arrival Date', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'StartDate', 'Start Date', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'EndDate', 'End Date', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'NoInsured', 'Nuber Of Insured', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'Age', 'Age', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'relation', 'Relation', 'trim|required|xss_clean|callback__validate_relation' );
		
		if ($user != NULL) {
			$this->load->model ( 'CaseMaster' );
			if ($this->form_validation->run () == FALSE) {
				$data ['Relations'] = $this->CaseMaster->getRelations ();
				$this->load->view ( 'travelcaseadd', $data );
				return;
			}
			
			$Result = $this->CaseMaster->addTravelCase ();
			
			if ($Result == TRUE) {
				// Send Email
				$CC = '';
				$EmailAddresTo = $user->email;
				$EmailAddressFrom = INFOEMAIL;
				$SubjectEmail = 'Your request For Insurance Quote';
				$BodyEmail = 'Your request for Insurance Quote is with us. We would process it and Let you Know the Details';
				
				$EmailNotification = array (
						'To' => $EmailAddresTo,
						'FROM' => $EmailAddressFrom,
						'CC' => $CC,
						'Subject' => $SubjectEmail,
						'Body' => $BodyEmail,
						'Type' => "",
						'Attach' => '' 
				);
				
				$this->load->helper ( 'notification_check' );
				if(get_notification_status_user($user->User_Id))
				{
					$ResultEmail = send_secured_email ( $EmailNotification );
				}
				
				
				
				// Send Email to Admin
				$CC = '';
				$EmailAddresTo = INSURANCEEMAIL;
				$EmailAddressFrom = SYSTEMEMAIL;
				$SubjectEmail = 'Insurance request';
					
					
				
		
		// Dates
		 
		$TodayDate = date ( DATETIMEFORMAT );
			
				$BodyEmailAdmin = array (
						'HomeCountry' => $this->input->post ( 'Homecountry' ),
						'Date_Arrival' => date ( DATEFORMAT, strtotime ( $this->input->post ( 'ArivalDate' ) ) ),
						'Start_Date' => date ( DATEFORMAT, strtotime ( $this->input->post ( 'StartDate' ) ) ),
						'End_Date' => date ( DATEFORMAT, strtotime ( $this->input->post ( 'EndDate' ) ) ),
						'Destination_Country' => $this->input->post ( 'Desticountry' ),
						'Number_Insured' => $this->input->post ( 'NoInsured' ),
						'Age' => $this->input->post ( 'Age' ),
						'Address' => $this->input->post ( 'address' ),
						'Relation' => $this->input->post ( 'relation' ),
						'Name' => $this->session->userdata ( 'user' )->First_name.' '. $this->session->userdata ( 'user' )->Last_Name,
						'Email' => $this->session->userdata ( 'user' )->email,
						'Mobile' => $this->session->userdata ( 'user' )->Mobile_Number,
						'TodayDate' => $TodayDate
				);
					
				$EmailNotificationAdmin = array (
						'To' => $EmailAddresTo,
						'FROM' => $EmailAddressFrom,
						'CC' => $CC,
						'Subject' => $SubjectEmail,
						'Body' => $BodyEmailAdmin,
						'Type' => "Email_CC_TravelCase",
						'Attach' => ''
				);
				$ResultEmail = send_secured_email ( $EmailNotificationAdmin );
					
				
				// Set Message
				$FinalMsg = 'Your Insurance request is created Successfully.You will receive email shortly.';
				$MsgBit = "Success";
				$Message = array (
						'CaseId' => $QuestionId,
						'Message' => $FinalMsg,
						'ErrorBit' => $MsgBit 
				);
				
				$this->session->set_flashdata ( 'TravelMsg', $Message );
			}
			
			redirect ( 'cases/getTravelCases', 'location' );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function getTravelCases() {
		 
		$user = $this->session->userdata ( 'user' );
		
		if ($user != null) {
			$this->load->model ( 'CaseMaster' );
			
			$QuoteList = $this->CaseMaster->getTravelCasesByUser ();
			
			$QuoteArray = array ();
			
			foreach ( $QuoteList as $SingleRec ) {
				$QuoteArray [] = array (
						'Id' => $SingleRec->Id,
						'Country' => $SingleRec->Country,
						'Date_Arrival' => date ( DATEFORMAT, strtotime ( $SingleRec->Date_Arrival ) ),
						'Start_Date' => date ( DATEFORMAT, strtotime ( $SingleRec->Start_Date ) ),
						'End_Date' => date ( DATEFORMAT, strtotime ( $SingleRec->End_Date ) ),
						'Destination_Country' => $SingleRec->Destination_Country,
						'Country_US' => $SingleRec->Country_US,
						'Number_Insured' => $SingleRec->Number_Insured,
						'Created_By' => $SingleRec->Created_By,
						'Created' => $SingleRec->Created 
				)
				;
			}
			
			$MessageDetails = $this->session->flashdata ( 'TravelMsg' );
			
			if ($MessageDetails == NUll) {
				$Message = array (
						'CaseId' => '',
						'Message' => '',
						'ErrorBit' => '' 
				);
			} else {
				$Message = array (
						'CaseId' => $MessageDetails ['CaseId'],
						'Message' => $MessageDetails ['Message'],
						'ErrorBit' => $MessageDetails ['ErrorBit'] 
				);
			}
			
			$data ['CaseMessage'] = $Message;
			$data ['Quotes'] = $QuoteArray;
			$this->load->view ( 'travelcaselist', $data );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	// To Attach Documents
	public function AttachDocuments($caseid) {
		 
		$user = $this->session->userdata ( 'user' );
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		if ($user != null) {
			$this->load->model ( 'CaseMaster' );
			$this->load->model ( 'PatientMaster' );
			
			$CaseDetail = $this->CaseMaster->getCasesById ( $caseid );
			$patientDetails = $this->PatientMaster->getPatientById ( $CaseDetail->Patient_Id );
			
			$UserId = $user->User_Id;
			$UserType = $user->User_Type;
			$CurrentUserEmail = $user->email;
			$UserAccess = FALSE;
			
			if ($CurrentUserEmail == $patientDetails->Email) {
				$UserAccess = TRUE;
			}
			
			if ($CaseDetail->created_by == $UserId || $UserType == ADMIN || $UserType == ADMINUSER || $UserType == DOCTORS || $UserAccess == TRUE) {
				
				if ($UserType == ADMIN || $UserType == ADMINUSER) {
					$UserId = $CaseDetail->created_by;
				}
				
				$DocumentList = $this->CaseMaster->getDocumentsByUser ( $UserId );
				$PatientList = $this->CaseMaster->getPatientsByUser ( $UserId );
				$CaseDocumentList = $this->CaseMaster->getCaseDocuments ( $CaseDetail->id );
				
				$PatientArray = array ();
				$DocumentArray = array ();
				
				if ($DocumentList != NULL) 
				{
					
					foreach ( $DocumentList as $Document ) {
						$PatientDetailsRecord = $this->PatientMaster->getPatientById ( $Document ["Patient_Id"] );
						if ($PatientDetailsRecord != NULL && $PatientDetailsRecord != '') {
							$DocumentArray [] = array (
									'Patient_Name' => $PatientDetailsRecord->FName . ' ' . $PatientDetailsRecord->LName,
									'document_id' => $Document ["document_id"],
									'document_title' => $Document ["document_title"],
									'document_detail' => $Document ["document_detail"],
									'Created_By' => $Document ["Created_By"],
									'created_on' => $Document ["created_on"],
									'Patient_Id' => $Document ["Patient_Id"],
									'Type' => $Document ["Type"] 
							);
						}
					}
					
					if ($PatientList != NULL && $PatientList != '') {
						foreach ( $PatientList as $Patient ) {
							$PatientArray [] = array (
									'Name' => $Patient->FName . ' ' . $Patient->LName,
									'Patient_Id' => $Patient->Patient_Id 
							);
						}
					}
				}
				 
				
				$PatientPresent = FALSE;
				
				if ($CaseDocumentList != NULL) 
				{
					foreach ( $CaseDocumentList as $SingleRec ) {
						if ($SingleRec ["Patient_Id"] != NULL && $SingleRec ["Patient_Id"] != '' && $SingleRec ["Patient_Id"] > 0) {
							$PatientPresent = TRUE;
							break;
						}
					}
				}
				
				
				
				
				$this->session->set_flashdata ( 'CaseMsg', $caseid );
				
				$PageUrl="cases/AttachDocuments/".$caseid;
				$this->session->set_flashdata ( 'CurrentUrl', $PageUrl);
				
				$data ['CaseDocList'] = $CaseDocumentList;
				$data ['PatientList'] = $PatientArray;
				$data ['Documents'] = $DocumentArray;
				$data ['PatientDetails'] = $patientDetails;
				$data ['Case'] = $CaseDetail;
				$data ['PHRStatus'] = $PatientPresent;
				$this->load->view ( 'attachcasedocuments', $data );
			} else {
				
				$this->load->view ( 'accessdenied' );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	// To Attach Documents
	public function AttachDocumentsPost($caseid) {
		 
		$user = $this->session->userdata ( 'user' );
		
		$SubmitValue = $this->input->post ( 'back' );
		if ($SubmitValue != NULL && $SubmitValue != '') {
			redirect ( 'cases/detail/' . $caseid, 'location' );
		}
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		if ($user != null) {
			$this->load->model ( 'CaseMaster' );
			$this->load->model ( 'PatientMaster' );
			
			$CaseDetail = $this->CaseMaster->getCasesById ( $caseid );
			$patientDetails = $this->PatientMaster->getPatientById ( $CaseDetail->Patient_Id );
			
			/*
			 * if ($this->form_validation->run () == FALSE)
			 * {
			 * $DocumentList = $this->CaseMaster->getDocumentsByUser($UserId);
			 * $PatientList = $this->CaseMaster->getPatientsByUser($UserId);
			 * $CaseDocumentList = $this->CaseMaster->getCaseDocuments($CaseDetail->id);
			 *
			 * $PatientArray= array();
			 * $DocumentArray=array();
			 *
			 * if($DocumentList !=NULL)
			 * {
			 *
			 * foreach ($DocumentList as $Document)
			 * {
			 * $PatientDetailsRecord=$this->PatientMaster->getPatientById($Document["Patient_Id"]);
			 * if($PatientDetailsRecord != NULL && $PatientDetailsRecord !='')
			 * {
			 * $DocumentArray[]=array(
			 * 'Patient_Name' => $PatientDetailsRecord->FName.' '.$PatientDetailsRecord->LName,
			 * 'document_id' => $Document["document_id"],
			 * 'document_title' => $Document["document_title"],
			 * 'document_detail' => $Document["document_detail"],
			 * 'Created_By' => $Document["Created_By"],
			 * 'created_on' => $Document["created_on"],
			 * 'Patient_Id' => $Document["Patient_Id"],
			 * 'Type' => $Document["Type"]
			 * );
			 * }
			 * }
			 *
			 *
			 * if($PatientList != NULL && $PatientList != '')
			 * {
			 * foreach ($PatientList as $Patient)
			 * {
			 * $PatientArray[]=array(
			 * 'Name' => $Patient->FName.' '.$Patient->LName,
			 * 'Patient_Id' =>$Patient->Patient_Id
			 * );
			 * }
			 * }
			 * }
			 *
			 * $data['CaseDocList']=$CaseDocumentList;
			 * $data['PatientList']=$PatientArray;
			 * $data['Documents']=$DocumentArray;
			 * $data['PatientDetails']=$patientDetails;
			 * $data['Case']=$CaseDetail;
			 * $this->load->view('attachcasedocuments',$data);
			 * return;
			 * }
			 */
			
			$Result = $this->CaseMaster->addCaseDocuments ( $caseid );
			
			$FinalMsg = 'Documents attached to the Case.';
			$MsgBit = "Success";
			$Message = array (
					'CaseId' => $caseId,
					'Message' => $FinalMsg,
					'ErrorBit' => $MsgBit 
			);
			
			$this->session->set_flashdata ( 'CaseUpdateMsg', $Message );
			
			redirect ( 'cases/detail/' . $caseid, 'location' );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	// Add the External Travel Insurance Case
	public function addExternalTravelCase() {
		//$this->load->helper ( 'geo_location_pi' );
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		$this->load->model ( 'CaseMaster' );
		
		$data ['Relations'] = $this->CaseMaster->getRelations ();
		$this->load->view ( 'travel_insurance', $data );
	}
	public function addExternalTravelCasePost() {
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		//$this->load->helper ( 'geo_location_pi' );
		$this->load->helper ( 'secureemail' );
		
		$this->form_validation->set_rules ( 'Fname', 'First Name', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'Lname', 'Last Name', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'Email', 'Email', 'trim|required|xss_clean|valid_email' );
		$this->form_validation->set_rules ( 'Mobile', 'Mobile', 'trim|required|xss_clean|max_length[20]' );
		
		$this->form_validation->set_rules ( 'Homecountry', 'Your Country', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'address', 'Address', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'Desticountry', 'Destination Country', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'ArivalDate', 'Arrival Date', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'StartDate', 'Start Date', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'EndDate', 'End Date', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'NoInsured', 'Nuber Of Insured', 'trim|required|xss_clean' );
		// $this->form_validation->set_rules ( 'Age', 'Age', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'relation', 'Relation', 'trim|required|xss_clean' );
		
		$this->load->model ( 'CaseMaster' );
		if ($this->form_validation->run () == FALSE) {
			$data ['Relations'] = $this->CaseMaster->getRelations ();
			
			$this->load->view ( 'travel_insurance', $data );
			return;
		}
		
		$UserEmail = $this->input->post ( 'Email' );
		$Result = $this->CaseMaster->addTravelCaseRequest ();
		
		if ($Result == TRUE && $UserEmail != NULL && $UserEmail != '') {
			// Send Email
			$CC = '';
			$EmailAddresTo = $UserEmail;
			$EmailAddressFrom = INFOEMAIL;
			$SubjectEmail = 'Your request For Insurance Quote';
			$BodyEmail = 'Your request for Insurance Quote is with us. We would process it and Let you Know the Details';
			
			$EmailNotification = array (
					'To' => $EmailAddresTo,
					'FROM' => $EmailAddressFrom,
					'CC' => $CC,
					'Subject' => $SubjectEmail,
					'Body' => $BodyEmail,
					'Type' => "",
					'Attach' => '' 
			);
			$ResultEmail = send_secured_email ( $EmailNotification );
			
			
			
			// Send Email to Admin
			$CC = '';
			$EmailAddresTo = INSURANCEEMAIL;
			$EmailAddressFrom = SYSTEMEMAIL;
			$SubjectEmail = 'Insurnace request';
				
				
			
			
			// Dates
				
			$TodayDate = date ( DATETIMEFORMAT );
				
			$BodyEmailAdmin = array (
					'HomeCountry' => $this->input->post ( 'Homecountry' ),
					'Date_Arrival' => date ( DATEFORMAT, strtotime ( $this->input->post ( 'ArivalDate' ) ) ),
					'Start_Date' => date ( DATEFORMAT, strtotime ( $this->input->post ( 'StartDate' ) ) ),
					'End_Date' => date ( DATEFORMAT, strtotime ( $this->input->post ( 'EndDate' ) ) ),
					'Destination_Country' => $this->input->post ( 'Desticountry' ),
					'Number_Insured' => $this->input->post ( 'NoInsured' ),
					'Age' => $this->input->post ( 'Age' ),
					'Address' => $this->input->post ( 'address' ),
					'Relation' => $this->input->post ( 'relation' ),
					'Name' => $this->input->post ( 'Fname' ).' '. $this->input->post ( 'Lname' ),
					'Email' => $this->input->post ( 'Email' ),
					'Mobile' => $this->input->post ( 'Mobile' ),
					'TodayDate' => $TodayDate
			);
				
			$EmailNotificationAdmin = array (
					'To' => $EmailAddresTo,
					'FROM' => $EmailAddressFrom,
					'CC' => $CC,
					'Subject' => $SubjectEmail,
					'Body' => $BodyEmailAdmin,
					'Type' => "Email_CC_TravelCase",
					'Attach' => ''
			);
			$ResultEmail = send_secured_email ( $EmailNotificationAdmin );
		}
		
		redirect ( 'pages/home', 'location' );
	}
	
	private function FilterExistingUserArray($UserList,$PatientArray)// method to add exisitng users to the list of existing patients.
	{
		
			$UserArray = array();
			$Count = count($PatientArray);
			foreach ($UserList as $SingleUsr)
			{
				//$result1 = array_search($SingleUsr->email, $PatientArray);
				$CreateBit = FALSE;
				foreach ($PatientArray as $Patient)
				{
					if ($SingleUsr->email != $Patient["Email"] && $SingleUsr->First_name != $Patient["FName"])
					{
						$CreateBit = TRUE;
					}
					else
					{
						if($SingleUsr->email == $Patient["Email"] && $SingleUsr->First_name != $Patient["FName"] )
						{
							$CreateBit = TRUE;
						}
						else
						{
							$CreateBit = FALSE;
							break;
						}
					}
				}
				if ($CreateBit == TRUE )
				{
					$UserArray [] = array (
							'DropdownId' => $Count,
							'FName' => $SingleUsr->First_name,
							'LName' => $SingleUsr->Last_Name,
							'Phone' => $SingleUsr->Mobile_Number,
							'Email' => $SingleUsr->email,
							'DOB' => date ( DATEFORMAT, strtotime ( $SingleUsr->Birth_Date ) ),
							'Gender' => $SingleUsr->Gender,
							'Relation' => '',
							'Country' => $SingleUsr->Country ,
							'Patient_Id' =>'',
							'Created_By' =>(($SingleUsr->Created_By != null)? $SingleUsr->Created_By : '')
								
					);
					$Count++;
				}
						
			}
			
			$AllPatient = array_merge($PatientArray,$UserArray);
			return  $AllPatient;
		}
	}

?>