<?php
class Doctors extends CI_Controller {
	// default action
	// We will show all patients created by user here
	public function index($offset = NULL) {
		
		$user = $this->session->userdata ( 'user' );
		
		if ($user != null) {
			
			if ($this->session->userdata ( 'user_type' ) == ADMIN || $this->session->userdata ( 'user_type' ) == ADMINUSER  || $user->User_Type == 7 /*Doctor Coordinator */) {
				$this->session->set_userdata ( 'activeMenu', "docmgt" );
				$this->load->model ( 'DoctorMaster' );
				$doctorArray = array ();
				if($user->User_Type == 7) {
					$doctorRecords = $this->DoctorMaster->getDoctorsByCurrentUser();
				} else {
					$doctorRecords = $this->DoctorMaster->getDoctorsByUser();
				}

				$SpecialitiesDB = $this->DoctorMaster->getAllSpecialities ();
					
				foreach ( $doctorRecords as $doctor ) {
					$docspecail = explode ( ',', $doctor->Speciality );
					$Speciality =$doctor->Speciality ;// $this->Speciality ( $docspecail, $SpecialitiesDB );
					
					$AddInfo = base_url ( "doctors/profiledetails/" . $doctor->Doctor_Id );
					
					$UrlName = $this->MakeUrlNameforDoctor ( $doctor->DName );
					$DoctorProfile = $this->DoctorMaster->getDoctorProfileDetails ( $doctor->Doctor_Id );

					$doctorArray [] = array (
							'Doctor_Id' => $doctor->Doctor_Id,
							'DName' => $doctor->DName,
							'Qualification' => $doctor->Qualification,
							'Speciality' => $Speciality,
							'Email' => $doctor->Email,
							'UrlName' => $UrlName,
							'MoreInfo' => $AddInfo ,
							'Visible' => $DoctorProfile->Visible,
							'ImgName' => $doctor->DImagePath,
							'User_Id' => $doctor->User_Id,
							'assigned' => $doctor->assigned,
							'closed' => $doctor->closed
					);
				}
				
				$MessageDetails = $this->session->flashdata ( 'DoctorMsg' );
				
				if ($MessageDetails == NUll) {
					$Message = array (
							'CaseId' => '',
							'Message' => '',
							'ErrorBit' => '' 
					);
				} else {
					$Message = array (
							'CaseId' => $MessageDetails ['CaseId'],
							'Message' => $MessageDetails ['Message'],
							'ErrorBit' => $MessageDetails ['ErrorBit'] 
					);
				}
				
				$data ['CaseMessage'] = $Message;
				
				$data ['doctors'] = $doctorArray;
				$data ['user']=$user;
				if($user->User_Type == 7){
				$this->load->view("doctorlist_doctorcoordinator", $data);
				} else {
				$this->load->view ( 'doctorlist', $data );
				}
			} else {
				$this->load->view ( 'accessdenied' );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	// To Assign Speciality of Doctor
	private function Speciality($Idvalues, $DbSpecialities) {
		$DrSpecial = '';
		
		foreach ( $Idvalues as $SingleRecord ) {
			foreach ( $DbSpecialities as $Specilality ) {
				if ($Specilality ['id'] == $SingleRecord) {
					$BracketPosition = strpos ( $Specilality ['name'], '(' );
					if ($BracketPosition === false) {
						$DrSpecial = $DrSpecial . $Specilality ['name'] . ',';
						break;
					} else {
						$DrSpecial = substr ( $Specilality ['name'], 0, $BracketPosition - 1 ) . ',';
						break;
					}
				}
			}
		}
		
		return trim ( $DrSpecial, ',' );
	}
	
	// To Make URl for Doctor
	private function MakeUrlNameforDoctor($DoctorName) {
		$FinalName = '';
		
		// $FinalNameArray=array();
		
		$DoctorNameArray = explode ( ' ', $DoctorName );
		$FindChar = '.';
		
		// Loop to Eliminate Character
		foreach ( $DoctorNameArray as $SingleWord ) {
			$CharPosition = strpos ( $SingleWord, $FindChar );
			
			if ($CharPosition !== FALSE) {
				// Remove that character Position
				$TempWord = substr_replace ( $SingleWord, '', $CharPosition, 1 );
				$ProcessedName = $TempWord;
			} else {
				$ProcessedName = ($SingleWord);
			}
			
			if ($FinalName != '') {
				$FinalName = $FinalName . '-' . $ProcessedName;
			} else {
				$FinalName = $ProcessedName;
			}
		}
		
		return $FinalName;
	}
	public function detail($id) {
		
		$user = $this->session->userdata ( 'user' );
		
		if ($user != null) {
			$this->load->model ( 'DoctorMaster' );
			$doctor = $this->DoctorMaster->getDoctorById ( $id );
			$SpecialitiesDB = $this->DoctorMaster->getAllSpecialities ();
			$docspecail = explode ( ',', $doctor->Speciality );
			$data ['Speciality'] = $doctor->Speciality;//$this->Speciality ( $docspecail, $SpecialitiesDB );
			$data ['doctors'] = $doctor;
			
			$MessageDetails = $this->session->flashdata ( 'DoctorMsg' );
			
			if ($MessageDetails == NUll) {
				$Message = array (
						'CaseId' => '',
						'Message' => '',
						'ErrorBit' => '' 
				);
			} else {
				$Message = array (
						'CaseId' => $MessageDetails ['CaseId'],
						'Message' => $MessageDetails ['Message'],
						'ErrorBit' => $MessageDetails ['ErrorBit'] 
				);
			}
			
			$data ['CaseMessage'] = $Message;
			
			$this->load->view ( 'doctordetail', $data );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function add() {
		
		$user = $this->session->userdata ( 'user' );
		
		if ($user != null) {
			if ($this->session->userdata ( 'user_type' ) == ADMIN || $this->session->userdata ( 'user_type' ) == ADMINUSER || $this->session->userdata ( 'user_type' ) == 7 /*DOCTOR COORDINATOR */) {
				$this->load->helper ( 'form' );
				$this->load->helper ( 'file' );
				$this->load->library ( 'form_validation' );
				$this->load->model ( 'DoctorMaster' );
				
				$data ['Speciality'] = $this->DoctorMaster->getAllSpecialities ();
				$data["user"]=$user;
				$this->load->view ( 'doctoradd', $data );
			} else {
				$this->load->view ( 'accessdenied' );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function addpost() {
		
		$user = $this->session->userdata ( 'user' );
		
		$SubmitValue = $this->input->post ( 'back' );
		if ($SubmitValue != NULL && $SubmitValue != '') {
			redirect ( 'doctors', 'location' );
		}
		
		$this->load->helper ( 'form' );
		$this->load->helper ( 'file' );
		$this->load->library ( 'form_validation' );
		
		// Upload
		$config ['upload_path'] = './images/doctors/';
		$config ['allowed_types'] = 'gif|jpg|png|jpeg';
		//$config ['max_size'] = '200';
		//$config ['max_width'] = '300';
		//$config ['max_height'] = '300';
		$config ['overwrite'] = TRUE;
		
		$this->load->library ( 'upload', $config );
		
		if($user->User_Type!=7) /* Doctor Coordinator - its their own email used always */ {
			$this->form_validation->set_rules ( 'email', 'Email', 'trim|required|xss_clean|valid_email|callback__check_existing_user' );
		}

		$this->form_validation->set_rules ( 'Fname', 'First Name', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'Lname', 'Last Name', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'qualification', 'Qualification', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'speciality', 'Speciality', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'phone', 'Phone', 'trim|required|xss_clean|max_length[20]' );
		// $this->form_validation->set_rules ( 'referraltoGO', 'referraltoGO', 'trim|required|xss_clean|max_length[20]' );
		// $this->form_validation->set_rules ( 'password1', 'Password', 'trim|required|xss_clean|min_length[6]|matches[password2]|md5' );
		// $this->form_validation->set_rules ( 'password2', 'Password Confirmation', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'dimg', 'Doctors Picture', 'callback__validate_uploadpic' );
		
		if ($user != null) {
			$this->load->model ( 'DoctorMaster' );
			
			if ($this->form_validation->run () == FALSE) {
				$data ['Speciality'] = $this->DoctorMaster->getAllSpecialities ();
				$this->load->view ( 'doctoradd', $data );
				return;
			}
			
			if (isset ( $_FILES ['dimg'] ) && ! empty ( $_FILES ['dimg'] ['name'] )) {
				$ProfilePicName = $_FILES ['dimg'] ['name'];
			} else {
				$ProfilePicName = NULL;
			}
			
			$Passwords = $this->GenerateRandomPassword ();
			$Result1 = $this->DoctorMaster->add ( $ProfilePicName, $Passwords ["PassHash"] );
			
			$Password2 = $Passwords ["Password"];
			
			$TodayDate = date ( DATETIMEFORMAT );
			// Send Email To Doctor
			$Body = array (
					'Name' => $this->input->post ( 'Fname' ) . ' ' . $this->input->post ( 'Lname' ),
					'Email' => $this->input->post ( 'email' ),
					'Password' => $Password2,
					'User_Id' => $Result1,
					'TimeStamp' => date ( DATEFORMAT, strtotime ( $TodayDate ) ) 
			);
			
			$this->load->helper ( 'secureemail' );
			$CC = '';
			$EmailAddresTo = $this->input->post ( 'email' );
			$EmailAddressFrom = INFOEMAIL;
			$SubjectEmail = 'Welcome to GrandOpinion';
			/*$BodyEmail = 'Your login credetials are as follows - Username: ' . $EmailAddresTo . '  and Password-' . $Password2 . '. Please Change once you Login';*/
			$EmailNotification = array (
					'To' => $EmailAddresTo,
					'FROM' => $EmailAddressFrom,
					'CC' => $CC,
					'Subject' => $SubjectEmail,
					'Body' => $Body,
					'Type' => 'Email_NewDoctor',
					'Attach' => '' 
			);
			$ResultEmail = send_secured_email ( $EmailNotification );
			
			// Audit Trail
			$this->load->model ( 'AuditTrailMaster' );
			$ControllerData = array (
					'Controller' => $this->router->class,
					'Action' => 'New Doctor created with User ID - '.$Result1.' by user '.$user->First_name.' '.$user->Last_Name.' type \''.$user->User_Type.'\'' //$this->router->method' 
			)
			;
			$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
			
			// Set Flash Message
			
			$FinalMsg = 'New Doctor Created in the System. A Welcome email has been sent to the doctor.';
			$MsgBit = "Success";
			$Message = array (
					'CaseId' => '',
					'Message' => $FinalMsg,
					'ErrorBit' => $MsgBit 
			);
			
			$this->session->set_flashdata ( 'DoctorMsg', $Message );
			
			redirect ( 'doctors', 'location' );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	private function GenerateRandomPassword() {
		$characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
		$charactersLength = strlen ( $characters );
		$randomString = '';
		for($i = 0; $i < 8; $i ++) {
			$randomString .= $characters [rand ( 0, $charactersLength - 1 )];
		}
		// echo $randomString;
		
		$this->load->helper ( 'security' );
		$PasswordHash = do_hash ( $randomString, 'md5' );
		// echo $PasswordHash;
		
		$PasswordArray = array (
				'Password' => $randomString,
				'PassHash' => $PasswordHash 
		);
		
		// print_r($PasswordArray) ;
		return $PasswordArray;
	}
	public function _check_existing_user($email) {
		$this->load->model ( 'UserMaster' );
		$user = $this->UserMaster->get_user_by_email ( $email );
		if (count ( $user ) > 0) {
			$this->form_validation->set_message ( '_check_existing_user', 'The email address ' . $email . ' is already registered with us.
					                                            Please use another Email-ID.' );
			return FALSE;
		} else {
			return TRUE;
		}
	}
	
	public function _check_existing_user_edit($email) 
	{
		$this->load->model ( 'DoctorMaster' );
		$DoctorRecord = $this->DoctorMaster->getDoctorById ( $this->input->post('DoctorId') );
		
		if(strtolower($DoctorRecord->Email) == strtolower($email))
		{
			return TRUE;
		}
		else 
		{
			$this->load->model ( 'UserMaster' );
			$user = $this->UserMaster->get_user_by_email ( $email );
			if (count ( $user ) > 0) {
				$this->form_validation->set_message ( '_check_existing_user_edit', 'The email address ' . $email . ' is already registered with us.
					                                            Please use another Email-ID.' );
				return FALSE;
			} else {
				return TRUE;
			}
		}
	}
	
	
	public function _validate_uploadpic() {
		$FisrtName = $this->input->post ( 'Fname' );
		$LastName = $this->input->post ( 'Lname' );
		$DName = $this->input->post ( 'Dname' );
		if ($DName != NULL) {
			$UploadName = $DName;
		} else {
			$UploadName = $FisrtName . ' ' . $LastName;
		}
		
		$DImage = $this->input->post ( 'DImgName' );
		
		if (isset ( $_FILES ['dimg'] ) && ! empty ( $_FILES ['dimg'] ['name'] )) {
			// $FileExt=new SplFileInfo($_FILES['dimg']['name']);
			// $UploadFileName=$UploadName.'.'.$FileExt->getExtension();
			// $_FILES['dimg']['name']=$UploadFileName;
			
			if (! $this->upload->do_upload ( 'dimg' )) {
				$error = array (
						'error' => $this->upload->display_errors () 
				);
				
				$FinalErrors = implode ( '<br/>', $error );
				$this->form_validation->set_message ( '_validate_uploadpic', $FinalErrors );
				return FALSE;
			} else {
				$this->form_validation->set_message ( '_validate_uploadpic', 'The document was uploaded successfully.' );
				return TRUE;
			}
		} else {
			if ($DImage != NULL) {
				$this->form_validation->set_message ( '_validate_uploadpic', 'The document was uploaded successfully.' );
				return TRUE;
			} else {
				$this->form_validation->set_message ( '_validate_uploadpic', "You must upload an image!" );
				return TRUE;
			}
		}
	}
	public function doctorEdit($id) {
		
		$user = $this->session->userdata ( 'user' );
		
		if ($user != null) {
			if ($user->User_Type == ADMIN || $user->User_Type == ADMINUSER ) 
			{
				$this->load->helper ( 'form' );
				$this->load->library ( 'form_validation' );
				$this->load->helper ( 'file' );
				$this->load->model ( 'DoctorMaster' );
				$DoctorRecord = $this->DoctorMaster->getDoctorById ( $id );
				
				$DoctorArray = array (
						'DName' => $DoctorRecord->DName,
						'Doctor_Id' => $DoctorRecord->Doctor_Id,
						'Gender' => $DoctorRecord->Gender,
						'Qualification' => $DoctorRecord->Qualification,
						'Speciality' => $DoctorRecord->Speciality,
						'Email' => $DoctorRecord->Email,
						'Phone' => $DoctorRecord->Phone,
						'User_Id' => $DoctorRecord->User_Id,
						'DImagePath' => $DoctorRecord->DImagePath,
					'ReferraltoGO' => $DoctorRecord->ReferraltoGO,
					'PayoutOpinion' => $DoctorRecord->PayoutOpinion,
					'PayoutConsult' => $DoctorRecord->PayoutConsult 
				);
				$data ['doctors'] = $DoctorArray;
				$data ['UserType'] = $user->User_Type;
				$data ['specialities'] = $this->DoctorMaster->getAllSpecialities ();
				$this->load->view ( 'doctoredit', $data );
			} else {
				$this->load->view ( 'accessdenied' );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function doctorEditSubmit($id) {
		
		$user = $this->session->userdata ( 'user' );
		
		$SubmitValue = $this->input->post ( 'back' );
		if ($SubmitValue != NULL && $SubmitValue != '') {
			redirect ( 'doctors/detail/' . $id, 'location' );
		}
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		$this->load->helper ( 'file' );
		
		// Upload
		$config ['upload_path'] = './images/doctors/';
		$config ['allowed_types'] = 'gif|jpg|png|jpeg';
		//$config ['max_size'] = '200';
		//$config ['max_width'] = '300';
		//$config ['max_height'] = '300';
		$config ['overwrite'] = TRUE;
		
		$this->load->library ( 'upload', $config );
		
		$this->form_validation->set_rules ( 'email', 'Email', 'trim|required|xss_clean|valid_email|callback__check_existing_user_edit' );
		$this->form_validation->set_rules ( 'Dname', 'First Name', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'qualification', 'Qualification', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'special', 'Speciality', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'phone', 'Phone', 'trim|required|xss_clean|max_length[20]' );
		
		if ($user != null) {
			$this->load->model ( 'DoctorMaster' );
			$DoctorRecord = $this->DoctorMaster->getDoctorById ( $id );
			$this->form_validation->set_rules ( 'dimg', 'Doctors Picture', 'callback__validate_uploadpic' );
			
			if ($this->form_validation->run () == FALSE) {
				
				$DoctorArray = array (
						'DName' => $this->input->post ( 'Dname' ),
						'Doctor_Id' => $id,
						'Gender' => $this->input->post ( 'gender' ),
						'Qualification' => $this->input->post ( 'qualification' ),
						'Speciality' => $this->input->post ( 'special' ),
						'Email' => $this->input->post ( 'email' ),
						'Phone' => $this->input->post ( 'phone' ),
						'User_Id' => $DoctorRecord->User_Id,
						'DImagePath' => $this->input->post ( 'dimg' ) 
				);
				
				$data ['doctors'] = $DoctorArray;
				$data ['UserType'] = $user->User_Type;
				$data ['specialities'] = $this->DoctorMaster->getAllSpecialities ();
				// print_r($id);
				$this->load->view ( 'doctoredit', $data );
				return;
			}
			
			if (isset ( $_FILES ['dimg'] ) && ! empty ( $_FILES ['dimg'] ['name'] )) {
				$ProfilePicName = $_FILES ['dimg'] ['name'];
			} else if ($DoctorRecord->DImagePath != NULL) {
				$ProfilePicName = $DoctorRecord->DImagePath;
			} else {
				$ProfilePicName = NULL;
			}
			
			$DoctorNameArray=explode(' ',$this->input->post ( 'Dname' ));
			$DFName='';
			$DLName='';
			$Countarray=count($DoctorNameArray)-1;
			
			for($i=0 ; i<$Countarray; $i++)
			{
				if($i==$Countarray)
				{
					$DLName=$DoctorNameArray[$i];
					break;
				}
				else 
				{
					if($i==0)
					{
						$DFName=$DoctorNameArray[$i];
					}
					else 
					{
						$DFName=$DFName.' '.$DoctorNameArray[$i];
					}
					
				}
				
			}
			
			$DoctorsSplitName=array(
					'FName' => $DFName,
					'LName' => $DLName
			);
			
			$Result = $this->DoctorMaster->EditDoctorDetail ( $id, $ProfilePicName ,$DoctorsSplitName);
			
			// Add Audit Trail
			$this->load->model ( 'AuditTrailMaster' );
			$ControllerData = array (
					'Controller' => $this->router->class,
					'Action' => 'Doctor with Id - '.$id.' details edited  by user-'.$user->First_name.' '.$user->Last_Name.'  who is  type-'.$user->User_Type //$this->router->method' 
			)
			;
			$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
			
			// Set Flash Message
			$FinalMsg = 'Doctor Information Updated Successfully.';
			$MsgBit = "Success";
			
			$Message = array (
					'CaseId' => '',
					'Message' => $FinalMsg,
					'ErrorBit' => $MsgBit 
			);
			
			$this->session->set_flashdata ( 'DoctorMsg', $Message );
			
			redirect ( 'doctors/detail/' . $id, 'location' );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	
	public function checkEmail()
	{
	
		$user = $this->session->userdata ( 'user' );
	
		if ($user != NULL)
		{
			$this->load->model ( 'UserMaster' );
			
			$Email=$this->input->post('Email');
			$UserDetails = $this->UserMaster->get_user_by_email ( $Email );
			
			$Message=array(
					'Msg' => '<span style="color:#05961A;"><b>Email Available</b><span>'
			);
			
			if($UserDetails != NULL && $UserDetails != '')
			{
				$Message=array(
					'Msg' => '<span style="color:Red;"><b>Email not available.<br>Try another Email.</b><span>'
					);
			}
			
			$this->output->set_header('Content-Type: application/json; charset=utf-8');
			echo json_encode($Message);
				
		} else {
	
			redirect ( 'users/login', 'location' );
		}
	}
	
	public function getcases() {
		
		$user = $this->session->userdata ( 'user' );
		
		if ($user != null) {
			$this->session->set_userdata ( 'activeMenu', "assigncase" );
			$this->load->model ( 'CaseMaster' );
			$this->load->model ( 'DoctorMaster' );
			$this->load->model ( 'PatientMaster' );
			$casesArray = array ();
			
			$searchdata = $this->input->get ( 'searchtext', TRUE );
			
			// If Searched Then else normal code
			if ($searchdata != FALSE && $searchdata != '' && $searchdata != NULL) {
				$casesArray = $this->Search ( $searchdata );
			} else if ($user->User_Type==7) { 

				$User_Id = $this->session->userdata ( 'user_id' );
				$CasesRecords = $this->DoctorMaster->getCasesForCoordinator ( );
				
				foreach ( $CasesRecords as $SingleCase ) {
					$PatientDetail = $this->PatientMaster->getPatientById ( $SingleCase ["Patient_Id"] );
					
					if ($PatientDetail != NULL) {
						$casesArray [] = array (
								'patient_first_name' => $PatientDetail->FName,
								'patient_last_name' => $PatientDetail->LName,
								'patient_contact_number' => $PatientDetail->Phone,
								'Patient_Id' => $SingleCase ["Patient_Id"],
								'Case_Id' => $SingleCase ["Case_Id"],
								'type' => $SingleCase ["type"],
								'Case_Date' => date ( DATEFORMAT, strtotime ( $SingleCase ["Case_Date"] ) ),
								'status' => $SingleCase ["status"] 
						);
					}
				}

			} else {
				// method to get DocId from USer
				$User_Id = $this->session->userdata ( 'user_id' );
				$DocDetail = $this->DoctorMaster->getDoctorsByUserId ( $User_Id );
				$CasesRecords = $this->DoctorMaster->getAllCasesForDoctor ( $DocDetail->Doctor_Id ); // DoctorId
				
				foreach ( $CasesRecords as $SingleCase ) {
					$PatientDetail = $this->PatientMaster->getPatientById ( $SingleCase ["Patient_Id"] );
					
					if ($PatientDetail != NULL) {
						$casesArray [] = array (
								'patient_first_name' => $PatientDetail->FName,
								'patient_last_name' => $PatientDetail->LName,
								'patient_contact_number' => $PatientDetail->Phone,
								'Patient_Id' => $SingleCase ["Patient_Id"],
								'Case_Id' => $SingleCase ["Case_Id"],
								'type' => $SingleCase ["type"],
								'Case_Date' => date ( DATEFORMAT, strtotime ( $SingleCase ["Case_Date"] ) ),
								'status' => $SingleCase ["status"] 
						);
					}
				}
			}
			$data ['cases'] = $casesArray;
			$data["user"]=$user;
			// print_r($data['cases']);
			$this->load->view ( 'doctorcaselist', $data );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	public function addComment($id) {
		
		$user = $this->session->userdata ( 'user' );
		
		if ($user != null) {
			$this->load->helper ( 'form' );
			$this->load->library ( 'form_validation' );
			$this->load->model ( 'CaseMaster' );
			$this->load->model ( 'NoteMaster' );
			$this->load->model ( 'PatientMaster' );
			$this->load->model ( 'DoctorMaster' );
			
			$CaseDetail = $this->CaseMaster->getCasesById ( $id );
			$this->session->set_userdata ( 'case', $CaseDetail );
			// Get User Type
			$UserType = $this->session->userdata ( 'user_type' );
			
			$doctorName = '';
			$doctorId = '';
			if ($CaseDetail->Doctor_Id != NULL && $CaseDetail->Doctor_Id != '') {
				$doctor = $this->DoctorMaster->getDoctorById ( $CaseDetail->Doctor_Id );
				
				$doctorId = $doctor->Doctor_Id;
				$doctorName = $doctor->DName;
			}
			
			$patientDetails = $this->PatientMaster->getPatientById ( $CaseDetail->Patient_Id );
			$relation = $this->CaseMaster->getRelationsById ( $patientDetails->Relation );
			
			$case = array (
					'patient_first_name' => $patientDetails->FName,
					'patient_last_name' => $patientDetails->LName,
					'Patient_Id' => $CaseDetail->Patient_Id,
					'patient_contact_number' => $patientDetails->Phone,
					'relation' => $relation->name,
					'patient_gender' => $patientDetails->Gender,
					'patient_birth_date' => date ( DATEFORMAT, strtotime ( $patientDetails->DOB ) ),
					'patient_email' => $patientDetails->Email,
					'patient_country' => $patientDetails->Country,
					'id' => $CaseDetail->id,
					'medical_query' => $CaseDetail->medical_query,
					'type' => $CaseDetail->type,
					'Case_Date' => date ( DATEFORMAT, strtotime ( $CaseDetail->Case_Date ) ),
					'status' => $CaseDetail->status,
					'plan' => $CaseDetail->plan,
					'is_paid' => $CaseDetail->is_paid,
					'UserType' => $UserType,
					'Doctor_Id' => $doctorId,
					'DName' => $doctorName 
			)
			;
			
			
			// To Pull List Of Documents
			$CaseDocuments = $this->CaseMaster->getCaseDocuments ( $id );
			$PHREnable = FALSE;
			$DocumentList = NUll;
			
			if ($CaseDocuments != NULL && $CaseDocuments != '') {
				$DocIdList = array ();
				$CaseDocumentCreator='';
					
				foreach ( $CaseDocuments as $SingleDoc ) {
			
					array_push ( $DocIdList, $SingleDoc ["Document_Id"] );
			
					$CaseDocumentCreator=$SingleDoc ["Created_By"];
					if ($PHREnable != TRUE) {
						if ($SingleDoc ["Patient_Id"] != NULL && $SingleDoc ["Patient_Id"] != '' && $SingleDoc ["Patient_Id"] > 0) {
							$PHREnable = TRUE;
						}
					}
				}
					
				// Gettin Documents from Doc table
				$DocumentList = $this->CaseMaster->getCaseDocumentsDeatils ( $CaseDocumentCreator, $DocIdList );
			}
			
			$data ["DocumentList"] = $DocumentList;
			$data ["PHRStatus"] = $PHREnable;
			
			$data ['case'] = $case;
			$data ['notes'] = $this->NoteMaster->getNotesByCase ( $id );
			$this->load->view ( 'doctorcaseadd', $data );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function addCommentpost($id) {
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		$user = $this->session->userdata ( 'user' );
		
		$SubmitValue = $this->input->post ( 'back' );
		if ($SubmitValue != NULL && $SubmitValue != '') {
			redirect ( 'doctors/CasedetailDoc/' . $id, 'location' );
		}
		
		$this->form_validation->set_rules ( 'comment', 'Medical Opinion', 'trim|required|xss_clean' );
		
		if ($user != null) {
			
			$this->load->model ( 'DoctorMaster' );
			
			if ($this->form_validation->run () == FALSE) {
				
				$this->load->model ( 'NoteMaster' );
				$this->load->model ( 'PatientMaster' );
				$this->load->model ( 'CaseMaster' );
				
				$CaseDetail = $this->CaseMaster->getCasesById ( $id );
				$this->session->set_userdata ( 'case', $CaseDetail );
				// Get User Type
				$UserType = $this->session->userdata ( 'user_type' );
				
				$doctorName = '';
				$doctorId = '';
				if ($CaseDetail->Doctor_Id != NULL && $CaseDetail->Doctor_Id != '') {
					$doctor = $this->DoctorMaster->getDoctorById ( $CaseDetail->Doctor_Id );
					
					$doctorId = $doctor->Doctor_Id;
					$doctorName = $doctor->DName;
				}
				
				$patientDetails = $this->PatientMaster->getPatientById ( $CaseDetail->Patient_Id );
				$relation = $this->CaseMaster->getRelationsById ( $patientDetails->Relation );
				
				$case = array (
						'patient_first_name' => $patientDetails->FName,
						'patient_last_name' => $patientDetails->LName,
						'Patient_Id' => $CaseDetail->Patient_Id,
						'patient_contact_number' => $patientDetails->Phone,
						'relation' => $relation->name,
						'patient_gender' => $patientDetails->Gender,
						'patient_birth_date' => date ( DATEFORMAT, strtotime ( $patientDetails->DOB ) ),
						'patient_email' => $patientDetails->Email,
						'patient_country' => $patientDetails->Country,
						'id' => $CaseDetail->id,
						'medical_query' => $CaseDetail->medical_query,
						'type' => $CaseDetail->type,
						'Case_Date' => date ( DATEFORMAT, strtotime ( $CaseDetail->Case_Date ) ),
						'status' => $CaseDetail->status,
						'plan' => $CaseDetail->plan,
						'is_paid' => $CaseDetail->is_paid,
						'UserType' => $UserType,
						'Doctor_Id' => $doctorId,
						'DName' => $doctorName 
				)
				;
				
				// To Pull List Of Documents
				$CaseDocuments = $this->CaseMaster->getCaseDocuments ( $id );
				$PHREnable = FALSE;
				$DocumentList = NUll;
				
				if ($CaseDocuments != NULL && $CaseDocuments != '') {
					$DocIdList = array ();
					$CaseDocumentCreator='';
						
					foreach ( $CaseDocuments as $SingleDoc ) {
				
						array_push ( $DocIdList, $SingleDoc ["Document_Id"] );
				
						$CaseDocumentCreator=$SingleDoc ["Created_By"];
						if ($PHREnable != TRUE) {
							if ($SingleDoc ["Patient_Id"] != NULL && $SingleDoc ["Patient_Id"] != '' && $SingleDoc ["Patient_Id"] > 0) {
								$PHREnable = TRUE;
							}
						}
					}
						
					// Gettin Documents from Doc table
					$DocumentList = $this->CaseMaster->getCaseDocumentsDeatils ( $CaseDocumentCreator, $DocIdList );
				}
				
				$data ["DocumentList"] = $DocumentList;
				$data ["PHRStatus"] = $PHREnable;
				
				$data ['case'] = $case;
				$data ['notes'] = $this->NoteMaster->getNotesByCase ( $id );
				$this->load->view ( 'doctorcaseadd', $data );
				return;
			}
			
			$DocDetail = $this->DoctorMaster->getDoctorsByUserId ( $this->session->userdata ( 'user_id' ) );
			
			$case = array (
					'Case_Id' => $id,
					'Doctor_Id' => $DocDetail->Doctor_Id 
			);
			
			$caseId = $this->DoctorMaster->addComments ( $case );
			
			// Add Audit Trail
			$this->load->model ( 'AuditTrailMaster' );
			$ControllerData = array (
					'Controller' => $this->router->class,
					'Action' => 'Dr'.$user->First_name.' '.$user->Last_Name.' added the comments for the case- '.$id 
			)
			;
			$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
			
			// Set Flash Message
			$FinalMsg = 'The Consultation added Successfully.';
			$MsgBit = "Success";
			$Message = array (
					'CaseId' => '',
					'Message' => $FinalMsg,
					'ErrorBit' => $MsgBit 
			);
			
			$this->session->set_flashdata ( 'DoctorCaseMsg', $Message );
			redirect ( 'doctors/CasedetailDoc/' . $id, 'location' );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	// Doctor Case Detail
	public function CasedetailDoc($id) {
		
		$user = $this->session->userdata ( 'user' );
		
	    $DoctorId = $this->session->userdata ( 'Doctor_Id' );
		
		if ($user != null) {
			
			$SubmitValue = $this->input->post ( 'back' );
			if ($SubmitValue != NULL && $SubmitValue != '') {
				redirect ( 'case/detail/' . $id, 'location' );
			}
			
			$this->load->helper ( 'form' );
			$this->load->library ( 'form_validation' );
			
			$this->load->model ( 'CaseMaster' );
			$this->load->model ( 'NoteMaster' );
			$this->load->model ( 'PatientMaster' );
			$this->load->model ( 'DoctorMaster' );
			
			$CaseDetail = $this->CaseMaster->getCasesById ( $id );
			// Get User Type
			$UserType = $user->User_Type;
			
			
			$doctorName = '';
			$doctorId = '';
			if ($CaseDetail->Doctor_Id != NULL && $CaseDetail->Doctor_Id != '') {
				$doctor = $this->DoctorMaster->getDoctorById ( $CaseDetail->Doctor_Id );
				
				$doctorId = $doctor->Doctor_Id;
				$doctorName = $doctor->DName;
			}
			
			$patientDetails = $this->PatientMaster->getPatientById ( $CaseDetail->Patient_Id );
			$relation = $this->CaseMaster->getRelationsById ( $patientDetails->Relation );
			
			$case = array (
					'patient_first_name' => $patientDetails->FName,
					'patient_last_name' => $patientDetails->LName,
					'Patient_Id' => $CaseDetail->Patient_Id,
					'patient_contact_number' => $patientDetails->Phone,
					'relation' => $relation->name,
					'patient_gender' => $patientDetails->Gender,
					'patient_birth_date' => date ( DATEFORMAT, strtotime ( $patientDetails->DOB ) ),
					'patient_email' => $patientDetails->Email,
					'patient_country' => $patientDetails->Country,
					'id' => $CaseDetail->id,
					'medical_query' => $CaseDetail->medical_query,
					'type' => $CaseDetail->type,
					'Case_Date' => date ( DATEFORMAT, strtotime ( $CaseDetail->Case_Date ) ),
					'status' => $CaseDetail->status,
					'plan' => $CaseDetail->plan,
					'is_paid' => $CaseDetail->is_paid,
					'UserType' => $UserType,
					'Doctor_Id' => $doctorId,
					'doctor' => $doctor,
					'DName' => $doctorName 
			)
			;
			
			$primarydoc = FALSE;
			if($case["Doctor_Id"] == $DoctorId)
			{
				$primarydoc = TRUE;
			}
			$data['primarydoc'] = $primarydoc;
			
			// To Pull List Of Documents
			$CaseDocuments = $this->CaseMaster->getCaseDocuments ( $id );
			$PHREnable = FALSE;
			$DocumentList = NUll;
			
			if ($CaseDocuments != NULL && $CaseDocuments != '') {
				$DocIdList = array ();
				$CaseDocumentCreator='';
					
				foreach ( $CaseDocuments as $SingleDoc ) {
			
					array_push ( $DocIdList, $SingleDoc ["Document_Id"] );
			
					$CaseDocumentCreator=$SingleDoc ["Created_By"];
					if ($PHREnable != TRUE) {
						if ($SingleDoc ["Patient_Id"] != NULL && $SingleDoc ["Patient_Id"] != '' && $SingleDoc ["Patient_Id"] > 0) {
							$PHREnable = TRUE;
						}
					}
				}
					
				// Gettin Documents from Doc table
				$DocumentList = $this->CaseMaster->getCaseDocumentsDeatils ( $CaseDocumentCreator, $DocIdList );
			}
			
			$data ["DocumentList"] = $DocumentList;
			$data ["PHRStatus"] = $PHREnable;
			
		
			$comments = $this->DoctorMaster->getAllCommentsOnCase ( $CaseDetail->id );
		
			
			$data ['case'] = $case;
			$data ['Casecomments'] = $comments;
			
			$MessageDetails = $this->session->flashdata ( 'DoctorCaseMsg' );
			
			if ($MessageDetails == NUll) {
				$Message = array (
						'CaseId' => '',
						'Message' => '',
						'ErrorBit' => '' 
				);
			} else {
				$Message = array (
						'CaseId' => $MessageDetails ['CaseId'],
						'Message' => $MessageDetails ['Message'],
						'ErrorBit' => $MessageDetails ['ErrorBit'] 
				);
			}
			
			$data ['CaseMessage'] = $Message;
			
			//--- To Show/hide Add Consult or Edit Consult button --- //
			
			$Show = array(
			'Add' => TRUE
			);
			
			foreach ($comments as $SingleComment) {
				
				if ($SingleComment["Doctor_Id"] == $DoctorId) {
					
					if($SingleComment["Comment"] != NULL && $SingleComment["Comment"] != '') {
						
						$Show["Add"]= FALSE;
						break;
					}
					
				}
				
			}
			$data ['Show'] = $Show;
			$data["user"]=$user;
			
			$this->load->view ( 'doctorcasedetail', $data );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function editCasedetail($id) {
		
		$user = $this->session->userdata ( 'user' );
		
		if ($user != null) {
			$this->load->helper ( 'form' );
			$this->load->library ( 'form_validation' );
			$this->load->model ( 'CaseMaster' );
			$this->load->model ( 'NoteMaster' );
			$this->load->model ( 'PatientMaster' );
			$this->load->model ( 'DoctorMaster' );
			
			$CaseDetail = $this->CaseMaster->getCasesById ( $id );
			$this->session->set_userdata ( 'case', $CaseDetail );
			// Get User Type
			$UserType = $this->session->userdata ( 'user_type' );
			$DoctorId = $this->session->userdata ( 'Doctor_Id' );
			
			$doctorName = '';
			$doctorId = '';
			if ($CaseDetail->Doctor_Id != NULL && $CaseDetail->Doctor_Id != '') {
				$doctor = $this->DoctorMaster->getDoctorById ( $CaseDetail->Doctor_Id );
				
				$doctorId = $doctor->Doctor_Id;
				$doctorName = $doctor->DName;
			}
			
			$patientDetails = $this->PatientMaster->getPatientById ( $CaseDetail->Patient_Id );
			$relation = $this->CaseMaster->getRelationsById ( $patientDetails->Relation );
			
			$case = array (
					'patient_first_name' => $patientDetails->FName,
					'patient_last_name' => $patientDetails->LName,
					'Patient_Id' => $CaseDetail->Patient_Id,
					'patient_contact_number' => $patientDetails->Phone,
					'relation' => $relation->name,
					'patient_gender' => $patientDetails->Gender,
					'patient_birth_date' => date ( DATEFORMAT, strtotime ( $patientDetails->DOB ) ),
					'patient_email' => $patientDetails->Email,
					'patient_country' => $patientDetails->Country,
					'id' => $CaseDetail->id,
					'medical_query' => $CaseDetail->medical_query,
					'type' => $CaseDetail->type,
					'Case_Date' => date ( DATEFORMAT, strtotime ( $CaseDetail->Case_Date ) ),
					'status' => $CaseDetail->status,
					'plan' => $CaseDetail->plan,
					'is_paid' => $CaseDetail->is_paid,
					'UserType' => $UserType,
					'Doctor_Id' => $doctorId,
					'DName' => $doctorName 
			)
			;
			
			$comments = $this->DoctorMaster->getAllCommentsOnCase ( $CaseDetail->id );
			
			$CommentsArray = array ();
			foreach ( $comments as $SingleComment ) {
				$ShowComment = FALSE;
				
				if ($SingleComment ["Doctor_Id"] == $DoctorId) {
					$ShowComment = TRUE;
				}
				
				$CommentsArray [] = array (
						'Case_Id' => $SingleComment ["Case_Id"],
						'Doctor_Id' => $SingleComment ["Doctor_Id"],
						'Comment' => $SingleComment ["Comment"],
						'Recommendation' => $SingleComment ["Recommendation"],
						'Case_Date' => $SingleComment ["Case_Date"],
						'Comment_Id' => $SingleComment ["Comment_Id"],
						'ShowComment' => $ShowComment 
				);
			}
			
			$data ['case'] = $case;
			$data ['Casecomments'] = $CommentsArray;
			$data ['notes'] = $this->NoteMaster->getNotesByCase ( $id );
			$this->load->view ( 'doctorcaseedit', $data );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function caseSubmit($id) {
		
		$user = $this->session->userdata ( 'user' );
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		$SubmitValue = $this->input->post ( 'back' );
		if ($SubmitValue != NULL && $SubmitValue != '') {
			redirect ( 'doctors/CasedetailDoc/' . $id, 'location' );
		}
		// $this->form_validation->set_rules ( 'mquery', 'Medical Query', 'trim|required|xss_clean' );
		
		if ($user != null) {
			
			$this->load->model ( 'DoctorMaster' );
			
			$DocDetail = $this->DoctorMaster->getDoctorsByUserId ( $this->session->userdata ( 'user_id' ) );
			
			$case = array (
					'Case_Id' => $id,
					'Doctor_Id' => $DocDetail->Doctor_Id 
			);
			
			$Result = $this->DoctorMaster->EditCommentsDetail ( $case );
			
			$SubmitValue = $this->input->post ( 'submit' );
			if ($SubmitValue == "submit") {
				$this->load->model ( 'CaseMaster' );
				$CaseDetails = $this->CaseMaster->getCasesById ( $id );
				// Send Notification
				// $DoctorDetails=$this->DoctorMaster->getDoctorById($this->input->post('referdocid'));
				// if($DoctorDetails != NULL)
				// {
				$Subject = 'Case ID '.$id.' has been reviewed by Dr ' . $DocDetail->DName;
				$BaseUrl = base_url ( 'cases/detail/' . $id );
				$Body = 'Dr ' . $DocDetail->DName . ' has submitted a review - <a target="_blank" href="' . $BaseUrl . '">Click here to open the case detail for Case ID '.$id.'</a>';
				$Notifications = array (
						'ToRole' => ADMINUSER,
						'Subject' => $Subject,
						'Body' => $Body,
						'ToUser' => '',
						'QuestionId' => '' 
				);
				
				$ResultNotify = send_notification_for_user ( $Notifications );
				
				// Send Email To Doctor
				$this->load->helper ( 'secureemail' );
				$CC = '';
				$EmailAddresTo = $DocDetail->Email;
				$EmailAddressFrom = ALERTEMAIL;
				$SubjectEmail = $Subject;
				
				$BodyEmailDoc = array (
						'DName' => $DocDetail->DName,
						'Patient_Id' => $CaseDetails->Patient_Id,
						'Link' => $BaseUrl,
						'Case_Id' => $id 
				);
				
				$EmailNotificationDoc = array (
						'To' => $EmailAddresTo,
						'FROM' => $EmailAddressFrom,
						'CC' => $CC,
						'Subject' => $SubjectEmail,
						'Body' => $BodyEmailDoc,
						'Type' => "Email_DocCase_Update",
						'Attach' => '' 
				);
				
				$this->load->helper ( 'notification_check' );
				if(get_notification_status_user($DocDetail->User_Id))
				{
					$ResultEmailDoc = send_secured_email ( $EmailNotificationDoc );
				}
				
				
				// Send Email To CC
				$CC = '';
				$EmailAddresTo = SUPPORTEMAIL;
				$EmailAddressFrom = ALERTEMAIL;
				$SubjectEmail = $Subject;
				
				$BodyEmail = array (
						'User_Id' => 'By Doctor ' . $DocDetail->DName,
						'Link' => $BaseUrl,
						'Case_Id' => $id,
						'Name' => ''
				);
				$EmailNotification = array (
						'To' => $EmailAddresTo,
						'FROM' => $EmailAddressFrom,
						'CC' => $CC,
						'Subject' => $SubjectEmail,
						'Body' => $BodyEmail,
						'Type' => "Email_CC_UpdateCase",
						'Attach' => '' 
				);
				
				$ResultEmail = send_secured_email ( $EmailNotification );
				// }
			}
			
			// Add Audit Trail
			$this->load->model ( 'AuditTrailMaster' );
			$ControllerData = array (
					'Controller' => $this->router->class,
					'Action' => 'Dr' . $DocDetail->DName . ' has made changes in case-'.$id 
			)
			;
			$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
			
			if ($SubmitValue == 'submit') {
				// Set Flash Message
				$FinalMsg = 'The Case review submitted Successfully.';
				$MsgBit = "Success";
				$Message = array (
						'CaseId' => '',
						'Message' => $FinalMsg,
						'ErrorBit' => $MsgBit 
				);
				$this->session->set_flashdata ( 'CaseUpdateMsg', $Message );
				
				redirect ( 'doctors/CasedetailDoc/' . $id, 'location' );
			} else {
				// Set Flash Message
				$FinalMsg = 'The Case Edited Successfully.';
				$MsgBit = "Success";
				$Message = array (
						'CaseId' => '',
						'Message' => $FinalMsg,
						'ErrorBit' => $MsgBit 
				);
				
				$this->session->set_flashdata ( 'DoctorCaseMsg', $Message );
				redirect ( 'doctors/CasedetailDoc/' . $id, 'location' );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function caseReview($id) {
		
		$user = $this->session->userdata ( 'user' );
		
		if ($user != null) {
			$this->load->helper ( 'form' );
			$this->load->library ( 'form_validation' );
			
			$this->load->model ( 'DoctorMaster' );
			$this->load->model ( 'CaseMaster' );
			
			$CaseDetail = $this->CaseMaster->getCasesById ( $id );
			$doctorList = $this->DoctorMaster->getAllDoctors ();
			
			foreach ($doctorList as $SingleDoctor)
			{
				$DoctorsList [] = array (
				'label' => $SingleDoctor ["DName"].' -('.$SingleDoctor["Doctor_Id"].')',
				'value' => $SingleDoctor ["Doctor_Id"]
				);
			}
			
			$case = array (
					'Case_Id' => $id,
					'Doctor_Id' => $CaseDetail->Doctor_Id 
			);
			
			$data ['Doctors'] = $DoctorsList;
			$data ['case'] = $case;
			
			$this->load->view ( 'doctorreview', $data );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function caseReviewSubmit($id) {
		
		$user = $this->session->userdata ( 'user' );
		
		$SubmitValue = $this->input->post ( 'back' );
		if ($SubmitValue != NULL && $SubmitValue != '')
		{
			redirect ( 'doctors/CasedetailDoc/'.$id, 'location' );
		}
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		$this->form_validation->set_rules ( 'referdocid', 'Doctor Name', 'trim|required|xss_clean|callback__validate_doctor' );
		
		if ($user != null) {
			
			$this->load->model ( 'DoctorMaster' );
			$this->load->model ( 'CaseMaster' );
			
			if ($this->form_validation->run () == FALSE) {
				$CaseDetail = $this->CaseMaster->getCasesById ( $id );
				$doctorList = $this->DoctorMaster->getAllDoctors ();
				
			foreach ($doctorList as $SingleDoctor)
			{
				$DoctorsList [] = array (
				'label' => $SingleDoctor ["DName"].' -('.$SingleDoctor["Doctor_Id"].')',
				'value' => $SingleDoctor ["Doctor_Id"]
				);
			}
				
				$case = array (
						'Case_Id' => $id,
						'Doctor_Id' => $CaseDetail->Doctor_Id 
				);
				
				$data ['Doctors'] = $DoctorsList;
				$data ['case'] = $case;
				
				$this->load->view ( 'doctorreview', $data );
				return;
			}
			
			// Function Yet to be written
			$DocDetail = $this->DoctorMaster->getDoctorsByUserId ( $this->session->userdata ( 'user_id' ) );
			
			$case = array (
					'Case_Id' => $id,
					'Doctor_Id' => $DocDetail->Doctor_Id 
			);
			
			$Result = $this->DoctorMaster->addreferal ( $case );
			
			// Send Notification
			$DoctorDetails = $this->DoctorMaster->getDoctorById ( $this->input->post ( 'referdocid' ) );
			if ($DoctorDetails != NULL) {
				$BaseUrl = base_url ( 'cases/detail/' . $id );
				$Subject = 'Referral request for Case ID ' . $id;
				$Body = 'Dr.' . $DocDetail->DName . ' has asked ' . $DoctorDetails->DName . ' to refer case ' . $id . ' . The URl for Case is <a target="_blank" href="' . $BaseUrl . '">here</a>';
				
				$Notifications = array (
						// 'ToUser' => $DoctorDetails->User_Id,
						'ToRole' => ADMINUSER,
						'Subject' => $Subject,
						'Body' => $Body,
						'ToUser' => '',
						'QuestionId' => '' 
				);
			}
			
			$ResultNotify = send_notification_for_user ( $Notifications );
			
			// Send Email
			$this->load->helper ( 'secureemail' );
			$CC = '';
			$EmailAddresTo = SUPPORTEMAIL;
			$EmailAddressFrom = ALERTEMAIL;
			$SubjectEmail = $Subject;
			$BaseUrl = base_url ( 'cases/detail/' . $id );
			$BodyEmail = 'Dr.' . $DocDetail->DName . ' has asked ' . $DoctorDetails->DName . ' to refer case-' . $id . '. The Url to Case is- ' . $BaseUrl;
			$EmailNotification = array (
					'To' => $EmailAddresTo,
					'FROM' => $EmailAddressFrom,
					'CC' => $CC,
					'Subject' => $SubjectEmail,
					'Body' => $BodyEmail,
					'Type' => '',
					'Attach' => '' 
			);
			$ResultEmail = send_secured_email ( $EmailNotification );
			
			// Add Audit Trail
			$this->load->model ( 'AuditTrailMaster' );
			$ControllerData = array (
					'Controller' => $this->router->class,
					'Action' => 'Dr' . $DocDetail->DName . ' has submitted review for case-'.$id 
			)
			;
			$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
			
			// Set Flash Message
			$FinalMsg = 'Message Sent to Doctor Successfully.';
			$MsgBit = "Success";
			$Message = array (
					'CaseId' => '',
					'Message' => $FinalMsg,
					'ErrorBit' => $MsgBit 
			);
			$this->session->set_flashdata ( 'CaseUpdateMsg', $Message );
			
			redirect ( 'doctors/CasedetailDoc/' . $id, 'location' );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function _validate_doctor($DoctorId) {
		if ($this->session->userdata ( 'user' ) != null) {
			if ("select" == $DoctorId) {
				$this->form_validation->set_message ( '_validate_doctor', 'Invalid Doctor' );
				return FALSE;
			}
			
			return TRUE;
		} else {
			$this->form_validation->set_message ( '_validate_doctor', 'Invalid Doctor' );
			return FALSE;
		}
	}
	public function getpayouts() {
		
		$user = $this->session->userdata ( 'user' );
		
		if ($user != null) {
			$this->load->model ( 'CaseMaster' );
			$this->load->model ( 'DoctorMaster' );
			$this->load->model ( 'PatientMaster' );
			$casesArray = array ();
			
			$searchdata = $this->input->get ( 'searchtext', TRUE );
			
			// If Searched Then else normal code
			if ($searchdata != FALSE && $searchdata != '' && $searchdata != NULL) {
				$casesArray = $this->Search ( $searchdata );
			} else {
				// method to get DocId from USer
				$User_Id = $this->session->userdata ( 'user_id' );
				$DocDetail = $this->DoctorMaster->getDoctorsByUserId ( $User_Id );
				$CasesRecords = $this->DoctorMaster->getAllSubmittedCasesForDoctor ( $DocDetail->Doctor_Id ); // DoctorId
				
				foreach ( $CasesRecords as $SingleCase ) {
					$PatientDetail = $this->PatientMaster->getPatientById ( $SingleCase ["Patient_Id"] );
					
					if ($PatientDetail != NULL) {
						$casesArray [] = array (
								'patient_first_name' => $PatientDetail->FName,
								'patient_last_name' => $PatientDetail->LName,
								'patient_contact_number' => $PatientDetail->Phone,
								'Patient_Id' => $SingleCase ["Patient_Id"],
								'Case_Id' => $SingleCase ["Case_Id"],
								'type' => $SingleCase ["type"],
								'Case_Date' => $SingleCase ["Case_Date"],
								'status' => $SingleCase ["status"] 
						);
					}
				}
			}
			$data ['cases'] = $casesArray;
			// print_r($data['cases']);
			$this->load->view ( 'doctorpayoutlist', $data );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function profiledetails($id) {
		
		$user = $this->session->userdata ( 'user' );
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		if ($user != null) {
			if ($user->User_Type == ADMIN || $user->User_Type == ADMINUSER) {
				$this->load->model ( 'DoctorMaster' );
				$doctor = $this->DoctorMaster->getDoctorById ( $id );
				$DoctorProfile = $this->DoctorMaster->getDoctorProfileDetails ( $id );
				
				if ($DoctorProfile != NULL && $DoctorProfile != '') {
					$Education = $this->DoctorMaster->getDoctorEducationDetailsNew ( $doctor->Doctor_Id );
					$Experience = $this->DoctorMaster->getDoctorExperienceDetailsNew ( $doctor->Doctor_Id );
					$Certificates = $this->DoctorMaster->getDoctorCertificateDetailsNew ( $doctor->Doctor_Id );
					$Awards = $this->DoctorMaster->getDoctorAwardDetailsNew ( $doctor->Doctor_Id );
					$Publication = $this->DoctorMaster->getDoctorPublicationDetailsNew ( $doctor->Doctor_Id );
					
					$DoctorArray = array (
							'Summary' => $DoctorProfile->Summary,
							'Speciality' => $DoctorProfile->Speciality,
							'ShortSummary' => $DoctorProfile->Short_Summary,
							'Visible' => $DoctorProfile->Visible,
							'Message' => 'You Can Add/Edit The Information' 
					);
					
					$EduFormat = $Education; // $this->ToGenrateArray($Education,'Edu_Details');
					$ExpFormat = $Experience; // $this->ToGenrateArray($Experience,'Exp_Details');
					$CertiFormat = $Certificates; // $this->ToGenrateArray($Certificates,'Certi_Details');
					$AwardsFormat = $Awards; // $this->ToGenrateArray($Awards,'Award_Details');
					$PubFormat = $Publication; // $this->ToGenrateArray($Publication,'Pub_Details');
				} else {
					$DoctorArray = array (
							'Summary' => '',
							'ShortSummary' => '',
							'Speciality' => '',
							'Visible' => '',
							'Message' => 'Please Add The Information' 
					);
					
					// Arrays
					$EduFormat = NULL;
					$ExpFormat = NULL;
					$CertiFormat = NULL;
					$AwardsFormat = NULL;
					$PubFormat = NULL;
				}
				
				// Flash Message
				$MessageDetails = $this->session->flashdata ( 'DoctorCaseMsg' );
				
				if ($MessageDetails == NUll) {
					$Message = array (
							'CaseId' => '',
							'Message' => '',
							'ErrorBit' => '' 
					);
				} else {
					$Message = array (
							'CaseId' => $MessageDetails ['CaseId'],
							'Message' => $MessageDetails ['Message'],
							'ErrorBit' => $MessageDetails ['ErrorBit'] 
					);
				}
				
				$data ['CaseMessage'] = $Message;
				
				// Arrays
				$data ['Education'] = $EduFormat;
				$data ['Prof_Exp'] = $ExpFormat;
				$data ['Certificates'] = $CertiFormat;
				$data ['Awards'] = $AwardsFormat;
				$data ['Publication'] = $PubFormat;
				
				$data ['ProfileValues'] = $DoctorArray;
				$data ['doctor'] = $doctor;
				$this->load->view ( 'doctorprofiledetailsnew', $data );
			} else {
				
				$this->load->view ( 'accessdenied' );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	/*
	 * public function profileadd($id)
	 * {
	 * session_start();
	 * $user = $this->session->userdata('user');
	 *
	 * $this->load->helper ( 'form' );
	 * $this->load->library ( 'form_validation' );
	 *
	 * if($user!= null)
	 * {
	 * if($user->User_Type == ADMIN || $user->User_Type == ADMINUSER)
	 * {
	 * $this->load->model('DoctorMaster');
	 * $doctor = $this->DoctorMaster->getDoctorById($id);
	 * $DoctorProfile=$this->DoctorMaster->getDoctorProfileDetails($id);
	 *
	 * if($DoctorProfile !=NULL && $DoctorProfile !='' )
	 * {
	 *
	 * $EduFormat=$this->DoctorMaster->getDoctorEducationDetails($doctor->Doctor_Id);
	 * $ExpFormat=$this->DoctorMaster->getDoctorExperienceDetails($doctor->Doctor_Id);
	 * $CertiFormat=$this->DoctorMaster->getDoctorCertificateDetails($doctor->Doctor_Id);
	 * $AwardsFormat=$this->DoctorMaster->getDoctorAwardDetails($doctor->Doctor_Id);
	 * $PubFormat=$this->DoctorMaster->getDoctorPublicationDetails($doctor->Doctor_Id);
	 *
	 * $DoctorArray=array(
	 * 'Summary' =>$DoctorProfile->Summary,
	 * 'Speciality' =>$DoctorProfile->Speciality,
	 * 'ShortSummary' =>$DoctorProfile->Short_Summary,
	 * 'Visible' =>$DoctorProfile->Visible
	 *
	 * );
	 *
	 * }
	 * else
	 * {
	 * $DoctorArray=array(
	 * 'Summary' =>'',
	 * 'Speciality' =>'',
	 * 'ShortSummary' =>'',
	 * 'Visible' =>''
	 *
	 * );
	 *
	 * //Arrays
	 * $EduFormat =NULL;
	 * $ExpFormat =NULL;
	 * $CertiFormat =NULL;
	 * $AwardsFormat =NULL;
	 * $PubFormat =NULL;
	 * }
	 *
	 *
	 * //Arrays
	 * $data['Education'] =$EduFormat;
	 * $data['Prof_Exp'] =$ExpFormat;
	 * $data['Certificates'] =$CertiFormat;
	 * $data['Awards'] =$AwardsFormat;
	 * $data['Publication'] =$PubFormat;
	 *
	 * $data['ProfileValues']=$DoctorArray;
	 * $data['doctor']=$doctor;
	 * $this->load->view('doctorprofileadd',$data);
	 * }
	 * else
	 * {
	 *
	 * $this->load->view('accessdenied');
	 * }
	 *
	 * }
	 * else
	 * {
	 * redirect ( 'users/login', 'location' );
	 * }
	 * }
	 *
	 *
	 *
	 * public function profileaddpost($id)
	 * {
	 * session_start();
	 * $user = $this->session->userdata('user');
	 *
	 * $SubmitValue=$this->input->post('back');
	 * if($SubmitValue!=NULL && $SubmitValue!='')
	 * {
	 * redirect ( 'doctors/profiledetails/'.$id, 'location' );
	 * }
	 *
	 * $this->load->helper ( 'form' );
	 * $this->load->library ( 'form_validation' );
	 *
	 * $this->form_validation->set_rules ( 'SpTitle', 'Speciality Title', 'trim|required|xss_clean' );
	 * $this->form_validation->set_rules ( 'Summary', 'Summary', 'trim|required|xss_clean' );
	 * $this->form_validation->set_rules ( 'ShortSummary', 'Short Summary', 'trim|required|xss_clean' );
	 * $this->form_validation->set_rules ( 'EduDetails', 'Education Details', 'required|xss_clean' );
	 * $this->form_validation->set_rules ( 'ExpDetails', 'Experience Details', 'required|xss_clean' );
	 *
	 * if($user!= null)
	 * {
	 * if($user->User_Type == ADMIN || $user->User_Type == ADMINUSER)
	 * {
	 * $this->load->model('DoctorMaster');
	 * $doctor = $this->DoctorMaster->getDoctorById($id);
	 *
	 * if ($this->form_validation->run () == FALSE) {
	 * $data['doctor']=$doctor;
	 *
	 *
	 * $EduFormat=$this->FormatArray($this->input->post('EduDetails'),$this->input->post('EduHeaderDetails'), 'Edu_Details');
	 * $ExpFormat=$this->FormatArray($this->input->post('ExpDetails'),$this->input->post('ExpHeaderDetails'), 'Exp_Details');
	 * $CertiFormat=$this->FormatArray($this->input->post('CertiDetails'),$this->input->post('CertiHeaderDetails'), 'Certi_Details');
	 * $AwardsFormat=$this->FormatArray($this->input->post('AwardDetails'), $this->input->post('AwardHeaderDetails'),'Award_Details');
	 * $PubFormat=$this->FormatArray($this->input->post('PublicDetails'), $this->input->post('PubHeaderDetails'),'Pub_Details');
	 *
	 * $DoctorArray=array(
	 * 'Summary' =>$this->input->post('Summary'),
	 * 'ShortSummary' =>$this->input->post('ShortSummary'),
	 * 'Speciality' =>$this->input->post('SpTitle'),
	 * 'Visible' =>$this->input->post('Visiblity')
	 * );
	 *
	 * //Arrays
	 * $data['Education'] =$EduFormat;
	 * $data['Prof_Exp'] =$ExpFormat;
	 * $data['Certificates'] =$CertiFormat;
	 * $data['Awards'] =$AwardsFormat;
	 * $data['Publication'] =$PubFormat;
	 *
	 * $data['ProfileValues']=$DoctorArray;
	 * $this->load->view('doctorprofileadd',$data);
	 * return;
	 * }
	 *
	 * $EduArray=$this->input->post('EduDetails');
	 * $EduHeaderArray=$this->input->post('EduHeaderDetails');
	 *
	 * $ExpArray=$this->input->post('ExpDetails');
	 * $ExpHeaderArray=$this->input->post('ExpHeaderDetails');
	 *
	 * $CertiArray=$this->input->post('CertiDetails');
	 * $CertiHeaderArray=$this->input->post('CertiHeaderDetails');
	 *
	 * $AwardsArray=$this->input->post('AwardDetails');
	 * $AwardsHeaderArray=$this->input->post('AwardHeaderDetails');
	 *
	 * $PubArray=$this->input->post('PublicDetails');
	 * $PubHeaderArray=$this->input->post('PubHeaderDetails');
	 *
	 * $Education=$this->FormatToArray($EduArray,$EduHeaderArray,'Edu_Details',$id);
	 * $Experience=$this->FormatToArray($ExpArray,$ExpHeaderArray,'Exp_Details',$id);
	 * $Ceritifcation=$this->FormatToArray($CertiArray,$CertiHeaderArray,'Certi_Details',$id);
	 * $Awards=$this->FormatToArray($AwardsArray,$AwardsHeaderArray,'Award_Details',$id);
	 * $Publication=$this->FormatToArray($PubArray,$PubHeaderArray,'Pub_Details',$id);
	 *
	 *
	 *
	 * $DoctorData=array(
	 * 'Doctor_Id' =>$id,
	 * 'Education'=>$Education,
	 * 'Prof_Exp'=>$Experience,
	 * 'Certificates'=>$Ceritifcation,
	 * 'Awards'=>$Awards,
	 * 'Publication'=>$Publication
	 * );
	 *
	 * $Result=$this->DoctorMaster->addDoctorProfile($DoctorData);
	 *
	 * //Set Flash Message
	 * $FinalMsg='Doctor Profile Information Updated Successfully.';
	 * $MsgBit="Success";
	 *
	 * $Message=array(
	 * 'CaseId'=>'',
	 * 'Message' => $FinalMsg,
	 * 'ErrorBit' => $MsgBit
	 * );
	 *
	 * $this->session->set_flashdata('DoctorCaseMsg',$Message);
	 *
	 * redirect ( 'doctors/profiledetails/'.$id, 'location' );
	 *
	 * }
	 * else
	 * {
	 *
	 * $this->load->view('accessdenied');
	 * }
	 *
	 * }
	 * else
	 * {
	 * redirect ( 'users/login', 'location' );
	 * }
	 * }
	 */
	public function profileaddnew($id) {
		
		$user = $this->session->userdata ( 'user' );
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		if ($user != null) {
			if ($user->User_Type == ADMIN || $user->User_Type == ADMINUSER) {
				$this->load->model ( 'DoctorMaster' );
				$doctor = $this->DoctorMaster->getDoctorById ( $id );
				$DoctorProfile = $this->DoctorMaster->getDoctorProfileDetails ( $id );
				
				if ($DoctorProfile != NULL && $DoctorProfile != '') {
					
					$EduFormat = $this->DoctorMaster->getDoctorEducationDetailsNew ( $doctor->Doctor_Id );
					$ExpFormat = $this->DoctorMaster->getDoctorExperienceDetailsNew ( $doctor->Doctor_Id );
					$CertiFormat = $this->DoctorMaster->getDoctorCertificateDetailsNew ( $doctor->Doctor_Id );
					$AwardsFormat = $this->DoctorMaster->getDoctorAwardDetailsNew ( $doctor->Doctor_Id );
					$PubFormat = $this->DoctorMaster->getDoctorPublicationDetailsNew ( $doctor->Doctor_Id );
					
					$DoctorArray = array (
							'Summary' => $DoctorProfile->Summary,
							'Speciality' => $DoctorProfile->Speciality,
							'ShortSummary' => $DoctorProfile->Short_Summary,
							'Visible' => $DoctorProfile->Visible 
					)
					;
				} else {
					$DoctorArray = array (
							'Summary' => '',
							'Speciality' => '',
							'ShortSummary' => '',
							'Visible' => ''
					)
					;
					
					// Arrays
					$EduFormat = NULL;
					$ExpFormat = NULL;
					$CertiFormat = NULL;
					$AwardsFormat = NULL;
					$PubFormat = NULL;
				}
				
				$SpecialitiesDB = $this->DoctorMaster->getAllSpecialities ();
				$docspecail = explode ( ',', $doctor->Speciality );
				$data ['Speciality'] = $doctor->Speciality;//$this->Speciality ( $docspecail, $SpecialitiesDB );
				
				// Arrays
				$data ['Education'] = $EduFormat;
				$data ['Prof_Exp'] = $ExpFormat;
				$data ['Certificates'] = $CertiFormat;
				$data ['Awards'] = $AwardsFormat;
				$data ['Publication'] = $PubFormat;
				
				$data ['ProfileValues'] = $DoctorArray;
				$data ['doctor'] = $doctor;
				$this->load->view ( 'doctorprofileaddnew', $data );
			} else {
				
				$this->load->view ( 'accessdenied' );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function profileaddnewpost($id) {
		
		$user = $this->session->userdata ( 'user' );
		
		$SubmitValue = $this->input->post ( 'back' );
		if ($SubmitValue != NULL && $SubmitValue != '') {
			redirect ( 'doctors/profiledetails/' . $id, 'location' );
		}
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		$this->form_validation->set_rules ( 'SpTitle', 'Speciality Title', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'Summary', 'Summary', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'ShortSummary', 'Short Summary', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'Education', 'Education Details', 'required|xss_clean' );
		$this->form_validation->set_rules ( 'Experience', 'Experience Details', 'required|xss_clean' );
		
		if ($user != null) {
			if ($user->User_Type == ADMIN || $user->User_Type == ADMINUSER) {
				$this->load->model ( 'DoctorMaster' );
				$doctor = $this->DoctorMaster->getDoctorById ( $id );
				
				if ($this->form_validation->run () == FALSE) {
					$data ['doctor'] = $doctor;
					
					$EduFormat = array (
							'Id' => '',
							'Doctor_Id' => '',
							'Created_By' => '',
							'Header' => '',
							'Edu_Details' => $this->input->post ( 'Education' ) 
					)
					;
					
					$ExpFormat = array (
							'Id' => '',
							'Doctor_Id' => '',
							'Created_By' => '',
							'Header' => '',
							'Exp_Details' => $this->input->post ( 'Experience' ) 
					)
					;
					$CertiFormat = array (
							'Id' => '',
							'Doctor_Id' => '',
							'Created_By' => '',
							'Header' => '',
							'Certi_Details' => $this->input->post ( 'Certification' ) 
					)
					;
					$AwardsFormat = array (
							'Id' => '',
							'Doctor_Id' => '',
							'Created_By' => '',
							'Header' => '',
							'Award_Details' => $this->input->post ( 'Awards' ) 
					)
					;
					$PubFormat = array (
							'Id' => '',
							'Doctor_Id' => '',
							'Created_By' => '',
							'Header' => '',
							'Pub_Details' => $this->input->post ( 'Publication' ) 
					)
					;
					
					$DoctorArray = array (
							'Summary' => $this->input->post ( 'Summary' ),
							'ShortSummary' => $this->input->post ( 'ShortSummary' ),
							'Speciality' => $this->input->post ( 'SpTitle' ),
							'Visible' => $this->input->post ( 'Visiblity' ) 
					);
					
					$SpecialitiesDB = $this->DoctorMaster->getAllSpecialities ();
					$docspecail = explode ( ',', $doctor->Speciality );
					$data ['Speciality'] =$doctor->Speciality; //$this->Speciality ( $docspecail, $SpecialitiesDB );
					
					// Arrays
					$data ['Education'] = $EduFormat;
					$data ['Prof_Exp'] = $ExpFormat;
					$data ['Certificates'] = $CertiFormat;
					$data ['Awards'] = $AwardsFormat;
					$data ['Publication'] = $PubFormat;
					
					$data ['ProfileValues'] = $DoctorArray;
					$this->load->view ( 'doctorprofileaddnew', $data );
					return;
				}
				
				$EduArray = $this->input->post ( 'Education' );
				$ExpArray = $this->input->post ( 'Experience' );
				$CertiArray = $this->input->post ( 'Certification' );
				$AwardsArray = $this->input->post ( 'Awards' );
				$PubArray = $this->input->post ( 'Publication' );
				
				$DoctorData = array (
						'Doctor_Id' => $id,
						'Education' => $EduArray,
						'Prof_Exp' => $ExpArray,
						'Certificates' => $CertiArray,
						'Awards' => $AwardsArray,
						'Publication' => $PubArray 
				);
				
				$Result = $this->DoctorMaster->addDoctorProfileNew ( $DoctorData );
				
				// Set Flash Message
				$FinalMsg = 'Doctor Profile Information Updated Successfully.';
				$MsgBit = "Success";
				
				$Message = array (
						'CaseId' => '',
						'Message' => $FinalMsg,
						'ErrorBit' => $MsgBit 
				);
				
				$this->session->set_flashdata ( 'DoctorCaseMsg', $Message );
				
				redirect ( 'doctors/profiledetails/' . $id, 'location' );
			} else {
				
				$this->load->view ( 'accessdenied' );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	// To make the Li of The String Entered
	private function FormatToUlLi($ArrayOfQualifcation) {
		$MainValue = '';
		
		if ($ArrayOfQualifcation != NUll && $ArrayOfQualifcation != '') {
			$ListPart = '';
			
			foreach ( $ArrayOfQualifcation as $SingleValue ) {
				$ListPart = $ListPart . '<li>' . $SingleValue . '</li>';
			}
			
			$MainValue = $ListPart; // '<ul>'.$ListPart.'</ul>';
		}
		
		return $MainValue;
	}
	
	// Database Saving
	private function FormatToArray($ArrayOfDetails, $ArrayOfHeader, $CoulmnName, $DoctorId) {
		$user = $this->session->userdata ( 'user' );
		
		if ($ArrayOfDetails != NUll && $ArrayOfDetails != '') {
			$FormattedArray = array ();
			for($i = 0; $i < count ( $ArrayOfDetails ); $i ++) {
				$FormattedArray [] = array (
						'Header' => $ArrayOfHeader [$i],
						$CoulmnName => $ArrayOfDetails [$i],
						'Doctor_Id' => $DoctorId,
						'Created_By' => $user->User_Id 
				)
				;
			}
		} else {
			$FormattedArray = NUll;
		}
		
		return $FormattedArray;
	}
	
	// To Format String for SheepIt Pulgin
	private function FormatArray($AllValuesArray, $AllValuesHeaderArray, $CoulmnName) {
		if ($AllValuesArray != NULL && $AllValuesArray != '') {
			$FormattedArray = array ();
			$HeaderName = 'Header';
			
			for($i = 0; $i < count ( $AllValuesArray ); $i ++) {
				$FormattedArray [] = array (
						$HeaderName => $AllValuesHeaderArray [$i],
						$CoulmnName => $AllValuesArray [$i] 
				);
			}
			/*
			 * foreach($AllValuesArray as $singleValue)
			 * {
			 * $FormattedArray[]=array(
			 * $CoulmnName => $singleValue
			 * );
			 * }
			 */
		} else {
			$FormattedArray = NULL;
		}
		
		return $FormattedArray;
	}
	
	// To Convert String to Array Format
	private function ConvertStringToArrayAndFromat($MainString, $CoulmnName) {
		if ($MainString != NULL && $MainString != '') {
			$FormattedArray = array ();
			
			$MainStringArray = explode ( '<li>', $MainString );
			
			foreach ( $MainStringArray as $singleValue ) {
				if (trim ( $singleValue ) != '' && trim ( $singleValue ) != NULL) {
					$FinalString = str_replace ( "</li>", "", $singleValue );
					$FormattedArray [] = array (
							$CoulmnName => $FinalString 
					);
				}
			}
		} else {
			$FormattedArray = NULL;
		}
		
		return $FormattedArray;
	}
	private function ToGenrateArray($MainValuesArray, $ColumnName) {
		$FormattedArray = array ();
		
		if ($MainValuesArray != NULL && $MainValuesArray != '') {
			$SecondaryArray = $MainValuesArray;
			
			foreach ( $MainValuesArray as $MainValue ) {
				$DependentValues = array ();
				$CountSec = count ( $SecondaryArray );
				
				if ($CountSec > 0) {
					for($Cnt = 0; $Cnt < $CountSec; $Cnt ++) {
						if ($MainValue ["Header"] != $SecondaryArray [$Cnt] ["Header"]) {
							break;
						}
						
						$DependentValues [] = array (
								'SingleEle' => $SecondaryArray [$Cnt] [$ColumnName] 
						);
						
						unset ( $SecondaryArray [$Cnt] );
					}
					
					if (Count ( $DependentValues ) > 0) {
						$FormattedArray [] = array (
								'Header' => $MainValue ["Header"],
								'Elements' => $DependentValues 
						);
					}
				}
			}
		}
		
		return $FormattedArray;
	}
	public function listAll() {
		$this->load->model ( 'DoctorMaster' );
		
		$DoctorList = $this->DoctorMaster->getAllDoctors ();
		$SpecialitiesDB = $this->DoctorMaster->getAllSpecialities ();
		
		$doctorArray = array ();
		
		foreach ( $DoctorList as $doctor ) {
			$docspecail = explode ( ',', $doctor ["Speciality"] );
			
			$DoctorProfile = $this->DoctorMaster->getDoctorProfileDetails ( $doctor ["Doctor_Id"] );
			if ($DoctorProfile != NULL && $DoctorProfile != '') {
				if ($DoctorProfile->Visible == 1) {
					$Speciality =$doctor ["Speciality"]; //$this->Speciality ( $docspecail, $SpecialitiesDB );
					$UrlName = 'profile/' . $doctor ["Doctor_Id"]; // $this->encodeUrl($doctor["Doctor_Id"])
					$doctorArray [] = array (
							'Doctor_Id' => $doctor ["Doctor_Id"],
							'DName' => $doctor ["DName"],
							'Qualification' => $doctor ["Qualification"],
							'Speciality' => $Speciality,
							'Email' => $doctor ["Email"],
							'ImgName' => $doctor ["DImagePath"],
							'UrlName' => $UrlName,
							'SpTitle' => $DoctorProfile->Speciality 
					);
				}
			}
		}
		
		$data ['doctors'] = $doctorArray;
		$data ['title'] = "Doctors";
		$this->load->view ( 'doctors', $data );
	}
	private function encodeUrl($DoctorId) {
		$DoctorName = base64_encode ( json_encode ( $DoctorId ) );
		return $DoctorName;
	}
	private function decodeUrl($EncodedData) {
		$DoctorId = json_decode ( base64_decode ( $EncodedData ) );
		return $DoctorId;
	}
	
	// Get The Specific Doctor
	public function profile($Id) 
	{
		$DoctorId = $Id; // $this->decodeUrl($Id);
		
		$this->load->model ( 'DoctorMaster' );
		
		$DoctorData = $this->DoctorMaster->getDoctorById ( $DoctorId );
		
		if($DoctorData != NULL && $DoctorData != '')
		{
			$SpecialitiesDB = $this->DoctorMaster->getAllSpecialities ();
			
			$doctorArray = array ();
			
			$docspecail = explode ( ',', $DoctorData->Speciality );
			
			$DoctorProfile = $this->DoctorMaster->getDoctorProfileDetails ( $DoctorData->Doctor_Id );
			if ($DoctorProfile != NULL && $DoctorProfile != '')
			{
				if ($DoctorProfile->Visible == 1)
				{
					$Speciality = $DoctorData->Speciality;//$this->Speciality ( $docspecail, $SpecialitiesDB );
					$UrlName = $this->MakeUrlNameforDoctor ( $DoctorData->DName );
			
					$doctorArray = array (
							'Doctor_Id' => $DoctorData->Doctor_Id,
							'DName' => $DoctorData->DName,
							'Qualification' => $DoctorData->Qualification,
							'Speciality' => $Speciality,
							'Email' => $DoctorData->Email,
							'ImgName' => $DoctorData->DImagePath
					);
			
					// Proflie Detials
					$Education = $this->DoctorMaster->getDoctorEducationDetailsNew ( $DoctorData->Doctor_Id );
					$Experience = $this->DoctorMaster->getDoctorExperienceDetailsNew ( $DoctorData->Doctor_Id );
					$Certificates = $this->DoctorMaster->getDoctorCertificateDetailsNew ( $DoctorData->Doctor_Id );
					$Awards = $this->DoctorMaster->getDoctorAwardDetailsNew ( $DoctorData->Doctor_Id );
					$Publication = $this->DoctorMaster->getDoctorPublicationDetailsNew ( $DoctorData->Doctor_Id );
			
					// Format The Array
					$EduFormat = $Education; // $this->ToGenrateArray($Education,'Edu_Details');
					$ExpFormat = $Experience; // $this->ToGenrateArray($Experience,'Exp_Details');
					$CertiFormat = $Certificates; // $this->ToGenrateArray($Certificates,'Certi_Details');
					$AwardsFormat = $Awards; // $this->ToGenrateArray($Awards,'Award_Details');
					$PubFormat = $Publication; // $this->ToGenrateArray($Publication,'Pub_Details');
			
					$DoctorArray = array (
							'Summary' => $DoctorProfile->Summary,
							'Speciality' => $DoctorProfile->Speciality,
							'ShortSummary' => $DoctorProfile->Short_Summary,
							'Visible' => $DoctorProfile->Visible
					);
				}
				else 
				{
					redirect('doctors/listAll' ,'location');
				}
			}
			else 
			{
				redirect('doctors/listAll' ,'location');
			}
			
			$data ['doctors'] = $doctorArray;
			$data ['ProfileValues'] = $DoctorArray;
			
			// Arrays
			$data ['Education'] = $EduFormat;
			$data ['Prof_Exp'] = $ExpFormat;
			$data ['Certificates'] = $CertiFormat;
			$data ['Awards'] = $AwardsFormat;
			$data ['Publication'] = $PubFormat;
			
			$data ['title'] = $DoctorData->DName;
			$this->load->view ( 'doctorsdetail', $data );
		}
		else 
		{
			redirect('doctors/listAll' ,'location');
		}
		
	}
	
	public function SubmitCasedetailDoc($id) {
		
		$user = $this->session->userdata ( 'user' );
		
		if ($user != null) {
			
			$SubmitValue = $this->input->post ( 'back' );
			if ($SubmitValue != NULL && $SubmitValue != '') {
				redirect ( 'case/detail/' . $id, 'location' );
			}
			
			$this->load->helper ( 'form' );
			$this->load->library ( 'form_validation' );
			
			$this->load->model ( 'CaseMaster' );
			$this->load->model ( 'NoteMaster' );
			$this->load->model ( 'PatientMaster' );
			$this->load->model ( 'DoctorMaster' );
			
			$CaseDetail = $this->CaseMaster->getCasesById ( $id );
			// Get User Type
			$UserType = $user->User_Type;
			
			
			$doctorName = '';
			$doctorId = '';
			if ($CaseDetail->Doctor_Id != NULL && $CaseDetail->Doctor_Id != '') {
				$doctor = $this->DoctorMaster->getDoctorById ( $CaseDetail->Doctor_Id );
				
				$doctorId = $doctor->Doctor_Id;
				$doctorName = $doctor->DName;
			}
			
			$patientDetails = $this->PatientMaster->getPatientById ( $CaseDetail->Patient_Id );
			$relation = $this->CaseMaster->getRelationsById ( $patientDetails->Relation );
			
			$case = array (
					'patient_first_name' => $patientDetails->FName,
					'patient_last_name' => $patientDetails->LName,
					'Patient_Id' => $CaseDetail->Patient_Id,
					'patient_contact_number' => $patientDetails->Phone,
					'relation' => $relation->name,
					'patient_gender' => $patientDetails->Gender,
					'patient_birth_date' => date ( DATEFORMAT, strtotime ( $patientDetails->DOB ) ),
					'patient_email' => $patientDetails->Email,
					'patient_country' => $patientDetails->Country,
					'id' => $CaseDetail->id,
					'medical_query' => $CaseDetail->medical_query,
					'type' => $CaseDetail->type,
					'Case_Date' => date ( DATEFORMAT, strtotime ( $CaseDetail->Case_Date ) ),
					'status' => $CaseDetail->status,
					'plan' => $CaseDetail->plan,
					'is_paid' => $CaseDetail->is_paid,
					'UserType' => $UserType,
					'Doctor_Id' => $doctorId,
					'DName' => $doctorName 
			)
			;
			
			// To Pull List Of Documents
			$CaseDocuments = $this->CaseMaster->getCaseDocuments ( $id );
			$PHREnable = FALSE;
			$DocumentList = NUll;
			
			if ($CaseDocuments != NULL && $CaseDocuments != '') {
				$DocIdList = array ();
				$CaseDocumentCreator='';
					
				foreach ( $CaseDocuments as $SingleDoc ) {
			
					array_push ( $DocIdList, $SingleDoc ["Document_Id"] );
			
					$CaseDocumentCreator=$SingleDoc ["Created_By"];
					if ($PHREnable != TRUE) {
						if ($SingleDoc ["Patient_Id"] != NULL && $SingleDoc ["Patient_Id"] != '' && $SingleDoc ["Patient_Id"] > 0) {
							$PHREnable = TRUE;
						}
					}
				}
					
				// Gettin Documents from Doc table
				$DocumentList = $this->CaseMaster->getCaseDocumentsDeatils ( $CaseDocumentCreator, $DocIdList );
			}
			
			$data ["DocumentList"] = $DocumentList;
			$data ["PHRStatus"] = $PHREnable;
			
			$DoctorId = $this->session->userdata ( 'Doctor_Id' );
			$comments = $this->DoctorMaster->getAllCommentsOnCase ( $CaseDetail->id );
		
			
			$data ['case'] = $case;
			$data ['Casecomments'] = $comments;
			
			$MessageDetails = $this->session->flashdata ( 'DoctorCaseMsg' );
			
			if ($MessageDetails == NUll) {
				$Message = array (
						'CaseId' => '',
						'Message' => '',
						'ErrorBit' => '' 
				);
			} else {
				$Message = array (
						'CaseId' => $MessageDetails ['CaseId'],
						'Message' => $MessageDetails ['Message'],
						'ErrorBit' => $MessageDetails ['ErrorBit'] 
				);
			}
			
			$data ['CaseMessage'] = $Message;
			
			//--- To Show/hide Add Consult or Edit Consult button --- //
			
			$Show = array(
			'Add' => TRUE
			);
			
			foreach ($comments as $SingleComment) {
				
				if ($SingleComment["Doctor_Id"] == $DoctorId) {
					
					if($SingleComment["Comment"] != NULL && $SingleComment["Comment"] != '') {
						
						$Show["Add"]= FALSE;
						break;
					}
					
				}
				
			}
			$data ['Show'] = $Show;
			
			$this->load->view ( 'doctorCaseSubmit', $data );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
}
?>