<?php
class Home extends CI_Controller {
	public function index($offset = NULL) {
		$user = $this->session->userdata ( 'user' );
		$this->session->set_userdata ( 'activeMenu', "dashboard" );
		
		if ($user!=NULL) 
		{
			switch ($user->User_Type) {
				case ADMIN :
						$this->load->model ( 'CaseMaster' );
						$statusdashboard = $this->CaseMaster->getGroupedCases();
						
						$this->load->view ( 'dashboard_admin', array ('user' => $user, 'statusdashboard' => $statusdashboard) );
						break;
					
				case ADMINUSER :
						$this->load->view ( 'dashboard_customercare', array (
								'user' => $user 
						) );
					
					break;
				
				case DOCTORS :
					/*if ($offset != NULL) {
						$this->load->view ( 'index', array (
								'user' => $user 
						) );
					} else {*/
						redirect ( 'doctors/getcases', 'location' );
					//}
					break;
				
				case CORPADMIN :
					$CorpStats = $this->GenerateCorporateData ();
					
					$data ['Emp'] = $CorpStats ["Emp"];
					$data ['Case'] = $CorpStats ["Case"];
					$data ['Plan'] = $CorpStats ["Plan"];
					$data ['User'] = $user;
					$this->load->view ( 'dashboard_corporate', $data );
					break;
				
				case SALES :
					$SalesStats = $this->GenerateSalesData ();
					
					$data ['Emp'] = $SalesStats ["Emp"];
					$data ['Case'] = $SalesStats ["Case"];
					$data ['Leads'] = $SalesStats ["Leads"];
					$data ['User'] = $user;
					$this->load->view ( 'salesdash', $data );
					break;
				
				case PARTNERS :
					$SalesStats = $this->GenerateSalesData ();
					
					$data ['Emp'] = $SalesStats ["Emp"];
					$data ['Case'] = $SalesStats ["Case"];
					$data ['Leads'] = $SalesStats ["Leads"];
					$data ['user'] = $user;

					$this->load->model ( 'CaseMaster' );
					$data["statusdashboard"] = $this->CaseMaster->getGroupedCases();
					
					$this->load->view ( 'dashboard_partner', $data );
					break;
				case 7: /* Doctor Coordinators */
					$this->load->model ( 'CaseMaster' );
					$statusdashboard = $this->CaseMaster->getGroupedCases();
						
					$this->load->view ( 'dashboard_doctorcoordinator', array ('user' => $user, 'statusdashboard' => $statusdashboard) );
					break;

				default :
					$this->load->view ( 'index', array (
							'user' => $user 
					) );
					break;
			}
		} 
		else {
			redirect ( 'users', 'location' );
		}
	}
	private function GenerateCorporateData() {
		$user = $this->session->userdata ( 'user' );
		
		$this->load->model ( 'UserMaster' );
		$this->load->model ( 'ReportMaster' );
		
		/* --------------------------Case Data--------------------------------------------- */
		
		$OpenCase = 0;
		$ReviewCase = 0;
		$DocAssigned = 0;
		$ClosedCase = 0;
		$TotalCase = 0;
		
		$CorporateDetails = $this->ReportMaster->getCorpDetailsById ( $user->User_Id );
		
		$Values = array (
				'Promocode' => $CorporateDetails->Corp_Unique_Id 
		);
		
		$CaseArray = $this->ReportMaster->getCasesByCorpCode ( $Values );
		
		$TotalCase = count ( $CaseArray );
		
		foreach ( $CaseArray as $SingleCase ) {
			switch ($SingleCase->status) {
				case 3 :
				case 4 :
					$ReviewCase ++;
					break;
				
				case 2 :
					$DocAssigned ++;
					break;
				
				case 5 :
				case 6 :
					$ClosedCase ++;
					break;
				
				default :
					$OpenCase ++;
					break;
			}
		}
		
		$CaseStats = array (
				'OpenCases' => $OpenCase,
				'DocAssign' => $DocAssigned,
				'Review' => $ReviewCase,
				'Closed' => $ClosedCase,
				'TotalCase' => $TotalCase 
		);
		
		/* ----------------------------------------------------------------------- */
		
		/* --------------------------Employee Data--------------------------------------------- */
		$TotalEmp = 0;
		$Active = 0;
		$Inactive = 0;
		$GetCreatedUserDetails = $this->UserMaster->getCreatedUsers ( $user->User_Id );
		
		foreach ( $GetCreatedUserDetails as $SingleUser ) 
		{
			if($SingleUser->Corp_Code == $CorporateDetails->Corp_Unique_Id )
			{
				$TotalEmp++;
				
				if($SingleUser->Verify_Status == 1)
				{
					$Active++;
				}
			}
				
		}
		
		//$UniqueUserIds = array_unique ( $ExtractUserIds );
		
		//$TotalEmp = count ( $GetCreatedUserDetails );
		//$Active = count ( $UniqueUserIds );
		$Inactive = $TotalEmp - $Active;
		
		$EmpStats = array (
				'TotalEmp' => $TotalEmp,
				'Active' => $Active,
				'Inactive' => $Inactive 
		);
		
		/* --------------------------Plan Data--------------------------------------------- */
		$Elite = 0;
		$Signature = 0;
		$None=0;
		
		
		foreach ( $GetCreatedUserDetails as $SingleUser )
		{
			
			if($SingleUser->Corp_Code == $user->Corp_Code)
			{
				$GetSubcriptionDetails = $this->UserMaster->getSubscriptionDetails ( $SingleUser->User_Id );
				
				if($GetSubcriptionDetails != NULL && $GetSubcriptionDetails !='')
				{
					if($GetSubcriptionDetails->Plan_Id == ELITEPLAN)
					{
						$Elite++;
					}
					else if($GetSubcriptionDetails->Plan_Id == SIGNATUREPLAN)
					{
						$Signature++;
					}
					else
					{
						$None++;
					}
				}
				
			}
		}
		
		//$UniqueUserIds = array_unique ( $ExtractUserIds );
		
		$TotalEmp = count ( $GetCreatedUserDetails );
		//$Active = count ( $UniqueUserIds );
		$Inactive = $TotalEmp - $Active;
		
		$PlanStats = array (
				'Elite' => $Elite,
				'Signature' => $Signature,
				'None' => $None
		);
		
		
		
		/* ----------------------------------------------------------------------- */
		
		$Statistics = array (
				'Emp' => $EmpStats,
				'Case' => $CaseStats,
				'Plan' => $PlanStats
		);
		
		return $Statistics;
	}
	
	// To Generate Sales Data
	private function GenerateSalesData() {
		$user = $this->session->userdata ( 'user' );
		
		$this->load->model ( 'CaseMaster' );
		$this->load->model ( 'UserMaster' );
		$this->load->model ( 'ReportMaster' );
		
		/* --------------------------Case Data--------------------------------------------- */
		
		$OpenCase = 0;
		$ReviewCase = 0;
		$DocAssigned = 0;
		$ClosedCase = 0;
		$TotalCase = 0;
		
		$CaseArray = $this->CaseMaster->getCasesByUser ( $user->User_Id );
		
		$TotalCase = count ( $CaseArray );
		
		foreach ( $CaseArray as $SingleCase ) {
			switch ($SingleCase->status) {
				case 3 :
				case 4 :
					$ReviewCase ++;
					break;
				
				case 2 :
					$DocAssigned ++;
					break;
				
				case 5 :
				case 6 :
					$ClosedCase ++;
					break;
				
				default :
					$OpenCase ++;
					break;
			}
		}
		
		$CaseStats = array (
				'OpenCases' => $OpenCase,
				'DocAssign' => $DocAssigned,
				'Review' => $ReviewCase,
				'Closed' => $ClosedCase,
				'TotalCase' => $TotalCase 
		);
		
		/* ----------------------------------------------------------------------- */
		
		/* --------------------------Sales User Data--------------------------------------------- */
		$TotalEmp = 0;
		$Active = 0;
		$Inactive = 0;
		$SalesUserCaseCount = 0;
		$GetCreatedUserDetails = $this->UserMaster->getCreatedUsers ( $user->User_Id );
		
		foreach ( $GetCreatedUserDetails as $SingleUser ) {
			$GetCaseCount = $this->ReportMaster->getCasesByUserCount ( $SingleUser->User_Id );
			if ($GetCaseCount != NULL && $GetCaseCount != '' && $GetCaseCount > 0) {
				$SalesUserCaseCount = $SalesUserCaseCount + $GetCaseCount;
				$Active ++;
			}
		}
		
		$TotalEmp = count ( $GetCreatedUserDetails );
		$Inactive = $TotalEmp - $Active;
		
		$EmpStats = array (
				'TotalEmp' => $TotalEmp,
				'Active' => $Active,
				'Inactive' => $Inactive,
				'CaseCounts' => $SalesUserCaseCount 
		);
		
		/* ----------------------------------------------------------------------- */
		
		/* --------------------------Leads Data--------------------------------------------- */
		$TotalLead = 0;
		$GetLeads = $this->ReportMaster->getLeadsByUser ( $user->User_Id );
		$TotalLead = count ( $GetLeads );
		
		/* ----------------------------------------------------------------------- */
		
		$Statistics = array (
				'Emp' => $EmpStats,
				'Case' => $CaseStats,
				'Leads' => $TotalLead 
		);
		
		return $Statistics;
	}
}
?>