<?php
class Master extends CI_Controller {
	public function __construct() {
		parent::__construct ();
		
		$this->load->helper ( 'url' );
		$this->load->library ( 'grocery_CRUD' );
	}
	public function _master_output($output = null) {
		/*
		 * if(!isset($_SESSION['user_id']))
		 * echo "<script>location.href = '/';</script>";
		 * else
		 */
		$this->load->view ( 'master', $output );
	}
	public function accounts() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'account' )->set_subject ( 'Accounts' );
			
			// $crud->columns('category','sub_cat','title','description', 'position');
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function cases() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'cases' )->set_subject ( 'Cases' );
			// $crud->set_relation('created_by','user','Email_Address');
			
			// $crud->set_relation('relation','relation_master','name');
			$crud->set_relation ( 'specialization', 'doctor_specialization_master', 'name' );
			
			$crud->field_type ( 'patient_gender', 'dropdown', array (
					'1' => 'Male',
					'2' => 'Female' 
			) );
			
			$crud->field_type ( 'terms', 'true_false', array (
					'No',
					'Yes' 
			) );
			$crud->display_as ( 'terms', 'Terms & Conditions and Privacy Policy' );
			
			$crud->where ( 'cases.created_by = ' . $this->session->userdata ( 'user' )->User_Id );
			
			$crud->fields ( 'relation', 'patient_country', 'patient_first_name', 'patient_last_name', 'patient_gender', 'patient_birth_date', 'patient_contact_number', 'patient_email', 'subject', 'medical_query', 'promo_code', 'specialization', 'terms', 'created_by' );
			$crud->field_type ( 'created_by', 'invisible' );
			
			$crud->callback_before_insert ( array (
					$this,
					'before_create_case' 
			) );
			
			$crud->callback_after_insert ( array (
					$this,
					'after_create_case' 
			) );
			
			$crud->callback_after_update ( array (
					$this,
					'after_update_case' 
			) );
			
			$crud->unset_delete ();
			
			$crud->columns ( 'patient_first_name', 'patient_last_name', 'patient_contact_number', 'patient_email', 'subject', 'relation' );
			
			$crud->add_action ( 'Documents', '', '', 'ui-icon-image', array (
					$this,
					'case_document_action' 
			) );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	function before_create_case($post_array) {
		$post_array ['created_by'] = $this->session->userdata ( 'user' )->User_Id;
		return $post_array;
	}
	function after_create_case($post_array, $primary_key) {
		// send message to user
		$this->load->library ( 'email', $config );
		$this->email->set_newline ( "\r\n" );
		
		$this->email->to ( $post_array ['patient_email'] );
		
		$title = "GrandOpinion case created: #" . $primary_key;
		$this->email->subject ( $title );
		
		$message = "This is a <b>secure message</b>. <br/>Please login to your grandopinion account to see the message details.";
		$message .= "<br/>Case created with case id: " . $primary_key;
		
		$this->email->message ( $message );
		$this->email->send ();
		
		return true;
	}
	function after_update_case($post_array, $primary_key) {
		// send message to user or doc
		$this->load->library ( 'email', $config );
		$this->email->set_newline ( "\r\n" );
		
		$this->email->to ( $post_array ['patient_email'] );
		
		$title = "GrandOpinion case updated: #" . $primary_key;
		$this->email->subject ( $title );
		
		$message = "This is a <b>secure message</b>. <br/>Please login to your grandopinion account to see the message details.";
		$message .= "<br/>Case #" . $primary_key . " has been updated by " . $this->session->userdata ( 'user_name' );
		
		$this->email->message ( $message );
		$this->email->send ();
		return true;
	}
	function case_document_action($primary_key, $row) {
		return site_url ( 'master/documents' ) . '?case=' . $primary_key;
	}
	public function relations() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'relation_master' )->set_subject ( 'Relations' );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function specializations() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'doctor_specialization_master' )->set_subject ( 'Specialization' );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function queries() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'query' )->set_subject ( 'Query' );
			$crud->set_relation ( 'case_id', 'cases', 'subject' );
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function opportunities() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'opportunities' )->set_subject ( 'Opportunity' );
			
			$this->session->set_userdata ( 'activeMenu', "opportmgt" );
			// $crud->set_relation('created_by','user','Email_Address');
			
			$crud->set_rules ( 'first_name', 'First Name', 'trim|required|xss_clean' );
			$crud->set_rules ( 'last_name', 'Last Name', 'trim|required|xss_clean' );
			$crud->set_rules ( 'mobile', 'Mobile Number', 'trim|required|xss_clean' );
			$crud->set_rules ( 'email', 'Email', 'trim|required|xss_clean|valid_email' );
			$crud->set_rules ( 'details', 'Message', 'trim|required|xss_clean' );
			
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER)
				$crud->where ( 'Created_By = ' . $this->session->userdata ( 'user' )->User_Id );
			
			$crud->field_type ( 'Created_By', 'invisible' );
			$crud->callback_before_insert ( array (
					$this,
					'before_create_opportunities' 
			) );
			
			
			$crud->callback_after_insert ( array (
					$this,
					'after_insert_opportunities'
			) );
				
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	function before_create_opportunities($post_array) {
		$TodayDate = date ( DATEFORMAT );
		
		$post_array ['created'] = $TodayDate;
		if ($this->session->userdata ( 'user' )->User_Id != NULL && $this->session->userdata ( 'user' )->User_Id != '') {
			$post_array ['created_by'] = $this->session->userdata ( 'user' )->User_Id;
			
		} else {
			$post_array ['created_by'] = 0;
		}
		
		return $post_array;
	}
	
	function after_insert_opportunities($post_array, $primary_key) 
	{
				$Body='New Enquiry with Details Follows<br/>
						
						Name -'.$post_array ["first_name"] . ' ' . $post_array ["last_name"].'  <br/>
						Email -'.$post_array ["email"] .'<br/>
						Mobile -'.$post_array ["mobile"] .'  <br/>
						Message -'.$post_array ["details"] .'  <br/>						
						';
				// Send Email To Admin
				$TodayDate = date ( DATETIMEFORMAT );
				$this->load->helper ( 'secureemail' );
				$CC = '';
				$EmailAddresTo = SUPPORTEMAIL;
				$EmailAddressFrom = INFOEMAIL;
				$SubjectEmail = 'New enquiry through Contact us.';
				$EmailNotification = array (
						'To' => $EmailAddresTo,
						'FROM' => $EmailAddressFrom,
						'CC' => $CC,
						'Subject' => $SubjectEmail,
						'Body' => $Body,
						'Type' => '',
						'Attach' => ''
				);
				$ResultEmail = send_secured_email ( $EmailNotification );
			
		return true;
	}
	public function documents() {
		$user = $this->session->userdata ( 'user' );
		
		if ($user != NULL) {
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'document' )->set_subject ( 'Documents' );
			$crud->set_field_upload ( 'document_detail', 'documents/uploads' );
			
			$crud->display_as ( 'document_title', 'Title' );
			$crud->display_as ( 'document_detail', 'Document' );
			$crud->field_type ( 'created_by', 'invisible' );
			$crud->field_type ( 'created_on', 'invisible' );
			
			$crud->field_type ( 'Type', 'dropdown', array (
					'Prescription' => 'Prescription',
					'Medical Image' => 'Medical Image',
					'Lab Report' => 'Lab Report',
					'Other' => 'Other' 
			) );
			
			$crud->set_relation ( 'Patient_Id', 'patients', 'FName', array (
					'Created_By' => $user->User_Id 
			) ); //
			
			$crud->required_fields ( 'document_title', 'document_detail' );
			
			$crud->display_as ( 'Patient_Id', 'Patient Name' );
			$crud->set_rules ( 'Patient_Id', 'Patient Name', 'trim|required|xss_clean' );
			
			$crud->columns ( 'document_title', 'document_detail', 'created_on' );
			
			$crud->where ( 'document.created_by = ' . $this->session->userdata ( 'user' )->User_Id );
			
			$crud->callback_before_insert ( array (
					$this,
					'before_create_document' 
			) );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	function before_create_document($post_array) {
		$post_array ['created_by'] = $this->session->userdata ( 'user' )->User_Id;
		$post_array ['created_on'] = date ( DATETIMEFORMAT );
		return $post_array;
	}
	public function messages() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'messages' )->set_subject ( 'Messages' );
			
			$crud->where ( 'to = \'' . $this->session->userdata ( 'user' )->email . '\'' );
			
			// $crud->set_relation('to','user','email');
			
			// $crud->set_relation('from','user','email');
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function reports() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'report' )->set_subject ( 'Reports' );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function users() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'user' )->set_subject ( 'Users' );
			
			$crud->columns ( 'First_name', 'Last_Name', 'Email_Address', 'Mobile_Number', 'City', 'Country' );
			
			$crud->field_type ( 'User_Type', 'dropdown', array (
					'0' => 'Regular' 
			) );
			
			$state_info = $crud->getStateInfo ();
			
			if ($state_info->primary_key != $this->session->userdata ( 'user' )->User_Id)
				redirect ( 'master/users/edit/' . $this->session->userdata ( 'user' )->User_Id, 'location' );
			
			$crud->where ( 'User_Id', $this->session->userdata ( 'user' )->User_Id );
			
			$crud->unset_add ();
			
			$crud->unset_delete ();
			
			$crud->field_type ( 'Password', 'invisible' );
			
			$output = $crud->render ();
			$this->_master_output ( $output );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function PaymentDetails() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'payment_details' )->set_subject ( 'Payment Details' );
			
			$crud->field_type ( 'PaymentMode', 'dropdown', array (
					'Credit Card' => 'Credit Card',
					'Debit Card' => 'Debit Card',
					'Internet Banking' => 'Internet Banking' 
			) );
			
			$crud->fields ( 'LastName', 'PromoCode', 'Currency', 'PaymentMode', 'CardNumber', 'CardName', 'ExpiryDate', 'CVC', 'Created_By' );
			$crud->field_type ( 'Created_By', 'invisible' );
			
			$crud->where ( 'Created_By = ' . $this->session->userdata ( 'user' )->User_Id );
			
			$crud->callback_before_insert ( array (
					$this,
					'before_create_PaymentDetails' 
			) );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	function before_create_PaymentDetails($post_array) {
		$post_array ['Created_By'] = $this->session->userdata ( 'user' )->User_Id;
		return $post_array;
	}
	public function ManageUsers() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER && $this->session->userdata ( 'user_type' ) != SALES)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'user' )->set_subject ( 'Users' );
			
			$this->session->set_userdata ( 'activeMenu', "usermgt" );
			
			$crud->columns ( 'First_name', 'Last_Name', 'email', 'Mobile_Number', 'City', 'Country' );
			
			$state_info = $crud->getStateInfo ();
			
			// $crud->field_type('Password', 'invisible');
			
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER)
				$crud->where ( 'Created_By = ' . $this->session->userdata ( 'user' )->User_Id );
			$crud->field_type ( 'Created_By', 'invisible' );
			
			$crud->callback_before_insert ( array (
					$this,
					'before_create_ManageUsers' 
			) );
			
			$output = $crud->render ();
			$this->_master_output ( $output );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	function before_create_ManageUsers($post_array) {
		$this->load->helper ( 'security' );
		
		$post_array ['Created_By'] = $this->session->userdata ( 'user' )->User_Id;
		$CreatorName=$this->session->userdata ( 'user' )->First_name.' '.$this->session->userdata ( 'user' )->Last_Name;
		$post_array ['Creator'] = $CreatorName;
		$post_array ['User_Type'] = 0;
		
		$PasswordHash = do_hash ( $post_array ['Password'], 'md5' );
		$post_array ['Password'] = $PasswordHash;
		return $post_array;
	}
	public function PartnerDetails() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER && $this->session->userdata ( 'user_type' ) != SALES)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'partners' )->set_subject ( 'GO Partners' );
			
			$this->session->set_userdata ( 'activeMenu', "partnermgt" );
			
			
			$crud->fields ( 'PartnerName', 'Phone', 'Email', 'KeyPerson1', 'KeyPerson1_Phone', 'KeyPerson1_Email', 'KeyPerson1_Designation', 'KeyPerson2', 'KeyPerson2_Phone', 'KeyPerson2_Email', 'KeyPerson2_Designation', 'Created_By' );
			$crud->field_type ( 'Created_By', 'invisible' );
			
			$crud->set_rules ( 'PartnerName', 'Partner Name', 'trim|required|xss_clean' );
			$crud->set_rules ( 'Phone', 'Phone', 'trim|required|xss_clean|max_length[20]' );
			$crud->set_rules ( 'Email', 'Email', 'trim|required|xss_clean|valid_email' );
			$crud->set_rules ( 'KeyPerson1', 'Primary Contact Name', 'trim|required|xss_clean' );
			$crud->set_rules ( 'KeyPerson1_Phone', 'Primary Contact Phone', 'trim|required|xss_clean|max_length[20]' );
			
			$crud->set_rules ( 'KeyPerson1_Email', 'Primary Contact Email', 'trim|xss_clean|valid_email' );
			
			$crud->set_rules ( 'KeyPerson2', 'Secondary Contact Name', 'trim|xss_clean' );
			$crud->set_rules ( 'KeyPerson2_Phone', 'Secondary Contact Phone', 'trim|xss_clean|max_length[20]' );
			$crud->set_rules ( 'KeyPerson2_Email', 'Secondary Contact Email', 'trim|xss_clean|valid_email' );
			
			$crud->required_fields('PartnerName','Phone','Email','KeyPerson1','KeyPerson1_Phone');
			
			$crud->columns ( 'PartnerName', 'Phone', 'Email', 'KeyPerson1', 'KeyPerson1_Phone' );
				
			$crud->display_as('PartnerName','Partner Name');
			
			$crud->display_as('KeyPerson1','Primary Contact Name');
			$crud->display_as('KeyPerson1_Phone','Primary Contact Phone');
			$crud->display_as('KeyPerson1_Email','Primary Contact Email');
			$crud->display_as('KeyPerson1_Designation','Primary Contact Designation');
			
			$crud->display_as('KeyPerson2','Secondary Contact Name');
			$crud->display_as('KeyPerson2_Phone','Secondary Contact Phone');
			$crud->display_as('KeyPerson2_Email','Secondary Contact Email');
			$crud->display_as('KeyPerson2_Designation','Secondary Contact Designation');
			
			$crud->where ( 'Created_By = ' . $this->session->userdata ( 'user' )->User_Id );
			
			$crud->callback_before_insert ( array (
					$this,
					'before_create_partner' 
			) );
			
			$output = $crud->render ();
			
			$this->_master_output ( $output );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	function before_create_partner($post_array) {
		$post_array ['Created_By'] = $this->session->userdata ( 'user' )->User_Id;
		return $post_array;
	}
	public function CorporateEmployeesAdd() {
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			if ($user->User_Type != ADMIN && $user->User_Type != ADMINUSER && $user->User_Type != CORPADMIN)
				redirect ( 'home/', 'location' );
			
			$crud = new grocery_CRUD ();
			$crud->set_theme ( 'twitter-bootstrap' );
			
			$crud->set_table ( 'user' )->set_subject ( 'Employees' );
			
			$this->session->set_userdata ( 'activeMenu', "usermgt" );
			
			$crud->columns ( 'First_name', 'Last_Name', 'email', 'Mobile_Number', 'City', 'Country' );
			
			$crud->set_rules ( 'First_name', 'First Name', 'trim|required|xss_clean' );
			$crud->set_rules ( 'Last_Name', 'Last Name', 'trim|required|xss_clean' );
			$crud->set_rules ( 'Birth_Date', 'Birth Date', 'trim|required|xss_clean' );
			$crud->set_rules ( 'Mobile_Number', 'Mobile Number', 'trim|required|xss_clean|numeric' );
			$crud->set_rules ( 'email', 'Email', 'trim|required|xss_clean|valid_email' );
			$crud->set_rules ( 'Country', 'Country', 'trim|required|xss_clean' );
			$crud->set_rules ( 'Password', 'Password', 'trim|required|xss_clean' );
			$crud->set_rules ( 'Corp_Code', 'Corporate Code', 'trim|required|xss_clean' );
			
			$crud->field_type ( 'Gender', 'dropdown', array (
					"Male" => "Male",
					"Female" => "Female" 
			) );
			
			$state_info = $crud->getStateInfo ();
			
			$crud->set_relation ( 'Created_By', 'user', '{First_name} {Last_Name}' );
			$crud->order_by ( 'User_Id', 'desc' );
			
			$crud->field_type ( 'Created_By', 'invisible' );
			
			if ($user->User_Type != ADMIN && $user->User_Type != ADMINUSER)
				$crud->where ( 'user.Created_By = ' . $this->session->userdata ( 'user' )->User_Id );
			
			$crud->field_type ( 'User_Type', 'invisible' );
			$crud->field_type ( 'User_Image', 'invisible' );
			
			$crud->callback_before_insert ( array (
					$this,
					'before_create_CorporateEmployeesAdd' 
			) );
			
			$output = $crud->render ();
			$this->_master_output ( $output );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	function before_create_CorporateEmployeesAdd($post_array) {
		$this->load->helper ( 'security' );
		$PasswordHash = do_hash ( $post_array ['Password'], 'md5' );
		$post_array ['Password'] = $PasswordHash;
		
		$post_array ['User_Type'] = CUSTOMER;
		$post_array ['Created_By'] = $this->session->userdata ( 'user' )->User_Id;
		$CreatorName=$this->session->userdata ( 'user' )->First_name.' '.$this->session->userdata ( 'user' )->Last_Name;
		$post_array ['Creator'] = $CreatorName;
		return $post_array;
	}
	
	
}
?>