<?php
class Messages extends CI_Controller {
	public function index($offset = NULL) {
		
		$user = $this->session->userdata ( 'user' );
		
		if ($user != null) {
			$this->load->model ( 'MessageMaster' );
			
			$this->session->set_userdata ( 'activeMenu', "messages" );
			if ($this->session->userdata ( 'user_type' ) == ADMIN || $this->session->userdata ( 'user_type' ) == ADMINUSER) {
				$Userid = $this->session->userdata ( 'user' )->User_Id;
				$UserType = $this->session->userdata ( 'user_type' );
				$MessageList = $this->MessageMaster->getMessagesForAdmin ( $Userid, $UserType );
			} else {
				$MessageList = $this->MessageMaster->getMessagesByUser ( $this->session->userdata ( 'user' )->User_Id );
			}
			
			$MessageArray = array ();
			
			foreach ( $MessageList as $SingleMessage ) 
			{
				if($SingleMessage->User_Type == ADMINUSER)
				{
					$MsgFrom='Customer Care';
				}
				else if($SingleMessage->User_Type == ADMIN)
				{
					$MsgFrom='Admin';
				}
				else
				{
					$MsgFrom=$SingleMessage->First_name.' '.$SingleMessage->Last_Name;
				}
				
				$MessageArray [] = array (
						'Msg_Id' => $SingleMessage->Msg_Id,
						'subject' => $SingleMessage->subject,
						'MsgFrom' =>$MsgFrom, //$SingleMessage->MsgFrom,
						'ReadStatus' => $SingleMessage->ReadStatus,
						'sent' => date ( DATETIMEFORMAT, strtotime ( $SingleMessage->sent ) ) 
				);
			}
			
			$MessageDetails = $this->session->flashdata ( 'DoctorCaseMsg' );
			
			if ($MessageDetails == NUll) {
				$Message = array (
						'CaseId' => '',
						'Message' => '',
						'ErrorBit' => '' 
				);
			} else {
				$Message = array (
						'CaseId' => $MessageDetails ['CaseId'],
						'Message' => $MessageDetails ['Message'],
						'ErrorBit' => $MessageDetails ['ErrorBit'] 
				);
			}
			
			$data ['CaseMessage'] = $Message;
			
			$data ['messages'] = $MessageArray;
			$this->load->view ( 'messagelist', $data );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function detail($id) {
		
		$user = $this->session->userdata ( 'user' );
		
		if ($user != NULL) {
			$this->load->model ( 'MessageMaster' );
			$data ['message'] = $this->MessageMaster->getMessageById ( $id );
			$UserType = $user->User_Type;
			$data ['UserType'] = $UserType;
			$this->load->view ( 'messagedetail', $data );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function add() {
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			$this->load->model ( 'MessageMaster' );
			
			$CaseDetails = $this->session->flashdata ( 'Msg' );
			
			// print_r($myVar);
			$UserType = $user->User_Type;
			
			if ($UserType != ADMIN && $UserType != ADMINUSER) {
				$this->load->view ( 'messageadd' );
			} else {
				
				$AllUserList = $this->MessageMaster->getAllUser ();
				
				$PatientList = array ();
				$DoctorList = array ();
				$CustomerCareList = array ();
				
				foreach ( $AllUserList as $SingleUser ) 
				{
					switch ($SingleUser->User_Type) 
					{
						case ADMINUSER :
						case ADMIN :
							$CustomerCareList [] = array (
									'label' => $SingleUser->First_name . ' ' . $SingleUser->Last_Name.'  -('.$SingleUser->User_Id.')',
									'value' => $SingleUser->User_Id 
							);
							break;
						
						case DOCTORS :
							$DoctorList [] = array (
									'label' => $SingleUser->First_name . ' ' . $SingleUser->Last_Name.'  -('.$SingleUser->User_Id.')',
									'value' => $SingleUser->User_Id 
							);
							break;
						
						default :
							$PatientList [] = array (
									'label' => $SingleUser->First_name . ' ' . $SingleUser->Last_Name.'  -('.$SingleUser->User_Id.')',
									'value' => $SingleUser->User_Id 
							);
							break;
					}
					/*
					$PatientList [] = array (
							'label' => $SingleUser->First_name . ' ' . $SingleUser->Last_Name.'  -('.$SingleUser->User_Id.')',
							'value' => $SingleUser->User_Id
					);*/
				}
				
				If ($CaseDetails == NULL) {
					$CaseDetails = array (
							'Patient_Id' => '',
							'User_Id' => '',
							'CaseId' => '',
							'Doctor_Id' => '',
							'Doc_UserId' => '' 
					);
				}
				$data ['Patients'] = $PatientList;
				$data ['Doctors'] = $DoctorList;
				$data ['CustCareList'] = $CustomerCareList;
				$data ['case'] = $CaseDetails;
				
				$this->load->view ( 'messageaddadmin', $data );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function addpost() {
		
		$user = $this->session->userdata ( 'user' );
		
		$SubmitValue = $this->input->post ( 'back' );
		if ($SubmitValue != NULL && $SubmitValue != '')
		{
			redirect ( 'messages', 'location' );
		}
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		// $this->form_validation->set_rules ( 'towhom', 'To Whom', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'subject', 'Subject', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'body', 'Body', 'trim|required|xss_clean' );
		
		if ($user != null) {
			if ($user->User_Type == ADMIN || $user->User_Type == ADMINUSER) {
				$this->form_validation->set_rules ( 'MsgTo', 'To Whom', 'trim|required|xss_clean' );
			}
			
			$this->load->model ( 'MessageMaster' );
			
			if ($this->form_validation->run () == FALSE) {
				if ($user->User_Type != ADMIN && $user->User_Type != ADMINUSER) {
					$this->load->view ( 'messageadd' );
					return;
				} else {
					$AllUserList = $this->MessageMaster->getAllUser ();
					$CaseDetails = $this->session->flashdata ( 'Msg' );
					$PatientList = array ();
					$DoctorList = array ();
					$CustomerCareList = array ();
					
					foreach ( $AllUserList as $SingleUser ) 
					{
						switch ($SingleUser->User_Type) {
							case ADMINUSER :
							case ADMIN :
								$CustomerCareList [] = array (
										'label' => $SingleUser->First_name . ' ' . $SingleUser->Last_Name.'  -('.$SingleUser->User_Id.')',
										'value' => $SingleUser->User_Id 
								);
								break;
							
							case DOCTORS :
								$DoctorList [] = array (
										'label' => $SingleUser->First_name . ' ' . $SingleUser->Last_Name.'  -('.$SingleUser->User_Id.')',
										'value' => $SingleUser->User_Id 
								);
								break;
							
							default :
								$PatientList [] = array (
										'label' => $SingleUser->First_name . ' ' . $SingleUser->Last_Name.'  -('.$SingleUser->User_Id.')',
										'value' => $SingleUser->User_Id 
								);
								break;
						}
						/*
						$PatientList [] = array (
								'label' => $SingleUser->First_name . ' ' . $SingleUser->Last_Name.'  -('.$SingleUser->User_Id.')',
								'value' => $SingleUser->User_Id
						); */
					}
					
					If ($CaseDetails == NULL) {
						$CaseDetails = array (
								'Patient_Id' => '',
								'User_Id' => '',
								'CaseId' => '',
								'Doctor_Id' => '',
								'Doc_UserId' => '' 
						);
					}
					$data ['Patients'] = $PatientList;
					$data ['Doctors'] = $DoctorList;
					$data ['CustCareList'] = $CustomerCareList;
					$data ['case'] = $CaseDetails;
					
					$this->load->view ( 'messageaddadmin', $data );
					return;
				}
			}
			
			$ToUser = '';
			if ($user->User_Type == ADMIN || $user->User_Type == ADMINUSER) 
			{
				$RadioSelect = $this->input->post ( 'MsgTo' );
				
				if ($RadioSelect != NULL && $RadioSelect != '') 
				{
					/*switch ($RadioSelect) 
					{
						case "CC" :
							$ToUser = $this->input->post ( 'CustCare' );
							break;
						
						case "Doctor" :
							$ToUser = $this->input->post ( 'doctorname' );
							break;
						
						case "Patient" :
							$ToUser = $this->input->post ( 'patient' );
							break;
					}*/
					
					$ToUser = $this->input->post ( 'patient' );
				}
			}
			
			$this->MessageMaster->add ( $ToUser );
			
			// Add Audit Trail
			$this->load->model ( 'AuditTrailMaster' );
			$ControllerData = array (
					'Controller' => $this->router->class,
					'Action' => 'New Message sent  by user-'.$user->First_name.' '.$user->Last_Name.'  who is  type-'.$user->User_Type //$this->router->method' 
			)
			;
			$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
			
			// Set Flash Message
			$FinalMsg = 'Message Sent.';
			$MsgBit = "Success";
			$Message = array (
					'CaseId' => '',
					'Message' => $FinalMsg,
					'ErrorBit' => $MsgBit 
			);
			
			$this->session->set_flashdata ( 'DoctorCaseMsg', $Message );
			
			redirect ( 'messages', 'location' );
			
			// redirect('home','location');
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function markread($msgid) {
		$this->load->model ( 'MessageMaster' );
		$Result = $this->MessageMaster->updatereadFlag ( $msgid );
		redirect ( 'messages', 'location' );
	}
	public function reply($msgid) {
		
		$user = $this->session->userdata ( 'user' );
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		if ($user != null) {
			$this->load->model ( 'MessageMaster' );
			$MsgDetails = $this->MessageMaster->getMessageById ( $msgid );
			$Result = $this->MessageMaster->updatereadFlag ( $msgid ); // Update the Flag
			$data ['ToWhom'] = $MsgDetails->MsgFrom;
			$data ['MsgId'] = $msgid;
			$this->load->view ( 'messagereply', $data );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function replypost($msgid) {
		
		$user = $this->session->userdata ( 'user' );
		
		$SubmitValue = $this->input->post ( 'back' );
		if ($SubmitValue != NULL && $SubmitValue != '')
		{
			redirect ( 'messages', 'location' );
		}
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		$this->form_validation->set_rules ( 'subject', 'Subject', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'body', 'Body', 'trim|required|xss_clean' );
		
		if ($user != null) {
			$this->load->model ( 'MessageMaster' );
			
			$MsgDetails = $this->MessageMaster->getMessageById ( $msgid );
			
			$MsgFrom=$MsgDetails->MsgFrom;
			if ($this->form_validation->run () == FALSE) {
				
				$data ['ToWhom'] = $MsgDetails->MsgFrom;
				$this->load->view ( 'messagereply', $data );
				return;
			}
			
			$FolloupQueryDetails=$this->MessageMaster->getFollowupQueryDetails($MsgDetails->Original_Reply_Id);
			
			if($FolloupQueryDetails != NULL && $FolloupQueryDetails != '')
			{
				$MsgFrom=$FolloupQueryDetails->QByUserId;
			}
			
			$MsgResult = $this->MessageMaster->replypost ($MsgFrom ,$MsgDetails->Original_Reply_Id );
			
			if ($MsgDetails->Original_Reply_Id != NULL && $MsgDetails->Original_Reply_Id != 0) 
			{
				$MsgRespone = $this->MessageMaster->updateFollowupQuery ( $MsgDetails->Original_Reply_Id );
				
				// Send Notification Admin
				$SubjectNotification = 'Case ID '.$FolloupQueryDetails->Case_Id.' has a reply from '. $this->session->userdata ( 'user_name' );
				$Bodynoti = $this->input->post('body');
				$Notifications1 = array (
						'ToRole' => ADMINUSER,
						'Subject' => $SubjectNotification,
						'Body' => $Bodynoti,
						'ToUser' => '',
						'QuestionId' => ''
				);
				$ResultNotify = send_notification_for_user ( $Notifications1 );
				
				
				$this->load->helper ( 'secureemail' );
				$CC = '';
				$EmailAddresTo = SUPPORTEMAIL;
				$EmailAddressFrom = SYSTEMEMAIL;
				$SubjectEmail = $SubjectNotification;
					
				$BodyEmail = $Bodynoti;
				$EmailNotification = array (
						'To' => $EmailAddresTo,
						'FROM' => $EmailAddressFrom,
						'CC' => $CC,
						'Subject' => $SubjectEmail,
						'Body' => $BodyEmail,
						'Type' => "",
						'Attach' => ''
				)
				;
				$ResultEmail = send_secured_email ( $EmailNotification );
			}
			
			// Add Audit Trail
			$this->load->model ( 'AuditTrailMaster' );
			$ControllerData = array (
					'Controller' => $this->router->class,
					'Action' => 'Reply for Message with message id-'.$msgid.' sent  by user-'.$user->First_name.' '.$user->Last_Name.'  who is  type-'.$user->User_Type //$this->router->method' 
			)
			;
			$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
			
			// Set Flash Message
			$FinalMsg = 'Reply Sent.';
			$MsgBit = "Success";
			$Message = array (
					'CaseId' => '',
					'Message' => $FinalMsg,
					'ErrorBit' => $MsgBit 
			);
			
			$this->session->set_flashdata ( 'DoctorCaseMsg', $Message );
			
			redirect ( 'messages', 'location' );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function forward($MsgId) {
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		$user = $this->session->userdata ( 'user' );
		if ($user != NULL) {
			$UserType = $user->User_Type;
			if ($UserType == ADMIN || $UserType == ADMINUSER) {
				$this->load->model ( 'MessageMaster' );
				
				$MessageDetails = $this->MessageMaster->getMessageById ( $MsgId );
				
				$CaseDetails = $this->session->flashdata ( 'Msg' );
				
				// print_r($myVar);
				
				$AllUserList = $this->MessageMaster->getAllUser ();
				
				$PatientList = array ();
				$DoctorList = array ();
				$CustomerCareList = array ();
				
				foreach ( $AllUserList as $SingleUser ) 
				{
					switch ($SingleUser->User_Type) {
						case ADMINUSER :
						case ADMIN :
							$CustomerCareList [] = array (
									'label' => $SingleUser->First_name . ' ' . $SingleUser->Last_Name.'  -('.$SingleUser->User_Id.')',
									'value' => $SingleUser->User_Id
							);
							break;
						
						case DOCTORS :
							$DoctorList [] = array (
									'label' => $SingleUser->First_name . ' ' . $SingleUser->Last_Name.'  -('.$SingleUser->User_Id.')',
									'value' => $SingleUser->User_Id
							);
							break;
						
						default :
							$PatientList [] = array (
									'label' => $SingleUser->First_name . ' ' . $SingleUser->Last_Name.'  -('.$SingleUser->User_Id.')',
									'value' => $SingleUser->User_Id
							);
							break;
					}
					/*
					$PatientList [] = array (
							'label' => $SingleUser->First_name . ' ' . $SingleUser->Last_Name.'  -('.$SingleUser->User_Id.')',
							'value' => $SingleUser->User_Id
					); */
				}
				
				If ($CaseDetails == NULL) {
					$CaseDetails = array (
							'Patient_Id' => '',
							'User_Id' => '',
							'CaseId' => '',
							'Doctor_Id' => '',
							'Doc_UserId' => ''
					);
				}
				$data ['Patients'] = $PatientList;
				$data ['Doctors'] = $DoctorList;
				$data ['CustCareList'] = $CustomerCareList;
				$data ['case'] = $CaseDetails;
				$data ['Message'] = $MessageDetails;
				
				$this->load->view ( 'messageforwardadmin', $data );
			} else {
				$this->load->view ( 'accessdenied' );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function forwardpost($MsgId) {
		
		$user = $this->session->userdata ( 'user' );
		
		$SubmitValue = $this->input->post ( 'back' );
		if ($SubmitValue != NULL && $SubmitValue != '')
		{
			redirect ( 'messages', 'location' );
		}
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		$this->form_validation->set_rules ( 'MsgTo', 'To Whom', 'required' );
		$this->form_validation->set_rules ( 'subject', 'Subject', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'body', 'Body', 'trim|required|xss_clean' );
		
		if ($user != null) {
			$this->load->model ( 'MessageMaster' );
			$MessageDetails = $this->MessageMaster->getMessageById ( $MsgId );
			
			if ($this->form_validation->run () == FALSE) {
				
				
				$CaseDetails = $this->session->flashdata ( 'Msg' );
				
				// print_r($myVar);
				$UserType = $user->User_Type;
				
				$AllUserList = $this->MessageMaster->getAllUser ();
				
				$PatientList = array ();
				$DoctorList = array ();
				$CustomerCareList = array ();
				
				foreach ( $AllUserList as $SingleUser ) 
				{
					switch ($SingleUser->User_Type) {
						case ADMINUSER :
						case ADMIN :
							$CustomerCareList [] = array (
									'label' => $SingleUser->First_name . ' ' . $SingleUser->Last_Name.'  -('.$SingleUser->User_Id.')',
									'value' => $SingleUser->User_Id
							);
							break;
						
						case DOCTORS :
							$DoctorList [] = array (
									'label' => $SingleUser->First_name . ' ' . $SingleUser->Last_Name.'  -('.$SingleUser->User_Id.')',
									'value' => $SingleUser->User_Id
							);
							break;
						
						default :
							$PatientList [] = array (
									'label' => $SingleUser->First_name . ' ' . $SingleUser->Last_Name.'  -('.$SingleUser->User_Id.')',
									'value' => $SingleUser->User_Id
							);
							break;
					}
					/*
					$PatientList [] = array (
							'label' => $SingleUser->First_name . ' ' . $SingleUser->Last_Name.'  -('.$SingleUser->User_Id.')',
							'value' => $SingleUser->User_Id
					); */
				}
				
				If ($CaseDetails == NULL) {
					$CaseDetails = array (
							'Patient_Id' => '',
							'User_Id' => '',
							'CaseId' => '',
							'Doctor_Id' => '',
							'Doc_UserId' => '' 
					);
				}
				$data ['Patients'] = $PatientList;
				$data ['Doctors'] = $DoctorList;
				$data ['CustCareList'] = $CustomerCareList;
				$data ['case'] = $CaseDetails;
				$data ['Message'] = $MessageDetails;
				
				$this->load->view ( 'messageforwardadmin', $data );
				return;
			}
			
			$RadioSelect = $this->input->post ( 'MsgTo' );
			$ToUser = '';
			
			if ($RadioSelect != NULL && $RadioSelect != '') 
			{
				/*switch ($RadioSelect) {
					case "CC" :
						$ToUser = $this->input->post ( 'CustCare' );
						break;
					
					case "Doctor" :
						$ToUser = $this->input->post ( 'doctorname' );
						break;
					
					case "Patient" :
						$ToUser = $this->input->post ( 'patient' );
						break;
				}*/
				
				$ToUser = $this->input->post ( 'patient' );
				
			}
			
			$this->MessageMaster->add ( $ToUser ,$MessageDetails->Original_Reply_Id);
			
			// Add Audit Trail
			$this->load->model ( 'AuditTrailMaster' );
			$ControllerData = array (
					'Controller' => $this->router->class,
					'Action' => 'Message forwarded  by User Type-'.$user->User_Type.' to User with id - '.$ToUser 
			)
			;
			$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
			
			// Set Flash Message
			$FinalMsg = 'Message Forwarded.';
			$MsgBit = "Success";
			$Message = array (
					'CaseId' => '',
					'Message' => $FinalMsg,
					'ErrorBit' => $MsgBit 
			);
			
			$this->session->set_flashdata ( 'DoctorCaseMsg', $Message );
			
			redirect ( 'messages', 'location' );
			
			// redirect('home','location');
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
}
?>