<?php
class Patients extends CI_Controller {
	// default action
	// We will show all patients created by user here
	public function index($offset = NULL) {
		
		$user = $this->session->userdata ( 'user' );
		
		if ($user != NULL) {
			
			$this->session->set_userdata ( 'activeMenu', "phr" );
			$this->load->model ( 'PatientMaster' );
			
			if ($user->User_Type == ADMIN || $user->User_Type == ADMINUSER) {
				$PatientsList = $this->PatientMaster->getAllPatients ();
			} else {
				$PatientsList = $this->PatientMaster->getPatientsByUser ( $this->session->userdata ( 'user' )->User_Id );
			}
			
			$Relations = $this->PatientMaster->getRelations ();
			
			$PatientsArray = array ();
			
			foreach ( $PatientsList as $Patient ) {
				$relation = $this->setRelationName ( $Relations, $Patient->Relation );
				$PatientsArray [] = array (
						'Patient_Id' => $Patient->Patient_Id,
						'FName' => $Patient->FName,
						'LName' => $Patient->LName,
						'Phone' => $Patient->Phone,
						'Email' => $Patient->Email,
						'DOB' => date ( DATEFORMAT, strtotime ( $Patient->DOB ) ),
						'Gender' => $Patient->Gender,
						'Created_Date' => date ( DATEFORMAT, strtotime ($Patient->Created_Date)),
						'Relation' => $relation 
				);
			}
			
			$MessageDetails = $this->session->flashdata ( 'PatientMsg' );
			
			if ($MessageDetails == NUll) {
				$Message = array (
						'CaseId' => '',
						'Message' => '',
						'ErrorBit' => '' 
				);
			} else {
				$Message = array (
						'CaseId' => $MessageDetails ['CaseId'],
						'Message' => $MessageDetails ['Message'],
						'ErrorBit' => $MessageDetails ['ErrorBit'] 
				);
			}
			
			$data ['CaseMessage'] = $Message;
			
			$data ['patients'] = $PatientsArray;
			$this->load->view ( 'patientlist', $data );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	// To set the Relation of the Patients
	private function setRelationName($Relations, $RelationId) {
		$RealationSelected = $RelationId;
		foreach ( $Relations as $SingleRealation ) {
			If ($SingleRealation->id == $RelationId) {
				$RealationSelected = $SingleRealation->name;
				Break;
			}
		}
		
		return $RealationSelected;
	}
	public function detail($id) {
		
		$user = $this->session->userdata ( 'user' );
		
		if ($user != NULL) {
			$this->load->model ( 'PatientMaster' );
			$Patient = $this->PatientMaster->getPatientById ( $id );
			$Relations = $this->PatientMaster->getRelations ();
			
			$relation = $this->setRelationName ( $Relations, $Patient->Relation );
			$PatientsArray = array (
					'Patient_Id' => $Patient->Patient_Id,
					'FName' => $Patient->FName,
					'LName' => $Patient->LName,
					'Phone' => $Patient->Phone,
					'Email' => $Patient->Email,
					'DOB' => date ( DATEFORMAT, strtotime ( $Patient->DOB ) ),
					'Gender' => $Patient->Gender,
					'Country' => $Patient->Country,
					'Relation' => $relation 
			);
			
			$data ['patients'] = $PatientsArray;
			$this->load->view ( 'patientdetail', $data );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function add() {
		
		$user = $this->session->userdata ( 'user' );
		
		if ($user != NULL) {
			$this->load->helper ( 'form' );
			$this->load->library ( 'form_validation' );
			$this->load->model ( 'CaseMaster' );
			$data ['Relations'] = $this->CaseMaster->getRelations ();
			$this->load->view ( 'patientadd',$data );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function addpost() {
		
		$user = $this->session->userdata ( 'user' );
		
		$SubmitValue = $this->input->post ( 'back' );
		
		if ($SubmitValue != NULL && $SubmitValue != '')
		{
				
			redirect ( 'patients', 'location' );
		}
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		$this->form_validation->set_rules ( 'email', 'Email', 'trim|required|xss_clean|valid_email' );
		$this->form_validation->set_rules ( 'fname', 'First Name', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'lname', 'Last Name', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'relation', 'Relation', 'trim|required|xss_clean|callback__validate_relation' );
		$this->form_validation->set_rules ( 'dob', 'Date of Birth', 'trim|required|xss_clean|callback__validate_dateofbirth' );
		
		if ($user != null) {
			
			if ($this->form_validation->run () == FALSE) {
				
				$this->load->model ( 'CaseMaster' );
				$data ['Relations'] = $this->CaseMaster->getRelations ();
			$this->load->view ( 'patientadd',$data );
				return;
			}
			$this->load->model ( 'PatientMaster' );
			$this->PatientMaster->add ();
			// Add Audit Trail
			$this->load->model ( 'AuditTrailMaster' );
			$ControllerData = array (
					'Controller' => $this->router->class,
					'Action' => 'New patient added in system by user-'.$user->First_name.' '.$user->Last_Name.'  who is  type-'.$user->User_Type //$this->router->method' 
			)
			;
			$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
			
			// Set Flash Message
			$FinalMsg = 'The Patient Added Successfully.';
			$MsgBit = "Success";
			$Message = array (
					'CaseId' => '',
					'Message' => $FinalMsg,
					'ErrorBit' => $MsgBit 
			);
			
			$this->session->set_flashdata ( 'PatientMsg', $Message );
			
			redirect ( 'patients', 'location' );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	
	public function _check_existing_user($email) 
	{
		$this->load->model ( 'CaseMaster' );
		$user = $this->CaseMaster->getPatientByEmail ( $email );
		if (count ( $user ) > 0) {
			$this->form_validation->set_message ( '_check_existing_user', 'The email address ' . $email . ' is already registered with us.
					                                            Please use alternate email or  contact GrandOpinion support ' );
			return FALSE;
		} else {
			return TRUE;
		}
	}
	
	public function patientEdit($id) {
		
		$user = $this->session->userdata ( 'user' );
		
		if ($user != null) {
			$this->load->helper ( 'form' );
			$this->load->library ( 'form_validation' );
			$this->load->model ( 'PatientMaster' );
			$data ['patients'] = $this->PatientMaster->getPatientById ( $id );
			$data ['Relations'] = $this->PatientMaster->getRelations ();
			
			$CaseDetails = $this->session->flashdata ( 'Msg' );
			if ($CaseDetails == NUll || $CaseDetails == '') {
				$CaseId = '';
			} else {
				$CaseId = $CaseDetails ['CaseId'];
			}
			
			$data ['CaseId'] = $CaseId;
			
			$this->load->view ( 'patientedit', $data );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	public function _validate_relation($RelationId) {
		if ($this->session->userdata ( 'user' ) != null) {
			if ("select" == $RelationId) {
				$this->form_validation->set_message ( '_validate_relation', 'Invalid Relation' );
				return FALSE;
			}
				
			return TRUE;
		} else {
			$this->form_validation->set_message ( '_validate_relation', 'Invalid Relation' );
			return FALSE;
		}
	}
	
	public function _validate_dateofbirth($DateOfBirth) {
		if ($this->session->userdata ( 'user' ) != null)
		{
			$TodayDate = date ( DATEFORMAT );
				
			if (strtotime($DateOfBirth) > strtotime($TodayDate) ) {
				$this->form_validation->set_message ( '_validate_dateofbirth', 'Invalid Date of Birth' );
				return FALSE;
			}
	
			return TRUE;
		} else {
			$this->form_validation->set_message ( '_validate_dateofbirth', 'Invalid Date of Birth' );
			return FALSE;
		}
	}
	public function patientEditSubmit($id) {
		
		$user = $this->session->userdata ( 'user' );
		
		$SubmitValue = $this->input->post ( 'back' );
		
		if ($SubmitValue != NULL && $SubmitValue != '') 
		{
			
			redirect ( $SubmitValue, 'location' );
		}
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		$this->form_validation->set_rules ( 'fname', 'First Name', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'lname', 'Last Name', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'email', 'Email', 'trim|required|xss_clean|valid_email' );
		$this->form_validation->set_rules ( 'dob', 'Date of Birth', 'trim|required|xss_clean|callback__validate_dateofbirth' );
		
		if ($user != null) {
			$this->load->model ( 'PatientMaster' );
			if ($this->form_validation->run () == FALSE) {
				
				$PatientData = array (
						'FName' => $this->input->post ( 'fname' ),
						'LName' => $this->input->post ( 'lname' ),
						'Gender' => $this->input->post ( 'gender' ),
						'DOB' => $this->input->post ( 'dob' ),
						'Country' => $this->input->post ( 'country' ),
						'Email' => $this->input->post ( 'email' ),
						'Phone' => $this->input->post ( 'phone' ),
						'Relation' => $this->input->post ( 'relation' ),
						'Patient_Id' => $id 
				);
				$ConvertedObject = ( object ) $PatientData;
				$data ['patients'] = $ConvertedObject;
				$data ['Relations'] = $this->PatientMaster->getRelations ();
				
				$CaseDetails = $this->session->flashdata ( 'Msg' );
				if ($CaseDetails == NUll || $CaseDetails == '') {
					$CaseId = '';
				} else {
					$CaseId = $CaseDetails ['CaseId'];
				}
					
				$data ['CaseId'] = $CaseId;
					
				// print_r($id);
				$this->load->view ( 'patientedit', $data );
				return;
			}
			$Result = $this->PatientMaster->EditPatientDetail ( $id );
			
			// Send Notification
			
			$Subject = 'Patient ID ' . $id . '  Updated';
			$Body = 'User-' . $this->session->userdata ( 'user_name' ) . ' Updated Patient -' . $id . 'Details.';
			$Notifications = array (
					'ToRole' => ADMINUSER,
					'Subject' => $Subject,
					'Body' => $Body,
					'ToUser' => '',
					'QuestionId' => '' 
			);
			$ResultNotify = send_notification_for_user ( $Notifications );
			
			/*
			// Send Email
			$this->load->helper ( 'secureemail' );
			$CC = '';
			$EmailAddresTo = SUPPORTEMAIL;
			$EmailAddressFrom = INFOEMAIL;
			$SubjectEmail = 'Patient-' . $id . '  Updated';
			$BaseUrl = base_url ( 'patients/detail/' . $id );
			$BodyEmail = array (
					'Name' => $user->First_name . ' ' . $user->Last_Name,
					'User_Id' => $user->User_Id,
					'Link' => $BaseUrl,
					'Case_Id' => '' 
			);
			$EmailNotification = array (
					'To' => $EmailAddresTo,
					'FROM' => $EmailAddressFrom,
					'CC' => $CC,
					'Subject' => $SubjectEmail,
					'Body' => $BodyEmail,
					'Type' => "Email_CC_UpdateCase",
					'Attach' => '' 
			);
			$ResultEmail = send_secured_email ( $EmailNotification ); */
			
			// Add Audit Trail
			$this->load->model ( 'AuditTrailMaster' );
			$ControllerData = array (
					'Controller' => $this->router->class,
					'Action' => 'Patient with Id -'.$id.'  detials is modified  by user-'.$user->First_name.' '.$user->Last_Name.'  who is  type-'.$user->User_Type //$this->router->method' 
			)
			;
			$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
			
			$CaseId = $this->input->post ( 'caseid' );
			if ($CaseId != NULL && $CaseId != '') {
				// Set Flash Message
				$FinalMsg = 'The Patient Details Edited Successfully.';
				$MsgBit = "Success";
				$Message = array (
						'CaseId' => '',
						'Message' => $FinalMsg,
						'ErrorBit' => $MsgBit 
				);
				
				$this->session->set_flashdata ( 'CaseUpdateMsg', $Message );
				redirect ( 'cases/detail/' . $CaseId, 'location' );
			} else {
				// Set Flash Message
				$FinalMsg = 'The Patient Details Edited Successfully.';
				$MsgBit = "Success";
				$Message = array (
						'CaseId' => '',
						'Message' => $FinalMsg,
						'ErrorBit' => $MsgBit 
				);
				
				$this->session->set_flashdata ( 'PatientMsg', $Message );
				redirect ( 'patients', 'location' );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
}
?>