<?php
use Omnipay\Omnipay;
use Omnipay\PayPal;
use Omnipay\Common\CreditCard;
class Payments extends CI_Controller {
	public function index($offset = NULL) {
		
		$user = $this->session->userdata ( 'user' );
		
		if ($user != null) {
			$this->session->set_userdata ( 'activeMenu', "payments" );
			$this->load->model ( 'PaymentMaster' );
			$PaymentArray = array ();
			
			if ($this->session->userdata ( 'user_type' ) == ADMIN || $this->session->userdata ( 'user_type' ) == ADMINUSER) {
				$PaymentRecords = $this->PaymentMaster->getAllPayments ();
			} else {
				$PaymentRecords = $this->PaymentMaster->getPaymentsByUser ( $this->session->userdata ( 'user' )->User_Id );
			}
			
			
			$PlanList = $this->PaymentMaster->getAllPlans ();
			$PlanArray = array ();
				
			foreach ( $PlanList as $SinglePlan ) {
				$PlanArray [] = array (
						'Plan_Name' => $SinglePlan->Plan_Name,
						'Plan_Id' => $SinglePlan->Plan_Id,
						'Desciption' => $SinglePlan->Desciption,
						'Plan_Type' =>  strtolower($SinglePlan->Plan_Type)
				);
			}
			
			foreach ( $PaymentRecords as $SingleRec ) {
				$PaymentArray [] = array (
						'case_id' => $SingleRec->case_id,
						'PaymentMode' => $SingleRec->PaymentMode,
						'Currency' => $SingleRec->Currency,
						'Amount' => $SingleRec->Amount,
						'Payment_Id' => $SingleRec->Payment_Id,
						'Payment_Status' => $SingleRec->Payment_Status,
						'TimeStamp' =>date ( DATETIMEFORMAT, strtotime ($SingleRec->TimeStamp) ),
						'plan_id' => $this->AssignPlanName($PlanArray, $SingleRec->Plan_Id)
				);
			}
			$data ['Payments'] = $PaymentArray;
			$this->load->view ( 'paymentlist', $data );
		} else {
			$this->load->view ( 'login' );
		}
	}
	
	private function AssignPlanName($PlanList,$PlanId)
	{
		$PlanName=NULL;
	
		if($PlanId !=NULL && $PlanId !='' &&  $PlanId > 0)
		{
			foreach($PlanList as $SinglePlan)
			{
				if($SinglePlan["Plan_Id"] == $PlanId)
				{
					$PlanName=$SinglePlan["Plan_Name"];
					break;
				}
			}
		}
		return $PlanName;
	}
	
	
	public function add($caseId) 
	{
		
		$user = $this->session->userdata ( 'user' );
		
		if ($user != NULL) {
			$this->load->helper ( 'form' );
			$this->load->library ( 'form_validation' );
			$this->load->model ( 'CaseMaster' );
			$case = $this->CaseMaster->getCasesById ( $caseId );
			
			$MessageDetails = $this->session->flashdata ( 'CaseAddMsg' );
			
			if ($MessageDetails == NUll) {
				$Message = array (
						'CaseId' => '',
						'Message' => '',
						'ErrorBit' => '' 
				);
			} else {
				$Message = array (
						'CaseId' => $MessageDetails ['CaseId'],
						'Message' => $MessageDetails ['Message'],
						'ErrorBit' => $MessageDetails ['ErrorBit'] 
				);
			}
			
			$CaseAmount = $this->DeterminePrice ( $case->type, $case->plan );
			$this->session->set_userdata ( 'case', $case );
			
			
			
			$MojoArray = array (
					'Amount' => '',
					'Email' => '',
					'Name' => '',
					'Phone' => '',
					'Case_Id' => '',
					'User_Id' => '',
					'Sign' => ''
					);
			
			
			if ($CaseAmount ["Currency"] == "INR")
			 {
				// redirect to Instamojo
				$UserName = $user->First_name . '+' . $user->Last_Name;
				
				if (strlen ( $UserName ) <= 20 && strlen ( $user->email ) <= 75 && strlen ( $user->Mobile_Number ) <= 75) 
				{
					$MojoArray=$this->GenerateMojoData($CaseAmount);
					$MojoLinks=$this->GenerateMojoCaseLinks();
					$data ['MojoLink'] = $MojoLinks;
				} 
				else
				 {
					$Message ["ErrorBit"] = "Error";
					
					$AppendMessage = "<br/> Please Check Following details :<br/>
									Name legth upto 20 Characters<br/>
									email legth upto 75 Characters<br/>
									Phone lenght upto 10 Characters<br/>";
					
					$Message ["Message"] = $Message ["Message"] . $AppendMessage;
				}
			} 
			
			$PromocodeName=$this->input->post('PromocodeName');
			if($PromocodeName != NULL && $PromocodeName != '')
			{
				$this->session->set_userdata('Promocode',$PromocodeName);
				$TempCaseAmount=$CaseAmount;
				$PromoAmountDetails=$this->ApplyPromocodePrice($TempCaseAmount);
				$data['PromoAmount']=$PromoAmountDetails;
			}
			
			$data ['Amount'] = $CaseAmount;
			$data ['CaseMessage'] = $Message;
			$data ['Mojo'] = $MojoArray;
			$this->load->view ( 'paymentadd', $data );
		} else {
			
			redirect ( 'users/login', 'location' );
		}
	}
	
	public function addpromocode()
	{
		
		$user = $this->session->userdata ( 'user' );
	
		if ($user != NULL) 
		{
			$case=$this->session->userdata ( 'case');
			$CaseAmount = $this->DeterminePrice ( $case->type, $case->plan );
			
			$PromocodeName=$this->input->post('PromocodeName');
			if($PromocodeName != NULL && $PromocodeName != '')
			{
				$this->session->set_userdata('Promocode',$PromocodeName);
				$TempCaseAmount=$CaseAmount;
				$PromoAmountDetails=$this->ApplyPromocodePrice($TempCaseAmount);
				$this->output->set_header('Content-Type: application/json; charset=utf-8');
				echo json_encode($PromoAmountDetails);
			}
			
		} else {
				
			redirect ( 'users/login', 'location' );
		}
	}
	
	
	private function GenerateMojoData($CaseAmount)
	{
		$user = $this->session->userdata ( 'user' );
		
		$PlanDetail = $this->session->userdata ( 'PlanDetails' );
		$CaseDetail = $this->session->userdata ( 'case' );
		
		if($PlanDetail != NULL && $PlanDetail!= '')
		{
			$IdValueCaseorPlan=$PlanDetail->Plan_Id;
		}
		else 
		{
			$IdValueCaseorPlan=$CaseDetail->id;
		}
		
		$UserName = $user->First_name . ' ' . $user->Last_Name;
		
			$MojoAmount = $CaseAmount ["Amount"];
			$MojoEmail = $user->email;
			$MojoName = $UserName;
			$MojoPhone = $user->Mobile_Number;
			
			$PaymentMessage = $MojoAmount. '|' .$MojoEmail.'|'.$IdValueCaseorPlan .'|'. $user->User_Id.'|'.$MojoName.'|'.$MojoPhone;
			
			$Signature = hash_hmac ( 'sha1', $PaymentMessage, MOJO_SALT );
			
			$MojoArray = array (
					'Amount' => $MojoAmount,
					'Email' => $MojoEmail,
					'Name' => $MojoName,
					'Phone' => $MojoPhone,
					'Case_Id' => $IdValueCaseorPlan,
					'User_Id' => $user->User_Id,
					'Sign' => $Signature
					//,'PaymentMsg'=>$PaymentMessage
			);
		
		return  $MojoArray;
		
	}
	
	
	private function GenerateMojoCaseLinks()
	{
		$MojoLink=array(
				'Link' => '',
				'CaseId' => '',
				'UserId' => '',
				'Promocode' => ''
		);
		 
		$Case=$this->session->userdata ( 'case' );
		 
		if($Case->type == 1)
		{
			if($Case->plan != NULL && $Case->plan != ''  && $Case->plan > DEFAULTPLAN)
			{
				$MojoLink=array(
						'Link' => MOJO_ELITE_OPINION,
						'CaseId' => MOJO_ELITE_OPINION_CaseId,
						'UserId' => MOJO_ELITE_OPINION_UserId,
						'Promocode' => MOJO_ELITE_OPINION_Promocode
				);
			}
			else 
			{
				$MojoLink=array(
						'Link' => MOJO_OPINION,
						'CaseId' => MOJO_OPINION_CaseId,
						'UserId' => MOJO_OPINION_UserId,
						'Promocode' => MOJO_OPINION_Promocode
				);
			}
			
		}
		else if($Case->type == 4)
		{
			if($Case->plan != NULL && $Case->plan != ''  && $Case->plan > DEFAULTPLAN)
			{
				$MojoLink=array(
					'Link' => MOJO_SPECIAL_TELECONSULT,
					'CaseId' => MOJO_SPECIAL_TELECONSULT_CaseId,
					'UserId' => MOJO_SPECIAL_TELECONSULT_UserId,
					'Promocode' => MOJO_SPECIAL_TELECONSULT_Promocode
				);
			}
			else
			{
				$MojoLink=array(
					'Link' => MOJO_SPECIAL_TELECONSULT,
					'CaseId' => MOJO_SPECIAL_TELECONSULT_CaseId,
					'UserId' => MOJO_SPECIAL_TELECONSULT_UserId,
					'Promocode' => MOJO_SPECIAL_TELECONSULT_Promocode
				);
			}
			
			
			
		}
		else
		{
			if($Case->plan != NULL && $Case->plan != ''  && $Case->plan > DEFAULTPLAN)
			{
				$MojoLink=array(
					'Link' => MOJO_ELITE_TELECOSULT,
					'CaseId' => MOJO_ELITE_TELECOSULT_CaseId,
					'UserId' => MOJO_ELITE_TELECOSULT_UserId,
					'Promocode' => MOJO_ELITE_TELECOSULT_Promocode
				);
			}
			else
			{
				$MojoLink=array(
					'Link' => MOJO_TELECOSULT,
					'CaseId' => MOJO_TELECOSULT_CaseId,
					'UserId' => MOJO_TELECOSULT_UserId,
					'Promocode' => MOJO_TELECOSULT_Promocode
				);
			}
			
			
		}
		
		
		return  $MojoLink;
	}
	
	// To determin Price
	private function DeterminePrice($CaseType, $CasePlan) 
	{
		$Amount = '351';
		$Currency = 'USD';
		$user = $this->session->userdata ( 'user' );
		$Subscription = $this->session->userdata ( 'UserSubscription' );
		
		//Assign Corporate Plan
		if(($user->Corp_Code != '' && $user->Corp_Code !=NULL) && ($Subscription == NULL || $Subscription == ''))
		{
			$this->load->model ( 'CorporateMaster' );
			$CorporateDetails = $this->CorporateMaster->getCorporateUserByCorporateID ( $user->Corp_Code );
			
			if($CorporateDetails != NULL && $CorporateDetails != '' )
			{
				if($CorporateDetails->Plan_Id != NULL &&  $CorporateDetails->Plan_Id != '' && $CorporateDetails->Plan_Id >0)
				{
					$CasePlan=$CorporateDetails->Plan_Id;
				}
			}
		}
		
		$this->load->model ( 'PaymentMaster' );
		
		if ($CasePlan != NULL && $CasePlan != '' && $CasePlan > 0)
		 {
		 	$PlanList = $this->PaymentMaster->getPlanDetails ( $CasePlan );
		  
		 }
		 else 
		 {
		 	$PlanList = $this->PaymentMaster->getPlanDetails ( DEFAULTPLAN );
		 }	
				
				
				if ($PlanList != NULL) 
				{
					foreach ( $PlanList as $PlanType ) 
					{
						if ($CaseType == $PlanType->Service) 
						{
							if ($user->Country == "IN" || $user->Country == "India") 
							{
								$Amount = $PlanType->Amount_Rupee; // '2001';
								$Currency = "INR";
							} 
							else
							 {
								$Amount = $PlanType->Amount_Dollar; // '351';
							}
							break;
						}
					}
				} 

			
			$Money = array (
					'Amount' => $Amount,
					'Currency' => $Currency ,
					'Msg' => ''
			);
		
		
		return $Money;
	}
	
	
	// To Apply Promocode Price
	private function ApplyPromocodePrice($Money)
	{	
		$Currentdate = date ( DATEFORMAT );
		$user = $this->session->userdata ( 'user' );
		$CaseDetail = $this->session->userdata ( 'case' );
		$Promocode = $this->session->userdata ( 'Promocode' );
	
		if($Promocode != NUll && $Promocode != '')
		{
			$this->load->model ( 'PaymentMaster' );
			$PlanList = $this->PaymentMaster->getPromoCodeDetails ( $Promocode );
			
			if ($PlanList != NULL)
			{
				foreach ( $PlanList as $PlanType )
				{
					if ($CaseDetail->type == $PlanType->Service)
					{
						if($PlanType->Start_Date <= $Currentdate &&  $PlanType->End_Date >= $Currentdate )
						{
							if($Money["Currency"] == "INR")
							{
								//rupee
								if($Money["Amount"] > $PlanType->Disc_Rupee)
								{
									$Money["Amount"]=$PlanType->Disc_Rupee;
									$Money["Msg"]="Success";
									break;
								}
								$Money["Msg"]="Invalid";
								break;
							}
							else 
							{
								//Dollar
								if($Money["Amount"] > $PlanType->Disc_Dollar)
								{
									$Money["Amount"]=$PlanType->Disc_Dollar;
									$Money["Msg"]="Success";
									break;
								}
								$Money["Msg"]="Invalid";
								break;
							}
							$Money["Msg"]="Invalid";
							break;
						}
					}
				}
			}
		}
	
		return $Money;
	}
	
	public function detail($caseId) {
		
		$user = $this->session->userdata ( 'user' );
		if ($user != null) {
			$this->load->model ( 'CaseMaster' );
			$case = $this->CaseMaster->getCasesById ( $caseId );
			//$this->session->set_userdata ( 'case', $case );
			
			$this->load->model ( 'PaymentMaster' );
			$data ['UserType'] = $user->User_Type;
			$data ['payment'] = $this->PaymentMaster->getPaymentByCase ( $caseId );
			
			$this->load->view ( 'paymentdetail', $data );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	public function detailpayment($Id) 
	{
		
		$user = $this->session->userdata ( 'user' );
		if ($user != null) 
		{		
			$this->load->model ( 'PaymentMaster' );
			 
			$PlanList = $this->PaymentMaster->getAllPlans ();
			$PlanArray = array ();
			
			foreach ( $PlanList as $SinglePlan ) {
				$PlanArray [] = array (
						'Plan_Name' => $SinglePlan->Plan_Name,
						'Plan_Id' => $SinglePlan->Plan_Id,
						'Desciption' => $SinglePlan->Desciption,
						'Plan_Type' =>  strtolower($SinglePlan->Plan_Type)
				);
			}
			
			$PaymentDetails=$this->PaymentMaster->getPaymentById ( $Id );
			$PaymenArray=array(
					'Payment_Id' => $PaymentDetails->Payment_Id,
					'case_id' => $PaymentDetails->case_id,
					'PromoCode' => $PaymentDetails->PromoCode,
					'Currency' => $PaymentDetails->Currency,
					'PaymentMode' => $PaymentDetails->PaymentMode,
					'Created_By' => $PaymentDetails->Created_By,
					'Amount' => $PaymentDetails->Amount,
					'Payment_Status' => $PaymentDetails->Payment_Status,
					'TimeStamp' => $PaymentDetails->TimeStamp,
					'Transaction_Id' => $PaymentDetails->Transaction_Id,
					'Plan_Id' =>$this->AssignPlanName($PlanArray, $PaymentDetails->Plan_Id) 
					
			);
			
			$data ['payment'] =$PaymenArray;
			$data ['UserType'] = $user->User_Type;
				
			$this->load->view ( 'paymentdetail', $data );
		} 
		else 
		{
			redirect ( 'users/login', 'location' );
		}
	}
	
	public function addpost()
	 {
		
		$user = $this->session->userdata ( 'user' );
		
		$SubmitValue = $this->input->post ( 'Skip' );
		if ($SubmitValue != NULL && $SubmitValue != '') {
			$this->session->unset_userdata('Promocode');
			redirect ( 'cases', 'location' );
		}
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		$this->load->helper ( 'secureemail' );
		// $this->load->library ( 'GoPayPal' );
		
		$this->form_validation->set_rules ( 'amount', 'Amount', 'trim|required|xss_clean' ); // is_natural
		$this->form_validation->set_rules ( 'cardno', 'Card number', 'trim|required|max_length[19]|xss_clean' );
		$this->form_validation->set_rules ( 'cardname', 'Name on card', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'cardyear', 'Expiry year', 'trim|required|is_natural|xss_clean' );
		$this->form_validation->set_rules ( 'cardmonth', 'Expiry month', 'trim|required|is_natural|xss_clean' );
		$this->form_validation->set_rules ( 'ccv', 'CCV', 'trim|required|xss_clean' );
		
		$this->form_validation->set_rules ( 'country', 'Card Country', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'city', 'Card City', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'cardAddress', 'Card Address', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'postalCode', 'Postal Code', 'trim|required|xss_clean|numeric|max_length[10]' );
		
		if ($user != NULL) 
		{
			$CaseDetail = $this->session->userdata ( 'case' );
			$CaseAmount = $this->DeterminePrice ( $CaseDetail->type, $CaseDetail->plan );
			$PromocodeName=$this->session->userdata('Promocode');
			if($PromocodeName != NULL && $PromocodeName != '')
			{
				$TempCaseAmount=$CaseAmount;
				$CaseAmount=$this->ApplyPromocodePrice($TempCaseAmount);
			}
			if ($this->form_validation->run () == FALSE) {
				$MojoArray = array (
						'Amount' => '',
						'Email' => '',
						'Name' => '',
						'Phone' => '',
						'Case_Id' => '',
						'User_Id' => '',
						'Sign' => ''
				);
				
				
					
				if ($CaseAmount ["Currency"] == "INR")
				{
					// redirect to Instamojo
					$UserName = $user->First_name . '+' . $user->Last_Name;
				
					if (strlen ( $UserName ) <= 20 && strlen ( $user->email ) <= 75 && strlen ( $user->Mobile_Number ) <= 75)
					{
						$MojoArray=$this->GenerateMojoData($CaseAmount);
						$MojoLinks=$this->GenerateMojoCaseLinks();
						$data ['MojoLink'] = $MojoLinks;
					}
					else
					{
						$Message ["ErrorBit"] = "Error";
							
						$AppendMessage = "<br/> Please Check Following details :<br/>
									Name legth upto 20 Characters<br/>
									email legth upto 75 Characters<br/>
									Phone lenght upto 10 Characters<br/>";
							
						$Message ["Message"] = $Message ["Message"] . $AppendMessage;
					}
				}
				$data ['Mojo'] = $MojoArray;
				$data ['Amount'] = $CaseAmount;
				$data ['CaseMessage'] = '';
				$this->load->view ( 'paymentadd', $data );
				return;
			}
			
			$PaymentAmount = $CaseAmount["Amount"];
			$this->load->model ( 'PaymentMaster' );
			$PaymentId = $this->PaymentMaster->add ($CaseAmount);
			
			$user = $this->session->userdata ( 'user' );
			
			$gateway = Omnipay::create ( 'PayPal\Rest' );
			
			$gateway->initialize ( array (
					'clientId' => PAYPAL_CLIENT_ID,
					'secret' => PAYPAL_SECRET,
					'testMode' => TESTMODE 
			) ) // Or false when you are ready for live transactions
;
			
			$CardNumber = str_replace ( ' ', '', $this->input->post ( 'cardno' ) );
			$card = new CreditCard ( array (
					'firstName' => $user->First_name,
					'lastName' => $user->Last_Name,
					'number' => $CardNumber,
					'expiryMonth' => $this->input->post ( 'cardmonth' ),
					'expiryYear' => $this->input->post ( 'cardyear' ),
					'cvv' => $this->input->post ( 'ccv' ),
					'billingAddress1' => $this->input->post ( 'cardAddress' ),
					'billingCountry' => $this->input->post ( 'country' ),
					'billingCity' => $this->input->post ( 'city' ),
					'billingPostcode' => $this->input->post ( 'postalCode' ) 
			) );
			
			// Do an authorisation transaction on the gateway
			if ($gateway->supportsAuthorize ()) {
				try {
					$transaction = $gateway->authorize ( array (
							'amount' => $CaseAmount["Amount"]. '.00',
							'currency' => $CaseAmount["Currency"],
							'description' => 'Payment for Grand opinion',
							'card' => $card 
					) );
					$response = $transaction->send ();
					$data = $response->getData ();
					// echo "Gateway authorize response data == " . print_r($data, true) . "\n";
					
					if ($response->isSuccessful ()) {
						echo "Transaction was successful!\n";
						
						// Store in db that transaction completed
						$TransactionId = $data ["id"];
						$ResultTransaction = $this->PaymentMaster->markPaymentStatus ( $PaymentId, $TransactionId );
						$TransactionMessage = "Transaction was successful! <br/> Kindly upload the documents and medical records by clicking attach.";
						$MsgBit = "Success";
						
						// Send Email To User
						if ($user->User_Type == ADMIN || $user->User_Type == ADMINUSER) {
							$this->load->model ( 'UserMaster' );
							$UserDetails = $this->UserMaster->get_singleuser ( $CaseDetail->created_by );
							$EmailAddresTo = $UserDetails->email;
						} else {
							$EmailAddresTo = $user->email;
						}
						
						$CC = '';
						// $EmailAddresTo= $user->email;
						$Subject = 'Payment Confirmation';
						$Body = array (
								'Name' => $user->First_name . ' ' . $user->Last_Name 
						);
						
						// Mail to User
						$Notifications = array (
								'To' => $EmailAddresTo,
								'FROM' => BILLINGEMAIL,
								'CC' => $CC,
								'Subject' => $Subject,
								'Body' => $Body,
								'Type' => "Email_User_PaymentReceived",
								'Attach' => '' 
						);
						$ResultNotify = send_secured_email ( $Notifications );
						
						// Mail to Support
						
						$PaymentDetail = $this->PaymentMaster->getPaymentByID ( $PaymentId );
						$BaseUrl = base_url ( 'cases/detail/' . $PaymentDetail->case_id );
						$BodySupport = array (
								'Name' => $user->First_name . ' ' . $user->Last_Name,
								'Payment_Id' => $TransactionId,
								'Amount' => $PaymentDetail->Currency . ' ' . $PaymentDetail->Amount,
								'TimeStamp' =>date ( DATETIMEFORMAT, strtotime (  $PaymentDetail->TimeStamp ) ),
								'User_Id' => $user->User_Id,
								'Link' => $BaseUrl 
						);
						$NotificationsEmail = array (
								'To' => BILLINGEMAIL,
								'FROM' =>INFOEMAIL,
								'CC' => $CC,
								'Subject' => $Subject,
								'Body' => $BodySupport,
								'Type' => "Email_CC_PaymentReceipt",
								'Attach' => '' 
						);
						$ResultNotifyAdmin = send_secured_email ( $NotificationsEmail );
					} else {
						$ErroMsg = $data ["message"];
						$MessagArray = $data ["details"];
						$FinalString = 'Please Check Amount and Currency.';
						// foreach($MessagArray as $singleValue)
						// {
						
						// }
						
						$TransactionMessage = '<br> ' . $FinalString . '. <br> If Afterwards then click on Skip.';
						$MsgBit = "Error";
					}
				} catch (Exception $e ) {
					// echo "Exception caught while attempting authorize.\n";
					// echo "Exception type == " . get_class($e) . "\n";
					// echo "Message == " . $e->getMessage() . "\n";
					
					$TransactionMessage = $e->getMessage () . '<br> Please try again now or afterwards. <br> If Afterwards then click on Skip.';
					$MsgBit = "Error";
				}
			} else {
				echo "Gateway does not support authorize.\n";
			}
			
			$Message = array (
					'CaseId' => ($CaseDetail->id != NULL ? $CaseDetail->id : ''),
					'Message' => $TransactionMessage,
					'ErrorBit' => $MsgBit 
			);
			
			// $data['Message']=$TransactionMessage;
			$this->session->set_flashdata ( 'CaseUpdateMsg', $Message );
			
			// Add Audit Trail
			$this->load->model ( 'AuditTrailMaster' );
			$ControllerData = array (
					'Controller' => $this->router->class,
					'Action' => 'Payment Attempted through Paypal for case - '.($CaseDetail->id != NULL ? $CaseDetail->id : '').'  by user-'.$user->First_name.' '.$user->Last_Name.'  who is  type-'.$user->User_Type //$this->router->method' 
			);
			$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
			
			if ($MsgBit == "Error") {
				$this->session->set_flashdata('CaseAddMsg', $Message);
				/*
				 
				$CaseAmount = $this->DeterminePrice ( $CaseDetail->type, $CaseDetail->plan );
				$MojoArray = array (
						'Amount' => '',
						'Email' => '',
						'Name' => '',
						'Phone' => '',
						'Case_Id' => '',
						'User_Id' => '',
						'Sign' => ''
				);
				
				if ($CaseAmount ["Currency"] == "INR")
				{
					// redirect to Instamojo
					$UserName = $user->First_name . '+' . $user->Last_Name;
				
					if (strlen ( $UserName ) <= 20 && strlen ( $user->email ) <= 75 && strlen ( $user->Mobile_Number ) <= 75)
					{
						$MojoArray=$this->GenerateMojoData($CaseAmount);
					}
					else
					{
						$Message ["ErrorBit"] = "Error";
							
						$AppendMessage = "<br/> Please Check Following details :<br/>
									Name legth upto 20 Characters<br/>
									email legth upto 75 Characters<br/>
									Phone lenght upto 10 Characters<br/>";
							
						$Message ["Message"] = $Message ["Message"] . $AppendMessage;
					}
				}
				$data ['Mojo'] = $MojoArray;
				$data ['Amount'] = $CaseAmount;
				$data ['CaseMessage'] = $Message;
				$this->load->view ( 'paymentadd', $data );
				//return;*/
				 redirect ( 'payments/add/'.$CaseDetail->id, 'location' );
			} else {
				if ($PaymentDetail != NULL) {
					if ($user->User_Type == ADMIN || $user->User_Type == ADMINUSER) {
						if ($UserDetails != NULL) {
							$EmailAddresTo = $UserDetails->email;
						} else {
							$EmailAddresTo = $user->email;
						}
					} else {
						$EmailAddresTo = $user->email;
					}
					// Send Email To User
					$CC = '';
					$Subject = 'Payment Receipt';
					$BaseUrl = base_url ( 'cases/detail/' . $PaymentDetail->case_id );
					$Body = array (
							'Name' => $user->First_name . ' ' . $user->Last_Name,
							'Payment_Id' => $TransactionId,
							'Amount' => $PaymentDetail->Currency . ' ' . $PaymentDetail->Amount,
							'TimeStamp' =>date ( DATETIMEFORMAT, strtotime (  $PaymentDetail->TimeStamp ) ),
							'User_Id' => $user->User_Id,
							'Link' => $BaseUrl 
					);
					
					// Mail to User
					$Notifications = array (
							'To' => $EmailAddresTo,
							'FROM' => BILLINGEMAIL,
							'CC' => $CC,
							'Subject' => $Subject,
							'Body' => $Body,
							'Type' => "Email_User_PaymentReceipt",
							'Attach' => '' 
					);
					$ResultNotify = send_secured_email ( $Notifications );
				}
				
				$this->session->unset_userdata('Promocode');
				redirect ( 'cases/detail/'.$PaymentDetail->case_id, 'location' );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
/* paypal success */
	public function success($id)
	 {
		
		$user = $this->session->userdata ( 'user' );
		
		$SubmitValue = $this->input->post ( 'Skip' );
		if ($SubmitValue != NULL && $SubmitValue != '') {
			$this->session->unset_userdata('Promocode');
			redirect ( 'cases', 'location' );
		}
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		$this->load->helper ( 'secureemail' );
	
		
		if ($user != NULL) 
		{
			$CaseDetail = $this->session->userdata ( 'case' );
			$CaseAmount = $this->DeterminePrice ( $CaseDetail->type, $CaseDetail->plan );
			$PromocodeName=$this->session->userdata('Promocode');
			if($PromocodeName != NULL && $PromocodeName != '')
			{
				$TempCaseAmount=$CaseAmount;
				$CaseAmount=$this->ApplyPromocodePrice($TempCaseAmount);
				$CaseAmount["promo"]=$PromocodeName;
			}
			$CaseAmount["paymentmode"]="PAYPAL";
			
			$PaymentAmount = $CaseAmount["Amount"];
			$this->load->model ( 'PaymentMaster' );
			$PaymentId = $this->PaymentMaster->addWithDetail ($CaseAmount);
			
			$user = $this->session->userdata ( 'user' );
			
	
			echo "Transaction was successful!\n";
			
			// Store in db that transaction completed
			$TransactionId = $_GET["tx"];
			$ResultTransaction = $this->PaymentMaster->markPaymentStatus ( $PaymentId, $TransactionId );
			$TransactionMessage = "Transaction was successful! <br/> Kindly upload the documents and medical records by clicking attach.";
			$MsgBit = "Success";
			
			// Send Email To User
			if ($user->User_Type == ADMIN || $user->User_Type == ADMINUSER) {
				$this->load->model ( 'UserMaster' );
				$UserDetails = $this->UserMaster->get_singleuser ( $CaseDetail->created_by );
				$EmailAddresTo = $UserDetails->email;
			} else {
				$EmailAddresTo = $user->email;
			}
			
			$CC = '';
			// $EmailAddresTo= $user->email;
			$Subject = 'Payment Confirmation';
			$Body = array (
					'Name' => $user->First_name . ' ' . $user->Last_Name 
			);
			
			// Mail to User
			$Notifications = array (
					'To' => $EmailAddresTo,
					'FROM' => BILLINGEMAIL,
					'CC' => $CC,
					'Subject' => $Subject,
					'Body' => $Body,
					'Type' => "Email_User_PaymentReceived",
					'Attach' => '' 
			);
			$ResultNotify = send_secured_email ( $Notifications );
			
			// Mail to Support
			
			$PaymentDetail = $this->PaymentMaster->getPaymentByID ( $PaymentId );
			$BaseUrl = base_url ( 'cases/detail/' . $PaymentDetail->case_id );
			$BodySupport = array (
					'Name' => $user->First_name . ' ' . $user->Last_Name,
					'Payment_Id' => $TransactionId,
					'Amount' => $PaymentDetail->Currency . ' ' . $PaymentDetail->Amount,
					'TimeStamp' =>date ( DATETIMEFORMAT, strtotime (  $PaymentDetail->TimeStamp ) ),
					'User_Id' => $user->User_Id,
					'Link' => $BaseUrl 
			);
			$NotificationsEmail = array (
					'To' => BILLINGEMAIL,
					'FROM' =>INFOEMAIL,
					'CC' => $CC,
					'Subject' => $Subject,
					'Body' => $BodySupport,
					'Type' => "Email_CC_PaymentReceipt",
					'Attach' => '' 
			);
			$ResultNotifyAdmin = send_secured_email ( $NotificationsEmail );
		
			
			$Message = array (
					'CaseId' => ($CaseDetail->id != NULL ? $CaseDetail->id : ''),
					'Message' => $TransactionMessage,
					'ErrorBit' => $MsgBit 
			);
			
			// $data['Message']=$TransactionMessage;
			$this->session->set_flashdata ( 'CaseUpdateMsg', $Message );
			
			// Add Audit Trail
			$this->load->model ( 'AuditTrailMaster' );
			$ControllerData = array (
					'Controller' => $this->router->class,
					'Action' => 'Payment Attempted through Paypal for case - '.($CaseDetail->id != NULL ? $CaseDetail->id : '').'  by user-'.$user->First_name.' '.$user->Last_Name.'  who is  type-'.$user->User_Type //$this->router->method' 
			);
			$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
			
			if ($MsgBit == "Error") {
				$this->session->set_flashdata('CaseAddMsg', $Message);
				 redirect ( 'payments/add/'.$id, 'location' );
			} else {
				if ($PaymentDetail != NULL) {
					if ($user->User_Type == ADMIN || $user->User_Type == ADMINUSER) {
						if ($UserDetails != NULL) {
							$EmailAddresTo = $UserDetails->email;
						} else {
							$EmailAddresTo = $user->email;
						}
					} else {
						$EmailAddresTo = $user->email;
					}
					// Send Email To User
					$CC = '';
					$Subject = 'Payment Receipt';
					$BaseUrl = base_url ( 'cases/detail/' . $PaymentDetail->case_id );
					$Body = array (
							'Name' => $user->First_name . ' ' . $user->Last_Name,
							'Payment_Id' => $TransactionId,
							'Amount' => $PaymentDetail->Currency . ' ' . $PaymentDetail->Amount,
							'TimeStamp' =>date ( DATETIMEFORMAT, strtotime (  $PaymentDetail->TimeStamp ) ),
							'User_Id' => $user->User_Id,
							'Link' => $BaseUrl 
					);
					
					// Mail to User
					$Notifications = array (
							'To' => $EmailAddresTo,
							'FROM' => BILLINGEMAIL,
							'CC' => $CC,
							'Subject' => $Subject,
							'Body' => $Body,
							'Type' => "Email_User_PaymentReceipt",
							'Attach' => '' 
					);
					$ResultNotify = send_secured_email ( $Notifications );
				}
				
				$this->session->unset_userdata('Promocode');
				redirect ( 'cases/detail/'.$PaymentDetail->case_id, 'location' );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}

/* end paypal success*/
	function notifyUser($caseid) {
		
		
		if ($this->session->userdata ( 'user_name' ) != null) {
			// Send Notification
			$this->load->model ( 'CaseMaster' );
			$CaseDetail = $this->CaseMaster->getCasesById ( $caseid );
			if ($CaseDetail != NULL) {
				$BaseUrl = base_url ( 'cases/detail/' . $caseid );
				
				$Subject = 'Payment Reminder';
				$Body = 'Dear Sir/Madam,  A quick reminder from GrandOpinion to make the payment for your <a target="_blank" href="' . $BaseUrl . '">Case ID ' . $caseid . '</a>';
				$Notifications = array (
						'ToUser' => $CaseDetail->created_by,
						'Subject' => $Subject,
						'Body' => $Body,
						'QuestionId' => '',
						'ToRole' => '' 
				);
				$ResultNotify = send_notification_for_user ( $Notifications );
				
				$this->load->model ( 'UserMaster' );
				$UserDetails = $this->UserMaster->get_user ( $CaseDetail->created_by );
				if ($UserDetails != NULL) {
					// Send Email
					$this->load->helper ( 'secureemail' );
					$CC = '';
					$EmailAddresTo = $UserDetails->email;
					$EmailAddressFrom = BILLINGEMAIL;
					$SubjectEmail = $Subject;
					$BodyEmail = $Body;
					$EmailNotification = array (
							'To' => $EmailAddresTo,
							'FROM' => $EmailAddressFrom,
							'CC' => $CC,
							'Subject' => $SubjectEmail,
							'Body' => $BodyEmail,
							'Type' => '',
							'Attach' => '' 
					);
					$ResultEmail = send_secured_email ( $EmailNotification );
				}
				
				redirect ( 'payments', 'location' );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function mojoaddpost() 
	{
		
		$user = $this->session->userdata ( 'user' );
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		$this->load->helper ( 'secureemail' );
		
		$File = APPPATH . "libraries/instamojo.php";
		require $File;
		
		$SubmitValue = $this->input->post ( 'Skip' );
		if ($SubmitValue != NULL && $SubmitValue != '') {
			$this->session->unset_userdata('Promocode');
			redirect ( 'cases', 'location' );
		}
		
		if ($user != NULL) {
			$CaseDetail = $this->session->userdata ( 'case' );
			$TransactionId = $this->input->get ( 'payment_id' );
			$TransactionStatus = $this->input->get ( 'status' );
			
			try {
				$api = new Instamojo ( MOJO_API_KEY, MOJO_AUTH_TOKEN );
				//curl_setopt ( $ch, CURLOPT_SSL_VERIFYPEER, false );
				$response = $api->paymentDetail ( $TransactionId );
				
				//echo 'Response \n';
				//print_r($response);
				
				
				$TransactionData = $response;
				
				if ($TransactionData != NULL ) {
					$this->load->model ( 'PaymentMaster' );
					
					$Promocode=$TransactionData ["discount_code"];//$TransactionData ["custom_fields"]['Field_68566']['value']; // Promocode
					//$UserIDinTrans=$TransactionData ["custom_fields"]['Field_68570']['value']; // User Id
					//$CaseIdinTrans=$TransactionData ["custom_fields"]['Field_68567']['value']; // case Id
					$PaymentData = array (
							'Amount' => $TransactionData ["amount"],
							'Promocode' => $Promocode,
							'Currency' => $TransactionData ["currency"],
							'PayMode' => $TransactionData ["status"],
							// 'TimeStampServer' =>$TransactionData["created_at"],
							'Transaction_Id' => $TransactionId 
					);
					
					$PaymentId = $this->PaymentMaster->addmojo ( $PaymentData );
					
					if ( $TransactionStatus== "success" ) {
						echo "Transaction was successful!\n";
						
						// Store in db that transaction completed
						$ResultTransaction = $this->PaymentMaster->markPaymentStatus ( $PaymentId, $TransactionId );
						$TransactionMessage = "Transaction was successful!";
						$MsgBit = "Success";
						
						// Send Email To User
						if ($user->User_Type == ADMIN || $user->User_Type == ADMINUSER) {
							$this->load->model ( 'UserMaster' );
							$UserDetails = $this->UserMaster->get_singleuser ( $CaseDetail->created_by );
							$EmailAddresTo = $UserDetails->email;
						} else {
							$EmailAddresTo = $user->email;
						}
						
						$CC = '';
						// $EmailAddresTo= $user->email;
						$Subject = 'Payment Confirmation';
						$Body = array (
								'Name' => $user->First_name . ' ' . $user->Last_Name 
						);
						
						// Mail to User
						$Notifications = array (
								'To' => $EmailAddresTo,
								'FROM' => BILLINGEMAIL,
								'CC' => $CC,
								'Subject' => $Subject,
								'Body' => $Body,
								'Type' => "Email_User_PaymentReceived",
								'Attach' => '' 
						);
						$ResultNotify = send_secured_email ( $Notifications );
						
						// Mail to Support
						
						$PaymentDetail = $this->PaymentMaster->getPaymentByID ( $PaymentId );
						$BaseUrl = base_url ( 'cases/detail/' . $PaymentDetail->case_id );
						$BodySupport = array (
								'Name' => $user->First_name . ' ' . $user->Last_Name,
								'Payment_Id' => $TransactionId,
								'Amount' => $PaymentDetail->Currency . ' ' . $PaymentDetail->Amount,
								'TimeStamp' =>date ( DATETIMEFORMAT, strtotime (  $PaymentDetail->TimeStamp ) ),
								'User_Id' => $user->User_Id,
								'Link' => $BaseUrl 
						);
						$NotificationsEmail = array (
								'To' =>BILLINGEMAIL ,
								'FROM' => INFOEMAIL,
								'CC' => $CC,
								'Subject' => $Subject,
								'Body' => $BodySupport,
								'Type' => "Email_CC_PaymentReceipt",
								'Attach' => '' 
						);
						$ResultNotifyAdmin = send_secured_email ( $NotificationsEmail );
					} else {
						//$ErroMsg = $data ["message"];
						//$MessagArray = $data ["details"];
						$FinalString = 'Please Check Amount and Currency.';
						$TransactionMessage = '<br> ' . $FinalString . '. <br> If Afterwards then click on Skip.';
						$MsgBit = "Error";
					}
				} else {
					$TransactionMessage = '<br>Something went wrong.<br/> Please try again now or afterwards. <br> If Afterwards then click on Skip.';
					$MsgBit = "Error";
				}
				
			} 
			catch ( Exception $e ) 
			{
				$TransactionMessage = $e->getMessage () . '<br> Please try again now or afterwards. <br> If Afterwards then click on Skip.';
				$MsgBit = "Error";
				
				
				echo '\n Excpetion Msg- '.$e->getMessage ();
			}
			
			
			$Message = array (
					'CaseId' => ($CaseDetail->id != NULL ? $CaseDetail->id : ''),
					'Message' => $TransactionMessage,
					'ErrorBit' => $MsgBit 
			);
			
			// $data['Message']=$TransactionMessage;
			$this->session->set_flashdata ( 'CaseUpdateMsg', $Message );
			
			// Add Audit Trail
			$this->load->model ( 'AuditTrailMaster' );
			$ControllerData = array (
					'Controller' => $this->router->class,
					'Action' => 'Payment Attempted through Instamojo for case - '.($CaseDetail->id != NULL ? $CaseDetail->id : '').'  by user-'.$user->First_name.' '.$user->Last_Name.'  who is  type-'.$user->User_Type //$this->router->method' 
			)
			;
			$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
			
			if ($MsgBit == "Error")
			 {
				// $this->session->set_flashdata('CaseAddMsg', $Message);
				$CaseAmount = $this->DeterminePrice ( $CaseDetail->type, $CaseDetail->plan );
				if ($CaseAmount ["Currency"] == "INR")
				{
					// redirect to Instamojo
					$UserName = $user->First_name . '+' . $user->Last_Name;
					
				
					if (strlen ( $UserName ) <= 20 && strlen ( $user->email ) <= 75 && strlen ( $user->Mobile_Number ) <= 75)
					{
						$MojoArray=$this->GenerateMojoData($CaseAmount);
						$MojoLinks=$this->GenerateMojoCaseLinks();
						$data ['MojoLink'] = $MojoLinks;
					}
					else
					{
						$Message ["ErrorBit"] = "Error";
							
						$AppendMessage = "<br/> Please Check Following details :<br/>
									Name legth upto 20 Characters<br/>
									email legth upto 75 Characters<br/>
									Phone lenght upto 10 Characters<br/>";
							
						$Message ["Message"] = $Message ["Message"] . $AppendMessage;
					}
				}
				$data ['Mojo'] = $MojoArray;
				$data ['Amount'] = $CaseAmount;
				$data ['CaseMessage'] = $Message;
				
				$this->load->view ( 'paymentadd', $data );
				// redirect ( 'payments/add', 'location' );
			} 
			else
			 {
				if ($PaymentDetail != NULL) {
					if ($user->User_Type == ADMIN || $user->User_Type == ADMINUSER) {
						if ($UserDetails != NULL) {
							$EmailAddresTo = $UserDetails->email;
						} else {
							$EmailAddresTo = $user->email;
						}
					} else {
						$EmailAddresTo = $user->email;
					}
					// Send Email To User
					$CC = '';
					$Subject = 'Payment Receipt';
					$BaseUrl = base_url ( 'cases/detail/' . $PaymentDetail->case_id );
					$Body = array (
							'Name' => $user->First_name . ' ' . $user->Last_Name,
							'Payment_Id' => $TransactionId,
							'Amount' => $PaymentDetail->Currency . ' ' . $PaymentDetail->Amount,
							'TimeStamp' =>date ( DATETIMEFORMAT, strtotime (  $PaymentDetail->TimeStamp ) ),
							'User_Id' => $user->User_Id,
							'Link' => $BaseUrl 
					);
					
					// Mail to User
					$Notifications = array (
							'To' => $EmailAddresTo,
							'FROM' => BILLINGEMAIL,
							'CC' => $CC,
							'Subject' => $Subject,
							'Body' => $Body,
							'Type' => "Email_User_PaymentReceipt",
							'Attach' => '' 
					);
					$ResultNotify = send_secured_email ( $Notifications );
				}
				
				$this->session->unset_userdata('Promocode');
				redirect ( 'cases/detail/'.$PaymentDetail->case_id, 'location' );
			} 
		} 
		else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	public function addplan($PlanId)
	 {
		
		$user = $this->session->userdata ( 'user' );
	
		if ($user != NULL) 
		{
			$this->load->helper ( 'form' );
			$this->load->library ( 'form_validation' );
			$this->load->model ( 'UserMaster' );
			$PlanDetails = $this->UserMaster->getPlanName ( $PlanId );
				
			$MessageDetails = $this->session->flashdata ( 'PlanData' );
				
			if ($MessageDetails == NUll) {
				$Message = array (
						'CaseId' => '',
						'Message' => '',
						'ErrorBit' => ''
				);
			} else {
				$Message = array (
						'CaseId' => $MessageDetails ['CaseId'],
						'Message' => $MessageDetails ['Message'],
						'ErrorBit' => $MessageDetails ['ErrorBit']
				);
			}
				
			$CaseAmount = $this->DeterminePlanPrice ($PlanDetails);
			$this->session->set_userdata ( 'PlanDetails', $PlanDetails );
				
			$MojoArray = array (
					'Amount' => '',
					'Email' => '',
					'Name' => '',
					'Phone' => '',
					'Case_Id' => '',
					'User_Id' => '',
					'Sign' => ''
			);
				
			if ($CaseAmount ["Currency"] == "INR")
			{
				// redirect to Instamojo
				$UserName = $user->First_name . '+' . $user->Last_Name;
	
				if (strlen ( $UserName ) <= 20 && strlen ( $user->email ) <= 75 && strlen ( $user->Mobile_Number ) <= 75)
				{
					$MojoArray=$this->GenerateMojoData($CaseAmount);
				}
				else
				{
					$Message ["ErrorBit"] = "Error";
						
					$AppendMessage = "<br/> Please Check Following details :<br/>
									Name legth upto 20 Characters<br/>
									email legth upto 75 Characters<br/>
									Phone lenght upto 10 Characters<br/>";
						
					$Message ["Message"] = $Message ["Message"] . $AppendMessage;
				}
			}
				
			$data ['Amount'] = $CaseAmount;
			$data ['CaseMessage'] = $Message;
			$data ['Mojo'] = $MojoArray;
			$this->load->view ( 'paymentaddsubscription', $data );
		} else {
				
			redirect ( 'users/login', 'location' );
		}
	}
	
	
	// To determin Price
	private function DeterminePlanPrice($PlanData) 
	{
		$Amount = '100';
		$Currency = 'USD';
		$user = $this->session->userdata ( 'user' );
	
		if ($user->Country == "IN" || $user->Country == "India")
		{
			$Amount = $PlanData->Plan_Price_Rupee; // '2001';
			$Currency = "INR";
		}
		else
		{
			$Amount = $PlanData->Plan_Price_Dollar; // '351';
		}
					
			
		$Money = array (
				'Amount' => $Amount,
				'Currency' => $Currency
		);
	
	
		return $Money;
	}
	
	
	
	public function addplanpost() 
	{
		
		$user = $this->session->userdata ( 'user' );
	
		$SubmitValue = $this->input->post ( 'Skip' );
		if ($SubmitValue != NULL && $SubmitValue != '') 
		{
			//Unset Plandata
			$this->session->unset_userdata('PlanDetails');
			$this->session->unset_userdata('PlanStartDate');
			redirect ( 'users/getPlansDeatils', 'location' );
		}
	
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		$this->load->helper ( 'secureemail' );
		// $this->load->library ( 'GoPayPal' );
	
		$this->form_validation->set_rules ( 'amount', 'Amount', 'trim|required|xss_clean' ); // is_natural
		$this->form_validation->set_rules ( 'cardno', 'Card number', 'trim|required|max_length[19]|xss_clean' );
		$this->form_validation->set_rules ( 'cardname', 'Name on card', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'cardyear', 'Expiry year', 'trim|required|is_natural|xss_clean' );
		$this->form_validation->set_rules ( 'cardmonth', 'Expiry month', 'trim|required|is_natural|xss_clean' );
		$this->form_validation->set_rules ( 'ccv', 'CCV', 'trim|required|xss_clean' );
	
		$this->form_validation->set_rules ( 'country', 'Card Country', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'city', 'Card City', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'cardAddress', 'Card Address', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'postalCode', 'Postal Code', 'trim|required|xss_clean|numeric|max_length[10]' );
	
		if ($user != NULL) 
		{
			$this->load->model ( 'UserMaster' );
			$PlanDetails = $this->session->userdata ( 'PlanDetails' );
			$CaseAmount = $this->DeterminePlanPrice ( $PlanDetails);
			if ($this->form_validation->run () == FALSE)
			 {
				$MojoArray = array (
						'Amount' => '',
						'Email' => '',
						'Name' => '',
						'Phone' => '',
						'Case_Id' => '',
						'User_Id' => '',
						'Sign' => ''
				);
					
				if ($CaseAmount ["Currency"] == "INR")
				{
					// redirect to Instamojo
					$UserName = $user->First_name . '+' . $user->Last_Name;
	
					if (strlen ( $UserName ) <= 20 && strlen ( $user->email ) <= 75 && strlen ( $user->Mobile_Number ) <= 75)
					{
						$MojoArray=$this->GenerateMojoData($CaseAmount);
					}
					else
					{
						$Message ["ErrorBit"] = "Error";
							
						$AppendMessage = "<br/> Please Check Following details :<br/>
									Name legth upto 20 Characters<br/>
									email legth upto 75 Characters<br/>
									Phone lenght upto 10 Characters<br/>";
							
						$Message ["Message"] = $Message ["Message"] . $AppendMessage;
					}
				}
				$data ['Mojo'] = $MojoArray;
				$data ['Amount'] = $CaseAmount;
				$data ['CaseMessage'] = '';
				$this->load->view ( 'paymentaddsubscription', $data );
				return;
			}
				
			$PaymentAmount = $CaseAmount["Amount"];
			$this->load->model ( 'PaymentMaster' );
			$PaymentId = $this->PaymentMaster->add ($CaseAmount);
				
			$user = $this->session->userdata ( 'user' );
				
			$gateway = Omnipay::create ( 'PayPal\Rest' );
				
			$gateway->initialize ( array (
					'clientId' => PAYPAL_CLIENT_ID,
					'secret' => PAYPAL_SECRET,
					'testMode' => TESTMODE
			) ) // Or false when you are ready for live transactions
			;
				
			$CardNumber = str_replace ( ' ', '', $this->input->post ( 'cardno' ) );
			$card = new CreditCard ( array (
					'firstName' => $user->First_name,
					'lastName' => $user->Last_Name,
					'number' => $CardNumber,
					'expiryMonth' => $this->input->post ( 'cardmonth' ),
					'expiryYear' => $this->input->post ( 'cardyear' ),
					'cvv' => $this->input->post ( 'ccv' ),
					'billingAddress1' => $this->input->post ( 'cardAddress' ),
					'billingCountry' => $this->input->post ( 'country' ),
					'billingCity' => $this->input->post ( 'city' ),
					'billingPostcode' => $this->input->post ( 'postalCode' )
			) );
				
			// Do an authorisation transaction on the gateway
			if ($gateway->supportsAuthorize ()) {
				try {
					$transaction = $gateway->authorize ( array (
							'amount' => $CaseAmount["Amount"]. '.00',
							'currency' => $CaseAmount["Currency"],
							'description' => 'Payment for Grand opinion',
							'card' => $card
					) );
					$response = $transaction->send ();
					$data = $response->getData ();
					// echo "Gateway authorize response data == " . print_r($data, true) . "\n";
						
					if ($response->isSuccessful ()) {
						echo "Transaction was successful!\n";
	
						// Store in db that transaction completed
						$TransactionId = $data ["id"];
						$ResultTransaction = $this->PaymentMaster->markPlanPaymentStatus ( $PaymentId, $TransactionId );
						$TransactionMessage = "Transaction was successful!";
						$MsgBit = "Success";
						
						
						$PlanSelected = $PlanDetails->Plan_Id;
						$PlanStartDate=$this->session->userdata ( 'PlanStartDate' );
						$StartDate = date ( DATEFORMAT, strtotime ( $PlanStartDate ) );
							
						$Tempdate = date ( DATEFORMAT, strtotime ( $StartDate . '+1 year' ) );
							
						$Endate = date ( DATEFORMAT, strtotime ( $Tempdate ) );
							
						$Subscription = array (
								'User_Id' => $user->User_Id,
								'Plan_Id' => $PlanSelected,
								'Start_Date' => $StartDate,
								'End_Date' => $Endate
						);
							
						$Result = $this->UserMaster->addSubscriptionDetails ( $Subscription );
	
						// Send Email To User
						//if ($user->User_Type == ADMIN || $user->User_Type == ADMINUSER) 
						//{
							
							//$UserDetails = $this->UserMaster->get_singleuser ( $CaseDetail->created_by );
							//$EmailAddresTo = $UserDetails->email;
						//} else {
							$EmailAddresTo = $user->email;
						//}
	
						$CC = '';
						// $EmailAddresTo= $user->email;
						$Subject = 'Payment Confirmation';
						$Body = array (
								'Name' => $user->First_name . ' ' . $user->Last_Name
						);
	
						// Mail to User
						$Notifications = array (
								'To' => $EmailAddresTo,
								'FROM' => BILLINGEMAIL,
								'CC' => $CC,
								'Subject' => $Subject,
								'Body' => $Body,
								'Type' => "Email_User_PaymentReceived",
								'Attach' => ''
						);
						$ResultNotify = send_secured_email ( $Notifications );
	
						// Mail to Support
	
						$PaymentDetail = $this->PaymentMaster->getPaymentByID ( $PaymentId );
						
						// Send Email to Admin
						$CC = '';
						$EmailAddresTo = BILLINGEMAIL;
						$EmailAddressFrom = INFOEMAIL;
						$SubjectEmail = 'Plan Change Payment Receipt';	
						$BodySupport = array (
								'User_Id' => $user->User_Id,
								'Name' => $user->First_name.' '.$user->Last_Name,
								'First_name' => $user->First_name,
								'Last_Name' => $user->Last_Name,
								'email' => $user->email,
								'Mobile_Number' => $user->Mobile_Number,
								'City' => $user->City,
								'Country' => $user->Country,
								'Payment_Id' => $TransactionId,
								'Amount' => $PaymentDetail->Currency . ' ' . $PaymentDetail->Amount,
								'TimeStamp' =>date ( DATETIMEFORMAT, strtotime (  $PaymentDetail->TimeStamp ) ),
								'Plan_Name' =>$PlanDetails->Plan_Name
						)
						;
						$NotificationsEmail = array (
								'To' => BILLINGEMAIL,
								'FROM' => INFOEMAIL,
								'CC' => $CC,
								'Subject' => $Subject,
								'Body' => $BodySupport,
								'Type' => "Email_CC_PlanChange",
								'Attach' => ''
						);
						$ResultNotifyAdmin = send_secured_email ( $NotificationsEmail );
						
						$SubDetailsUser = $this->UserMaster->getSubscriptionDetails ( $user->User_Id );
						if($this->CheckUserSubscription($SubDetailsUser))
						{
							$this->session->set_userdata ( 'UserSubscription', $SubDetailsUser );
						}
						
					} else
					 {
						$ErroMsg = $data ["message"];
						$MessagArray = $data ["details"];
						$FinalString = 'Please Check Amount and Currency.';
						// foreach($MessagArray as $singleValue)
						// {
	
						// }
	
						$TransactionMessage = '<br> ' . $FinalString . '. <br> If Afterwards then click on Skip.';
						$MsgBit = "Error";
					}
				} catch ( \Exception $e ) {
					// echo "Exception caught while attempting authorize.\n";
					// echo "Exception type == " . get_class($e) . "\n";
					// echo "Message == " . $e->getMessage() . "\n";
						
					$TransactionMessage = $e->getMessage () . '<br> Please try again now or afterwards. <br> If Afterwards then click on Skip.';
					$MsgBit = "Error";
				}
			} else {
				echo "Gateway does not support authorize.\n";
			}
				
			$Message = array (
					'CaseId' => ($PlanDetails->Plan_Id != NULL ? $PlanDetails->Plan_Id : ''),
					'Message' => $TransactionMessage,
					'ErrorBit' => $MsgBit
			);
				
			
			$this->session->set_flashdata ( 'TransMsgSuccess', $Message );
				
			// Add Audit Trail
			$this->load->model ( 'AuditTrailMaster' );
			$ControllerData = array (
					'Controller' => $this->router->class,
					'Action' => 'Payment Attempted through Paypal for Plan'.($PlanDetails->Plan_Name != NULL ? $PlanDetails->Plan_Name : '').'  by user-'.$user->First_name.' '.$user->Last_Name.'  who is  type-'.$user->User_Type //$this->router->method'
			);
			$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
				
			if ($MsgBit == "Error") 
			{
				$this->session->set_flashdata('PlanData', $Message);
				/*
				$CaseAmount = $this->DeterminePlanPrice ( $PlanDetails);
				if ($CaseAmount ["Currency"] == "INR")
				{
					// redirect to Instamojo
					$UserName = $user->First_name . '+' . $user->Last_Name;
	
					if (strlen ( $UserName ) <= 20 && strlen ( $user->email ) <= 75 && strlen ( $user->Mobile_Number ) <= 75)
					{
						$MojoArray=$this->GenerateMojoData($CaseAmount);
					}
					else
					{
						$Message ["ErrorBit"] = "Error";
							
						$AppendMessage = "<br/> Please Check Following details :<br/>
									Name legth upto 20 Characters<br/>
									email legth upto 75 Characters<br/>
									Phone lenght upto 10 Characters<br/>";
							
						$Message ["Message"] = $Message ["Message"] . $AppendMessage;
					}
				}
				$data ['Mojo'] = $MojoArray;
				$data ['Amount'] = $CaseAmount;
				$data ['CaseMessage'] = $Message;
				$this->load->view ( 'paymentaddsubscription', $data );*/
				 redirect ( 'payments/addplan/'.$PlanDetails->Plan_Id, 'location' );
			} 
			else 
			{
				if ($PaymentDetail != NULL) 
				{
					//if ($user->User_Type == ADMIN || $user->User_Type == ADMINUSER) 
					//{
						//if ($UserDetails != NULL) 
						//{
							//$EmailAddresTo = $UserDetails->email;
						//} else {
							//$EmailAddresTo = $user->email;
						//}
					//} else {
						$EmailAddresTo = $user->email;
					//}
					// Send Email To User
					$CC = '';
					$Subject = 'Payment Receipt';
					$BaseUrl = base_url ( 'cases/detail/' . $PaymentDetail->case_id );
					$Body = array (
							'Name' => $user->First_name . ' ' . $user->Last_Name,
							'Payment_Id' => $TransactionId,
							'Amount' => $PaymentDetail->Currency . ' ' . $PaymentDetail->Amount,
							'TimeStamp' =>date ( DATETIMEFORMAT, strtotime (  $PaymentDetail->TimeStamp ) ),
							'User_Id' => $user->User_Id,
							'Link' => $BaseUrl
					);
						
					// Mail to User
					$Notifications = array (
							'To' => $EmailAddresTo,
							'FROM' => BILLINGEMAIL,
							'CC' => $CC,
							'Subject' => $Subject,
							'Body' => $Body,
							'Type' => "Email_User_PaymentReceipt",
							'Attach' => ''
					);
					$ResultNotify = send_secured_email ( $Notifications );
				}
	
				//Unset Plandata
				$this->session->unset_userdata('PlanStartDate');
				$this->session->unset_userdata('PlanDetails');
				redirect ( 'users/getPlansDeatils', 'location' );
			}
		} 
		else 
		{
			redirect ( 'users/login', 'location' );
		}
	}
	
	
	public function mojoaddplanpost()
	{
		
		$user = $this->session->userdata ( 'user' );
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		$this->load->helper ( 'secureemail' );
	
		$File = APPPATH . "libraries/instamojo.php";
		require $File;
	
		$SubmitValue = $this->input->post ( 'Skip' );
		if ($SubmitValue != NULL && $SubmitValue != '') {
			//Unset Plandata
			$this->session->unset_userdata('PlanStartDate');
			$this->session->unset_userdata('PlanDetails');
			redirect ( 'users/getPlansDeatils', 'location' );
		}
	
		if ($user != NULL) {
			$this->load->model ( 'UserMaster' );
			$PlanDetails = $this->session->userdata ( 'PlanDetails' );
			$TransactionId = $this->input->get ( 'payment_id' );
			$TransactionStatus = $this->input->get ( 'status' );
				
			try {
				$api = new Instamojo ( MOJO_API_KEY, MOJO_AUTH_TOKEN );
				//curl_setopt ( $ch, CURLOPT_SSL_VERIFYPEER, false );
				$response = $api->paymentDetail ( $TransactionId );
	
				//echo 'Response \n';
				//print_r($response);
	
	
				$TransactionData = $response;
	
				if ($TransactionData != NULL ) {
					$this->load->model ( 'PaymentMaster' );
						
					$Promocode=$TransactionData ["discount_code"];//$TransactionData ["custom_fields"]['Field_91332']['value']; // Promocode
					//$UserIDinTrans=$TransactionData ["custom_fields"]['Field_44952']['value']; // User Id
					//$CaseIdinTrans=$TransactionData ["custom_fields"]['Field_91333']['value']; // Plan Id
					$PaymentData = array (
							'Amount' => $TransactionData ["amount"],
							'Promocode' => $Promocode,
							'Currency' => $TransactionData ["currency"],
							'PayMode' => $TransactionData ["status"],
							// 'TimeStampServer' =>$TransactionData["created_at"],
							'Transaction_Id' => $TransactionId
					);
						
					$PaymentId = $this->PaymentMaster->addmojo ( $PaymentData );
						
					if ( $TransactionStatus== "success" ) {
						echo "Transaction was successful!\n";
	
						// Store in db that transaction completed
						$ResultTransaction = $this->PaymentMaster->markPlanPaymentStatus ( $PaymentId, $TransactionId );
						$TransactionMessage = "Transaction was successful!";
						$MsgBit = "Success";
						
						
						$PlanSelected = $PlanDetails->Plan_Id;
						$PlanStartDate=$this->session->userdata ( 'PlanStartDate' );
						$StartDate = date ( DATEFORMAT, strtotime ( $PlanStartDate ) );
							
						$Tempdate = date ( DATEFORMAT, strtotime ( $StartDate . '+1 year' ) );
							
						$Endate = date ( DATEFORMAT, strtotime ( $Tempdate ) );
							
						$Subscription = array (
								'User_Id' => $user->User_Id,
								'Plan_Id' => $PlanSelected,
								'Start_Date' => $StartDate,
								'End_Date' => $Endate
						);
							
						$Result = $this->UserMaster->addSubscriptionDetails ( $Subscription );
	
						// Send Email To User
						//if ($user->User_Type == ADMIN || $user->User_Type == ADMINUSER) 
						//{
							
							//$UserDetails = $this->UserMaster->get_singleuser ( $CaseDetail->created_by );
							//$EmailAddresTo = $UserDetails->email;
						//} else {
							$EmailAddresTo = $user->email;
						//}
	
						$CC = '';
						// $EmailAddresTo= $user->email;
						$Subject = 'Payment Confirmation';
						$Body = array (
								'Name' => $user->First_name . ' ' . $user->Last_Name
						);
	
						// Mail to User
						$Notifications = array (
								'To' => $EmailAddresTo,
								'FROM' => BILLINGEMAIL,
								'CC' => $CC,
								'Subject' => $Subject,
								'Body' => $Body,
								'Type' => "Email_User_PaymentReceived",
								'Attach' => ''
						);
						$ResultNotify = send_secured_email ( $Notifications );
	
						// Mail to Support
	
						$PaymentDetail = $this->PaymentMaster->getPaymentByID ( $PaymentId );
						
						// Send Email to Admin
						$CC = '';
						$EmailAddresTo = BILLINGEMAIL;
						$EmailAddressFrom = INFOEMAIL;
						$SubjectEmail = 'Plan Change Payment Receipt';	
						$BodySupport = array (
								'User_Id' => $user->User_Id,
								'Name' => $user->First_name.' '.$user->Last_Name,
								'First_name' => $user->First_name,
								'Last_Name' => $user->Last_Name,
								'email' => $user->email,
								'Mobile_Number' => $user->Mobile_Number,
								'City' => $user->City,
								'Country' => $user->Country,
								'Payment_Id' => $TransactionId,
								'Amount' => $PaymentDetail->Currency . ' ' . $PaymentDetail->Amount,
								'TimeStamp' =>date ( DATETIMEFORMAT, strtotime (  $PaymentDetail->TimeStamp ) ),
								'Plan_Name' =>$PlanDetails->Plan_Name
						)
						;
						$NotificationsEmail = array (
								'To' => BILLINGEMAIL,
								'FROM' => INFOEMAIL,
								'CC' => $CC,
								'Subject' => $Subject,
								'Body' => $BodySupport,
								'Type' => "Email_CC_PlanChange",
								'Attach' => ''
						);
						$ResultNotifyAdmin = send_secured_email ( $NotificationsEmail );
						
						$SubDetailsUser = $this->UserMaster->getSubscriptionDetails ( $user->User_Id );
						if($this->CheckUserSubscription($SubDetailsUser))
						{
							$this->session->set_userdata ( 'UserSubscription', $SubDetailsUser );
						}
						
					} else {
						//$ErroMsg = $data ["message"];
						//$MessagArray = $data ["details"];
						$FinalString = 'Please Check Amount and Currency.';
						$TransactionMessage = '<br> ' . $FinalString . '. <br> If Afterwards then click on Skip.';
						$MsgBit = "Error";
					}
				} else {
					$TransactionMessage = '<br>Something went wrong.<br/> Please try again now or afterwards. <br> If Afterwards then click on Skip.';
					$MsgBit = "Error";
				}
	
			}
			catch ( Exception $e )
			{
				$TransactionMessage = $e->getMessage () . '<br> Please try again now or afterwards. <br> If Afterwards then click on Skip.';
				$MsgBit = "Error";
	
	
				echo '\n Excpetion Msg- '.$e->getMessage ();
			}
				
				
				$Message = array (
					'CaseId' => ($PlanDetails->Plan_Id != NULL ? $PlanDetails->Plan_Id : ''),
					'Message' => $TransactionMessage,
					'ErrorBit' => $MsgBit
			);
				
			
			$this->session->set_flashdata ( 'TransMsgSuccess', $Message );
				
			// Add Audit Trail
			$this->load->model ( 'AuditTrailMaster' );
			$ControllerData = array (
					'Controller' => $this->router->class,
					'Action' => 'Payment Attempted through Instamojo for Plan - '.($PlanDetails->Plan_Name != NULL ? $PlanDetails->Plan_Name : '').'  by user-'.$user->First_name.' '.$user->Last_Name.'  who is  type-'.$user->User_Type //$this->router->method'
			);
			$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
				
			if ($MsgBit == "Error") 
			{
				$CaseAmount = $this->DeterminePlanPrice ( $PlanDetails);
				if ($CaseAmount ["Currency"] == "INR")
				{
					// redirect to Instamojo
					$UserName = $user->First_name . '+' . $user->Last_Name;
	
					if (strlen ( $UserName ) <= 20 && strlen ( $user->email ) <= 75 && strlen ( $user->Mobile_Number ) <= 75)
					{
						$MojoArray=$this->GenerateMojoData($CaseAmount);
					}
					else
					{
						$Message ["ErrorBit"] = "Error";
							
						$AppendMessage = "<br/> Please Check Following details :<br/>
									Name legth upto 20 Characters<br/>
									email legth upto 75 Characters<br/>
									Phone lenght upto 10 Characters<br/>";
							
						$Message ["Message"] = $Message ["Message"] . $AppendMessage;
					}
				}
				$data ['Mojo'] = $MojoArray;
				$data ['Amount'] = $CaseAmount;
				$data ['CaseMessage'] = $Message;
				$this->load->view ( 'paymentaddsubscription', $data );
				// redirect ( 'payments/add', 'location' );
			} 
			else 
			{
				if ($PaymentDetail != NULL) 
				{
					//if ($user->User_Type == ADMIN || $user->User_Type == ADMINUSER) 
					//{
						//if ($UserDetails != NULL) 
						//{
							//$EmailAddresTo = $UserDetails->email;
						//} else {
							//$EmailAddresTo = $user->email;
						//}
					//} else {
						$EmailAddresTo = $user->email;
					//}
					// Send Email To User
					$CC = '';
					$Subject = 'Payment Receipt';
					$BaseUrl = base_url ( 'cases/detail/' . $PaymentDetail->case_id );
					$Body = array (
							'Name' => $user->First_name . ' ' . $user->Last_Name,
							'Payment_Id' => $TransactionId,
							'Amount' => $PaymentDetail->Currency . ' ' . $PaymentDetail->Amount,
							'TimeStamp' =>date ( DATETIMEFORMAT, strtotime (  $PaymentDetail->TimeStamp ) ),
							'User_Id' => $user->User_Id,
							'Link' => $BaseUrl
					);
						
					// Mail to User
					$Notifications = array (
							'To' => $EmailAddresTo,
							'FROM' => BILLINGEMAIL,
							'CC' => $CC,
							'Subject' => $Subject,
							'Body' => $Body,
							'Type' => "Email_User_PaymentReceipt",
							'Attach' => ''
					);
					$ResultNotify = send_secured_email ( $Notifications );
				}
	
				//Unset Plandata
				$this->session->unset_userdata('PlanStartDate');
				$this->session->unset_userdata('PlanDetails');
				redirect ( 'users/getPlansDeatils', 'location' );
			}
		}
		else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	private function CheckUserSubscription($SubscriptionDetails)
	{
		$Sub=False;
	
		$TodayDate = date ( DATEFORMAT );
	
		if (strtotime($SubscriptionDetails->Start_Date) <= strtotime($TodayDate)  &&  strtotime($TodayDate) <= strtotime($SubscriptionDetails->End_Date))
		{
			$Sub=true;
		}
	
		return $Sub;
	}
	
	
}
?>