<?php
class Reports extends CI_Controller {
	// default action
	// We will show all patients created by user here
	public function index($offset = NULL) {
		
		$user = $this->session->userdata ( 'user' );
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		if ($user != null) {
			$this->session->set_userdata ( 'activeMenu', "reportmgt" );
			if ($user->User_Type == ADMIN || $user->User_Type == ADMINUSER || $user->User_Type == SALES || $user->User_Type == PARTNERS || $user->User_Type == DOCTORS || $user->User_Type == CORPADMIN) {
				$data ['DropValues'] = $this->PopulateDropdown ();
				$this->load->view ( 'reportindex', $data );
			} else {
				$this->load->view ( 'accessdenied' );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function generatereport() {
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		$this->form_validation->set_rules ( 'FromDate', 'From Date', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'ToDate', 'To Date', 'trim|required|xss_clean' );
		
		if ($this->session->userdata ( 'user_name' ) != null) {
			if ($this->form_validation->run () == FALSE) {
				$data ['DropValues'] = $this->PopulateDropdown ();
				$this->load->view ( 'reportindex', $data );
				return;
			}
			
			$DropDownValue = $this->input->post ( 'ReportType' );
			$UserType = $this->session->userdata ( 'user_type' );
			
			switch ($DropDownValue) {
				case "Sales Report" :
					if ($UserType == ADMIN || $UserType == ADMINUSER || $UserType == SALES) {
						$data ['Cases'] = $this->SalesReport ();
						$data ['Leads'] = $this->LeadsReport ();
						$data ['Name'] = "Sales Report";
						$ViewName = 'salespersonreport';
					} else {
						$ViewName = 'accessdenied';
					}
					
					break;
				
				case "Partner Sales Report" :
					if ($UserType == ADMIN || $UserType == ADMINUSER || $UserType == PARTNERS) {
						$data ['Cases'] = $this->SalesReport ();
						$data ['Leads'] = $this->LeadsReport ();
						$data ['Name'] = "Partner Sales Report";
						$ViewName = 'salespersonreport';
					} else {
						$ViewName = 'accessdenied';
					}
					
					break;
				
				case "Doctor Payment Report" :
					if ($UserType == ADMIN || $UserType == ADMINUSER || $UserType == DOCTORS) {
						$data ['Doctor'] = $this->DoctorPaymentReport ();
						$ViewName = 'doctorpayoutreport';
					} else {
						$ViewName = 'accessdenied';
					}
					
					break;
				
				case "Partner Payment Report" :
					if ($UserType == ADMIN || $UserType == ADMINUSER || $UserType == PARTNERS) {
						$data ['Partner'] = $this->PartnerPaymentReport ();
						$ViewName = 'partnerpaymentreport';
					} else {
						$ViewName = 'accessdenied';
					}
					
					break;
				
				case "Cases Report" :
					if ($UserType == ADMIN || $UserType == ADMINUSER || $UserType == CORPADMIN) {
						$data ['Statistics'] = $this->CalculateCasesResult ();
						$ViewName = 'corporateadminreport';
					} else {
						$ViewName = 'accessdenied';
					}
					
					break;
				
				default :
					$ViewName = 'accessdenied';
					break;
			}
			
			$this->load->view ( $ViewName, $data );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	private function SalesReport() {
		$this->load->model ( 'ReportMaster' );
		
		$UserType = $this->session->userdata ( 'user_type' );
		$FromDate = date ( DATEFORMAT, strtotime ( $this->input->post ( 'FromDate' ) ) );
		$ToDate = date ( DATEFORMAT, strtotime ( $this->input->post ( 'ToDate' ) ) );
		
		$UserId = $this->session->userdata ( 'user' )->User_Id;
		$Values = array (
				'UserId' => $UserId,
				'FromDate' => $FromDate,
				'ToDate' => $ToDate 
		);
		
		$Cases = $this->ReportMaster->getCasesByUserByDate ( $Values );
		
		$CaseDetails = array ();
		
		foreach ( $Cases as $Singlecase ) {
			$PatientDetails = $this->ReportMaster->getPatientById ( $Singlecase->Patient_Id );
			$PaymentDetails = $this->ReportMaster->getPaymentByCase ( $Singlecase->id );
			
			$CaseAmount = "";
			if ($PaymentDetails != NULL) {
				$CaseAmount = $PaymentDetails->Amount;
			}
			
			if ($PatientDetails != NULL) {
				$CaseDetails [] = array (
						'FName' => $PatientDetails->FName,
						'LName' => $PatientDetails->LName,
						'Case_Id' => $Singlecase->id,
						'type' => $Singlecase->type,
						'Case_Date' => date ( DATEFORMAT, strtotime ( $Singlecase->Case_Date ) ),
						'status' => $Singlecase->status,
						'plan' => $Singlecase->plan,
						'is_paid' => $Singlecase->is_paid,
						'Amount' => $CaseAmount 
				);
			}
		}
		
		return $CaseDetails;
	}
	private function LeadsReport() {
		$this->load->model ( 'ReportMaster' );
		
		$UserType = $this->session->userdata ( 'user_type' );
		$UserId = $this->session->userdata ( 'user' )->User_Id;
		
		$Leads = $this->ReportMaster->getLeadsByUser ( $UserId );
		$LeadsArray = array ();
		
		// if($UserType == SALES || $UserType == ADMINUSER || $UserType == ADMIN)
		// {
		foreach ( $Leads as $Singlecase ) {
			
			$LeadsArray [] = array (
					'FName' => $Singlecase->FName,
					'LName' => $Singlecase->LName,
					'Email' => $Singlecase->Email,
					'Phone' => $Singlecase->Phone,
					'CDate' => date ( DATEFORMAT, strtotime ( $Singlecase->created ) ) 
			);
		}
		
		// }
		
		return $LeadsArray;
	}
	private function DoctorPaymentReport() {
		$this->load->model ( 'ReportMaster' );
		$this->load->model ( 'DoctorMaster' );
		
		$UserType = $this->session->userdata ( 'user_type' );
		$FromDate = date ( DATEFORMAT, strtotime ( $this->input->post ( 'FromDate' ) ) );
		$ToDate = date ( DATEFORMAT, strtotime ( $this->input->post ( 'ToDate' ) ) );
		
		$DoctorId = "";
		
		if ($UserType == DOCTORS) {
			$DoctorId = $this->session->userdata ( 'Doctor_Id' );
			if($DoctorId != NULL && $DoctorId != '')
			{
				$DoctorLogDetails=$this->DoctorMaster->getDoctorById($DoctorId);
			}
			
		}
		
		$Values = array (
				'Doctor_Id' => $DoctorId,
				'FromDate' => $FromDate,
				'ToDate' => $ToDate 
		);
		
		$PayoutHistory = $this->ReportMaster->getDoctorPaymentDetails ( $Values );
		$DocPayoutArray = array ();
		
		// if($UserType == DOCTORS || $UserType == ADMINUSER || $UserType == ADMIN)
		// {
		foreach ( $PayoutHistory as $SinglePayout ) 
		{
			$DoctorName="";
			 	if($UserType == ADMINUSER || $UserType == ADMIN || $DoctorLogDetails == NULL)
				{
					$DoctorDetails=$this->DoctorMaster->getDoctorById($SinglePayout->Doctor_Id);
					$DoctorName=$DoctorDetails->DName;
				}
				else 
				{
					$DoctorName=$DoctorLogDetails->DName;
				}
				
				
			$DocPayoutArray [] = array (
					'Case_Id' => $SinglePayout->Case_Id,
					'Doctor_Id' => $DoctorName,//$SinglePayout->Doctor_Id,
					'Amount' => $SinglePayout->Amount,
					'Id' => $SinglePayout->Id,
					'TimeStamp' => date ( DATEFORMAT, strtotime ( $SinglePayout->TimeStamp ) ) 
			);
		}
		
		// }
		
		return $DocPayoutArray;
	}
	private function PartnerPaymentReport() {
		$this->load->model ( 'ReportMaster' );
		
		$UserType = $this->session->userdata ( 'user_type' );
		$FromDate = date ( DATEFORMAT, strtotime ( $this->input->post ( 'FromDate' ) ) );
		$ToDate = date ( DATEFORMAT, strtotime ( $this->input->post ( 'ToDate' ) ) );
		$UserId = $this->session->userdata ( 'user' )->User_Id;
		
		$Values = array (
				'UserId' => $UserId,
				'FromDate' => $FromDate,
				'ToDate' => $ToDate 
		);
		
		$PaymentRecords = $this->ReportMaster->getPaymentHistoryByUser ( $Values );
		
		$CaseDetails = array ();
		
		foreach ( $PaymentRecords as $SingleRec ) {
			
			$Case = $this->ReportMaster->getByCaseId ( $SingleRec->case_id );
			if($Case != NULL)
			{
				$PatientDetails = $this->ReportMaster->getPatientById ( $Case->Patient_Id );
					
				if ($PatientDetails != NULL) {
					$CaseDetails [] = array (
							'FName' => $PatientDetails->FName,
							'LName' => $PatientDetails->LName,
							'Case_Id' => $SingleRec->case_id,
							'PaymentMode' => $SingleRec->PaymentMode,
							'Amount' => $SingleRec->Amount,
							'Case_Date' => date ( DATEFORMAT, strtotime ( $SingleRec->TimeStamp ) ),
							'status' => $SingleRec->Payment_Status
					);
				}
			}
			
		}
		
		return $CaseDetails;
	}
	private function PopulateDropdown() {
		$UserType = $this->session->userdata ( 'user_type' );
		
		switch ($UserType) {
			case ADMIN :
			case ADMINUSER :
				$DropdownValues = array (
						'Sales Report',
						'Partner Sales Report',
						'Doctor Payment Report',
						'Partner Payment Report'
								//,'Cases Report' 
				);
				
				break;
			
			case SALES :
				$DropdownValues = array (
						'Sales Report' 
				);
				break;
			
			case PARTNERS :
				$DropdownValues = array (
						'Partner Sales Report',
						'Partner Payment Report' 
				);
				break;
			
			case DOCTORS :
				$DropdownValues = array (
						'Doctor Payment Report' 
				);
				
				break;
			
			case CORPADMIN :
				$DropdownValues = array (
						'Cases Report' 
				);
				break;
			
			default :
				$DropdownValues = array ();
				break;
		}
		
		return $DropdownValues;
	}
	private function CalculateCasesResult() {
		$OpenCase = 0;
		$ReportSubmitCase = 0;
		$ClosedCase = 0;
		
		$this->load->model ( 'ReportMaster' );
		
		$FromDate = date ( DATEFORMAT, strtotime ( $this->input->post ( 'FromDate' ) ) );
		$ToDate = date ( DATEFORMAT, strtotime ( $this->input->post ( 'ToDate' ) ) );
		$UserId = $this->session->userdata ( 'user' )->User_Id;
		
		$CorporateDetails = $this->ReportMaster->getCorpDetailsById ( $UserId );
		
		$Values = array (
				'Promocode' => $CorporateDetails->Corp_Unique_Id,
				'FromDate' => $FromDate,
				'ToDate' => $ToDate 
		);
		$CaseArray = $this->ReportMaster->getCasesByPromocode ( $Values );
		
		foreach ( $CaseArray as $SingleCase ) {
			switch ($SingleCase->status) {
				case 3 :
				case 4 :
					$ReportSubmitCase ++;
					break;
				
				case 5 :
				case 6 :
					$ClosedCase ++;
					break;
				
				default :
					$OpenCase ++;
					break;
			}
		}
		
		$Statistics = array (
				'OpenCases' => $OpenCase,
				'SubmitCase' => $ReportSubmitCase,
				'Closed' => $ClosedCase 
		);
		
		return $Statistics;
	}
	public function reportdetail($id) {
		
		$user = $this->session->userdata ( 'user' );
		
		if ($user != null) {
			$this->load->model ( 'CaseMaster' );
			$this->load->model ( 'PatientMaster' );
			$this->load->model ( 'DoctorMaster' );
			$this->load->model ( 'ReportMaster' );
			
			// $CaseDetail = $this->CaseMaster->getCasesById($id);
			// $patientDetails=$this->PatientMaster->getPatientById($CaseDetail->Patient_Id);
			
			$UserId = $user->User_Id;
			$UserType = $user->User_Type;
			$CurrentUserEmail = $user->email;
			$UserAccess = FALSE;
			
			if ($UserType == ADMIN || $UserType == ADMINUSER) {
				$CaseReportDetail = $this->ReportMaster->getCaseReportByID ( $id );
				
				if ($CaseReportDetail != NULL && $CaseReportDetail != '') {
					$case = array (
							'Case_Id' => $id,
							'Query' => $CaseReportDetail->Medical_Query,
							'Medic_History' => $CaseReportDetail->Medical_History,
							'Case_Date' => '',
							'Doc_Comment' => $CaseReportDetail->Doc_Comment,
							'Doc_Recommend' => $CaseReportDetail->Doc_Recommendation,
							'Online' => $CaseReportDetail->Online_Resource,
							'Add_Service' => $CaseReportDetail->Add_Services,
							'Go_Recommend' => $CaseReportDetail->Go_Recommend 
					)
					;
				} else {
					$case = array (
							'Case_Id' => $id,
							'Query' => 'No Record Found.',
							'Medic_History' => 'No Record Found.',
							'Case_Date' => 'No Record Found.',
							'Doc_Comment' => 'No Record Found.',
							'Doc_Recommend' => 'No Record Found.',
							'Online' => 'No Record Found.',
							'Add_Service' => 'No Record Found.',
							'Go_Recommend' => 'No Record Found.' 
					)
					;
				}
				
				$data ['case'] = $case;
				
				// Get Case Update Message
				$MessageDetails = $this->session->flashdata ( 'CaseUpdateMsg' );
				
				if ($MessageDetails == NUll) {
					$UpdtMsg = array (
							'CaseId' => '',
							'Message' => '',
							'ErrorBit' => '' 
					);
				} else {
					$UpdtMsg = array (
							'CaseId' => $MessageDetails ['CaseId'],
							'Message' => $MessageDetails ['Message'],
							'ErrorBit' => $MessageDetails ['ErrorBit'] 
					);
				}
				
				$data ['CaseMessage'] = $UpdtMsg;
				$this->load->view ( 'casereportdetails', $data );
				// print_r($case);
			} else {
				$this->load->view ( 'accessdenied' );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function reportEdit($id) {
		
		$user = $this->session->userdata ( 'user' );
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		if ($user != null) {
			$this->load->model ( 'CaseMaster' );
			$this->load->model ( 'PatientMaster' );
			$this->load->model ( 'DoctorMaster' );
			$this->load->model ( 'ReportMaster' );
			
			$UserId = $user->User_Id;
			$UserType = $user->User_Type;
			$CurrentUserEmail = $user->email;
			$UserAccess = FALSE;
			
			if ($UserType == ADMIN || $UserType == ADMINUSER)
			 {
				
				$CaseReportDetail = $this->ReportMaster->getCaseReportByID ( $id );
				$CaseDetail = $this->CaseMaster->getCasesById ( $id );
				if ($CaseReportDetail == NULL || $CaseReportDetail == '') 
				{
					
					$patientDetails = $this->PatientMaster->getPatientById ( $CaseDetail->Patient_Id );
					$relation = $this->CaseMaster->getRelationsById ( $patientDetails->Relation );
					
					$doctorName = '';
					$doctorId = '';
					$doctorUserId = '';
					
					if ($CaseDetail->Doctor_Id != NULL && $CaseDetail->Doctor_Id != '' && $CaseDetail->Doctor_Id > 0) {
						$doctor = $this->DoctorMaster->getDoctorById ( $CaseDetail->Doctor_Id );
						
						$doctorId = $doctor->Doctor_Id;
						$doctorName = $doctor->DName;
						$doctorUserId = $doctor->User_Id;
					}
					
					// Doctor Differentiate His case
					$DifferentiateCase = FALSE; // To Show The Payment Button
					If ($UserType == DOCTORS) {
						if ($CaseDetail->created_by != $UserId) {
							$DifferentiateCase = TRUE; // To Hide the Payment Button
						}
					}
					
					$CaseDetailRecord = array (
							'patient_first_name' => $patientDetails->FName,
							'patient_last_name' => $patientDetails->LName,
							'Patient_Id' => $CaseDetail->Patient_Id,
							'patient_contact_number' => $patientDetails->Phone,
							'relation' => ($relation->name != NULL ? $relation->name : ''),
							'patient_gender' => $patientDetails->Gender,
							'patient_birth_date' => date ( DATEFORMAT, strtotime ( $patientDetails->DOB ) ),
							'patient_email' => $patientDetails->Email,
							'patient_country' => $patientDetails->Country,
							'id' => $CaseDetail->id,
							'medical_query' => $CaseDetail->medical_query,
							'type' => $CaseDetail->type,
							'Case_Date' => date ( DATEFORMAT, strtotime ( $CaseDetail->Case_Date ) ),
							'status' => $CaseDetail->status,
							'plan' => $CaseDetail->plan,
							'is_paid' => $CaseDetail->is_paid,
							'UserType' => $UserType,
							'Doctor_Id' => $doctorId,
							'DName' => $doctorName 
					)
					;
					
					$comments = $this->DoctorMaster->getAllCommentsOnCase ( $id );
					
					$CommentsArray = array ();
					$RecommendationArray = array (); //
					if ($comments != NULL && $comments != '') {
						foreach ( $comments as $com ) {
							$DocDetails = $this->DoctorMaster->getDoctorById ( $com ["Doctor_Id"] );
							
							if ($DocDetails != NULL) {
								$Comments = $com ["Comment"];
								
								$Recommendation = $com ["Recommendation"];
								
								array_push ( $CommentsArray, $Comments );
								array_push ( $RecommendationArray, $Recommendation );
								
								/*
								 * $CommentsArray[]=array(
								 * 'Comment' => $com["Comment"],
								 * 'Recommendation' => $com["Recommendation"],
								 * 'Doctor_Id' => $com["Doctor_Id"],
								 * 'DocName' => $DocDetails->DName
								 *
								 * );
								 */
							}
						}
					}
					
					$MedicalHistory=$this->PatientMedicalHistory($CaseDetail->Patient_Id);
					
					$case = array (
							'Case_Id' => $id,
							'Query' => $CaseDetail->medical_query,
							'Medic_History' => $MedicalHistory,
							'Case_Date' => date ( DATEFORMAT, strtotime ( $CaseDetail->Case_Date ) ),
							'Doc_Comment' => implode ( " ", $CommentsArray ),
							'Doc_Recommend' => implode ( " ", $RecommendationArray ),
							'Online' => '',
							'Add_Service' => REPORTADDSERVICE,
							'Go_Recommend' => REPORTGORECOMMEND,
							'Doctor_Id' => $CaseDetail->Doctor_Id,
							'Patient_Id' => $CaseDetail->Patient_Id 
					)
					;
				} else {
					$case = array (
							'Case_Id' => $id,
							'Query' => $CaseReportDetail->Medical_Query,
							'Medic_History' => $CaseReportDetail->Medical_History,
							'Case_Date' => date ( DATEFORMAT, strtotime ( $CaseDetail->Case_Date ) ),
							'Doc_Comment' => $CaseReportDetail->Doc_Comment,
							'Doc_Recommend' => $CaseReportDetail->Doc_Recommendation,
							'Online' => $CaseReportDetail->Online_Resource,
							'Add_Service' => $CaseReportDetail->Add_Services,
							'Go_Recommend' => $CaseReportDetail->Go_Recommend,
							'Doctor_Id' => $CaseReportDetail->Doctor_Id,
							'Patient_Id' => $CaseReportDetail->Patient_Id 
					)
					;
					
					$CommentsArray = array ();
					$CaseDetailRecord = array ();
				}
				
				$data ['Casecomments'] = $CommentsArray;
				$data ['CaseRecord'] = $CaseDetailRecord;
				$data ['case'] = $case;
				$this->load->view ( 'casereportadd', $data );
				// print_r($case);
			} else {
				$this->load->view ( 'accessdenied' );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function reportEditSubmit($id) {
		
		$user = $this->session->userdata ( 'user' );
		
		$SubmitValue = $this->input->post ( 'back' );
		if ($SubmitValue != NULL && $SubmitValue != '')
		{
			redirect ( 'reports/reportdetail/'.$id, 'location' );
		}
		
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		$this->form_validation->set_rules ( 'MQuery', 'Patient Message', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'DocComment', 'Doctors  Opinion', 'trim|required|xss_clean' );
		
		if ($user != null) {
			if ($user->User_Type == ADMIN || $user->User_Type == ADMINUSER) {
				$this->load->model ( 'CaseMaster' );
				$this->load->model ( 'PatientMaster' );
				$this->load->model ( 'DoctorMaster' );
				$this->load->model ( 'ReportMaster' );
				
				$CaseDetail = $this->CaseMaster->getCasesById ( $id );
				if ($this->form_validation->run () == FALSE) {
					// $CaseReportDetail=$this->ReportMaster->getCaseReportByID($id);
					$case = array (
							'Case_Id' => $id,
							'Query' => $this->input->post ( 'MQuery' ),
							'Medic_History' => $this->input->post ( 'MedHistory' ),
							'Case_Date' => date ( DATEFORMAT, strtotime ( $CaseDetail->Case_Date ) ),
							'Doc_Comment' => $this->input->post ( 'DocComment' ),
							'Doc_Recommend' => $this->input->post ( 'DocRecommend' ),
							'Online' => $this->input->post ( 'Online' ),
							'Add_Service' => $this->input->post ( 'AddService' ),
							'Go_Recommend' => $this->input->post ( 'GORec' ),
							'Doctor_Id' => $this->input->post ( 'DoctorId' ),
							'Patient_Id' => $this->input->post ( 'PatientId' ) 
					)
					;
					
					$data ['case'] = $case;
					$this->load->view ( 'casereportadd', $data );
					return;
				}
				
				$CaseArray = array (
						'Case_Id' => $id,
						'Doctor_Id' => $CaseDetail->Doctor_Id,
						'Patient_Id' => $CaseDetail->Patient_Id 
				);
				
				$Result = $this->ReportMaster->addReport ( $CaseArray );
				
				// Set Measage
				$FinalMsg = 'The Report was Updated Successfully.';
				$MsgBit = "Success";
				$Message = array (
						'CaseId' => $caseId,
						'Message' => $FinalMsg,
						'ErrorBit' => $MsgBit 
				);
				
				$this->session->set_flashdata ( 'CaseUpdateMsg', $Message );
				
				redirect ( 'reports/reportdetail/' . $id, 'location' );
			} else {
				$this->load->view ( 'accessdenied' );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function reportPreview($id) {
		
		$user = $this->session->userdata ( 'user' );
		
		if ($user != null) {
			$UserId = $user->User_Id;
			$UserType = $user->User_Type;
			$CurrentUserEmail = $user->email;
			$UserAccess = FALSE;
			
			if ($UserType == ADMIN || $UserType == ADMINUSER) {
				$this->load->model ( 'CaseMaster' );
				$this->load->model ( 'PatientMaster' );
				$this->load->model ( 'DoctorMaster' );
				$this->load->model ( 'ReportMaster' );
				
				$CaseDetail = $this->CaseMaster->getCasesById ( $id );
				$patientDetails = $this->PatientMaster->getPatientById ( $CaseDetail->Patient_Id );
				
				$DoctorDetails = $this->DoctorMaster->getDoctorById ( $CaseDetail->Doctor_Id );
				$DoctorProfileDetials = $this->DoctorMaster->getDoctorProfileDetails ( $CaseDetail->Doctor_Id );
				$DoctorEducation = $this->DoctorMaster->getDoctorEducationDetailsNew ( $CaseDetail->Doctor_Id );
				
				$CaseReportDetail = $this->ReportMaster->getCaseReportByID ( $id );
				
				if ($CaseReportDetail != NULL && $CaseReportDetail != '') {
					$Report = array (
							'Case_Id' => $id,
							'Query' => $CaseReportDetail->Medical_Query,
							'Medic_History' => $CaseReportDetail->Medical_History,
							'Doc_Comment' => $CaseReportDetail->Doc_Comment,
							'Doc_Recommend' => $CaseReportDetail->Doc_Recommendation,
							'Online' => $CaseReportDetail->Online_Resource,
							'Add_Service' => $CaseReportDetail->Add_Services,
							'Go_Recommend' => $CaseReportDetail->Go_Recommend,
							'Case_Date' => date ( DATEFORMAT, strtotime ( $CaseDetail->Case_Date ) ),
							'Patient_Name' => $patientDetails->FName . ' ' . $patientDetails->LName,
							'Patient_Gender' => $patientDetails->Gender,
							'DName' => $DoctorDetails->DName,
							'Qualification' => $DoctorDetails->Qualification,
							'DImage' => $DoctorDetails->DImagePath,
							'Specialization' => $DoctorProfileDetials->Speciality,
							'Summary' => $DoctorProfileDetials->Summary,
							'Short_Summary' => $DoctorProfileDetials->Short_Summary,
							'Education' => $DoctorEducation ["Edu_Details"] 
					)
					;
				} else {
					$Report = array (
							'Case_Id' => $id,
							'Query' => 'No Record Found.',
							'Medic_History' => 'No Record Found.',
							'Case_Date' => 'No Record Found.',
							'Doc_Comment' => 'No Record Found.',
							'Doc_Recommend' => 'No Record Found.',
							'Online' => 'No Record Found.',
							'Add_Service' => 'No Record Found.',
							'Qualification' => 'No Record Found.',
							'Go_Recommend' => 'No Record Found.',
							'Case_Date' => 'No Record Found.',
							'Patient_Name' => 'No Record Found.',
							'Patient_Gender' => 'No Record Found.',
							'DName' => 'No Record Found.',
							'DImage' => 'User1.jpg',
							'Specialization' => 'No Record Found.',
							'Summary' => 'No Record Found.',
							'Short_Summary' => 'No Record Found.',
							'Education' => 'No Record Found.' 
					)
					;
				}
				
				$data ['Report'] = $Report;
				$this->load->view ( 'reportpreview', $data ); // reportpreview
					                                          // print_r($case);
			} else {
				$this->load->view ( 'accessdenied' );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function reportGenerate($id) {
		
		$user = $this->session->userdata ( 'user' );
		$this->load->helper ( 'pdf_helper' );
		$this->load->helper ( 'secureemail' );
		
		if ($user != null) {
			$UserId = $user->User_Id;
			$UserType = $user->User_Type;
			$CurrentUserEmail = $user->email;
			$UserAccess = FALSE;
			
			if ($UserType == ADMIN || $UserType == ADMINUSER) {
				$this->load->model ( 'CaseMaster' );
				$this->load->model ( 'PatientMaster' );
				$this->load->model ( 'DoctorMaster' );
				$this->load->model ( 'ReportMaster' );
				
				$CaseDetail = $this->CaseMaster->getCasesById ( $id );
				$patientDetails = $this->PatientMaster->getPatientById ( $CaseDetail->Patient_Id );
				
				$DoctorDetails = $this->DoctorMaster->getDoctorById ( $CaseDetail->Doctor_Id );
				$DoctorProfileDetials = $this->DoctorMaster->getDoctorProfileDetails ( $CaseDetail->Doctor_Id );
				$DoctorEducation = $this->DoctorMaster->getDoctorEducationDetailsNew ( $CaseDetail->Doctor_Id );
				
				$CaseReportDetail = $this->ReportMaster->getCaseReportByID ( $id );
				
				if ($CaseReportDetail != NULL && $CaseReportDetail != '') {
					$Report = array (
							'Case_Id' => $id,
							'Title' => 'Report for '.$patientDetails->FName . ' ' . $patientDetails->LName.'  Case-' . $id,
							'FileName' => 'Case_' . $id . '_Report',
							'Query' => $CaseReportDetail->Medical_Query,
							'Medic_History' => $CaseReportDetail->Medical_History,
							'Doc_Comment' => $CaseReportDetail->Doc_Comment,
							'Doc_Recommend' => $CaseReportDetail->Doc_Recommendation,
							'Online' => $CaseReportDetail->Online_Resource,
							'Add_Service' => $CaseReportDetail->Add_Services,
							'Go_Recommend' => $CaseReportDetail->Go_Recommend,
							'Case_Date' => date ( DATEFORMAT, strtotime ( $CaseDetail->Case_Date ) ),
							'Patient_Name' => $patientDetails->FName . ' ' . $patientDetails->LName,
							'Patient_Gender' => $patientDetails->Gender,
							'DName' => $DoctorDetails->DName,
							'DImage' => $DoctorDetails->DImagePath,
							'Specialization' => $DoctorProfileDetials->Speciality,
							'Summary' => $DoctorProfileDetials->Summary,
							'Short_Summary' => $DoctorProfileDetials->Short_Summary,
							'Qualification' => $DoctorDetails->Qualification,
							'Education' => $DoctorEducation ["Edu_Details"] 
					)
					;
					
					$data ['Report'] = $Report;

					$this->load->view ( 'reportpdf', $data );

										//var_dump($data); 
					//die();

					$FileName = ''; // FCPATH.'documents/TempPDF/'.$Report["FileName"].'.pdf';
					              
					// Send Email to USer
					$CC = '';
					$EmailAddresTo = $patientDetails->Email;
					$Subject = 'Final Report for Case ID ' . $id;
					$BaseUrl = base_url ( 'cases/detail/' . $id );
					$BaseUrlAdd = base_url ( 'cases/add' );
					$Body = array (
							'Name' => $patientDetails->FName . ' ' . $patientDetails->LName,
							'Case_Id' => $id,
							'Doctor' => $DoctorDetails->DName,
							'Link' => $BaseUrl,
							'AddLink' => $BaseUrlAdd,
							'User_Id' => $CaseDetail->created_by 
					);
					
					// Mail to New User
					$NotificationsNewUser = array (
							'To' => $EmailAddresTo,
							'FROM' => ALERTEMAIL,
							'CC' => $CC,
							'Subject' => $Subject,
							'Body' => $Body,
							'Type' => "Email_User_FinalReport",
							'Attach' => $FileName 
					);
					
					//$this->load->helper ( 'notification_check' );
					//if(get_notification_status_user($user->User_Id))
					//{
						$ResultNotifyNewUser = send_secured_email ( $NotificationsNewUser );
					//}
					
					
					// Update Expiry Date forcase
					$TodayDate = date ( DATEFORMAT );
					$Tempdate = date ( DATEFORMAT, strtotime ( $TodayDate . '+5 days' ) );
					$TempdateDay = date ( 'D', $Tempdate );
					
					if ($TempdateDay == 'Sat') {
						$FinalDate = date ( DATEFORMAT, strtotime ( $Tempdate . '+2 days' ) );
					} else if ($TempdateDay == 'Sun') {
						$FinalDate = date ( DATEFORMAT, strtotime ( $Tempdate . '+1 days' ) );
					} else {
						$FinalDate = $Tempdate;
					}
					
					$CaseDetailsArray = array (
							'Case_Id' => $id,
							'ExpDate' => $FinalDate 
					)
					;
					$Result = $this->CaseMaster->UpdateCaseReportStatus ( $CaseDetailsArray );
					
					// Set Measage
					$FinalMsg = 'The Report was generated and sent  Successfully to <br/> Patient Email Address.';
					$MsgBit = "Success";
					$Message = array (
							'CaseId' => $id,
							'Message' => $FinalMsg,
							'ErrorBit' => $MsgBit 
					);
					
					// $this->session->set_flashdata('CaseUpdateMsg',$Message);
					
					// redirect ( 'reports/reportdetail/'.$id, 'location' );
				} else {
					// Set Measage
					$FinalMsg = 'Create The Report Record.<br/> Then Try Genearting Report.';
					$MsgBit = "Error";
					$Message = array (
							'CaseId' => $caseId,
							'Message' => $FinalMsg,
							'ErrorBit' => $MsgBit 
					);
					
					$this->session->set_flashdata ( 'CaseUpdateMsg', $Message );
					
					redirect ( 'reports/reportdetail/' . $id, 'location' );
				}
			} else {
				$this->load->view ( 'accessdenied' );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function reportviewUser($id) {
		
		$user = $this->session->userdata ( 'user' );
		$this->load->helper ( 'pdf_helper' );
		$this->load->helper ( 'secureemail' );
		
		if ($user != null) {
			$UserId = $user->User_Id;
			$UserType = $user->User_Type;
			$CurrentUserEmail = $user->email;
			$UserAccess = FALSE;
			
			$this->load->model ( 'CaseMaster' );
			$this->load->model ( 'PatientMaster' );
			$this->load->model ( 'DoctorMaster' );
			$this->load->model ( 'ReportMaster' );
			
			$CaseDetail = $this->CaseMaster->getCasesById ( $id );
			$patientDetails = $this->PatientMaster->getPatientById ( $CaseDetail->Patient_Id );
			
			if ($UserType == ADMIN || $UserType == ADMINUSER || $CaseDetail->created_by == $user->User_Id || $patientDetails->Email == $user->email) {
				
				$DoctorDetails = $this->DoctorMaster->getDoctorById ( $CaseDetail->Doctor_Id );
				$DoctorProfileDetials = $this->DoctorMaster->getDoctorProfileDetails ( $CaseDetail->Doctor_Id );
				$DoctorEducation = $this->DoctorMaster->getDoctorEducationDetailsNew ( $CaseDetail->Doctor_Id );
				
				$CaseReportDetail = $this->ReportMaster->getCaseReportByID ( $id );
				
				if ($CaseReportDetail != NULL && $CaseReportDetail != '') {
					$Report = array (
							'Case_Id' => $id,
							'Title' => 'Report for '.$patientDetails->FName . ' ' . $patientDetails->LName.'  Case-' . $id,
							'FileName' => 'Case_' . $id . '_Report',
							'Query' => $CaseReportDetail->Medical_Query,
							'Medic_History' => $CaseReportDetail->Medical_History,
							'Doc_Comment' => $CaseReportDetail->Doc_Comment,
							'Doc_Recommend' => $CaseReportDetail->Doc_Recommendation,
							'Online' => $CaseReportDetail->Online_Resource,
							'Add_Service' => $CaseReportDetail->Add_Services,
							'Go_Recommend' => $CaseReportDetail->Go_Recommend,
							'Case_Date' => date ( DATEFORMAT, strtotime ( $CaseDetail->Case_Date ) ),
							'Patient_Name' => $patientDetails->FName . ' ' . $patientDetails->LName,
							'Patient_Gender' => $patientDetails->Gender,
							'DName' => $DoctorDetails->DName,
							'DImage' => $DoctorDetails->DImagePath,
							'Specialization' => $DoctorProfileDetials->Speciality,
							'Summary' => $DoctorProfileDetials->Summary,
							'Short_Summary' => $DoctorProfileDetials->Short_Summary,
							'Education' => $DoctorEducation ["Edu_Details"] 
					)
					;
					
					$data ['Report'] = $Report;
					$this->load->view ( 'reportpdf', $data );
					
					//$this->load->view ( 'reportdompdf', $data );
				} else {
					// Set Measage
					$FinalMsg = 'No Report Yet.<br/>.';
					$MsgBit = "Error";
					$Message = array (
							'CaseId' => $caseId,
							'Message' => $FinalMsg,
							'ErrorBit' => $MsgBit 
					);
					
					$this->session->set_flashdata ( 'CaseUpdateMsg', $Message );
					
					redirect ( 'reports/reportdetail/' . $id, 'location' );
				}
			} else {
				$this->load->view ( 'accessdenied' );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	
	private function PatientMedicalHistory($PatientId)
	{
			$this->load->model ( 'PHRMaster' );
				
			$patientId = $PatientId;
	
				$MedicalConditions = $this->PHRMaster->getFlyMedicalConditions ();
				$familyHistory=$this->PHRMaster->getPatientsFlyMedicalHistory ( $patientId );
				$FlyHistory=$this->TransformFamilyMediArray($familyHistory,$MedicalConditions);
				$FamilyHistoryData = $FlyHistory;
	
				//PersonalMedical
				$PersonMedicConditions = $this->PHRMaster->getMedicalConditions ();
				$personalHistory=$this->PHRMaster->getPatientsMedicalHistory ( $patientId );
				$PersonHistory=$this->TransformPersonalMediArray($personalHistory,$PersonMedicConditions);
				$personalHistorydata = $PersonHistory;
	
	
				//Alergies
				$AlergyTypes = $this->PHRMaster->getDistinctAlergyType ();
				$Alergies = $this->PHRMaster->getAllAlergies ();
				$PatientsAlergies=$this->PHRMaster->getPatientsAlergies ( $patientId );
				$TranformAlergies=$this->TransformAlergyHistory($AlergyTypes,$Alergies,$PatientsAlergies);
				$PatientsAlergies = $TranformAlergies;
	
				//Feeling Question
				$FeelQuestions = $this->PHRMaster->getAllQuestions ();
				$FeelingAns = $this->PHRMaster->getPatientsAnswers ( $patientId );
				$answers = $this->TransformAnswerArray($FeelingAns,$FeelQuestions);
	
				
				//Hospital
				$HopitalList = $this->PHRMaster->getPatientsHospitalAdmissions ( $patientId );
				$HopitalDetails = $this->TransformHospitalRecords($HopitalList);
	
	
				$ReportString=$FamilyHistoryData.'<br/>'.$personalHistorydata.'<br/>'.$PatientsAlergies.'<br/>'.$answers.'<br/>'.$HopitalDetails;
	
				//$data['Report']=$ReportArray;
	
	
				//$this->load->view ( 'phrpdf', $data );
				return $ReportString;
				//print_r($ReportArray);
	}
	
	
	
	//Hospital Records
	private function TransformHospitalRecords($HospitalRecords)
	{
		$NoRecord= '<span>No Records Found</span>';
	
		$Header='<h4>Hospital Admission Records</h4><div>';
		$FinalValue='';
		$Value='';
		foreach( $HospitalRecords as $Hopital )
		{
			$Value=$Value . '<tr>
										<td>'.$Hopital->Reason.'</td>
										<td>&nbsp;</td>
										<td>'.date ( DATEFORMAT, strtotime ( $Hopital->Admit_Date ) ).'</td>
										</tr>';
		}
		
		
		$FinalValue='<table>
						<tr>
						<th><h5>REASON</h5></th>
						<th><h5>&nbsp;</h5></th>
						<th><h5>DATE</h5></th>
						</tr>'.$Value.'</table>';
		
		
		
			
		$HospitalHistory=$Header . ($HospitalRecords != '' && $HospitalRecords != NULL ? $FinalValue : $NoRecord) . '<div>';
	
		return $HospitalHistory;
	}
	
	
	//Feeling Question Answer
	private function TransformAnswerArray($AnsArray,$FeelQuestions)
	{	
		$NoRecord= '<li>No Records Found</li>';
		
		$Header='<h4>Question About How Are You Feeling</h4><ul>';
		$FinalValue='';
		foreach( $FeelQuestions as $Questions )
		{
			foreach ($AnsArray as $SingleAns)
			{
				if($SingleAns->State == $Questions->Id)
				{
					$FinalValue=$FinalValue . '<li>'.$Questions->Question.' -> Yes</li>';
				}
			}
		}
			
		$AnswersHistory=$Header . ($FinalValue != '' && $FinalValue != NULL ? $FinalValue : $NoRecord) . '</ul>';
		
		return $AnswersHistory;
	}
	
	 
	//Family Medic History
	private function TransformFamilyMediArray($FlyMedicArray,$MedicalConditions)
	{
		$NoRecord= '<li>No Records Found</li>';
		
		$Header='<h4>Family Medical History</h4><ul>';
		$FinalValue='';
		foreach( $MedicalConditions as $MedicCond )
		{
			foreach ($FlyMedicArray as $SingleAns) 
			{
				if($SingleAns->illness == $MedicCond->Condition_Id)
				{
					$FinalValue=$FinalValue . '<li>'.$MedicCond->ConditionName.'</li>';
				}
			}									  							
		}
		 
		$FamilyMedicalHistory=$Header . ($FinalValue != '' && $FinalValue != NULL ? $FinalValue : $NoRecord) . '</ul>';
		
		return $FamilyMedicalHistory;
	}
	 
	 
	//Personal Medical History
	private function TransformPersonalMediArray($PersonalMedicArray,$MedicalConditions)
	{		
		$NoRecord= '<li>No Records Found</li>';
		
		$Header='<h4>Your Medical History</h4><ul>';
		$FinalValue='';
		foreach( $MedicalConditions as $MedicCond )
		{
			foreach ($PersonalMedicArray as $SingleAns)
			{
				if($SingleAns->MedicalHistory == $MedicCond->Condition_Id)
				{
					$FinalValue=$FinalValue . '<li>'.$MedicCond->ConditionName.'</li>';
				}
			}
		}
			
		$PersonalMedicalHistory=$Header . ($FinalValue != '' && $FinalValue != NULL ? $FinalValue : $NoRecord) . '</ul>';
		
		return $PersonalMedicalHistory;
	}
	 
	 
	//AlergyHistory
	private function TransformAlergyHistory($AlergyTypes,$Alergies,$PatientsAlergies)
	{	
		$NoRecord= '<li>No Records Found</li>';
		
		$Header='<h4>Allergies</h4><ul>';
		$FinalValue='';
		$Value='';
		
		foreach( $AlergyTypes as $AlType )
		{
			$SetValue=false;
			$FinalHeaderValue='<li><strong><u>'.$AlType->AlegryType.'</u></strong></li>';
															
			foreach ( $Alergies as $Alergy )
			{
				if ($AlType->AlegryType == $Alergy->AlegryType)
				{
					foreach ($PatientsAlergies as $SingleAns)
					{
						 if($SingleAns->Allergies == $Alergy->Alergy_Id)
						 {
						 	$Value=$Value . '<li>'.$Alergy->AlergyName.'</li>';
						 	$SetValue=true;
						 }																											
					}
				}																
			}
			
			if($SetValue)
			{
				$FinalValue=$FinalValue.$FinalHeaderValue.$Value;
				$Value='';
			}
		}
		   										
			
		$AlergiesHistory=$Header . ($FinalValue != '' && $FinalValue != NULL ? $FinalValue : $NoRecord) . '</ul>';
		
		return $AlergiesHistory;
	}
	 
	 	
}
?>