<?php
class Users extends CI_Controller {
	public function __construct() {
		parent::__construct ();
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
	}
	public function index() {
		redirect ( 'users/login', 'location' );
	}
	private function _generate_captcha() {
		$this->load->helper ( 'captcha' );
		$num_str = sprintf ( "%06d", mt_rand ( 123456, 999999 ) );
		$val = array (
				'word' => $num_str,
				'img_path' => FCPATH . 'img/captcha/',
				'img_url' => '../img/captcha/',
				'font_path' => '../app/fonts/texb.ttf',
				'img_width' => '150',
				'img_height' => '30' 
		);
		/* Generate the captcha */
		$captcha = create_captcha ( $val );
		
		/* Store the captcha value (or 'word') in a session to retrieve later */
		$this->session->set_userdata ( 'captchaWord', $captcha ['word'] );
		
		return $captcha;
	}
	public function register() {
		
		// $ip = $this->input->ip_address();
		// $geo_data = geolocation_by_ip($ip);
		
		// echo "Country code : ".$geo_data['country_name']."\n";
		// echo "Country name : ".$geo_data['city']."\n";
		$data ['title'] = "Create an account";
		$this->load->view ( 'register', $this->_generate_captcha () );
	}
	public function _check_existing_user($email) {
		$this->load->model ( 'UserMaster' );
		$user = $this->UserMaster->get_user_by_email ( $email );
		if (count ( $user ) > 0) {
			$this->form_validation->set_message ( '_check_existing_user', 'The email address ' . $email . ' is already registered with us. 
					                                            Please use the forgot password option if you do not remember your password, or contact GrandOpinion support ' );
			return FALSE;
		} else {
			return TRUE;
		}
	}
	public function _check_non_existing_user($email) {
		$this->load->model ( 'UserMaster' );
		$user = $this->UserMaster->get_user_by_email ( $email );
		if (count ( $user ) == 0) {
			$this->form_validation->set_message ( '_check_non_existing_user', 'The email address ' . $email . ' is not registered with us.' );
			return FALSE;
		} else {
			return TRUE;
		}
	}
	public function _check_captcha($captcha) {
		$word = $this->session->userdata ( 'captchaWord' );
		if (strcmp ( strtoupper ( $captcha ), strtoupper ( $word ) ) != 0) {
			$this->form_validation->set_message ( '_check_captcha', 'Human verification failed. Please enter the text exactly' );
			return FALSE;
		} else {
			return TRUE;
		}
	}
	public function requestvisit() {
		redirect ( 'users/requestopinion?t=2', 'location' );
	}
	public function requestopinion() {
		$data ['title'] = "Request an opinion";
		$this->load->view ( 'request_opinion', $this->_generate_captcha () );
	}
	
	//Commented Previous Logic
	/*
	public function requestopinionsubmit() {
		$this->form_validation->set_rules ( 'firstName', 'First Name', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'lastName', 'Last Name', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'email', 'Email', 'trim|required|valid_email|callback__check_existing_user' );
		$this->form_validation->set_rules ( 'phone', 'Phone', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'country', 'Country', 'required|xss_clean' );
		$this->form_validation->set_rules ( 'city', 'City', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'password1', 'Password', 'trim|required|xss_clean|min_length[6]|matches[password2]|md5' );
		$this->form_validation->set_rules ( 'password2', 'Password Confirmation', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'query', 'Query', 'trim|required|xss_clean' );
		
		// $this->form_validation->set_rules('hearAboutUs', 'Awareness', 'trim|xss_clean');
		$this->form_validation->set_rules ( 'captcha', 'Human check', 'trim|required|xss_clean|callback__check_captcha' );
		$this->form_validation->set_rules ( 'agreeConditions', '', 'callback__check_acceptance' );
		
		if ($this->form_validation->run () == FALSE) {
			$data ['title'] = "Create an account";
			$this->load->view ( 'request_opinion', $this->_generate_captcha () );
			return;
		}
		
		
		
		$this->load->model ( 'UserMaster' );
		$this->load->model ( 'CaseMaster' );
		$this->db->trans_start ();
		
		$SaveUserData = array (
				'firstName' => $this->input->post ('firstName'),
				'lastName' => $this->input->post ('lastName'),
				'email' => $this->input->post ('email'),
				'country' => $this->input->post ('country'),
				'city' => $this->input->post ('city'),
				'phone' => $this->input->post ('phone'),
				'hearAboutUs' => $this->input->post ('hearAboutUs'),
				'password1' => $this->input->post ('password1'),
				'User_Image' => '',
				'gender' => '',
				'Regi_From' => NORMAL_CUST
		);
		
		$u = $this->UserMaster->register_array ($SaveUserData,TRUE);
		$this->session->set_userdata ( 'user', $u );
		$this->session->set_userdata ( 'user_id', $u->User_Id );
		$this->session->set_userdata ( 'user_name', $u->First_name );
		$this->CaseMaster->createQuery ();
		$this->db->trans_complete ();
		
		// Send Email to User
		$this->load->helper ( 'secureemail' );
		$TodayDate = date ( DATEFORMAT );
		
		$CC = '';
		$EmailAddresTo = $u->email;
		$Subject = 'Congratulations and welcome';
				$Body = array (
						'Name' => $u->First_name . ' ' . $u->Last_Name,
						'User_Id' => $u->User_Id,
						'Email' => $u->email,
						'Password' => '',
						'TimeStamp' => date ( DATEFORMAT, strtotime ( $TodayDate ) ) 
				);
				
				// Mail to New User
				$NotificationsNewUser = array (
						'To' => $EmailAddresTo,
						'FROM' => INFOEMAIL,
						'CC' => $CC,
						'Subject' => $Subject,
						'Body' => $Body,
						'Type' => 'Email_NewUser',
						'Attach' => '' 
				);
				$ResultNotifyNewUser = send_secured_email ( $NotificationsNewUser );
		
		// Send Email to Admin
		//$this->load->helper ( 'secureemail' );
		$CC = '';
		$EmailAddresTo = SUPPORTEMAIL;
		$EmailAddressFrom = INFOEMAIL;
		$SubjectEmail = 'New User through Request Opinion';
		
		$BodyEmailAdmin = array (
				'User_Id' => $u->User_Id,
				'First_name' => $u->First_name,
				'Last_Name' => $u->Last_Name,
				'email' => $u->email,
				'Mobile_Number' => $u->Mobile_Number,
				'City' => $u->City,
				'Country' => $u->Country,
				'DateStamp' => date ( DATEFORMAT, strtotime ( $TodayDate ) ) 
		);
		
		$EmailNotificationAdmin = array (
				'To' => $EmailAddresTo,
				'FROM' => $EmailAddressFrom,
				'CC' => $CC,
				'Subject' => $SubjectEmail,
				'Body' => $BodyEmailAdmin,
				'Type' => "Email_CC_NewUser",
				'Attach' => '' 
		);
		$ResultEmail = send_secured_email ( $EmailNotificationAdmin );
		
		$Message = array (
				'CaseId' => '',
				'Message' => 'Opinion Submitted. <br> Please verify your Email to Enjoy the benefits.<br>  The Email is sent to you.',
				'ErrorBit' => 'ErrorBit' 
		);
		
		$this->session->set_flashdata ( 'TransMsgSuccess', $Message );
		
		// echo "<script>location.href = '/master/cases';</script>";
		redirect ( 'cases', 'location' );
	}*/
	
	
	public function requestopinionsubmit() {
		$this->form_validation->set_rules ( 'firstName', 'First Name', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'lastName', 'Last Name', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'email', 'Email', 'trim|required|valid_email' ); //callback__check_existing_user
		$this->form_validation->set_rules ( 'phone', 'Phone', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'country', 'Country', 'required|xss_clean' );
		$this->form_validation->set_rules ( 'city', 'City', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'query', 'Query', 'trim|required|xss_clean' );
	
		$this->form_validation->set_rules ( 'agreeConditions', '', 'callback__check_acceptance' );
	
		if ($this->form_validation->run () == FALSE) {
			$data ['title'] = "Create an account";
			$this->load->view ( 'request_opinion', $this->_generate_captcha () );
			return;
		}
	
		
	
		$this->load->model ( 'OpportunitiesMaster' );
		
		$this->db->trans_start ();
	
		$UserCountry=$this->input->post ('country');
		$UserCity=$this->input->post ('city');
		$UserQuery=$this->input->post ('query');
		
		$FinalMessage='User City - '.$UserCity.' <br> User Country-'.$UserCountry.' <br><br> Query -<br> '.$UserQuery;
		
		$SaveUserData = array (
				'FName' => $this->input->post ('firstName'),
				'LName' => $this->input->post ('lastName'),
				'Email' => $this->input->post ('email'),
				'Msg' => $FinalMessage,
				'Mobile' => $this->input->post ('phone')
		);
	
		$LeadId = $this->OpportunitiesMaster->add ($SaveUserData);
		$this->db->trans_complete ();
	
		
		$TodayDate = date ( DATETIMEFORMAT );
	
		// Send Email to Client
		$this->load->helper ( 'secureemail' );
		$CC = '';
		$EmailAddresTo = $this->input->post ('email');
		$EmailAddressFrom = INFOEMAIL;
		$SubjectEmail = $SaveUserData["FName"].' '. $SaveUserData["LName"].' has Requested Opinion';
	
		$BodyEmailAdmin = array (
				'User_Id' => '',
				'First_name' => $SaveUserData["FName"],
				'Last_Name' => $SaveUserData["LName"],
				'email' => $SaveUserData["Email"],
				'Mobile_Number' => $SaveUserData["Mobile"],
				'City' => $UserCity,
				'Country' => $UserCountry,
				'query' => $UserQuery,
				'DateStamp' => date ( DATETIMEFORMAT, strtotime ( $TodayDate ) )
		);
	
		$EmailNotificationAdmin = array (
				'To' => $EmailAddresTo,
				'FROM' => $EmailAddressFrom,
				'CC' => $CC,
				'Subject' => $SubjectEmail,
				'Body' => $BodyEmailAdmin,
				'Type' => "Email_NewUser_RequestOpinion",
				'Attach' => ''
		);
		$ResultEmail = send_secured_email ( $EmailNotificationAdmin );
		
		// Send Email to  Support
		$EmailAddresTo = SUPPORTEMAIL;
		
		$EmailNotificationAdmin = array (
				'To' => $EmailAddresTo,
				'FROM' => $EmailAddressFrom,
				'CC' => $CC,
				'Subject' => $SubjectEmail,
				'Body' => $BodyEmailAdmin,
				'Type' => "Email_NewUser_RequestOpinion",
				'Attach' => ''
		);
		
		$ResultEmail = send_secured_email ( $EmailNotificationAdmin );
	
		$Message = array (
				'CaseId' => '',
				'Message' => 'Opinion Submitted. <br> Please verify your Email to Enjoy the benefits.<br>  The Email is sent to you.',
				'ErrorBit' => 'ErrorBit'
		);
	
		$this->load->view ( 'requestopinioncomplete');
	
		// echo "<script>location.href = '/master/cases';</script>";
		//redirect ( 'cases', 'location' );
	}
	
	public function _check_acceptance($accept) {
		$this->form_validation->set_message ( '_check_acceptance', 'You must agree to the terms and conditions to proceed.' );
		return $this->input->post ( 'agreeConditions' ) ? TRUE : FALSE;
	}
	public function save() {
		$this->form_validation->set_rules ( 'firstName', 'First Name', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'lastName', 'Last Name', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'email', 'Email', 'trim|required|valid_email|callback__check_existing_user' );
		$this->form_validation->set_rules ( 'phone', 'Phone', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'country', 'Country', 'required|xss_clean' );
		$this->form_validation->set_rules ( 'city', 'City', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'password1', 'Password', 'trim|required|xss_clean|min_length[6]|matches[password2]|md5' );
		$this->form_validation->set_rules ( 'password2', 'Password Confirmation', 'trim|required|xss_clean' );
		// $this->form_validation->set_rules('hearAboutUs', 'Awareness', 'trim|xss_clean');
		$this->form_validation->set_rules ( 'captcha', 'Human check', 'trim|required|xss_clean|callback__check_captcha' );
		$this->form_validation->set_rules ( 'agreeConditions', '', 'callback__check_acceptance' );
		
		if ($this->form_validation->run () == FALSE) {
			$data ['title'] = "Create an account";
			$this->load->view ( 'register', $this->_generate_captcha () );
			return;
		}
		
		$this->load->model ( 'UserMaster' );
		$u = $this->UserMaster->register ();
		
		// Send Email to User
		$this->load->helper ( 'secureemail' );
		$TodayDate = date ( DATETIMEFORMAT );
		
		$CC = '';
		$EmailAddresTo = $u->email;
		$Subject = 'Welcome to GrandOpinion';
		$Body = array (
				'Name' => $u->First_name . ' ' . $u->Last_Name,
				'VerificationId' => $u->Verification_Code,
				'Email' => $u->email 
		);
		
		// Mail to New User
		$NotificationsNewUser = array (
				'To' => $EmailAddresTo,
				'FROM' => INFOEMAIL,
				'CC' => $CC,
				'Subject' => $Subject,
				'Body' => $Body,
				'Type' => 'Email_User_Validation',
				'Attach' => '' 
		);
		$ResultNotifyNewUser = send_secured_email ( $NotificationsNewUser );
		
		
		// Send Email to Admin
		$CC = '';
		$EmailAddresTo = SUPPORTEMAIL;
		$EmailAddressFrom = INFOEMAIL;
		$SubjectEmail = 'New User through Registration without activated account';
		
		$BodyEmailAdmin = array (
				'User_Id' => $u->User_Id,
				'Name' => $u->First_name.' '.$u->Last_Name,
				'First_name' => $u->First_name,
				'Last_Name' => $u->Last_Name,
				'email' => $u->email,
				'Mobile_Number' => $u->Mobile_Number,
				'City' => $u->City,
				'Country' => $u->Country,
				'DateStamp' => date ( DATEFORMAT, strtotime ( $TodayDate ) )
		);
		
		$EmailNotificationAdmin = array (
				'To' => $EmailAddresTo,
				'FROM' => $EmailAddressFrom,
				'CC' => $CC,
				'Subject' => $SubjectEmail,
				'Body' => $BodyEmailAdmin,
				'Type' => "Email_CC_NewUser_NtActive",
				'Attach' => ''
		);
		$ResultEmail = send_secured_email ( $EmailNotificationAdmin );
		
		// $this->session->set_userdata ( 'user', $u );
		// $this->session->set_userdata ( 'user_id', $u->User_Id );
		// $this->session->set_userdata ( 'user_name', $u->First_name );
		// $this->session->set_userdata ( 'user_type', $u->User_Type );
		// echo $this->email->print_debugger();
		// redirect ( 'home/index', 'location' );
		$this->load->view ( 'registrationcomplete' );
	}
	public function _validate_user($password) {
		$this->load->model ( 'UserMaster' );
		$user = $this->UserMaster->get_user_by_email ( $this->input->post ( 'mail' ) );
		if (count ( $user ) == 0) {
			$this->form_validation->set_message ( '_validate_user', 'Invalid username/password combination.' );
			$this->session->sess_destroy ();
			return FALSE;
		} else if ($user [0]->Verify_Status != 1) {
			$BaseUrl = base_url ( 'users/resendcode?email=' . $user [0]->email );
			$this->form_validation->set_message ( '_validate_user', 'Your account is not verified.Kindly check your email and click the link provided in you email.<br/> Click <a href="' . $BaseUrl . '">here</a> to resend activation link. ' );
			$this->session->sess_destroy ();
			return FALSE;
		} else {
			$u = $user [0];
			if ($user [0]->Password != $password) {
				$this->form_validation->set_message ( '_validate_user', 'Invalid username/password combination.' );
				$this->session->sess_destroy ();
				return FALSE;
			}
			$this->session->set_userdata ( 'user', $u );
			$this->session->set_userdata ( 'user_id', $u->User_Id );
			$this->session->set_userdata ( 'user_name', $u->First_name );
			$this->session->set_userdata ( 'user_type', $u->User_Type );
			
			
			//UserNotification
			$this->CheckAssignNotification();
			
				$SubDetailsUser = $this->UserMaster->getSubscriptionDetails ( $u->User_Id );
				if($this->CheckUserSubscription($SubDetailsUser))
				{
					$this->session->set_userdata ( 'UserSubscription', $SubDetailsUser );
				}
			
			
			if ($u->User_Type == DOCTORS) {
				$this->load->model ( 'DoctorMaster' );
				
				$DoctorData = $this->DoctorMaster->getDoctorsByUserId ( $u->User_Id );
				$this->session->set_userdata ( 'Doctor_Id', $DoctorData->Doctor_Id );
			}
			return TRUE;
		}
	}
	public function switchback() { 
		if($this->session->userdata ( 'switch_back')>0) // allows me to use this if I did a 2nd level login
		{
			$this->load->model ( 'UserMaster' );
			$u = $this->UserMaster->get_singleuser ( $this->session->userdata ( 'switch_back'));

			$this->session->set_userdata ( 'user', $u );
			$this->session->set_userdata ( 'user_id', $u->User_Id );
			$this->session->set_userdata ( 'user_type', $u->User_Type );
			$this->session->set_userdata ( 'user_name', $u->First_name );

			$this->session->unset_userdata ( 'switch_back' ); // we are baap user now - allow the logout option
			
		} 
		
		redirect ( 'home/index', 'location' );
	}
	public function loginas($user_id) { 
		$user = $this->session->userdata ( 'user' );
		if($user->User_Type==7 /* doctor coordinator */ || $user->User_Type == ADMIN || $user->User_Type == ADMINUSER)
		{
			$this->load->model ( 'UserMaster' );

			$u = $this->UserMaster->get_singleuser ( $user_id );

			$this->session->set_userdata ( 'user', $u );
			$this->session->set_userdata ( 'user_id', $u->User_Id );
			$this->session->set_userdata ( 'user_type', $u->User_Type );
			$this->session->set_userdata ( 'user_name', $u->First_name );

			$this->session->set_userdata ( 'switch_back', $user->User_Id ); // switch back to baap user
			
		} 

		redirect ( 'home/index', 'location' );
	}
	public function login($error_id = 0) { // 1 for Facebook error, 2 for Google+ error
		$u = $this->session->userdata ( 'user' );
		
		if ($u != FALSE)
			redirect ( 'home/index', 'location' );
		
		$this->form_validation->set_rules ( 'mail', 'Email', 'trim|required|xss_clean|valid_email' );
		$this->form_validation->set_rules ( 'pass', 'Password', 'trim|required|xss_clean|md5|callback__validate_user' );
		
		if ($error_id == FACEBOOK_CUST) // FB login error
			$this->form_validation->set_message ( '_validate_user', 'Unable to login using Facebook.' );
		
		if ($error_id == GOOGLE_CUST) // Google+ login error
			$this->form_validation->set_message ( '_validate_user', 'Unable to login using Google+.' );
		
		try {
			$this->load->helper ( 'fblogin' );
			$fb = get_fb_object ();
			
			$user = $fb->getUser ();
			if ($user) {
				return $this->fblogin ();
			}
			
			$this->load->helper ( 'googlelogin' );
			$Googleclient = get_google_object ();
			
			$GoogleAccessToken = $this->session->userdata ( 'GoogleAccessToken' );
			
			if ($GoogleAccessToken) {
				return $this->googlelogin ();
			}
		} catch ( Exception $e ) {
			log_message ( 'error', $e->getMessage (), $e );
		}
		
		if ($this->form_validation->run () == FALSE) {
			$redirect = base_url ( 'users/fblogin' );
			
			$loginUrl = $fb->getLoginUrl ( array (
					'redirect_uri' => $redirect,
					'scope' => 'public_profile, user_location, email' 
			) );
			
			$authUrl = $Googleclient->createAuthUrl ();
			
			$data ['Google'] = $authUrl;
			$data ['FbLogin'] = $loginUrl;
			$this->load->view ( 'login', $data );
			return;
		}
		
		// Check Password ExpiryDate
		/*$CurrentDate = date ( DATEFORMAT );
		$UserPwdExpiryDate = date ( DATEFORMAT, strtotime ( $this->session->userdata ( 'user' )->Password_Expiry ) );
		if ($CurrentDate >= $UserPwdExpiryDate) {
			$WarningMsg = TRUE;
			$this->session->set_flashdata('W_Msg',$WarningMsg);
			redirect ( 'users/changePasswordload', 'location' );
			
		} else {*/
			redirect ( 'home/index', 'location' );
		//}
	}
	public function _validate_admin($password) {
		$this->load->model ( 'UserMaster' );
		$user = $this->UserMaster->get_user_by_email ( $this->input->post ( 'mail' ) );
		if (count ( $user ) == 0) {
			$this->form_validation->set_message ( '_validate_user', 'Invalid username/password combination.' );
			$this->session->sess_destroy ();
			return FALSE;
		} else {
			$u = $user [0];
			if ($user [0]->Password != $password) {
				$this->form_validation->set_message ( '_validate_user', 'Invalid username/password combination.' );
				$this->session->sess_destroy ();
				return FALSE;
			}
			if ($user [0]->User_Type != 1) {
				$this->form_validation->set_message ( '_validate_user', 'Invalid username/password combination.' );
				$this->session->sess_destroy ();
				return FALSE;
			}
			$this->session->set_userdata ( 'user', $u );
			$this->session->set_userdata ( 'user_id', $u->User_Id );
			$this->session->set_userdata ( 'user_type', $u->User_Type );
			$this->session->set_userdata ( 'user_name', $u->First_name );
			return TRUE;
		}
	}
	public function admin() {
		$this->form_validation->set_rules ( 'mail', 'Email', 'trim|required|xss_clean|valid_email' );
		$this->form_validation->set_rules ( 'pass', 'Password', 'trim|required|xss_clean|md5|callback__validate_admin' );
		
		if ($this->form_validation->run () == FALSE) {
			$this->load->view ( 'admin' );
			return;
		}
		redirect ( 'home/index', 'location' );
	}
	public function forgot() {
		$this->load->view ( 'forgot_password', $this->_generate_captcha () );
	}
	public function forgotsubmit() {
		//$this->form_validation->set_rules ( 'captcha', 'Human check', 'trim|required|xss_clean|callback__check_captcha' );
		$this->form_validation->set_rules ( 'email', 'Email', 'trim|required|valid_email|callback__check_non_existing_user' );
		
		if ($this->form_validation->run () == FALSE) {
			$this->load->view ( 'forgot_password', $this->_generate_captcha () );
			return;
		}
		
		$this->load->model ( 'UserMaster' );
		$users = $this->UserMaster->get_user_by_email ( $this->input->post ( 'email' ) );
		$user = $users [0];
		
		$data = array (
				'user_id' => $user->User_Id,
				'reset_key' => substr ( str_shuffle ( MD5 ( microtime () ) ), 0, 10 ),
				'reset_time' => time (),
				'request_ip' => $this->input->ip_address () 
		);
		
		$query = $this->db->insert_string ( 'password_reset_history', $data );
		$this->db->query ( $query );
		
		$msg = $this->load->view ( 'forgot_email', array (
				'user' => $user,
				'reset_url' => base_url ( 'users/reset/' . $data ['reset_key'] ) 
		), true );
		
		$this->load->library ( 'email' );
		
		$this->email->from ( INFOEMAIL, 'Team GrandOpinion' );
		$this->email->to ( $user->email );
		// $this->email->bcc ( 'sachin@grandopinion.com' );
		
		$this->email->subject ( 'GrandOpinion Password reset request' );
		$this->email->message ( $msg );
		$this->email->send ();
		
		$this->_resetsent ( $user->email );
	}
	public function _resetsent($email) {
		$data ['email'] = $email;
		$this->load->view ( 'forgot_sent', $data );
	}
	public function reset($reset_key) {
		$expiration = time () - (1 * 24 * 60 * 60); // Two day limit
		$this->db->query ( "DELETE FROM password_reset_history WHERE reset_time < " . $expiration );
		
		$sql = "SELECT * FROM password_reset_history WHERE reset_key = ?";
		$query = $this->db->query ( $sql, array (
				$reset_key 
		) );
		$keys = $query->result ();
		if (count ( $keys ) > 0) // reset was requested
{
			$this->load->view ( 'reset_password', array (
					'reset_key' => $reset_key 
			) );
		} else {
			$this->load->view ( 'reset_error' );
		}
	}
	public function resetsubmit($reset_key) {
		$this->form_validation->set_rules ( 'password1', 'Password', 'trim|required|xss_clean|min_length[6]|matches[password2]|md5' );
		$this->form_validation->set_rules ( 'password2', 'Password Confirmation', 'trim|required|xss_clean' );
		
		if ($this->form_validation->run () == FALSE) {
			$this->load->view ( 'reset_password', array (
					'reset_key' => $reset_key 
			) );
			return;
		}
		
		$sql = "SELECT * FROM password_reset_history WHERE reset_key = ?";
		$query = $this->db->query ( $sql, array (
				$reset_key 
		) );
		$keys = $query->result ();
		if (count ( $keys ) == 0) // reset was requested
{
			$this->load->view ( 'reset_error' );
			return;
		}
		
		$this->load->model ( 'UserMaster' );
		$this->load->helper ( 'secureemail' );

		$u = $this->UserMaster->get_singleuser( $keys [0]->user_id );
		
		$data = array (
				'password' => $this->input->post ( 'password1' ) 
		);
		
		$this->db->where ( 'User_Id', $u->User_Id );
		$this->db->update ( 'user', $data );

		send_secured_email_without_logo ( array (
				'To' => $u->email,
				'FROM' => INFOEMAIL,
				'Subject' => 'GrandOpinion Password Reset Done',
				'Type' => "Email_User_Password_Reset_Done"
		));
		
		$this->load->view ( 'reset_success' );
		
		$this->session->set_userdata ( 'user', $u );
		$this->session->set_userdata ( 'user_id', $u->User_Id );
		$this->session->set_userdata ( 'user_type', $u->User_Type );
		$this->session->set_userdata ( 'user_name', $u->First_name );

		
		$sql = "DELETE FROM password_reset_history WHERE reset_key =  ?";
		$this->db->query ( $sql, array (
				$reset_key 
		) );
	}
	public function logout() {
		$logout = $this->session->userdata ( 'logout_url' );
		
		if ($logout == TRUE) { // facebook session
			$this->load->helper ( 'fblogin' );
			$fb = get_fb_object ();
			$fb->destroySession ();
		}
		
		$this->session->sess_destroy ();
		redirect ( '/', 'location' );
	}
	public function profiledetails() {
		
		$user = $this->session->userdata ( 'user' );
		
		// print_r($SessionVar);
		
		if ($user != null) {
			$this->load->model ( 'UserMaster' );
			$this->session->set_userdata ( 'activeMenu', "dashboard" );
			$UserArray = $this->UserMaster->get_singleuser ( $user->User_Id );
			
			$CorpCode='';
			
			if($UserArray->User_Type == CORPADMIN)
			{
				$this->load->model ( 'CaseMaster' );
				$CorporateDetails=$this->CaseMaster->getCorpDetailsById ( $UserArray->User_Id );
				if($CorporateDetails != NULL)
				{
					$CorpCode=$CorporateDetails->Corp_Unique_Id;
				}
			}
			
			$ImageName = "default-user.png";
			$FileName = FCPATH."images/Users/" . $UserArray->User_Image;
			if(is_file($FileName))
			{
				$ImageName = $UserArray->User_Image;
			}
			
			
			$UserDetailsArray = array (
					'User_Id' => $UserArray->User_Id,
					'First_name' => $UserArray->First_name,
					'Last_Name' => $UserArray->Last_Name,
					'Gender' => ($UserArray->Gender != NULL ? $UserArray->Gender : 'NA'),
					'Birth_Date' => date ( DATEFORMAT, strtotime ( $UserArray->Birth_Date ) ),
					'Address' => ($UserArray->Address != NULL ? $UserArray->Address: 'NA'),
					'City' => ($UserArray->City != NULL ? $UserArray->City : 'NA'),
					'State' => ($UserArray->State != NULL ? $UserArray->State : 'NA'),
					'Zip_Code' => ($UserArray->Zip_Code != NULL ? $UserArray->Zip_Code : 'NA'),
					'Country' => ($UserArray->Country != NULL ? $UserArray->Country : 'NA'),
					'email' => ($UserArray->email != NULL ? $UserArray->email : 'NA'),
					'Mobile_Number' => ($UserArray->Mobile_Number != NULL ? $UserArray->Mobile_Number : 'NA'),
					'User_Image' => $ImageName,
					'UserType' => $UserArray->User_Type,
					'Company' => $UserArray->Company,
					'CorpCode' =>  $CorpCode
			);
			
			
			//Subscription  Details
			
			$SubscriptionArray=array(
					'PlanName' =>'NA',
					'StartDate' =>'NA',
					'EndDate' =>'NA'
			);
			
			$SubscriptionDetails=$this->UserMaster->getSubscriptionDetails($UserArray->User_Id);
			
			if($SubscriptionDetails != NULL && $SubscriptionDetails != '')
			{
				$PlanDetails=$this->UserMaster->getPlanName($SubscriptionDetails->Plan_Id);
				
				$SubscriptionArray=array(
						'PlanName' =>$PlanDetails->Plan_Name,
						'StartDate' =>date ( DATEFORMAT, strtotime ( $SubscriptionDetails->Start_Date ) ),
						'EndDate' =>date ( DATEFORMAT, strtotime ( $SubscriptionDetails->End_Date ) )
				);
			}
			
			
			
			$MessageDetails = $this->session->flashdata ( 'UserMsg' );
			
			if ($MessageDetails == NUll) {
				$Message = array (
						'CaseId' => '',
						'Message' => '',
						'ErrorBit' => '' 
				);
			} else {
				$Message = array (
						'CaseId' => $MessageDetails ['CaseId'],
						'Message' => $MessageDetails ['Message'],
						'ErrorBit' => $MessageDetails ['ErrorBit'] 
				);
			}
			
			$data['Subscription']=$SubscriptionArray;
			$data ['CaseMessage'] = $Message;
			
			$data ['userdetails'] = $UserDetailsArray;
			$data ['notifications'] = $this->UserMaster->getNotificationByUser ( $user->User_Id );
			
			if($UserArray->User_Type == CORPADMIN)
			{
				$this->load->view ( 'corporate_profile', $data );
			}
			else 
			{
				$this->load->view ( 'profile', $data );
			}
			
			// print_r($UserArray);
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function profileEdit($id) {
		
		$user = $this->session->userdata ( 'user' );
		
		if ($user != null) {
			$this->load->model ( 'UserMaster' );
			$this->load->helper ( 'form' );
			$this->load->helper ( 'file' );
			$this->load->library ( 'form_validation' );
			$this->load->helper ( 'geo_location_pi' );
			$userdetails = $this->UserMaster->get_singleuser ( $id );
			$data ['userdetails'] = $userdetails;
			$data ['notifications'] = $this->UserMaster->getNotificationByUser ( $id );
			// print_r($data['notifications']);
			
			$ImageName = "default-user.png";
			$FileName = "images/Users/" . $userdetails->User_Image;
			if(is_file($FileName))
			{
				$ImageName = $userdetails->User_Image;
			}
			$data ['Image'] = $ImageName;
			if($user->User_Type == CORPADMIN)
			{
				$this->load->view ( 'corporate_profile_edit', $data );
			}
			else
			{
				$this->load->view ( 'profileedit', $data );
			}
			
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function profileEditSubmit($id) {
		// print_r("Check");
		
		$user = $this->session->userdata ( 'user' );
		
		$SubmitValue = $this->input->post ( 'back' );
		if ($SubmitValue != NULL && $SubmitValue != '')
		{
			redirect ( 'users/profiledetails', 'location' );
		}
		
		$this->load->helper ( 'file' );
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		$this->load->helper ( 'geo_location_pi' );
		
		$config ['upload_path'] = './images/Users/';
		$config ['allowed_types'] = 'gif|jpg|png|jpeg';
		$config ['max_size'] = '2000';
		
		$config ['overwrite'] = TRUE;
		
		$this->load->library ( 'upload', $config );
		
		
		$this->form_validation->set_rules ( 'email', 'Email', 'trim|required|xss_clean|valid_email' );
		$this->form_validation->set_rules ( 'pincode', 'Zip Code', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'country', 'Country', 'trim|required|xss_clean' );
		
		$this->form_validation->set_rules ( 'mobile', 'Mobile Number', 'trim|required|xss_clean|max_length[20]' );
		$this->form_validation->set_rules ( 'profilePic', 'Profile Picture', 'callback__validate_uploadpic' );
		
		if ($user != null) {
			
			if($user->User_Type != CORPADMIN)
			{
				$this->form_validation->set_rules ( 'firstName', 'First Name', 'trim|required|xss_clean' );
				$this->form_validation->set_rules ( 'lastName', 'Last Name', 'trim|required|xss_clean' );
				$this->form_validation->set_rules ( 'gender', 'Gender', 'trim|required|xss_clean' );
				$this->form_validation->set_rules ( 'Bdate', 'Birth Date', 'trim|required|xss_clean|callback__validate_dateofbirth' );
			}
			else 
			{
				$this->form_validation->set_rules ( 'company', 'Company Name', 'trim|required|xss_clean' );
			}
			
			try {
				$this->load->model ( 'UserMaster' );
				if ($this->form_validation->run () == FALSE) {
					
					$ProfileData = array (
							'First_name' => $this->input->post ( 'firstName' ),
							'Last_Name' => $this->input->post ( 'lastName' ),
							'Gender' => $this->input->post ( 'gender' ),
							'Birth_Date' => $this->input->post ( 'Bdate' ),
							'Address' => $this->input->post ( 'address' ),
							'City' => $this->input->post ( 'city' ),
							'State' => $this->input->post ( 'state' ),
							'Zip_Code' => $this->input->post ( 'pincode' ),
							'Country' => $this->input->post ( 'country' ),
							'email' => $this->input->post ( 'email' ),
							'Mobile_Number' => $this->input->post ( 'mobile' ),
							'Company' => $this->input->post ( 'company' ),
							'User_Type' => $user->User_Type,
							'User_Image' => $user->User_Image,
							'User_Id' => $id 
					);
					$ConvertedObject = ( object ) $ProfileData;
					$data ['userdetails'] = $ConvertedObject;
					$data ['notifications'] = $this->UserMaster->getNotificationByUser ( $id );
					// print_r($id);
					
					if($user->User_Type == CORPADMIN)
					{
						$this->load->view ( 'corporate_profile_edit', $data );
					}
					else
					{
						$this->load->view ( 'profileedit', $data );
					}
					
					return;
				}
				
				
				$Notification1 = $this->input->post ( 'emailnoti' );
				$Notification2 = $this->input->post ( 'smsnoti' );
				$Notification3 = $this->input->post ( 'callnoti' );
				
				if (isset ( $_FILES ['profilePic'] ) && ! empty ( $_FILES ['profilePic'] ['name'] )) {
					$ProfilePicName = $_FILES ['profilePic'] ['name'];
				} else if ($user->User_Image != NULL) {
					$ProfilePicName = $user->User_Image;
				} else {
					$ProfilePicName = NULL;
				}
				
				$Result = $this->UserMaster->EditProfile ( $id, $ProfilePicName );
				// to update corporate details
				if($user->User_Type == CORPADMIN)
				{
					
							$Corp_array = array (
								'Company_Name' => $this->input->post('company') ,
								'Address' => $this->input->post('address') ,
								'Phone' => $this->input->post('mobile') ,
							'User_Id' => $user->User_Id
							);
					
					$Result = $this->UserMaster->update_corpdetails ( $Corp_array );
				}
				
				$UserArray = $this->UserMaster->get_singleuser ( $user->User_Id );
				$this->session->set_userdata ( 'user', $UserArray );
				//Assign Notification
				$this->CheckAssignNotification();
				
				// Send Email to User
				$this->load->helper ( 'secureemail' );
				$CC = '';
				$EmailAddresTo = $user->email;
				$EmailAddressFrom = INFOEMAIL;
				$SubjectEmail = 'Profile Updated';
				$BaseUrl = base_url ( 'users/profiledetails' );
				
				$BodyEmailUser = array (
						'Name' => $user->First_name . ' ' . $user->Last_Name,
						'Link' => $BaseUrl,
						'User_Id' => $user->User_Id 
				);
				
				$EmailNotificationAdmin = array (
						'To' => $EmailAddresTo,
						'FROM' => $EmailAddressFrom,
						'CC' => $CC,
						'Subject' => $SubjectEmail,
						'Body' => $BodyEmailUser,
						'Type' => "Email_User_Profile",
						'Attach' => '' 
				);
				
				$this->load->helper ( 'notification_check' );
				if(get_notification_status_user($user->User_Id))
				{
					$ResultEmail = send_secured_email ( $EmailNotificationAdmin );
				}
				
				
				// Set Flash Message
				
				$FinalMsg = 'The Profile Successfully Updated.';
				$MsgBit = "Success";
				$Message = array (
						'CaseId' => '',
						'Message' => $FinalMsg,
						'ErrorBit' => $MsgBit 
				);
				
				$this->session->set_flashdata ( 'UserMsg', $Message );
				
				redirect ( 'users/profiledetails', 'location' );
				// print_r($Notification1);
				// print_r($Notification2);
				// print_r($Notification3);
			} catch ( Exception $Ex ) {
				echo 'Caught Exp Message: <br>';
				echo $Ex->getMessage (), '\n';
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function _validate_uploadpic() {
		$user = $this->session->userdata ( 'user' );
		
		if (isset ( $_FILES ['profilePic'] ) && ! empty ( $_FILES ['profilePic'] ['name'] )) {
			// $FileExt=new SplFileInfo($_FILES['profilePic']['name']);
			$FileExt = pathinfo ( $_FILES ['profilePic'] ['name'], PATHINFO_EXTENSION );
			$UploadFileName = $user->First_name . '-' . $user->Birth_Date . '.' . $FileExt;
			$_FILES ['profilePic'] ['name'] = $UploadFileName;
			
			if (! $this->upload->do_upload ( 'profilePic' )) {
				$error = array (
						'error' => $this->upload->display_errors () 
				);
				
				$FinalErrors = implode ( '<br/>', $error );
				$this->form_validation->set_message ( '_validate_uploadpic', $FinalErrors );
				return FALSE;
			} 
			else 
			{
				$config['image_library'] = 'gd2';
				$config['source_image'] = $this->upload->upload_path.$this->upload->file_name;
				$config['maintain_ratio'] = TRUE;
				$config['master_dim'] = 'width';
				$config ['width'] = '160';
				$config ['height'] = '1';
				$this->load->library('image_lib', $config);
				
				if ( ! $this->image_lib->resize())
				{
					$error = array (
							'error' => $this->image_lib->display_errors()
					);
					
					$FinalErrors = implode ( '<br/>', $error );
					$this->form_validation->set_message ( '_validate_uploadpic', $FinalErrors );
					return FALSE;
				}
				
				$this->form_validation->set_message ( '_validate_uploadpic', 'The document was uploaded successfully.' );
				return TRUE;
			}
		} else {
			if ($user->User_Image != NULL) {
				$this->form_validation->set_message ( '_validate_uploadpic', 'The document was uploaded successfully.' );
				return TRUE;
			} else {
				$this->form_validation->set_message ( '_validate_uploadpic', "You must upload an image!" );
				return TRUE;
			}
		}
	}
	
	//Validate dateof birth
	public function _validate_dateofbirth($DateOfBirth) {
		if ($this->session->userdata ( 'user' ) != null)
		{
			$TodayDate = date ( DATEFORMAT );
				
			if (strtotime($DateOfBirth) > strtotime($TodayDate) ) {
				$this->form_validation->set_message ( '_validate_dateofbirth', 'Invalid Date of Birth' );
				return FALSE;
			}
	
			return TRUE;
		} else {
			$this->form_validation->set_message ( '_validate_dateofbirth', 'Invalid Date of Birth' );
			return FALSE;
		}
	}
	
	public function changePasswordload() {
		
		$user = $this->session->userdata ( 'user' );
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		if ($user != null) 
		{
			$Warning_Msg = $this->session->flashdata('W_Msg');
			if($Warning_Msg == null ){
				$Warning_Msg = FALSE;
			}
			$this->session->set_userdata ( 'activeMenu', "dashboard" );
			$data ['UserId'] = $this->session->userdata ( 'user' )->User_Id;
			$data ['WarnMsg'] = $Warning_Msg;
			$this->load->view ( 'changepassword', $data );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function changePassword() {
		
		$user = $this->session->userdata ( 'user' );
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		$this->form_validation->set_rules ( 'oldpwd', 'Old Password', 'trim|required|xss_clean|md5|callback__validate_userpassword' );
		$this->form_validation->set_rules ( 'newpwd', 'New Password', 'trim|required|xss_clean|min_length[6]|matches[confirmpwd]|md5' );
		$this->form_validation->set_rules ( 'confirmpwd', 'Password Confirmation', 'trim|required|xss_clean' );
		
		if ($user != null) 
		{
			$Warning_Msg = $this->input->post('WarnMsg');
			if($Warning_Msg == null){
				$Warning_Msg = FALSE;
			}
		$data ['WarnMsg'] = $Warning_Msg;
			if ($this->form_validation->run () == FALSE) {
				$data ['UserId'] = $user->User_Id;
				$this->load->view ( 'changepassword', $data );
				return;
			}
			$this->load->model ( 'UserMaster' );
			$Result = $this->UserMaster->changePassword ();
			
			redirect ( 'home/index', 'location' );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function _validate_userpassword($password) {
		if ($this->session->userdata ( 'user' ) != null) {
			$currentPassowrd = $this->session->userdata ( 'user' )->Password;
			if ($currentPassowrd != $password) {
				$this->form_validation->set_message ( '_validate_userpassword', 'Invalid Old Password.' );
				return FALSE;
			}
			
			return TRUE;
		} else {
			$this->form_validation->set_message ( '_validate_userpassword', 'Invalid Old Password.' );
			return FALSE;
		}
	}
	public function getPlansDeatils() {
		
		$user = $this->session->userdata ( 'user' );
		
		if ($user != NULL) {
			$this->session->set_userdata ( 'activeMenu', "subsciption" );
			$this->load->model ( 'UserMaster' );
			$SubDetailsUser = $this->UserMaster->getSubscriptionDetails ( $user->User_Id );
			
			$PlanArray = array (
					'Plan_Name' => 'NA',
					'Plan_Id' => '',
					'Start_Date' => 'NA',
					'End_Date' => 'NA' 
			);
			
			if ($SubDetailsUser != NULL && $SubDetailsUser != '') {
				$PlanDetails = $this->UserMaster->getPlanName ( $SubDetailsUser->Plan_Id );
				
				$PlanArray = array (
						'Plan_Name' => $PlanDetails->Plan_Name,
						'Plan_Id' => $PlanDetails->Plan_Id,
						'Start_Date' => date ( DATEFORMAT, strtotime ( $SubDetailsUser->Start_Date ) ),
						'End_Date' => date ( DATEFORMAT, strtotime ( $SubDetailsUser->End_Date ) ) 
				);
			}
			
			// Get Payment Message
			$MessageDetails = $this->session->flashdata ( 'TransMsgSuccess' );
			
			if ($MessageDetails == NUll) {
				$UpdtMsg = array (
						'CaseId' => '',
						'Message' => '',
						'ErrorBit' => '' 
				);
			} else {
				$UpdtMsg = array (
						'CaseId' => $MessageDetails ['CaseId'],
						'Message' => $MessageDetails ['Message'],
						'ErrorBit' => $MessageDetails ['ErrorBit'] 
				);
			}
			
			$data ['CaseMessage'] = $UpdtMsg;
			
			$data ['Plan'] = $PlanArray;
			$this->load->view ( 'subscriptiondetails', $data );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function getPlansDeatilsEdit() {
		
		$user = $this->session->userdata ( 'user' );
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		if ($user != NULL) {
			$this->load->model ( 'UserMaster' );
			$SubDetailsUser = $this->UserMaster->getSubscriptionDetails ( $user->User_Id );
			
			$UserPlanArray = array (
					'Plan_Name' => '',
					'Plan_Id' => '',
					'Start_Date' => '',
					'End_Date' => '' 
			);
			
			if ($SubDetailsUser != NULL && $SubDetailsUser != '') {
				$PlanDetails = $this->UserMaster->getPlanName ( $SubDetailsUser->Plan_Id );
				$UserPlanArray = array (
						'Plan_Name' => $PlanDetails->Plan_Name,
						'Plan_Id' => $PlanDetails->Plan_Id,
						'Start_Date' => date ( DATEFORMAT, strtotime ( $SubDetailsUser->Start_Date ) ),
						'End_Date' => date ( DATEFORMAT, strtotime ( $SubDetailsUser->End_Date ) ) 
				);
			}
			
			$PlanList = $this->UserMaster->getAllPlans ();
			$PlanArray = array ();
			
			foreach ( $PlanList as $SinglePlan ) {
				$PlanArray [] = array (
						'Plan_Name' => $SinglePlan->Plan_Name,
						'Plan_Id' => $SinglePlan->Plan_Id,
						'Desciption' => $SinglePlan->Desciption,
						'Plan_Type' =>  strtolower($SinglePlan->Plan_Type)
				);
			}
			
			$data['CorpCode']=strtolower($user->Corp_Code);
			$data ['UserPlan'] = $UserPlanArray;
			$data ['Plans'] = $PlanArray;
			$this->load->view ( 'subscriptiondetailsedit', $data );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function getPlansDeatilsEditPost() {
		
		$this->load->helper ( 'secureemail' );
		$user = $this->session->userdata ( 'user' );
		
		$SubmitValue = $this->input->post ( 'back' );
		
		if ($SubmitValue != NULL && $SubmitValue != '') {
			redirect ( 'users/getPlansDeatils', 'location' );
		}
		
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		$this->form_validation->set_rules ( 'Plan', 'Plan', 'callback__validate_planpurchase|callback__validate_PlanName' );
		$this->form_validation->set_rules ( 'Startdate', 'Start date', 'callback__validate_dateofplan' );
		
		if ($user != NULL) {
			$this->load->model ( 'UserMaster' );
			$SubDetailsUser = $this->UserMaster->getSubscriptionDetails ( $user->User_Id );
			
			if ($this->form_validation->run () == FALSE) {
				$UserPlanArray = array (
						'Plan_Name' => '',
						'Plan_Id' => '',
						'Start_Date' => '',
						'End_Date' => '' 
				);
				
				if ($SubDetailsUser != NULL && $SubDetailsUser != '') {
					$PlanDetails = $this->UserMaster->getPlanName ( $SubDetailsUser->Plan_Id );
					$UserPlanArray = array (
							'Plan_Name' => $PlanDetails->Plan_Name,
							'Plan_Id' => $PlanDetails->Plan_Id,
							'Start_Date' => date ( DATEFORMAT, strtotime ( $SubDetailsUser->Start_Date ) ),
							'End_Date' => date ( DATEFORMAT, strtotime ( $SubDetailsUser->End_Date ) ) 
					);
				}
				
				$PlanList = $this->UserMaster->getAllPlans ();
				$PlanArray = array ();
				
				foreach ( $PlanList as $SinglePlan ) {
					$PlanArray [] = array (
							'Plan_Name' => $SinglePlan->Plan_Name,
							'Plan_Id' => $SinglePlan->Plan_Id,
							'Desciption' => $SinglePlan->Desciption,
							'Plan_Type' =>  strtolower($SinglePlan->Plan_Type)
					);
				}
				
				$data['CorpCode']=strtolower($user->Corp_Code);
				$data ['UserPlan'] = $UserPlanArray;
				$data ['Plans'] = $PlanArray;
				$this->load->view ( 'subscriptiondetailsedit', $data );
				return;
			}
			
			$PlanSelected = $this->input->post ( 'Plan' );
			
			$PlanStartDate = $this->input->post ( 'Startdate' );
			$this->session->set_userdata ( 'PlanStartDate', $PlanStartDate );
			
			redirect ( 'payments/addplan/' . $PlanSelected, 'location' );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	public function _validate_PlanName($PlanId) {
		if ($this->session->userdata ( 'user' ) != null) {
			if ($PlanId == "null") {
				$this->form_validation->set_message ( '_validate_PlanName', 'Invalid Plan' );
				return FALSE;
			}
				
			return TRUE;
		} else {
			$this->form_validation->set_message ( '_validate_PlanName', 'Invalid Plan' );
			return FALSE;
		}
	}
	
	public function _validate_planpurchase() {
		$user = $this->session->userdata ( 'user' );
		$this->load->helper ( 'secureemail' );
		
		if ($user != null) {
			$Subscription = $SubDetailsUser = $this->UserMaster->getSubscriptionDetails ( $user->User_Id );
			if ($Subscription != NULL) {
				$Curredate = date ( DATEFORMAT );
				$Endate = ($Subscription->End_Date);
				if ($Curredate < $Endate) {
					// Send Email to Admin
					$CC = '';
					$EmailAddresTo = SUPPORTEMAIL;
					$EmailAddressFrom = INFOEMAIL;
					$SubjectEmail = 'Plan Change Request';
					
					$BodyEmailAdmin = array (
							'User_Id' => $user->User_Id,
							'Name' => $u->First_name.' '.$u->Last_Name,
							'First_name' => $user->First_name,
							'Last_Name' => $user->Last_Name,
							'email' => $user->email,
							'Mobile_Number' => $user->Mobile_Number,
							'City' => $user->City,
							'Country' => $user->Country,
							'DateStamp' => date ( DATEFORMAT, strtotime ( $Curredate ) ) 
					);
					
					$EmailNotificationAdmin = array (
							'To' => $EmailAddresTo,
							'FROM' => $EmailAddressFrom,
							'CC' => $CC,
							'Subject' => $SubjectEmail,
							'Body' => $BodyEmailAdmin,
							'Type' => "Email_CC_PlanChangeRequest",
							'Attach' => '' 
					);
					$ResultEmail = send_secured_email ( $EmailNotificationAdmin );
					
					$this->form_validation->set_message ( '_validate_planpurchase', 'Cannot Buy New Plan.Unless previous gets over.<br>Contact our Support' );
					return FALSE;
				}
				return TRUE;
			}
			
			return TRUE;
		} else {
			$this->form_validation->set_message ( '_validate_planpurchase', 'Cannot Buy New Plan.Unless previous gets over.<br>Contact our Support' );
			return FALSE;
		}
	}
	
	
	public function _validate_dateofplan($DateOfBirth) 
	{
		if ($this->session->userdata ( 'user' ) != null)
		{
			$TodayDate = date ( DATEFORMAT );
				
			if (strtotime($DateOfBirth) < strtotime($TodayDate) ) {
				$this->form_validation->set_message ( '_validate_dateofplan', 'Start Date Cannot be Previous Date. <br>Set Atleast Todays date' );
				return FALSE;
			}
	
			return TRUE;
		} else {
			$this->form_validation->set_message ( '_validate_dateofplan', 'Start Date Cannot be Previous Date. <br>Set Atleast Todays date' );
			return FALSE;
		}
	}
	
	
	
	public function profiledetailsAdmin($id) {
		
		$user = $this->session->userdata ( 'user' );
		
		// print_r($SessionVar);
		
		if ($user != null) {
			if ($user->User_Type == ADMIN || $user->User_Type == ADMINUSER) {
				$this->load->model ( 'UserMaster' );
				$UserDetails = $this->UserMaster->get_singleuser ( $id );
				
				$UserArray = array (
						'User_Id' => $UserDetails->User_Id,
						'First_name' => $UserDetails->First_name,
						'Last_Name' => $UserDetails->Last_Name,
						'Gender' => $UserDetails->Gender,
						'Birth_Date' => date ( DATEFORMAT, strtotime ( $UserDetails->Birth_Date ) ),
						'Address' => $UserDetails->Address,
						'City' => $UserDetails->City,
						'State' => $UserDetails->State,
						'Zip_Code' => $UserDetails->Zip_Code,
						'Country' => $UserDetails->Country,
						'email' => $UserDetails->email,
						'Mobile_Number' => $UserDetails->Mobile_Number,
						'User_Image' => ($UserDetails->User_Image != NUll ? $UserDetails->User_Image : '') 
				);
				
				$Message = array (
						'CaseId' => '',
						'Message' => '',
						'ErrorBit' => '' 
				);
				$data ['CaseMessage'] = $Message;
				
				$data ['userdetails'] = $UserArray;
				$data ['notifications'] = $this->UserMaster->getNotificationByUser ( $user->User_Id );
				$this->load->view ( 'profile', $data );
				// print_r($UserArray);
			} else {
				$this->load->view ( 'accessdenied' );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	public function verifyaccount($VerificationCode) {
		$this->load->helper ( 'secureemail' );
		$this->load->model ( 'UserMaster' );
		$EmailId = $this->input->get ( 'email' );
		
		if ($EmailId != NULL && $EmailId != '' && $VerificationCode != NULL && $VerificationCode != '') {
			$UserDetails = $this->UserMaster->get_singleuser_by_email ( $EmailId );
			
			if ($UserDetails->Verification_Code == $VerificationCode) {
				$Result = $this->UserMaster->updateVerification ( $UserDetails->User_Id );
				// success
				$TodayDate = date ( DATETIMEFORMAT );
				
				$CC = '';
				$EmailAddresTo = $UserDetails->email;
				$Subject = 'Welcome to GrandOpinion';
				$Body = array (
						'Name' => $UserDetails->First_name . ' ' . $UserDetails->Last_Name,
						'User_Id' => $UserDetails->User_Id,
						'Email' => $UserDetails->email,
						'Password' => '',
						'TimeStamp' => $TodayDate 
				);
				
				// Mail to New User
				$NotificationsNewUser = array (
						'To' => $EmailAddresTo,
						'FROM' => INFOEMAIL,
						'CC' => $CC,
						'Subject' => $Subject,
						'Body' => $Body,
						'Type' => 'Email_NewUser',
						'Attach' => '' 
				);
				$ResultNotifyNewUser = send_secured_email ( $NotificationsNewUser );
				
				// Send Email to Admin
				$CC = '';
				$EmailAddresTo = SUPPORTEMAIL;
				$EmailAddressFrom = INFOEMAIL;
				$SubjectEmail = 'New User through Registration';
				
				$BodyEmailAdmin = array (
						'User_Id' => $UserDetails->User_Id,
						'Name' => $UserDetails->First_name.' '.$UserDetails->Last_Name,
						'First_name' => $UserDetails->First_name,
						'Last_Name' => $UserDetails->Last_Name,
						'email' => $UserDetails->email,
						'Mobile_Number' => $UserDetails->Mobile_Number,
						'City' => $UserDetails->City,
						'Country' => $UserDetails->Country,
						'DateStamp' => date ( DATEFORMAT, strtotime ( $TodayDate ) ) 
				);
				
				$EmailNotificationAdmin = array (
						'To' => $EmailAddresTo,
						'FROM' => $EmailAddressFrom,
						'CC' => $CC,
						'Subject' => $SubjectEmail,
						'Body' => $BodyEmailAdmin,
						'Type' => "Email_CC_NewUser",
						'Attach' => '' 
				);
				$ResultEmail = send_secured_email ( $EmailNotificationAdmin );
				
				$data ['Verification'] = true;
				$this->load->view ( 'accountverify', $data );
			} else {
				// no success
				$data ['Verification'] = false;
				$this->load->view ( 'accountverify', $data );
			}
		} else {
			// no success
			$data ['Verification'] = false;
			$this->load->view ( 'accountverify', $data );
		}
	}
	public function resendcode() {
		$this->load->helper ( 'secureemail' );
		$this->load->model ( 'UserMaster' );
		
		$EmailId = $this->input->get ( 'email' );
		if ($EmailId != NULL && $EmailId != '') {
			$UserDetails = $this->UserMaster->get_singleuser_by_email ( $EmailId );
			
			$VerificationCode = $this->generateRandomCode ();
			$Result = $this->UserMaster->resendVerification ( $UserDetails->User_Id, $VerificationCode );
			// success
			$TodayDate = date ( DATEFORMAT );
			
			$CC = '';
			$EmailAddresTo = $UserDetails->email;
			$Subject = 'Welcome to GrandOpinion';
			$Body = array (
					'Name' => $UserDetails->First_name . ' ' . $UserDetails->Last_Name,
					'VerificationId' => $VerificationCode,
					'Email' => $UserDetails->email 
			);
			
			// Mail to New User
			$NotificationsNewUser = array (
					'To' => $EmailAddresTo,
					'FROM' => INFOEMAIL,
					'CC' => $CC,
					'Subject' => $Subject,
					'Body' => $Body,
					'Type' => 'Email_User_Validation',
					'Attach' => '' 
			);
			$ResultNotifyNewUser = send_secured_email ( $NotificationsNewUser );
			
			$data ['Verification'] = true;
			$this->load->view ( 'accountpartilaverify', $data );
		} else {
			// no success
			$data ['Verification'] = false;
			$this->load->view ( 'accountverify', $data );
		}
	}
	private function generateRandomCode() {
		$TodayDate = date ( DATETIMEFORMAT );
		
		$this->load->helper ( 'security' );
		$randomString = do_hash ( $TodayDate, 'md5' );
		return $randomString;
	}
	public function fblogin() {
		$this->load->helper ( 'fblogin' );
		$fb = get_fb_object ();
		
		$user = $fb->getUser ();
		if ($user) {
			$fb->getAccessToken ();
			$logoutUrl = $fb->getLogoutUrl ( array (
					'next' => base_url ( '/' ) 
			) );
			$userdata = $fb->api ( '/me?fields=id,name,first_name,last_name,email,address' );
			$this->load->model ( 'UserMaster' );
			$user = $this->UserMaster->get_user_by_email ( $userdata ['email'] );
			$u = null;
			if (count ( $user ) == 0) { // new user
				$user_array = array ();
				// not very reliable but should get the current city and country of the user
				// $this->load->helper ( 'geo_location_pi' );
				// $ip = $this->input->ip_address();
				// $geo_data = get_geolocation($ip);
				
				$user_array ['firstName'] = $userdata ['first_name'];
				$user_array ['lastName'] = $userdata ['last_name'];
				$user_array ['email'] = $userdata ['email'];
				$user_array ['country'] = ''; // $geo_data['country_name'];
				$user_array ['city'] = ''; // $geo_data['city'];
				$user_array ['country'] = '';
				$user_array ['city'] = '';
				$user_array ['phone'] = '';
				$user_array ['password1'] = $this->generateRandomCode ();
				
				$user_array ['gender'] = '';
				$user_array ['hearAboutUs'] = '';
				$user_array ['User_Image'] = $userdata ['id'] . '.jpg';
				$user_array ['Regi_From'] = FACEBOOK_CUST;
				
				// download profile image
				$ch = curl_init ( 'http://graph.facebook.com/' . $userdata ['id'] . '/picture?type=large' );
				$fp = fopen ( FCPATH . 'images/Users/' . $userdata ['id'] . '.jpg', 'wb' );
				curl_setopt ( $ch, CURLOPT_FILE, $fp );
				curl_setopt ( $ch, CURLOPT_HEADER, 0 );
				curl_setopt ( $ch, CURLOPT_SSL_VERIFYPEER, false );
				curl_setopt ( $ch, CURLOPT_FOLLOWLOCATION, true );
				curl_exec ( $ch );
				curl_close ( $ch );
				fclose ( $fp );
				
				$u = $this->UserMaster->register_array ( $user_array, TRUE );
				
				// Mail Send to User
				$this->load->helper ( 'secureemail' );
				$TodayDate = date ( DATETIMEFORMAT );
				
				$CC = '';
				$EmailAddresTo = $u->email;
				$Subject = 'Welcome to GrandOpinion';
				$Body = array (
						'Name' => $u->First_name . ' ' . $u->Last_Name,
						'User_Id' => $u->User_Id,
						'Email' => $u->email,
						'Password' => '',
						'TimeStamp' => $TodayDate 
				);
				
				// Mail to New User
				$NotificationsNewUser = array (
						'To' => $EmailAddresTo,
						'FROM' => INFOEMAIL,
						'CC' => $CC,
						'Subject' => $Subject,
						'Body' => $Body,
						'Type' => 'Email_NewUser',
						'Attach' => '' 
				);
				$ResultNotifyNewUser = send_secured_email ( $NotificationsNewUser );
				
				// Send Email to Admin
				$CC = '';
				$EmailAddresTo = SUPPORTEMAIL;
				$EmailAddressFrom = INFOEMAIL;
				$SubjectEmail = 'New User through Facebook';
				
				$BodyEmailAdmin = array (
						'User_Id' => $u->User_Id,
						'Name' => $u->First_name.' '.$u->Last_Name,
						'First_name' => $u->First_name,
						'Last_Name' => $u->Last_Name,
						'email' => $u->email,
						'Mobile_Number' => $u->Mobile_Number,
						'City' => $u->City,
						'Country' => $u->Country,
						'DateStamp' => date ( DATEFORMAT, strtotime ( $TodayDate ) ) 
				);
				
				$EmailNotificationAdmin = array (
						'To' => $EmailAddresTo,
						'FROM' => $EmailAddressFrom,
						'CC' => $CC,
						'Subject' => $SubjectEmail,
						'Body' => $BodyEmailAdmin,
						'Type' => "Email_CC_NewUser",
						'Attach' => '' 
				);
				$ResultEmail = send_secured_email ( $EmailNotificationAdmin );
			} else {
				$u = $user [0];
			}
			
			$this->session->set_userdata ( 'user', $u );
			$this->session->set_userdata ( 'user_id', $u->User_Id );
			$this->session->set_userdata ( 'user_name', $u->First_name );
			$this->session->set_userdata ( 'logout_url', $logoutUrl );
			
				
			$this->CheckAssignNotification();
			
				$SubDetailsUser = $this->UserMaster->getSubscriptionDetails ( $u->User_Id );
				if($this->CheckUserSubscription($SubDetailsUser))
				{
					$this->session->set_userdata ( 'UserSubscription', $SubDetailsUser );
				}
			
			if ($u->User_Type == DOCTORS) {
				$this->load->model ( 'DoctorMaster' );
				
				$DoctorData = $this->DoctorMaster->getDoctorsByUserId ( $u->User_Id );
				$this->session->set_userdata ( 'Doctor_Id', $DoctorData->Doctor_Id );
			}
			
			// Redirecting to home.php
			redirect ( 'home/index', 'location' );
		} else {
			// invalid login
			$this->session->sess_destroy ();
			redirect ( 'users/login/' . FACEBOOK_CUST, 'location' );
		}
	}
	public function googlelogin() {
		$this->load->helper ( 'googlelogin' );
		$Googleclient = get_google_object ();
		$AccessToken = $this->session->userdata ( 'GoogleAccessToken' );
		// Send Client Request
		$objOAuthService = new Google_Service_Oauth2 ( $Googleclient );
		if ($AccessToken == NULL && $AccessToken == '') {
			// Add Access Token to Session
			if (isset ( $_GET ['code'] )) {
				$Googleclient->authenticate ( $_GET ['code'] );
				$GoogAccessToken = $Googleclient->getAccessToken ();
				$AccessToken = $GoogAccessToken;
				$this->session->set_userdata ( 'GoogleAccessToken', $GoogAccessToken );
				// header('Location: ' . filter_var(GOOGLE_REDIRECT, FILTER_SANITIZE_URL));
			}
		}
		// Set Access Token to make Request
		if ($AccessToken != NULL && $AccessToken != '') {
			$Googleclient->setAccessToken ( $AccessToken );
		}
		if ($Googleclient->getAccessToken () && !$Googleclient->isAccessTokenExpired()) {
			$UserDetails = $objOAuthService->userinfo->get ();
			
			$AccessTokenNew = $Googleclient->getAccessToken ();
			$this->load->model ( 'UserMaster' );
			$user = $this->UserMaster->get_user_by_email ( $UserDetails->email );
			$u = null;
			if (count ( $user ) == 0) { // new user
				$SaveUserData = array (
						'firstName' => $UserDetails->givenName,
						'lastName' => $UserDetails->familyName,
						'email' => $UserDetails->email,
						'gender' => $UserDetails->gender,
						'country' => '',
						'city' => '',
						'phone' => '',
						'hearAboutUs' => '',
						'password1' => $this->generateRandomCode (),
						'User_Image' => $UserDetails->id.'.jpg',
						'Regi_From' => GOOGLE_CUST 
				);
				$u = $this->UserMaster->register_array ( $SaveUserData, TRUE );
				
				$ch = curl_init ( $UserDetails->picture);
				$fp = fopen ( FCPATH . 'images/Users/' . $UserDetails->id.'.jpg', 'wb' );
				curl_setopt ( $ch, CURLOPT_FILE, $fp );
				curl_setopt ( $ch, CURLOPT_HEADER, 0 );
				curl_setopt ( $ch, CURLOPT_SSL_VERIFYPEER, false );
				curl_setopt ( $ch, CURLOPT_FOLLOWLOCATION, true );
				curl_exec ( $ch );
				curl_close ( $ch );
				fclose ( $fp );
								
				$this->load->helper ( 'secureemail' );
				$TodayDate = date ( DATETIMEFORMAT );
				$CC = '';
				$EmailAddresTo = $u->email;
				$Subject = 'Welcome to GrandOpinion';
				$Body = array (
						'Name' => $u->First_name . ' ' . $u->Last_Name,
						'User_Id' => $u->User_Id,
						'Email' => $u->email,
						'Password' => '',
						'TimeStamp' => $TodayDate 
				);
				
				// Mail to New User
				$NotificationsNewUser = array (
						'To' => $EmailAddresTo,
						'FROM' => INFOEMAIL,
						'CC' => $CC,
						'Subject' => $Subject,
						'Body' => $Body,
						'Type' => 'Email_NewUser',
						'Attach' => '' 
				);
				$ResultNotifyNewUser = send_secured_email ( $NotificationsNewUser );
				
				// Send Email to Admin
				$CC = '';
				$EmailAddresTo = SUPPORTEMAIL;
				$EmailAddressFrom = INFOEMAIL;
				$SubjectEmail = 'New User through Google+';
				
				$BodyEmailAdmin = array (
						'User_Id' => $u->User_Id,
						'Name' => $u->First_name . ' ' . $u->Last_Name,
						'First_name' => $u->First_name,
						'Last_Name' => $u->Last_Name,
						'email' => $u->email,
						'Mobile_Number' => $u->Mobile_Number,
						'City' => $u->City,
						'Country' => $u->Country,
						'DateStamp' => date ( DATEFORMAT, strtotime ( $TodayDate ) ) 
				);
				
				$EmailNotificationAdmin = array (
						'To' => $EmailAddresTo,
						'FROM' => $EmailAddressFrom,
						'CC' => $CC,
						'Subject' => $SubjectEmail,
						'Body' => $BodyEmailAdmin,
						'Type' => "Email_CC_NewUser",
						'Attach' => '' 
				);
				$ResultEmail = send_secured_email ( $EmailNotificationAdmin );
			} else {
				$u = $user [0];
			}
			
			$this->session->set_userdata ( 'user', $u );
			$this->session->set_userdata ( 'user_id', $u->User_Id );
			$this->session->set_userdata ( 'user_name', $u->First_name );
			$this->session->set_userdata ( 'user_type', $u->User_Type );
			
			
			
			$this->CheckAssignNotification();
			
			$SubDetailsUser = $this->UserMaster->getSubscriptionDetails ( $u->User_Id );
			if($this->CheckUserSubscription($SubDetailsUser))
			{
				$this->session->set_userdata ( 'UserSubscription', $SubDetailsUser );
			}
			
			if ($u->User_Type == DOCTORS) {
				$this->load->model ( 'DoctorMaster' );
				$DoctorData = $this->DoctorMaster->getDoctorsByUserId ( $u->User_Id );
				$this->session->set_userdata ( 'Doctor_Id', $DoctorData->Doctor_Id );
			}
			redirect ( 'home/index', 'location' );
		} else {
			// invalid login
			$this->session->sess_destroy ();
			redirect ( 'users/login/' . GOOGLE_CUST, 'location' );
		}
	}
	
	private function CheckAssignNotification()
	{
		
		$user = $this->session->userdata ( 'user' );
		
		if($user != NULL)
		{
			$this->load->model ( 'UserMaster' );
			$NotificationDetails=$this->UserMaster->getNotificationByUser($user->User_Id);
			
			$UserNotification=null;
			
			if($NotificationDetails == NULL)
			{
				// Add and return
				$UserNotification=$this->UserMaster->AddNotificationDetails();
			}
			else 
			{
				$UserNotification=$NotificationDetails;
			}
			
			$this->session->set_userdata ( 'UserNotification', $UserNotification );
			
		}
		else
		{
			redirect ( 'users/login' , 'location' );
		}
	}
	
	
	
	/*----------------------Document managenement-----------------------------*/
	
	public function documentslist() 
	{
		
		$user = $this->session->userdata ( 'user' );
	
		if ($user != null)
		 {
			$this->load->model ( 'UserMaster' );
			$this->session->set_userdata ( 'activeMenu', "document" );
				
			//if ($this->session->userdata ( 'user_type' ) == ADMIN || $this->session->userdata ( 'user_type' ) == ADMINUSER)
			 //{
				//$Userid = $this->session->userdata ( 'user' )->User_Id;
				//$UserType = $this->session->userdata ( 'user_type' );
				//$MessageList = $this->MessageMaster->getMessagesForAdmin ( $Userid, $UserType );
			//} 
			//else 
			//{
				$DocumentList = $this->UserMaster->getDocumentByUser ( $user->User_Id );
			//}
				
			$DocArray = array ();
				
			foreach ( $DocumentList as $SingleDoc )
			{
				$DocArray [] = array (
						'Doc_Id' => $SingleDoc->document_id,
						'Title' => $SingleDoc->document_title,
						'Detail' =>$SingleDoc->document_detail,
						'Created_By' => $SingleDoc->created_by,
						'Patient_Id' => $SingleDoc->Patient_Id,
						'Type' => $SingleDoc->Type,
						'Created_On' => date ( DATEFORMAT, strtotime ( $SingleDoc->created_on ) )
				);
			}
				
			$MessageDetails = $this->session->flashdata ( 'DocMsg' );
				
			if ($MessageDetails == NUll) {
				$Message = array (
						'CaseId' => '',
						'Message' => '',
						'ErrorBit' => ''
				);
			} else {
				$Message = array (
						'CaseId' => $MessageDetails ['CaseId'],
						'Message' => $MessageDetails ['Message'],
						'ErrorBit' => $MessageDetails ['ErrorBit']
				);
			}
				
			$data ['CaseMessage'] = $Message;	
			$data ['Documents'] = $DocArray;
			$this->load->view ( 'documentlist', $data );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	public function addDocument() 
	{
		
		$user = $this->session->userdata ( 'user' );
	
		if ($user != null) 
		{
				$this->session->set_userdata ( 'activeMenu', "document" );
				$this->load->helper ( 'form' );
				$this->load->library ( 'form_validation' );
				$this->load->model ( 'CaseMaster' );
				$this->load->model ( 'UserMaster' );
	
	
				$PatientList = $this->CaseMaster->getPatientsByUser ( $user->User_Id );
				$PatientArray = array ();
	
				
				if ($PatientList != NULL && $PatientList != '') {
					foreach ( $PatientList as $SingPatient )
					{
						$PatientArray [] = array (
								'FName' => $SingPatient->FName,
								'LName' => $SingPatient->LName,
								'Phone' => $SingPatient->Phone,
								'Email' => $SingPatient->Email,
								'DOB' => date ( DATEFORMAT, strtotime ( $SingPatient->DOB ) ),
								'Gender' => $SingPatient->Gender,
								'Relation' => $SingPatient->Relation,
								'Country' => $SingPatient->Country ,
								'Patient_Id' =>$SingPatient->Patient_Id
						);
					}
				} 
				else 
				{
					$PatientArray [] = array (
							'DropdownId' => '-1',
							'FName' => 'No Patient.',
							'LName' => 'Please Add'
					);
				}
				
				$CaseIdDetails = $this->session->flashdata ( 'CaseMsg' );
				if ($CaseIdDetails == NUll || $CaseIdDetails == '') {
					$CaseId = '';
				} else {
					$CaseId = $CaseIdDetails;
				}
					
				$data ['CaseId'] = $CaseId;
	
				$data ['Patients'] = $PatientArray;
				$this->load->view ( 'documentadd', $data );
			
		} 
		else 
		{
			redirect ( 'users/login', 'location' );
		}
	}
	
	public function addDocumentpost() 
	{
		
		$user = $this->session->userdata ( 'user' );
	
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
		
		$this->load->helper ( 'file' );
		
		$config ['upload_path'] = './documents/uploads/';
		$config ['allowed_types'] = 'gif|jpg|png|jpeg|pdf|txt|docx|doc';
		$config ['max_size'] = 0;
		$config ['overwrite'] = TRUE;
		
		$this->load->library ( 'upload', $config );
		
		$CaseId=$this->input->post('CaseId');
		$SubmitValue = $this->input->post ( 'back' );
		if ($SubmitValue != NULL && $SubmitValue != '')
		{
			if($CaseId!= NULL && $CaseId != '' && $CaseId > 0)
			{
				redirect ( 'cases/AttachDocuments/'.$CaseId, 'location' );
			}
			else 
			{
				redirect ( 'users/documentslist', 'location' );
			}
			
		}
	
		$this->form_validation->set_rules ( 'patient', 'Patient', 'trim|required|xss_clean|callback__validate_patient' );
		$this->form_validation->set_rules ( 'doctype', 'Document Type', 'trim|required|xss_clean|callback__validate_documenttype' );
		$this->form_validation->set_rules ( 'doctitle', 'Document Title', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'document', 'Document', 'trim|xss_clean|callback__validate_uploaddocument' );
	
		if ($user != NULL && $user != '')
		{
			$this->load->model ( 'UserMaster' );
			
			
			if ($this->form_validation->run () == FALSE) 
			{
				$this->load->model ( 'CaseMaster' );
	
				$PatientList = $this->CaseMaster->getPatientsByUser ( $user->User_Id );
				$PatientArray = array ();
	
				
				if ($PatientList != NULL && $PatientList != '') {
					foreach ( $PatientList as $SingPatient )
					{
						$PatientArray [] = array (
								'FName' => $SingPatient->FName,
								'LName' => $SingPatient->LName,
								'Phone' => $SingPatient->Phone,
								'Email' => $SingPatient->Email,
								'DOB' => date ( DATEFORMAT, strtotime ( $SingPatient->DOB ) ),
								'Gender' => $SingPatient->Gender,
								'Relation' => $SingPatient->Relation,
								'Country' => $SingPatient->Country ,
								'Patient_Id' =>$SingPatient->Patient_Id
						);
					}
				} 
				else 
				{
					$PatientArray [] = array (
							'DropdownId' => '-1',
							'FName' => 'No Patient.',
							'LName' => 'Please Add'
					);
				}
	
				
				$data ['CaseId'] = $CaseId;
				$data ['Patients'] = $PatientArray;
				$this->load->view ( 'documentadd', $data );
				return;
			}
				
			if (isset ( $_FILES ['document'] ) && ! empty ( $_FILES ['document'] ['name'] )) 
			{
				$DocName = $_FILES ['document'] ['name'];
				
				$DocumentArray=array(
						'document_title' => $this->input->post('doctitle'),
						'document_detail' => $DocName,
						'Type' => $this->input->post('doctype'),
						'Patient_Id' => $this->input->post('patient')
				);
				
				$DocId = $this->UserMaster->AddDocument ($DocumentArray);
				
				// Add Audit Trail
				$this->load->model ( 'AuditTrailMaster' );
				$ControllerData = array (
						'Controller' => $this->router->class,
						'Action' => 'New  Document add by user-'.$user->First_name.' '.$user->Last_Name
				)
				;
				$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
			} 
				
			// Set Flash Message
			if ($DocId == NULL || $DocId == '' || $DocId == 0) 
			{
				$FinalMsg = 'The document was not uploaded successfully.';
				$MsgBit = "Error";
			} 
			else 
			{
				$FinalMsg = 'The document was uploaded successfully.';
				$MsgBit = "Success";
			}
				
			$Message = array (
					'CaseId' => $caseId,
					'Message' => $FinalMsg,
					'ErrorBit' => $MsgBit
			);
				
			$this->session->set_flashdata ( 'DocMsg', $Message );
				
				
			if($CaseId!= NULL && $CaseId != '' && $CaseId > 0)
			{
				redirect ( 'cases/AttachDocuments/'.$CaseId, 'location' );
			}
			else 
			{
				redirect ( 'users/documentslist', 'location' );
			}
			
			
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	
	public function _validate_patient($RelationId) 
	{
		if ($this->session->userdata ( 'user' ) != null) {
			if ("select" == $RelationId) {
				$this->form_validation->set_message ( '_validate_patient', 'Invalid Patient' );
				return FALSE;
			}
				
			return TRUE;
		} else {
			$this->form_validation->set_message ( '_validate_patient', 'Invalid Patient' );
			return FALSE;
		}
	}
	
	public function _validate_documenttype($RelationId) 
	{
		if ($this->session->userdata ( 'user' ) != null) {
			if ("select" == $RelationId) {
				$this->form_validation->set_message ( '_validate_documenttype', 'Invalid Document Type' );
				return FALSE;
			}
	
			return TRUE;
		} else {
			$this->form_validation->set_message ( '_validate_documenttype', 'Invalid Document Type' );
			return FALSE;
		}
	}
	
	public function _validate_uploaddocument() 
	{
		$user = $this->session->userdata ( 'user' );
	
		if (isset ( $_FILES ['document'] ) && ! empty ( $_FILES ['document'] ['name'] )) {
			// $FileExt=new SplFileInfo($_FILES['profilePic']['name']);
			$FileExt = pathinfo ( $_FILES ['document'] ['name'], PATHINFO_EXTENSION );
			$UploadFileName = $user->User_Id .'-' . $this->generateRandomCode ()  . '.' . $FileExt;
			$_FILES ['document'] ['name'] = $UploadFileName;
				
			if (! $this->upload->do_upload ( 'document' )) {
				$error = array (
						'error' => $this->upload->display_errors ()
				);
	
				$FinalErrors = implode ( '<br/>', $error );
				$this->form_validation->set_message ( '_validate_uploaddocument', $FinalErrors );
				return FALSE;
			} else {
				$this->form_validation->set_message ( '_validate_uploaddocument', 'The document was uploaded successfully.' );
				return TRUE;
			}
		} 
		else 
		{
			if ($user->User_Image != NULL) {
				$this->form_validation->set_message ( '_validate_uploaddocument', 'The image was uploaded successfully.' );
				return TRUE;
			} else {
				$this->form_validation->set_message ( '_validate_uploaddocument', "You must upload document!" );
				return FALSE;
			}
		}
	}
	
	
	
	public function editDocument($id)
	{
		
		$user = $this->session->userdata ( 'user' );
	
		if ($user != null)
		{
			$this->session->set_userdata ( 'activeMenu', "document" );
			$this->load->helper ( 'form' );
			$this->load->library ( 'form_validation' );
			$this->load->model ( 'CaseMaster' );
			$this->load->model ( 'UserMaster' );
	
			$DocumentDetail=$this->UserMaster->getDocumentById($id);
			
			if($DocumentDetail != NULL)
			{
				$DocumentArray=array(
						'Doc_Id' => $DocumentDetail->document_id,
						'Title' => $DocumentDetail->document_title,
						'Detail' => $DocumentDetail->document_detail,
						'Patient_Id' => $DocumentDetail->Patient_Id,
						'Created_By' => $DocumentDetail->created_by,
						'Type' => $DocumentDetail->Type
				);
				
				
				$PatientList = $this->CaseMaster->getPatientsByUser ( $user->User_Id );
				$PatientArray = array ();
				
				
				if ($PatientList != NULL && $PatientList != '') {
					foreach ( $PatientList as $SingPatient )
					{
						$PatientArray [] = array (
								'FName' => $SingPatient->FName,
								'LName' => $SingPatient->LName,
								'Phone' => $SingPatient->Phone,
								'Email' => $SingPatient->Email,
								'DOB' => date ( DATEFORMAT, strtotime ( $SingPatient->DOB ) ),
								'Gender' => $SingPatient->Gender,
								'Relation' => $SingPatient->Relation,
								'Country' => $SingPatient->Country ,
								'Patient_Id' =>$SingPatient->Patient_Id
						);
					}
				}
				else
				{
					$PatientArray [] = array (
							'DropdownId' => '-1',
							'FName' => 'No Patient.',
							'LName' => 'Please Add'
					);
				}
				
				$data['Document']=$DocumentArray;
				$data ['Patients'] = $PatientArray;
				$this->load->view ( 'documentedit', $data );
			}
				
		}
		else
		{
			redirect ( 'users/login', 'location' );
		}
	}
	
	public function editDocumentpost($id) 
	{
		
		$user = $this->session->userdata ( 'user' );
	
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
	
		$SubmitValue = $this->input->post ( 'back' );
		if ($SubmitValue != NULL && $SubmitValue != '')
		{
			redirect ( 'users/documentslist', 'location' );
		}
	
		$this->form_validation->set_rules ( 'patient', 'Patient', 'trim|required|xss_clean|callback__validate_patient' );
		$this->form_validation->set_rules ( 'doctype', 'Document Type', 'trim|required|xss_clean|callback__validate_documenttype' );
		$this->form_validation->set_rules ( 'doctitle', 'Document Title', 'trim|required|xss_clean' );
	
		if ($user != NULL && $user != '')
		{
			$this->load->model ( 'UserMaster' );
	
			$DocumentDetail=$this->UserMaster->getDocumentById($id);
			
			if ($this->form_validation->run () == FALSE)
			{
				$this->load->model ( 'CaseMaster' );
	
				$DocumentArray=array(
						'Doc_Id' => $DocumentDetail->document_id,
						'Title' => $DocumentDetail->document_title,
						'Detail' => $DocumentDetail->document_detail,
						'Patient_Id' => $DocumentDetail->Patient_Id,
						'Created_By' => $DocumentDetail->created_by,
						'Type' => $DocumentDetail->Type
				);
				
				
				$PatientList = $this->CaseMaster->getPatientsByUser ( $user->User_Id );
				$PatientArray = array ();
				
				
				if ($PatientList != NULL && $PatientList != '') {
					foreach ( $PatientList as $SingPatient )
					{
						$PatientArray [] = array (
								'FName' => $SingPatient->FName,
								'LName' => $SingPatient->LName,
								'Phone' => $SingPatient->Phone,
								'Email' => $SingPatient->Email,
								'DOB' => date ( DATEFORMAT, strtotime ( $SingPatient->DOB ) ),
								'Gender' => $SingPatient->Gender,
								'Relation' => $SingPatient->Relation,
								'Country' => $SingPatient->Country ,
								'Patient_Id' =>$SingPatient->Patient_Id
						);
					}
				}
				else
				{
					$PatientArray [] = array (
							'DropdownId' => '-1',
							'FName' => 'No Patient.',
							'LName' => 'Please Add'
					);
				}
				
				$data['Document']=$DocumentArray;
				$data ['Patients'] = $PatientArray;
				$this->load->view ( 'documentedit', $data );
				return;
			}
	
				
				$DocumentArray=array(
						'Doc_Id' =>$id,
						'document_title' => $this->input->post('doctitle'),
						'Type' => $this->input->post('doctype'),
						'Patient_Id' => $this->input->post('patient')
				);
	
				$Result = $this->UserMaster->EditDocument ($DocumentArray);
	
				// Add Audit Trail
				$this->load->model ( 'AuditTrailMaster' );
				$ControllerData = array (
						'Controller' => $this->router->class,
						'Action' => 'Document updated   by user-'.$user->First_name.' '.$user->Last_Name
				)
				;
				$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
		
	
			// Set Flash Message
				$FinalMsg = 'Update successful.';
				$MsgBit = "Success";
	
			$Message = array (
					'CaseId' => $caseId,
					'Message' => $FinalMsg,
					'ErrorBit' => $MsgBit
			);
	
			$this->session->set_flashdata ( 'DocMsg', $Message );
	
	
			redirect ( 'users/documentslist', 'location' );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	
	public function deleteDocument($id)
	{
		
		$user = $this->session->userdata ( 'user' );
	
		if ($user != NULL && $user != '')
		{
			$this->load->model ( 'UserMaster' );
			
			$Result = $this->UserMaster->deleteDocumentById ($id);
	
				// Add Audit Trail
				$this->load->model ( 'AuditTrailMaster' );
				$ControllerData = array (
						'Controller' => $this->router->class,
						'Action' => 'Document deleted  by user-'.$user->First_name.' '.$user->Last_Name
				)
				;
				$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
	
			
				$FinalMsg = 'Document Deleted Successfully.';
				$MsgBit = "Success";
			
	
			$Message = array (
					'CaseId' => $caseId,
					'Message' => $FinalMsg,
					'ErrorBit' => $MsgBit
			);
	
			$this->session->set_flashdata ( 'DocMsg', $Message );
	
	
			redirect ( 'users/documentslist', 'location' );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	
	
 /*----------------------User Management-----------------------------------------------------*/	
	//Add Users
	
	public function userslist()
	{
	
		$user = $this->session->userdata ( 'user' );
	
		if ($user != null)
		{
			$this->load->model ( 'UserMaster' );
	
			if ($user->User_Type == ADMIN || $user->User_Type == ADMINUSER ||  $user->User_Type == SALES)
			{
				$this->session->set_userdata ( 'activeMenu', "usermgt" );
				
				if($user->User_Type == ADMIN || $user->User_Type == ADMINUSER)
				{
					$UserList = $this->UserMaster->getAllUsers ();
				}
				else 
				{
					$UserList = $this->UserMaster->getCreatedUsers ($user->User_Id);
				}
				
				
				$UsersArray = array ();
				
				foreach ( $UserList as $SingleUser )
				{
					$UsersArray [] = array (
							'User_Id' => $SingleUser->User_Id,
							'FName' => $SingleUser->First_name,
							'LName' =>$SingleUser->Last_Name,
							'Email' => $SingleUser->email,
							'Mobile' => $SingleUser->Mobile_Number,
							'UserType' => $SingleUser->User_Type,
							'Creator' => $SingleUser->Creator,
							'Created_By' => $SingleUser->Created_By
							//'Created_On' => date ( DATEFORMAT, strtotime ( $SingleDoc->created_on ) )
					);
				}
				
				$MessageDetails = $this->session->flashdata ( 'UserMsg' );
				
				if ($MessageDetails == NUll) {
					$Message = array (
							'CaseId' => '',
							'Message' => '',
							'ErrorBit' => ''
					);
				} else {
					$Message = array (
							'CaseId' => $MessageDetails ['CaseId'],
							'Message' => $MessageDetails ['Message'],
							'ErrorBit' => $MessageDetails ['ErrorBit']
					);
				}
				
				$data ['CaseMessage'] = $Message;
				$data ['Users'] = $UsersArray;
				$data ['LoggedUser'] = $user->User_Type;
				$this->load->view ( 'userlist', $data );
			}
			else
			{
				$this->load->view ( 'accessdenied' );
			}
	
			
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	
	public function addusers()
	{
	
		$user = $this->session->userdata ( 'user' );
	
		if ($user != null)
		{
			if($user->User_Type == ADMIN || $user->User_Type ==ADMINUSER ||  $user->User_Type == SALES)
			{
				$this->session->set_userdata ( 'activeMenu', "usermgt" );
				$this->load->helper ( 'form' );
				$this->load->library ( 'form_validation' );
				$data['user']=$user;
				
				if($user->User_Type == SALES)
				{
					$this->load->view ( 'salesuseradd' ,$data);
				}
				else 
				{
					$this->load->view ( 'useradd' ,$data);
				}
				
			}	
		}
		else
		{
			redirect ( 'users/login', 'location' );
		}
	}
	
	public function adduserspost()
	{
	
		$user = $this->session->userdata ( 'user' );
	
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
	
		$SubmitValue = $this->input->post ( 'back' );
		if ($SubmitValue != NULL && $SubmitValue != '')
		{
			redirect ( 'users/userslist', 'location' );
		}
	
		$this->form_validation->set_rules ( 'fname', 'First Name', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'lname', 'Last Name', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'dob', 'Birth Date', 'trim|xss_clean|callback__validate_dateofbirth' );
		$this->form_validation->set_rules ( 'phone', 'Mobile Number', 'trim|required|xss_clean|max_length[20]' );
		$this->form_validation->set_rules ( 'email', 'Email', 'trim|required|xss_clean|valid_email|callback__check_existing_user' );
	
		if ($user != NULL && $user != '')
		{
			$this->load->model ( 'UserMaster' );
	
			if ($this->form_validation->run () == FALSE)
			{
				$data['user']=$user;
				
				if($user->User_Type == SALES)
				{
					$this->load->view ( 'salesuseradd' ,$data);
				}
				else
				{
					$this->load->view ( 'useradd' ,$data);
				}
				return;
			}
			
				$PasswordsArray = $this->GenerateRandomPassword ();
			
				$UserArray=array(
						'FName' => $this->input->post('fname'),
						'LName' =>  $this->input->post('lname'),
						'Email' =>  $this->input->post('email'),
						'Gender' =>  $this->input->post('gender'),
						'Password' =>  $PasswordsArray["PassHash"],
						'BDate' =>  $this->input->post('dob'),
						'Phone' =>  $this->input->post('phone'),
						'Phone2' =>  $this->input->post('otherno'),
						'Country' =>  $this->input->post('country'),
						'State' =>  $this->input->post('state'),
						'City' =>  $this->input->post('city'),
						'Address' =>  $this->input->post('address'),
						'Zip_Code' =>  $this->input->post('pincode'),
						'Company' =>  $this->input->post('company'),
						'UserType' =>  $this->input->post('usertype'),
						'Verify' =>  $this->input->post('verify'),
						'SalesContact' =>  $this->input->post('sales'),
						'CorpCode' =>  $this->input->post('corpcode')
				);
	
				$NewUserId = $this->UserMaster->adduser ($UserArray);
	
				
				// Send Email to User
				$this->load->helper ( 'secureemail' );
				$TodayDate = date ( DATETIMEFORMAT );
				
				$CC = '';
				$EmailAddresTo = $NewUserId->email;
				$Subject = 'Welcome to GrandOpinion';
				$Body = array (
						'Name' => $NewUserId->First_name . ' ' . $NewUserId->Last_Name,
						'VerificationId' => $NewUserId->Verification_Code,
						'Email' => $NewUserId->email
				);
				
				// Mail to New User
				$NotificationsNewUser = array (
						'To' => $EmailAddresTo,
						'FROM' => INFOEMAIL,
						'CC' => $CC,
						'Subject' => $Subject,
						'Body' => $Body,
						'Type' => 'Email_User_Validation',
						'Attach' => ''
				);
				$ResultNotifyNewUser = send_secured_email ( $NotificationsNewUser );
				
				
				if($user->User_Type == SALES)
				{
					// Send Email to Admin
					$CC = '';
					$EmailAddresTo = SUPPORTEMAIL;
					$EmailAddressFrom = INFOEMAIL;
					$SubjectEmail = 'New User is Added by the  Sales-'.$user->First_name.' without activated account ';
					
					$BodyEmailAdmin = array (
							'User_Id' => $NewUserId->User_Id,
							'Name' => $NewUserId->First_name . ' ' . $NewUserId->Last_Name,
							'First_name' => $NewUserId->First_name,
							'Last_Name' => $NewUserId->Last_Name,
							'email' => $NewUserId->email,
							'Mobile_Number' => $NewUserId->Mobile_Number,
							'City' => $NewUserId->City,
							'Country' => $NewUserId->Country,
							'DateStamp' => date ( DATEFORMAT, strtotime ( $TodayDate ) )
					);
					
					$EmailNotificationAdmin = array (
							'To' => $EmailAddresTo,
							'FROM' => $EmailAddressFrom,
							'CC' => $CC,
							'Subject' => $SubjectEmail,
							'Body' => $BodyEmailAdmin,
							'Type' => "Email_CC_NewUser_NtActive",
							'Attach' => ''
					);
					$ResultEmail = send_secured_email ( $EmailNotificationAdmin );
				}
				
				
				
				// Add Audit Trail
				$this->load->model ( 'AuditTrailMaster' );
				$ControllerData = array (
						'Controller' => $this->router->class,
						'Action' => 'A new User  add by user-'.$user->First_name.' '.$user->Last_Name);
				$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
			
	
			// Set Flash Message
			if ($NewUserId == NULL || $NewUserId == '' || $NewUserId == 0)
			{
				$FinalMsg = 'There was some error while creating  the user.';
				$MsgBit = "Error";
			}
			else
			{
				$FinalMsg = 'The user was created successfully.';
				$MsgBit = "Success";
			}
	
			$Message = array (
					'CaseId' => $NewUserId,
					'Message' => $FinalMsg,
					'ErrorBit' => $MsgBit
			);
	
			$this->session->set_flashdata ( 'UserMsg', $Message );
	
	
			redirect ( 'users/userslist', 'location' );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
		
	
	private function GenerateRandomPassword() 
	{
		$characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
		$charactersLength = strlen ( $characters );
		$randomString = '';
		for($i = 0; $i < 8; $i ++) {
			$randomString .= $characters [rand ( 0, $charactersLength - 1 )];
		}
		// echo $randomString;
	
		$this->load->helper ( 'security' );
		$PasswordHash = do_hash ( $randomString, 'md5' );
		// echo $PasswordHash;
	
		$PasswordArray = array (
				'Password' => $randomString,
				'PassHash' => $PasswordHash
		);
	
		// print_r($PasswordArray) ;
		return $PasswordArray;
	}
	
	
	public function editUser($id)
	{
	
		$user = $this->session->userdata ( 'user' );
	
		if ($user != null)
		{
			$this->session->set_userdata ( 'activeMenu', "usermgt" );
			$this->load->helper ( 'form' );
			$this->load->library ( 'form_validation' );
			$this->load->model ( 'UserMaster' );
	
			if($user->User_Type == ADMIN || $user->User_Type ==ADMINUSER ||  $user->User_Type == SALES)
			{
				$UserDetail=$this->UserMaster->get_singleuser($id);
				
				if($UserDetail != NULL)
				{
					if($user->User_Type == SALES)
					{
						$TempCheckUser=$UserDetail;
						if($TempCheckUser->Created_By == $user->User_Id)
						{
							$data ['user'] = $UserDetail;
							$data ['LoggedUser'] = $user->User_Type;
							$this->load->view ( 'salesuseredit', $data );
						}
						else 
						{
							$this->load->view ( 'accessdenied' );
						}
					}
					else 
					{
						$data ['user'] = $UserDetail;
						$data ['LoggedUser'] = $user->User_Type;
						$this->load->view ( 'useredit', $data );
					}
				}	
			}
			else 
			{
				
				$this->load->view ( 'accessdenied' );
			}
		}
		else
		{
			redirect ( 'users/login', 'location' );
		}
	}
	
	
	public function _check_existing_user_edit($email)
	{
		$this->load->model ( 'UserMaster' );
		$UserDetails=$this->UserMaster->get_singleuser( $this->input->post('UserId') );
		
		if(strtolower($UserDetails->email) == strtolower($email))
		{
			return TRUE;
		}
		else
		{
			$this->load->model ( 'UserMaster' );
			$user = $this->UserMaster->get_user_by_email ( $email );
			if (count ( $user ) > 0) {
				$this->form_validation->set_message ( '_check_existing_user_edit', 'The email address ' . $email . ' is already registered with us.
					                                            Please use another Email-ID.' );
				return FALSE;
			} else {
				return TRUE;
			}
		}
	}
	
	public function editUserpost($id)
	{
	
		$user = $this->session->userdata ( 'user' );
	
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
	
		$SubmitValue = $this->input->post ( 'back' );
		if ($SubmitValue != NULL && $SubmitValue != '')
		{
			redirect ( 'users/userslist', 'location' );
		}
	
		$this->form_validation->set_rules ( 'fname', 'First Name', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'lname', 'Last Name', 'trim|required|xss_clean' );
		$this->form_validation->set_rules ( 'dob', 'Birth Date', 'trim|xss_clean|callback__validate_dateofbirth' );
		$this->form_validation->set_rules ( 'phone', 'Mobile Number', 'trim|required|xss_clean|max_length[20]' );
		$this->form_validation->set_rules ( 'email', 'Email', 'trim|required|xss_clean|valid_email|callback__check_existing_user_edit' );
	
	
		if ($user != NULL && $user != '')
		{
			$this->load->model ( 'UserMaster' );
	
			$UserDetail=$this->UserMaster->get_singleuser($id);
				
			$this->load->model ( 'UserMaster' );
	
			if ($this->form_validation->run () == FALSE)
			{
				if($user->User_Type == SALES)
				{
					$TempCheckUser=$UserDetail;
					if($TempCheckUser->Created_By == $user->User_Id)
					{
						$data ['user'] = $UserDetail;
						$data ['LoggedUser'] = $user->User_Type;
						$this->load->view ( 'salesuseredit', $data );
					}
					else
					{
						$this->load->view ( 'accessdenied' );
					}
				}
				else
				{
					$data ['user'] = $UserDetail;
					$data ['LoggedUser'] = $user->User_Type;
					$this->load->view ( 'useredit' ,$data);
				}
				return;
			}
			
				$UserArray=array(
						'User_Id' => $id ,
						'FName' => $this->input->post('fname'),
						'LName' =>  $this->input->post('lname'),
						'Email' =>  $this->input->post('email'),
						'Gender' =>  $this->input->post('gender'),
						'BDate' =>  $this->input->post('dob'),
						'Phone' =>  $this->input->post('phone'),
						'Phone2' =>  $this->input->post('otherno'),
						'Country' =>  $this->input->post('country'),
						'State' =>  $this->input->post('state'),
						'City' =>  $this->input->post('city'),
						'Address' =>  $this->input->post('address'),
						'Zip_Code' =>  $this->input->post('pincode'),
						'Company' =>  $this->input->post('company'),
						'UserType' =>  $this->input->post('usertype'),
						'Verify' =>  $this->input->post('verify'),
						'SalesContact' =>  $this->input->post('sales'),
						'CorpCode' =>  $this->input->post('corpcode')
				);

			
				
				$NewUserId = $this->UserMaster->edituser ($UserArray);
	
				// Add Audit Trail
				$this->load->model ( 'AuditTrailMaster' );
				$ControllerData = array (
						'Controller' => $this->router->class,
						'Action' => 'A new User  add by user-'.$user->First_name.' '.$user->Last_Name);
				$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
			
	
			// Set Flash Message
			if ($NewUserId == NULL || $NewUserId == '' || $NewUserId == 0)
			{
				$FinalMsg = 'There was some error while editing  the user.';
				$MsgBit = "Error";
			}
			else
			{
				$FinalMsg = 'The user was edited successfully.';
				$MsgBit = "Success";
			}
	
			$Message = array (
					'CaseId' => $NewUserId,
					'Message' => $FinalMsg,
					'ErrorBit' => $MsgBit
			);
	
			$this->session->set_flashdata ( 'UserMsg', $Message );
	
	
			redirect ( 'users/userslist', 'location' );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	public function checkEmail()
	{
	
		$user = $this->session->userdata ( 'user' );
	
		if ($user != NULL)
		{
			$this->load->model ( 'UserMaster' );
				
			$Email=$this->input->post('Email');
			$UserDetails = $this->UserMaster->get_user_by_email ( $Email );
				
			$Message=array(
					'Msg' => '<span style="color:#05961A;"><b>Email Available</b><span>'
			);
				
			if($UserDetails != NULL && $UserDetails != '')
			{
				$Message=array(
						'Msg' => '<span style="color:Red;"><b>Email not available.<br>Try another Email.</b><span>'
				);
			}
				
			$this->output->set_header('Content-Type: application/json; charset=utf-8');
			echo json_encode($Message);
	
		} else {
	
			redirect ( 'users/login', 'location' );
		}
	}
	
	
	public function deleteUser($id)
	{
	
		$user = $this->session->userdata ( 'user' );
	
		if ($user != null)
		{
			$this->session->set_userdata ( 'activeMenu', "usermgt" );
			$this->load->helper ( 'form' );
			$this->load->library ( 'form_validation' );
			$this->load->model ( 'UserMaster' );
	
			if($user->User_Type == ADMIN || $user->User_Type ==ADMINUSER)
			{
				$UserDetail=$this->UserMaster->get_singleuser($id);
	
				if($UserDetail != NULL)
				{
					
					$data ['user'] = $UserDetail;
					$this->load->view ( 'userdelete', $data );
				}
			}
			else
			{
	
				$this->load->view ( 'accessdenied' );
			}
		}
		else
		{
			redirect ( 'users/login', 'location' );
		}
	}
	
	public function deleteUserpost($id)
	{
	
		$user = $this->session->userdata ( 'user' );
		
		$SubmitValue = $this->input->post ( 'back' );
		if ($SubmitValue != NULL && $SubmitValue != '')
		{
			redirect ( 'users/userslist', 'location' );
		}
	
		if ($user != NULL && $user != '')
		{
			$this->load->model ( 'UserMaster' );
				
			$Result = $this->UserMaster->deleteUserById ($id);
	
			// Add Audit Trail
			$this->load->model ( 'AuditTrailMaster' );
			$ControllerData = array (
					'Controller' => $this->router->class,
					'Action' => 'User '.$id.' deleted by User ID '.$user->User_Id.', '.$user->First_name.' '.$user->Last_Name
			)
			;
			$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
	
				
			$FinalMsg = 'User deleted successfully.';
			$MsgBit = "Success";
				
	
			$Message = array (
					'CaseId' => $id,
					'Message' => $FinalMsg,
					'ErrorBit' => $MsgBit
			);
	
			$this->session->set_flashdata ( 'UserMsg', $Message );
	
	
			redirect ( 'users/userslist', 'location' );
		} 
		else
		 {
			redirect ( 'users/login', 'location' );
		}
	}
	
	
	
	/*------------------------------Subscription----------------------------------------*/
	
	public function subscriptionlist()
	{
		$user = $this->session->userdata ( 'user' );
	
		if ($user != null) {
			$this->load->model ( 'UserMaster' );
	
			if ($user->User_Type == ADMIN || $user->User_Type == ADMINUSER)
			{
				$this->session->set_userdata ( 'activeMenu', "subsciption" );
				
				$UserList = $this->UserMaster->getAllUsers ();

				$PlanList = $this->UserMaster->getAllPlans ();
				$PlanArray = array ();
					
				foreach ( $PlanList as $SinglePlan ) {
					$PlanArray [] = array (
							'Plan_Name' => $SinglePlan->Plan_Name,
							'Plan_Id' => $SinglePlan->Plan_Id,
							'Desciption' => $SinglePlan->Desciption,
							'Plan_Type' =>  strtolower($SinglePlan->Plan_Type)
					);
				}
	
	
				$UsersArray = array ();
					
				foreach ( $UserList as $SingleUser )
				{
					$UserSubscriptionDetails=$this->UserMaster->getSubscriptionDetails ($SingleUser->User_Id);
						
					$PlanName="NA";
					$PlanID='';
					if($UserSubscriptionDetails != NULL && $UserSubscriptionDetails !='')
					{
						$PlanName=$this->AssignPlanName($PlanArray,$UserSubscriptionDetails->Plan_Id);
						$PlanID=$UserSubscriptionDetails->Plan_Id;
						
						$UsersArray [] = array (
								'User_Id' => $SingleUser->User_Id,
								'FName' => $SingleUser->First_name,
								'LName' => $SingleUser->Last_Name,
								'Email' => $SingleUser->email,
								'Phone' => $SingleUser->Mobile_Number,
								'Country' => $SingleUser->Country,
								'Plan' => $PlanName,
								'Plan_Id' => $PlanID,
								'Age' => $this->calculateAge($SingleUser->Birth_Date)
						);
					}
				}
					
				$MessageDetails = $this->session->flashdata ( 'UserMsg' );
					
				if ($MessageDetails == NUll) {
					$Message = array (
							'CaseId' => '',
							'Message' => '',
							'ErrorBit' => ''
					);
				} else {
					$Message = array (
							'CaseId' => $MessageDetails ['CaseId'],
							'Message' => $MessageDetails ['Message'],
							'ErrorBit' => $MessageDetails ['ErrorBit']
					);
				}
					
				$data ['CaseMessage'] = $Message;
				$data ['Users'] = $UsersArray;
				$data ['Plans'] = $PlanArray;
	
				$this->load->view ( 'usersublist', $data );
			} else {
				$this->load->view ( 'accessdenied' );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	
	
	
	
	
	
	public function subscribeuser()
	{
		$user = $this->session->userdata ( 'user' );
	
		if ($user != null)
		{
			if ($user->User_Type == ADMIN || $user->User_Type == ADMINUSER)
			{
				$this->load->model ( 'UserMaster' );
				$this->session->set_userdata ( 'activeMenu', "subsciption" );
				$this->load->helper ( 'form' );
				$this->load->library ( 'form_validation' );
	
				$UserList = $this->UserMaster->getAllUsers ();
	
				$PlanList = $this->UserMaster->getAllPlans ();
				$PlanArray = array ();
					
				foreach ( $PlanList as $SinglePlan ) {
					$PlanArray [] = array (
							'Plan_Name' => $SinglePlan->Plan_Name,
							'Plan_Id' => $SinglePlan->Plan_Id,
							'Desciption' => $SinglePlan->Desciption,
							'Plan_Type' =>  strtolower($SinglePlan->Plan_Type)
					);
				}
	
	
				$UsersArray = array ();
					
				foreach ( $UserList as $SingleUser )
				{
					$UserSubscriptionDetails=$this->UserMaster->getSubscriptionDetails ($SingleUser->User_Id);
						
					if($UserSubscriptionDetails == NULL || $UserSubscriptionDetails =='')
					{
						$UsersArray [] = array (
								'User_Id' => $SingleUser->User_Id,
								'FName' => $SingleUser->First_name,
								'LName' => $SingleUser->Last_Name,
								'Email' => $SingleUser->email,
								'Phone' => $SingleUser->Mobile_Number,
								'Country' => $SingleUser->Country,
								'Plan' => "NA",
								'Age' => $this->calculateAge($SingleUser->Birth_Date)
						);
					}
						
						
				}
					
				$MessageDetails = $this->session->flashdata ( 'UserMsg' );
					
				if ($MessageDetails == NUll) {
					$Message = array (
							'CaseId' => '',
							'Message' => '',
							'ErrorBit' => ''
					);
				} else {
					$Message = array (
							'CaseId' => $MessageDetails ['CaseId'],
							'Message' => $MessageDetails ['Message'],
							'ErrorBit' => $MessageDetails ['ErrorBit']
					);
				}
					
				$data ['CaseMessage'] = $Message;
				$data ['Users'] = $UsersArray;
				$data ['Plans'] = $PlanArray;
	
				$this->load->view ( 'usersubadd', $data );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	
	private function calculateAge($DateOfBirth)
	{
		$from = new DateTime($DateOfBirth);
		$to   = new DateTime('today');
		$Age= $from->diff($to)->y;
		return $Age;
	}
	
	private function AssignPlanName($PlanList,$PlanId)
	{
		$PlanName="NA";
	
		foreach($PlanList as $SinglePlan)
		{
			if($SinglePlan["Plan_Id"] == $PlanId)
			{
				$PlanName=$SinglePlan["Plan_Name"];
				break;
			}
		}
	
		return $PlanName;
	}
	
	public function subscribeuserpost()
	{
		$user = $this->session->userdata ( 'user' );
	
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
	
		$SubmitValue = $this->input->post ( 'back' );
		if ($SubmitValue != NULL && $SubmitValue != '') {
			redirect ( 'users/subscriptionlist', 'location' );
		}
	
	
		if ($user != NULL && $user != '')
		{
			$this->load->model ( 'UserMaster' );
	
			$NewUserId = $this->UserMaster->addSubscriptionDetailsUser ();
	

			/*
			$PlanList = $this->CorporateMaster->getAllPlans ();
			$PlanArray = array ();
	
			foreach ( $PlanList as $SinglePlan ) {
				$PlanArray [] = array (
						'Plan_Name' => $SinglePlan->Plan_Name,
						'Plan_Id' => $SinglePlan->Plan_Id,
						'Desciption' => $SinglePlan->Desciption,
						'Plan_Type' =>  strtolower($SinglePlan->Plan_Type)
				);
			}
				
				
			$UserIds = $this->input->post ( 'UserList' );
			$UserCount=0;
			$fromUserId=0;
			$toUserId=0;
				
			if ($UserIds != NULL)
			{
				$ArrayCount=count($UserIds);
				foreach ( $UserIds as $Single )
				{
					if($UserCount == 0)
					{
						$fromUserId=$Single;
					}
						
					if($ArrayCount == $UserCount)
					{
						$toUserId=$Single;
					}
					$UserCount++;
						
				}
			}*/
				
			// Add Audit Trail
			$this->load->model ( 'AuditTrailMaster' );
			$ControllerData = array (
					'Controller' => $this->router->class,
					'Action' => 'Users added to Plan by user-' . $user->First_name . ' ' . $user->Last_Name
			);
			$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
	
			// Set Flash Message
			if ($NewUserId == NULL || $NewUserId == '' || $NewUserId == 0) {
				$FinalMsg = 'There was some error while adding   the users.';
				$MsgBit = "Error";
			} else {
				$FinalMsg = 'Users added successfully.';
				$MsgBit = "Success";
			}
	
			$Message = array (
					'CaseId' => $NewUserId,
					'Message' => $FinalMsg,
					'ErrorBit' => $MsgBit
			);
	
			$this->session->set_flashdata ( 'UserMsg', $Message );
				
				
			$this->load->helper ( 'secureemail' );
				
			$TodayDate = date ( DATETIMEFORMAT );
				
			/*
				$CC = '';
				$EmailAddresTo = $NewUserId->email;
				$Subject = ' Welcome to GrandOpinion - Thank you';
				$Body = array (
				'Name' => $NewUserId->First_name . ' ' . $NewUserId->Last_Name,
				'VerificationId' => $NewUserId->Verification_Code,
				'Email' => $NewUserId->email
				);
					
				// Mail to New User
				$NotificationsNewUser = array (
				'To' => $EmailAddresTo,
				'FROM' => INFOEMAIL,
				'CC' => $CC,
				'Subject' => $Subject,
				'Body' => $Body,
				'Type' => 'Email_User_Validation',
				'Attach' => ''
				);
			$ResultNotifyNewUser = send_secured_email ( $NotificationsNewUser );
				
				
			// Send Email to Admin
			$CC = '';
			$EmailAddresTo = SUPPORTEMAIL;
			$EmailAddressFrom = INFOEMAIL;
			$SubjectEmail = 'Corporate User With Corporate ID -'.$user->Corp_Code.' Added Users to Plan';
				
			$BodyEmailAdmin = array (
					'Corp_Code' => $user->Corp_Code,
					'From_UserID' => $fromUserId,
					'To_UserID' => $toUserId,
					'Plan_Name' => $this->AssignPlanName($PlanList, $this->input->post ( 'Plan' )),
					'DateStamp' => date ( DATEFORMAT, strtotime ( $TodayDate ) )
			);
				
			$EmailNotificationAdmin = array (
					'To' => $EmailAddresTo,
					'FROM' => $EmailAddressFrom,
					'CC' => $CC,
					'Subject' => $SubjectEmail,
					'Body' => $BodyEmailAdmin,
					'Type' => "Email_CC_PlanCorp",
					'Attach' => ''
			);
			$ResultEmail = send_secured_email ( $EmailNotificationAdmin );*/
				
	
			redirect ( 'users/subscriptionlist', 'location' );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	
	public function editUserPlan($id)
	{
		$user = $this->session->userdata ( 'user' );
	
		if ($user != null) {
			$this->session->set_userdata ( 'activeMenu', "subsciption" );
			$this->load->helper ( 'form' );
			$this->load->library ( 'form_validation' );
			$this->load->model ( 'UserMaster' );
	
			if ($user->User_Type == ADMIN || $user->User_Type == ADMINUSER  )
			{
				$UserDetail = $this->UserMaster->get_singleuser ( $id );
				$UserSubscriptionDetails=$this->UserMaster->getSubscriptionDetails ($id);
	
				if ($UserDetail != NULL)
				{
					$UsersArray  = array (
							'User_Id' => $UserDetail->User_Id,
							'FName' => $UserDetail->First_name,
							'LName' => $UserDetail->Last_Name,
							'Email' => $UserDetail->email,
							'Phone' => $UserDetail->Mobile_Number,
							'Country' => $UserDetail->Country,
							'Plan' => $UserSubscriptionDetails->Plan_Id,
							'StartDate' => date ( DATEFORMAT, strtotime ( $UserSubscriptionDetails->Start_Date) ),
							'EndDate' => date ( DATEFORMAT, strtotime ( $UserSubscriptionDetails->End_Date) ),
							'Age' => $this->calculateAge($UserDetail->Birth_Date)
					);
						
					$PlanList = $this->UserMaster->getAllPlans ();
					$PlanArray = array ();
	
					foreach ( $PlanList as $SinglePlan ) {
						$PlanArray [] = array (
								'Plan_Name' => $SinglePlan->Plan_Name,
								'Plan_Id' => $SinglePlan->Plan_Id,
								'Desciption' => $SinglePlan->Desciption,
								'Plan_Type' =>  strtolower($SinglePlan->Plan_Type)
						);
					}
						
					$data ['Plans'] = $PlanArray;
					$data ['user'] = $UsersArray;
					$this->load->view ( 'usersubedit', $data );
				}
			} else {
	
				$this->load->view ( 'accessdenied' );
			}
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	
	
	
	public function editUserPlanpost($id)
	{
		$user = $this->session->userdata ( 'user' );
	
		$this->load->helper ( 'form' );
		$this->load->library ( 'form_validation' );
	
		$SubmitValue = $this->input->post ( 'back' );
		if ($SubmitValue != NULL && $SubmitValue != '') {
			redirect ( 'users/subscriptionlist', 'location' );
		}
	
	
		if ($user != NULL && $user != '')
		{
			$this->load->model ( 'UserMaster' );
	
			$UserDetail = $this->UserMaster->get_singleuser ( $id );
			$UserSubscriptionDetails=$this->UserMaster->getSubscriptionDetails ($id);
	
			$NewUserId = $this->UserMaster->updateSubscriptionPlan ( $UserSubscriptionDetails->Sub_Id );
	
			// Add Audit Trail
			$this->load->model ( 'AuditTrailMaster' );
			$ControllerData = array (
					'Controller' => $this->router->class,
					'Action' => 'User plan altered   by User-' . $user->First_name . ' ' . $user->Last_Name
			);
			$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
	
			// Set Flash Message
			if ($NewUserId == NULL || $NewUserId == '' || $NewUserId == 0) {
				$FinalMsg = 'There was some error while editing  the plan.';
				$MsgBit = "Error";
			} else {
				$FinalMsg = 'The User plan was edited successfully.';
				$MsgBit = "Success";
			}
	
			$Message = array (
					'CaseId' => $NewUserId,
					'Message' => $FinalMsg,
					'ErrorBit' => $MsgBit
			);
	
			$this->session->set_flashdata ( 'UserMsg', $Message );
	
			redirect ( 'users/subscriptionlist', 'location' );
		} else {
			redirect ( 'users/login', 'location' );
		}
	}
	
	
	
	public function deleteSubscription($id)
	{
	
		$user = $this->session->userdata ( 'user' );
	
		if ($user != null)
		{
			$this->session->set_userdata ( 'activeMenu', "subsciption" );
			$this->load->helper ( 'form' );
			$this->load->library ( 'form_validation' );
			$this->load->model ( 'UserMaster' );
	
			if($user->User_Type == ADMIN || $user->User_Type ==ADMINUSER)
			{
				$UserDetail=$this->UserMaster->get_singleuser($id);
				$UserSubscriptionDetails=$this->UserMaster->getSubscriptionDetails ($id);
	
				if($UserDetail != NULL)
				{
					$UsersArray  = array (
							'User_Id' => $UserDetail->User_Id,
							'FName' => $UserDetail->First_name,
							'LName' => $UserDetail->Last_Name,
							'Email' => $UserDetail->email,
							'Phone' => $UserDetail->Mobile_Number,
							'Country' => $UserDetail->Country,
							'Company' => (($UserDetail->Company != NULL &&  $UserDetail->Company != '' ) ? $UserDetail->Company : 'NA'),
							'Corp_Code' => (($UserDetail->Corp_Code != NULL &&  $UserDetail->Corp_Code != '' ) ? $UserDetail->Corp_Code : 'NA'),
							'Plan' => $UserSubscriptionDetails->Plan_Id,
							'StartDate' => date ( DATEFORMAT, strtotime ( $UserSubscriptionDetails->Start_Date) ),
							'EndDate' => date ( DATEFORMAT, strtotime ( $UserSubscriptionDetails->End_Date) )
					);
					
					$data ['user'] = $UsersArray;
					$this->load->view ( 'usersubdelete', $data );
				}
			}
			else
			{
	
				$this->load->view ( 'accessdenied' );
			}
		}
		else
		{
			redirect ( 'users/login', 'location' );
		}
	}
	
	public function deleteSubscriptionpost($id)
	{
	
		$user = $this->session->userdata ( 'user' );
	
		$SubmitValue = $this->input->post ( 'back' );
		if ($SubmitValue != NULL && $SubmitValue != '')
		{
			redirect ( 'users/subscriptionlist', 'location' );
		}
	
		if ($user != NULL && $user != '')
		{
			$this->load->model ( 'UserMaster' );
	
			$Result = $this->UserMaster->deleteUserSubscriptionByUserId ($id);
	
			// Add Audit Trail
			$this->load->model ( 'AuditTrailMaster' );
			$ControllerData = array (
					'Controller' => $this->router->class,
					'Action' => 'User subscription deleted  by user-'.$user->First_name.' '.$user->Last_Name
			)
			;
			$AuditId = $this->AuditTrailMaster->add ( $ControllerData );
	
	
			$FinalMsg = 'User deleted successfully.';
			$MsgBit = "Success";
	
	
			$Message = array (
					'CaseId' => $id,
					'Message' => $FinalMsg,
					'ErrorBit' => $MsgBit
			);
	
			$this->session->set_flashdata ( 'UserMsg', $Message );
	
	
			redirect ( 'users/subscriptionlist', 'location' );
		}
		else
		{
			redirect ( 'users/login', 'location' );
		}
	}
	
	private function CheckUserSubscription($SubscriptionDetails)
	{
		$Sub=False;
		
		$TodayDate = date ( DATEFORMAT );
		
		if (strtotime($SubscriptionDetails->Start_Date) <= strtotime($TodayDate)  &&  strtotime($TodayDate) <= strtotime($SubscriptionDetails->End_Date))
		{
			$Sub=true;
		}
		
		return $Sub;
	}
	
}
