<?php

if (! defined ( 'BASEPATH' ))
	exit ( 'No direct script access allowed' );

if (! function_exists ( 'get_notification_for_user' )) {
	function get_notification_for_user() {
		$NotificationCount = 0;
		$CI = & get_instance ();
		
		if ($CI->session->userdata ( 'user_id' ) != NULL) {
			$UserType = $CI->session->userdata ( 'user_type' );
			$UserId = $CI->session->userdata ( 'user_id' );
			
			$CI->load->model ( 'MessageMaster' );
			
			if ($UserType != NULL && $UserId != NULL && ($UserType == ADMIN || $UserType == ADMINUSER)) {
				$NotificationCount = $CI->MessageMaster->countNotificationAdmin ( $UserId, $UserType );
			} else {
				$NotificationCount = $CI->MessageMaster->countNotification ( $UserId );
			}
		}
		
		return $NotificationCount;
	}
}

if (! function_exists ( 'send_notification_for_user' )) {
	function send_notification_for_user($UserNotifyData) {
		$NotificationCount = 0;
		$CI = & get_instance ();
		
		if ($CI->session->userdata ( 'user_id' ) != NULL) {
			$ToUser = (($UserNotifyData ["ToUser"] != NULL && $UserNotifyData ["ToUser"] != '') ? $UserNotifyData ["ToUser"] : '');
			
			$QuestionId = (($UserNotifyData ["QuestionId"] != NULL && $UserNotifyData ["QuestionId"] != '') ? $UserNotifyData ["QuestionId"] : '');
			
			$ToRole = (($UserNotifyData ["ToRole"] != NULL && $UserNotifyData ["ToRole"] != '') ? $UserNotifyData ["ToRole"] : '');
			
			$CI->load->model ( 'MessageMaster' );
			$NotificationArray = array (
					'ToUser' => $ToUser,
					'Subject' => $UserNotifyData ["Subject"],
					'Body' => $UserNotifyData ["Body"],
					'QuestionId' => $QuestionId,
					'ToRole' => $ToRole 
			);
			$NotificationCount = $CI->MessageMaster->sendNotification ( $NotificationArray );
		}
		
		return $NotificationCount;
	}
}

