<?php
class CaseMaster extends CI_Model {
	function __construct() {
		// Call the Model constructor
		parent::__construct ();
	}
	function getGroupedCases() {
		$user = $this->session->userdata ( 'user' );

		if(!isset($user)) return null;

		if($user->User_Type==7) /*Doctor Coordinator*/
		{
		$query = $this->db->query ( 'select status,count(*) "numbers" from cases where Doctor_Id in (select doctor_id from doctors where user_id in (select user_id from user where created_by='.$user->User_Id.')) or Doctor_Id = (select doctor_id from doctors where user_id='.$user->User_Id.') group by status');
		} else {
		$query = $this->db->query ( 'select status,count(*) "numbers" from cases group by status');
		}
		return $query->result ();
	}

	function getCasesByUser($user) {
		$this->db->order_by ( "id", "desc" );
		$this->db->order_by ( "Case_Date", "desc" );
		$query = $this->db->get_where ( 'cases', array (
				'created_by' => $user 
		) );
		return $query->result ();
	}
	function getAllCases() {
		$this->db->order_by ( "id", "desc" );
		$this->db->order_by ( "Case_Date", "desc" );
		$query = $this->db->get ( 'cases' );
		return $query->result ();
	}
	function getPatientsByUser($user) {
		$query = $this->db->get_where ( 'patients', array (
				'Created_By' => $user 
		) );
		return $query->result ();
	}
	function getCasesById($id) {
		$query = $this->db->get_where ( 'cases', array (
				'id' => $id 
		) );
		
		if ($query->num_rows () > 0) {
			return $query->row ();
		} else {
			return;
		}
	}
	function getCasesDetailByPatientId($id) {
		$query = $this->db->get_where ( 'cases', array (
				'Patient_Id' => $id 
		) );
		
		if ($query->num_rows () > 0) {
			return $query->row ();
		} else {
			return;
		}
	}
	
	function getCasesByPatientId($id) {
		$query = $this->db->get_where ( 'cases', array (
				'Patient_Id' => $id
		) );
	
		return $query->result ();
	}
	
	
	function getCasesByDoctorId($DoctorId) {
		$query = $this->db->get_where ( 'cases', array (
				'Doctor_Id' => $DoctorId 
		) );
		return $query->result ();
	}
	function getCasesSearchByUser($keyword, $user) {
		$this->db->like ( 'id', $keyword );
		$this->db->or_like ( 'Case_Date', $keyword );
		$this->db->or_like ( 'subject', $keyword );
		$this->db->or_like ( 'medical_query', $keyword );
		$query = $this->db->get_where ( 'cases', array (
				'created_by' => $user 
		) );
		return $query->result ();
	}
	function getCasesSearchAll($keyword) {
		$this->db->like ( 'id', $keyword );
		$this->db->or_like ( 'Case_Date', $keyword );
		$this->db->or_like ( 'subject', $keyword );
		$this->db->or_like ( 'medical_query', $keyword );
		$query = $this->db->get ( 'cases' );
		return $query->result ();
	}
	function getCasesSearchByDoctorId($keyword, $DoctorId) {
		$this->db->like ( 'id', $keyword );
		$this->db->or_like ( 'Case_Date', $keyword );
		$this->db->or_like ( 'subject', $keyword );
		$this->db->or_like ( 'medical_query', $keyword );
		$query = $this->db->get_where ( 'cases', array (
				'Doctor_Id' => $DoctorId 
		) );
		return $query->result ();
	}
	function getCasesByDoctorByUserId($DoctorId, $UserId) {
		$query = $this->db->get_where ( 'cases', array (
				'Doctor_Id' => $DoctorId,
				'created_by' => $UserId 
		) );
		return $query->result ();
	}
	function add() {
		$GeneratedCaseId = '';
		$this->db->trans_start ();
		
		$ExistingPatientId=$this->input->post ( 'PatientId' );
		
		if($ExistingPatientId != NULL && $ExistingPatientId != '' && $ExistingPatientId > 0 )
		{
			$PatientId=$ExistingPatientId;
		}
		else 
		{
			$PatientId = $this->addPatient ();
		}
		
		
		$this->Patient_Id = $PatientId;
		
		$this->subject = substr ( $this->input->post ( 'query' ), 0, 100 );
		$this->medical_query = $this->input->post ( 'query' );
		$this->promo_code = ''; // $this->input->post('promo');
		/*
		 * $this->patient_first_name = $this->input->post('fname');
		 * $this->patient_last_name = $this->input->post('lname');
		 * $this->patient_email = $this->input->post('email');
		 * $this->patient_gender = $this->input->post('gender');
		 * $this->patient_country = $this->input->post('country');
		 */
		$this->specialization = $this->input->post ( 'specialization' );
		// $this->patient_contact_number = $this->input->post('phone');
		$this->type = $this->input->post ( 'type' );
		$this->terms = 1;
		// $this->relation=$this->input->post('relation');
		
		$TodayDate = date ( 'Y-m-d' );
		$this->Case_Date = $TodayDate;
		
		$Subscription = $this->session->userdata ( 'UserSubscription' );
		if ($Subscription != NULL && $Subscription != '') {
			$this->plan = $Subscription->Plan_Id;
		}
		
		$user = $this->session->userdata ( 'user' );
		$this->created_by = $user->User_Id;
		
		if ($user->Corp_Code != NULL && $user->Corp_Code != '') {
			$this->Corp_Code = $user->Corp_Code;
		}
		
		$this->db->insert ( 'cases', $this );
		$GeneratedCaseId = $this->db->insert_id ();
		$this->db->trans_complete ();
		
		return $GeneratedCaseId;
	}
	function createQuery() {
		$this->subject = substr ( $this->input->post ( 'query' ), 0, 100 );
		$this->medical_query = $this->input->post ( 'query' );
		$this->promo_code = $this->input->post ( 'referral' );
		$PatientId = $this->addPatientCreatequery ();
		$this->Patient_Id = $PatientId;
		$this->type = $this->input->post ( 'type' );
		$this->terms = 1;
		
		$user = $this->session->userdata ( 'user' );
		$this->created_by = $user->User_Id;
		
		$this->db->insert ( 'cases', $this );
		
		return $this->db->insert_id ();
	}
	function addPatient() {
		$user = $this->session->userdata ( 'user' );
		
		$PatientId=0;
		//$PatientDetails=$this->getPatientByEmail($this->input->post ( 'email' )); // email check revoked so that multiple patient can be created on single email id.
		
		//if($PatientDetails == NULL)
		//{
			$DateofBirth = $this->input->post ( 'dob' );
			$TodayDate = date ( 'Y-m-d' );
			$PatientsArray = array (
					'FName' => $this->input->post ( 'fname' ),
					'LName' => $this->input->post ( 'lname' ),
					'Phone' => $this->input->post ( 'phone' ),
					'Email' => $this->input->post ( 'email' ),
					'DOB' => date ( 'Y-m-d', strtotime ( $DateofBirth ) ),
					'Gender' => $this->input->post ( 'gender' ),
					'Relation' => $this->input->post ( 'relation' ),
					'Country' => $this->input->post ( 'country' ),
					'Created_By' => $user->User_Id ,
					'Created_Date'=> $TodayDate
			)
			;
			
			$this->db->insert ( 'patients', $PatientsArray );
			
			$PatientId=$this->db->insert_id ();
		//}
		/*else 
		{
			$PatientId=$PatientDetails->Patient_Id;
		}*/
		
		
		
		return $PatientId;
	}
	function addPatientCreatequery() {
		$user = $this->session->userdata ( 'user' );
		
		$PatientId=0;
		$PatientDetails=$this->getPatientByEmail($this->input->post ( 'email' ));
		
		if($PatientDetails == NULL)
		{
			$DateofBirth = $this->input->post ( 'dob' );
			$TodayDate = date ( 'Y-m-d' );
			
			$PatientsArray = array (
					'FName' => $this->input->post ( 'firstName' ),
					'LName' => $this->input->post ( 'lastName' ),
					'Phone' => $this->input->post ( 'phone' ),
					'Email' => $this->input->post ( 'email' ),
					'Country' => $this->input->post ( 'country' ),
					'Created_By' => $user->User_Id,
					'Created_Date'=> $TodayDate
			)
			;
			
			$this->db->insert ( 'patients', $PatientsArray );
			
			$PatientId=$this->db->insert_id ();
		}
		else
		{
			$PatientId=$PatientDetails->Patient_Id;
		}
		
		
		
		return $PatientId;
		
	}
	function getRelations() {
		$query = $this->db->get ( 'relation_master' );
		return $query->result ();
	}
	function getRelationsById($relId) {
		$query = $this->db->get_where ( 'relation_master', array (
				'id' => $relId 
		) );
		if ($query->num_rows () > 0) {
			return $query->row ();
		} else {
			return;
		}
	}
	function EditCaseDetail($id) {
		$this->medical_query = $this->input->post ( 'mquery' );
		
		$this->Doctor_Id = $this->input->post ( 'doctorname' );
		
		$query = $this->db->update ( 'cases', $this, array (
				'id' => $id 
		) );
		
		return $query;
	}
	function addFollowupQuery($caseDetails) {
		$this->Question = $this->input->post ( 'question' );
		
		$user = $this->session->userdata ( 'user' );
		$this->QByUserId = $user->User_Id;
		$this->QByUserType = $user->User_Type;
		$this->Case_Id = $caseDetails ["Case_Id"];
		
		$this->db->insert ( 'followup_case_questions', $this );
		
		return $this->db->insert_id ();
	}
	function getCorpDetailsById($UserID) {
		$query = $this->db->get_where ( 'corporate_details', array (
				'User_Id' => $UserID 
		) );
		
		if ($query->num_rows () > 0) {
			return $query->row ();
		} else {
			return;
		}
	}
	function getCasesPatientsByPromocode($Promocode) {
		$query = $this->db->get_where ( 'cases', array (
				'promo_code' => $Promocode 
		) );
		$QueryResultReferal = $query->result ();
		
		if ($QueryResultReferal != NULL) {
			$PatientIdList = array ();
			
			foreach ( $QueryResultReferal as $singlerecord ) {
				array_push ( $PatientIdList, $singlerecord->Patient_Id );
			}
		}
		return $PatientIdList;
	}
	function getCasesPatientsByCorporateCode($CorpCode) {
		$query = $this->db->get_where ( 'cases', array (
				'Corp_Code' => $CorpCode 
		) );
		
		$QueryResultReferal = $query->result ();
		
		if ($QueryResultReferal != NULL) {
			$PatientIdList = array ();
			
			foreach ( $QueryResultReferal as $singlerecord ) {
				array_push ( $PatientIdList, $singlerecord->Patient_Id );
			}
		}
		return $PatientIdList;
	}
	function ToAddPatientAsUser($PasswordHash) {
		$this->db->trans_start ();
		// Add Expiry
		$DateofBirth = $this->input->post ( 'dob' );
		$TodayDate = date ( 'Y-m-d H:i:s' );
		$userDetails = array (
				'First_name' => $this->input->post ( 'fname' ),
				'Last_Name' => $this->input->post ( 'lname' ),
				'email' => $this->input->post ( 'email' ),
				'Gender' => $this->input->post ( 'gender' ),
				'Birth_Date' => date ( 'Y-m-d', strtotime ( $DateofBirth ) ),
				'Mobile_Number' => $this->input->post ( 'phone' ),
				'Country' => $this->input->post ( 'country' ),
				'password' => $PasswordHash,
				'Password_Expiry' => $TodayDate,
				'Verify_Status' => 1, //Cutomer Verified
				'User_Type' => CUSTOMER 
		)
		;
		
		$this->db->insert ( 'user', $userDetails );
		$this->db->trans_complete ();
		return $this->db->insert_id ();
	}
	function getPlans() {
		$query = $this->db->get ( 'plan' );
		return $query->result ();
	}
	function EditCaseDetailAdmin($CaseDetailArray) 
	{
		$DoctorId = $this->input->post ( 'doctorname' );
		$this->status = $this->input->post ( 'caseStatus' );

		if ($DoctorId != NULL && $DoctorId !=null && $this->status<2) {
			// if you had a doc assigned, status must be at least 2
			$this->status = 2;
		}
		
		if ($this->status <= 3) {
			$this->Case_Expiry = NULL;
		}
		
		$this->medical_query = $this->input->post ( 'mquery' );
		$this->type = $this->input->post ( 'caseType' );
		$this->Doctor_Id = $DoctorId;
		
		$this->is_paid = $this->input->post ( 'casePaid' );
		$this->plan = $this->input->post ( 'Plan' );
		
		// Patient
		$Relation = $this->input->post ( 'relation' );
		$Result = $this->updatePatientRelation ( $CaseDetailArray ["Patient_Id"], $Relation );
		
		$query = $this->db->update ( 'cases', $this, array (
				'id' => $CaseDetailArray ["CaseId"] 
		) );
		
		return $query;
	}
	function updatePatientRelation($PatientId, $RelationId) {
		$PatientArray = array (
				'Relation' => $RelationId 
		);
		
		$query = $this->db->update ( 'patients', $PatientArray, array (
				'Patient_Id' => $PatientId 
		) );
		
		return $query;
	}
	function addreferaldoctor($caseArray) {
		$this->Case_Id = $caseArray ["CaseId"];
		$this->Refering_Doctor_Id = $caseArray ["UserId"];
		$this->Referred_Doctor_Id = $caseArray ["DoctorId"];
		
		$TodayDate = date ( 'Y-m-d H:i:s' );
		$this->Referal_Date = $TodayDate;
		
		$this->db->insert ( 'doctor_referal_history', $this );
		
		return $this->db->insert_id ();
	}
	function addTravelCase() {
		$this->Country = $this->input->post ( 'Homecountry' );
		
		// Dates
		$this->Date_Arrival = date ( 'Y-m-d', strtotime ( $this->input->post ( 'ArivalDate' ) ) );
		$this->Start_Date = date ( 'Y-m-d', strtotime ( $this->input->post ( 'StartDate' ) ) );
		$this->End_Date = date ( 'Y-m-d', strtotime ( $this->input->post ( 'EndDate' ) ) );
		
		$this->Country_US = $this->input->post ( 'CountryUs' );
		$this->Destination_Country = $this->input->post ( 'Desticountry' );
		
		$this->Number_Insured = $this->input->post ( 'NoInsured' );
		$this->Age = $this->input->post ( 'Age' );
		$this->Address = $this->input->post ( 'address' );
		$this->Relation = $this->input->post ( 'relation' );
		
		$this->Created_By = $this->session->userdata ( 'user' )->User_Id;
		
		$this->FName = $this->session->userdata ( 'user' )->First_name;
		$this->LName = $this->session->userdata ( 'user' )->Last_Name;
		$this->Email = $this->session->userdata ( 'user' )->email;
		$this->Mobile = $this->session->userdata ( 'user' )->Mobile_Number;
		
		$TodayDate = date ( 'Y-m-d H:i:s' );
		$this->Created = $TodayDate;
		
		$this->db->insert ( 'travel_insurance', $this );
		
		return $this->db->insert_id ();
	}
	function addTravelCaseRequest() {
		$this->Country = $this->input->post ( 'Homecountry' );
		
		// Dates
		$this->Date_Arrival = date ( 'Y-m-d', strtotime ( $this->input->post ( 'ArivalDate' ) ) );
		$this->Start_Date = date ( 'Y-m-d', strtotime ( $this->input->post ( 'StartDate' ) ) );
		$this->End_Date = date ( 'Y-m-d', strtotime ( $this->input->post ( 'EndDate' ) ) );
		
		$this->Country_US = $this->input->post ( 'CountryUs' );
		$this->Destination_Country = $this->input->post ( 'Desticountry' );
		
		$this->Number_Insured = $this->input->post ( 'NoInsured' );
		$this->Age = $this->input->post ( 'Age' );
		$this->Address = $this->input->post ( 'address' );
		$this->Relation = $this->input->post ( 'relation' );
		
		$this->FName = $this->input->post ( 'Fname' );
		;
		$this->LName = $this->input->post ( 'Lname' );
		$this->Email = $this->input->post ( 'Email' );
		$this->Mobile = $this->input->post ( 'Mobile' );
		
		$TodayDate = date ( 'Y-m-d H:i:s' );
		$this->Created = $TodayDate;
		
		$this->db->insert ( 'travel_insurance', $this );
		
		return $this->db->insert_id ();
	}
	function getTravelCasesByUser() {
		$UserObj = $this->session->userdata ( 'user' );
		
		if ($UserObj->User_Type != ADMIN && $UserObj->User_Type != ADMINUSER) {
			$this->db->where ( 'Created_By', $UserObj->User_Id );
		}
		
		$query = $this->db->get ( 'travel_insurance' );
		return $query->result ();
	}
	function getDocumentsByUser($UserId) {
		$UserObj = $this->session->userdata ( 'user' );
		
		if ($UserObj->User_Type != ADMIN && $UserObj->User_Type != ADMINUSER) {
			$query = $this->db->get_where ( 'document', array (
					'created_by' => $UserId 
			) );
		} else {
			$query = $this->db->get_where ( 'document');
		}
		
		$QueryResultRef = $query->result ();
		$result = array ();
		foreach ( $QueryResultRef as $singlerecord ) {
			$result [] = array (
					'document_id' => $singlerecord->document_id,
					'document_title' => $singlerecord->document_title,
					'document_detail' => $singlerecord->document_detail,
					'Created_By' => $singlerecord->created_by,
					'created_on' => $singlerecord->created_on,
					'Patient_Id' => $singlerecord->Patient_Id,
					'Type' => $singlerecord->Type 
			)
			;
		}
		
		return $result;
	}
	function getCaseDocuments($CaseId) {
		$query = $this->db->get_where ( 'case_documents', array (
				'Case_Id' => $CaseId 
		) );
		
		$QueryResultRef = $query->result ();
		$result = array ();
		foreach ( $QueryResultRef as $singlerecord ) {
			$result [] = array (
					'id' => $singlerecord->id,
					'Case_Id' => $singlerecord->Case_Id,
					'Document_Id' => $singlerecord->Document_Id,
					'Created_By' => $singlerecord->Created_By,
					'Patient_Id' => $singlerecord->Patient_Id 
			);
		}
		
		return $result;
	}
	function addCaseDocuments($CaseId) 
	{
		$PatientId = $this->input->post ( 'patient' );
		
		$user = $this->session->userdata ( 'user' );
		
		$this->db->where ( 'Case_Id', $CaseId );
		$this->db->delete ( 'case_documents' );
		
		$DocumentIds = $this->input->post ( 'DocumentIds' );
		if ($DocumentIds != NULL) 
		{
			$CaseDocInsert = array ();
			foreach ( $DocumentIds as $DocId ) {
				$CaseDocInsert [] = array (
						'Case_Id' => $CaseId,
						'Patient_Id' => $PatientId,
						'Created_By' => $user->User_Id,
						'Document_Id' => $DocId 
				);
			}
			$this->db->insert_batch ( 'case_documents', $CaseDocInsert );
		}
		else 
		{
			if($PatientId != NULL && $PatientId !='')
			{
				$CaseDocInsert = array (
						'Case_Id' => $CaseId,
						'Patient_Id' => $PatientId,
						'Created_By' => $user->User_Id,
						'Document_Id' => '' 
				);
				$this->db->insert ( 'case_documents', $CaseDocInsert );
			}
		}
	}
	function getCaseDocumentsDeatils($UserId, $DocumentIdList) {
		$this->db->where_in ( 'document_id', $DocumentIdList );
//		$this->db->where ( 'created_by', $UserId );
		$query = $this->db->get ( 'document' );
		
		$QueryResultRef = $query->result ();
		$result = array ();
		foreach ( $QueryResultRef as $singlerecord ) {
			$result [] = array (
					'document_id' => $singlerecord->document_id,
					'document_title' => $singlerecord->document_title,
					'document_detail' => $singlerecord->document_detail,
					'Created_By' => $singlerecord->created_by,
					'created_on' => $singlerecord->created_on,
					'Patient_Id' => $singlerecord->Patient_Id,
					'Type' => $singlerecord->Type 
			)
			;
		}
		
		return $result;
	}
	function UpdateCaseReportStatus($CaseDetailArray) {
		$this->status = 4;
		$this->Case_Expiry = $CaseDetailArray ["ExpDate"];
		
		$query = $this->db->update ( 'cases', $this, array (
				'id' => $CaseDetailArray ["Case_Id"] 
		) );
		
		return $query;
	}
	function UpdateCaseCloseStatus($CaseId) {
		$this->status = 5;
		// $this->Case_Expiry = $CaseDetailArray["ExpDate"];
		
		$query = $this->db->update ( 'cases', $this, array (
				'id' => $CaseId 
		) );
		
		return $query;
	}
	
	function getPatientByEmail($Email) {
		$query = $this->db->get_where ( 'patients', array (
				'Email' => $Email
		) );
	
		if ($query->num_rows () > 0) {
			return $query->row ();
		} else {
			return;
		}
	}
	
	function getAllPatients(){
		$query = $this->db->get ('patients');
		return $query->result();
		
	}
	
	function getExistingUsers(){
		 $sql = "SELECT * FROM `user` where User_Type != 4 and User_Type != 6";
		$query = $this->db->query ($sql);
		return $query-> result();
	}
	
}
?>