<?php
class CorporateMaster extends CI_Model {
	function __construct() {
		// Call the Model constructor
		parent::__construct ();
	}
	
	function getUserById($id) 
	{
		$query = $this->db->get_where ( 'user', array ('User_Id' => $id ) );
		
		if ($query->num_rows () > 0) 
		{
			return $query->row ();
		} 
		else 
		{
			return;
		}
	}
	
	function getUsersCreatedBy($id)
	{
		$query = $this->db->get_where ( 'user', array ('Created_By' => $id ) );
	
		if ($query->num_rows () > 0)
		{
			return $query->result ();
		}
		else
		{
			return;
		}
	}
	
	function getCorporateUserById($id)
	{
		$query = $this->db->get_where ( 'corporate_details', array ('Corp_Id' => $id ) );
	
		if ($query->num_rows () > 0)
		{
			return $query->row ();
		}
		else
		{
			return;
		}
	}
	
	
	function getCorporateUserByCorporateID($id)
	{
		$query = $this->db->get_where ( 'corporate_details', array ('Corp_Unique_Id' => $id ) );
	
		if ($query->num_rows () > 0)
		{
			return $query->row ();
		}
		else
		{
			return;
		}
	}
	
	function getAllCorporateUsers()
	{
		$this->db->select( "*");
		$this->db->from( "corporate_details");
		$this->db->join('user', 'user.User_Id = corporate_details.User_Id');
		$this->db->order_by ( "corporate_details.Corp_Id", "desc" );
		
		$query = $this->db->get();

		//$query = $this->db->get( 'corporate_details');
		return $query->result ();
	}
	
	
	
	
	function get_user_by_email($email) {
		$query = $this->db->get_where ( 'user', array (
				'email' => $email 
		) );
		return $query->result (); // $query->row ();
	}
	
	
	function get_singleuser_by_email($email) {
		$query = $this->db->get_where ( 'user', array (
				'email' => $email
		) );
		if ($query->num_rows () > 0)
		{
			return $query->row ();
		}
		else
		{
			return;
		}
	}
	
	
	function getSubscriptionDetails($UserId) {
		$query = $this->db->get_where ( 'user_plan_subscripton', array (
				'User_Id' => $UserId 
		) );
		
		if ($query->num_rows () > 0) 
		{
			return $query->row ();
			
		} else 
		{
			return;
		}
	}
	function getPlanName($PlanId) {
		$query = $this->db->get_where ( 'plan', array (
				'Plan_Id' => $PlanId 
		) );
		
		if ($query->num_rows () > 0) {
			return $query->row ();
		} else {
			return;
		}
	}
	function getAllPlans() {
		$query = $this->db->get ( 'plan' );
		
		return $query->result ();
	}
	
	
	
	
	function addSubscriptionDetailsEmployees() 
	{
		$user = $this->session->userdata ( 'user' );
		
		$StartDate = date ( 'Y-m-d' );			
		$Tempdate = date ( 'Y-m-d', strtotime ( $StartDate . '+1 year' ) );
		$EndDate = date ( 'Y-m-d', strtotime ( $Tempdate ) );
		

		$PlanId = $this->input->post ( 'Plan' );
		
		$UserIds = $this->input->post ( 'UserList' );

		if ($UserIds != NULL) 
		{
			$UserSubInsert = array ();
			foreach ( $UserIds as $Single ) 
			{
				$UserSubInsert [] = array (
						'User_Id' => $Single,
						'Plan_Id' => $PlanId,
						'Created_By' => $user->User_Id,
						'Start_Date' => $StartDate,
						'End_Date' => $EndDate
				);
			}
			
			$this->db->insert_batch ( 'user_plan_subscripton', $UserSubInsert );
			
			return  1;
		}
		
		return  0;
	}
	
	function updateSubscriptionPlan($SubId) 
	{
		
		$this->Plan_Id = $this->input->post('Plan');
		
		$query = $this->db->update ( 'user_plan_subscripton', $this, array ('Sub_Id' => $SubId ) );
		return $query;
	}
	
	
	function getCreatedUsers($UserId,$CorporateId) 
	{
		$query = $this->db->get_where ( 'user', array ('created_by' => $UserId ,'Corp_Code' => $CorporateId  ) );
		return $query->result ();
	}
	
	function getCorporateEmployess()
	{
		$this->db->where('Corp_Code !=', NULL);
		$this->db->where('Corp_Code !=', '');
		$query = $this->db->get( 'user');
		return $query->result ();
	}
	
	function generateRandomCode() {
		$TodayDate = date ( 'Y-m-d H:i:s' );
		
		$this->load->helper ( 'security' );
		$randomString = do_hash ( $TodayDate, 'md5' );
		return $randomString;
	}
	function resendVerification($UserId, $NewCode) {
		$this->Verify_Status = 0;
		$this->Verification_Code = $NewCode;
		$query = $this->db->update ( 'user', $this, array (
				'User_Id' => $UserId 
		) );
		return $query;
	}
	
	function AddNotificationDetails()
	{
		$UserId = $this->session->userdata ( 'user' )->User_Id;
		
		$NotificationArray=array(
				'Email' => 1,
				'SMS' =>1,
				'Phone' =>1,
				'User_Id' => $UserId
		);
		$this->Email=1;
		$this->SMS=1;
		$this->Phone=1;
		$this->User_Id=$UserId;
		
		$this->db->insert ( 'notification', $NotificationArray );
		
		$UserNoti = $this->getNotificationByUser ( $UserId );
		
		return $UserNoti;
	}
	
	
	
	
	function adduser($user_array)
	{
		$this->First_name = $user_array ['FName'];
		$this->Last_Name = $user_array ['LName'];
		$this->email = $user_array ['Email'];
		$this->Gender =$user_array ['Gender'];
		$this->password = $user_array ['Password'];
		$this->Birth_Date = date ( 'Y-m-d', strtotime ( $user_array ['BDate'] ) );
		$this->Mobile_Number = $user_array ['Phone'];
		$this->Other_Number = $user_array ['Phone2'];
		
		$this->Country = $user_array ['Country'];
		$this->State = $user_array ['State'];
		$this->City = $user_array ['City'];
		$this->Address = $user_array ['Address'];
		$this->Zip_Code = $user_array ['Zip_Code'];
		
		
		$this->User_Type= CUSTOMER;
		
		$this->Company= $user_array ['Company'];
		
		$this->Verify_Status = 0;
		$this->Sales_Contact= '';
		$this->Corp_Code= $user_array ['CorpCode'];
		
		$user = $this->session->userdata ( 'user' );
		$this->Created_By= $user->User_Id;
		$this->Registered_From = NORMAL_CUST;
		
		$this->Creator= $user->First_name.' '.$user->Last_Name;
	
		$this->Verification_Code = $this->generateRandomCode ();
			// Set Expiry
		$TodayDate = date ( 'Y-m-d' );
		$AddedDaysDate = date ( 'Y-m-d H:i:s', strtotime ( $TodayDate . ' + 1 days' ) );
		$this->Password_Expiry = $AddedDaysDate;
	
		$this->db->insert ( 'user', $this );
	
		$UserDetails=$this->getUserById($this->db->insert_id ());
		
		return $UserDetails;
	}
	
	
	function edituser($user_array)
	{
		$this->First_name = $user_array ['FName'];
		$this->Last_Name = $user_array ['LName'];
		$this->email = $user_array ['Email'];
		$this->Gender =$user_array ['Gender'];
		
		$this->Birth_Date = date ( 'Y-m-d', strtotime ( $user_array ['BDate'] ) );
		$this->Mobile_Number = $user_array ['Phone'];
		$this->Other_Number = $user_array ['Phone2'];
	
		$this->Country = $user_array ['Country'];
		$this->State = $user_array ['State'];
		$this->City = $user_array ['City'];
		$this->Address = $user_array ['Address'];
		$this->Zip_Code = $user_array ['Zip_Code'];
	
		$this->Company= $user_array ['Company'];
		
		$this->Verify_Status = $user_array ['Verify'];
	
		$query = $this->db->update ( 'user', $this, array ('User_Id' =>$user_array['User_Id'] ) );
		return $query;
	}
	
	
	function deleteUserById($id)
	{
		$UserArray=array(
				'Corp_Code' => '');
		
		$this->db->where ( 'User_Id', $id );
		$query = $this->db->update ( 'user', $UserArray, array ('User_Id' => $id ) );
	
		return $query;
	}
	
	
	function getAllUsers() 
	{
		$query = $this->db->get( 'user');
		return $query->result ();
	}
	
	function getAllUsersNotAllCorporate($UserIdList)
	{
		$this->db->where('User_Type', CORPADMIN);
		if($UserIdList!=NUlL && $UserIdList !='' )
		{
			$this->db->where_not_in('User_Id', $UserIdList);
		}
		
		$query = $this->db->get( 'user');
		return $query->result ();
	}
	
	
	function addCorporate($UserData)
	{
		$this->User_Id = $UserData ['UserId'];
		$this->Company_Name = $UserData ['Company'];
		$this->Address = $UserData ['Address'];
		$this->Phone = $UserData ['Phone'];
		
		//$this->Plan_Id = $UserData ['Plan_Id'];
		//$this->Corp_Unique_Id =$UserData ['CorpId'];

		$this->db->insert ( 'corporate_details', $this );
	
		$Result=$this->generateCorporateCode($this->db->insert_id (), $UserData ['UserId']);
		
		return $Result ;
	}
	
	function generateCorporateCode($primary_key, $UserId) 
	{
		$UniqueId = 'CorpId' . $primary_key;
		$this->Corp_Unique_Id = $UniqueId;
	
		$query = $this->db->update ( 'corporate_details', $this, array ('Corp_Id' => $primary_key ) );
		
		$UserArray=array(
				'Corp_Code' => $UniqueId,
				'User_Id' => $UserId,
				'User_Type' => CORPADMIN
				);
		
		$Result1=$this->UpdateCorporateCodeUser($UserArray);
		
		return $query;
	}
	
	function UpdateCorporateCodeUser($UserArray)
	{
		$query = $this->db->update ( 'user', $UserArray, array ('User_Id' => $UserArray['User_Id'] ) );
		return $query;
	}
	
	
	function addImportUser($UserList,$UserCount)
	{
		if($UserList != NULL &&  $UserCount > 0)
		{
			$query=$this->db->insert_batch ( 'user', $UserList );
			
			return $UserCount;
		}
	}
	
	
	function UpdateCorporateDeatils($UserArray)
	{
		$this->Company_Name = $UserArray ['Company'];
		$this->Address = $UserArray ['Address'];
		$this->Phone = $UserArray ['Phone'];
		$this->Plan_Id = $UserArray ['Plan_Id'];
		
		$query = $this->db->update ( 'corporate_details', $this, array ('Corp_Id' => $UserArray['Corp_Id'] ) );
		return $query;
	}
	
	
	function deleteCorporateUserById($CorporateData)
	{
		$UserArray=array(
				'User_Id' => $CorporateData["User_Id"],
				'User_Type' => CUSTOMER,
				'Corp_Code' => '',
		);
		
		$this->db->where ( 'Corp_Id', $CorporateData["Corp_Id"] );
		$query = $this->db->delete ( 'corporate_details' );
		
		$Result=$this->UpdateCorporateUser($UserArray);
		
		return $query;
	}
	
	
	function UpdateCorporateUser($UserArray)
	{
		$query = $this->db->update ( 'user', $UserArray, array ('User_Id' => $UserArray['User_Id'] ) );
		return $query;
	}
	
	
	function UpdateCorporateUserBatch($CorpUserlist)
	{
		$PostUserList=$this->input->post('UserList');
		$UserArray = array();
		
		foreach($CorpUserlist as $SingleCorpUser)
		{
			$CheckValue=false;
			
			if($PostUserList != NULL)
			{
				If(in_array($SingleCorpUser->User_Id, $PostUserList) )
				{
					$CheckValue=true;
				}
			}
			
			$UserArray [] = array (
					'User_Id' => $SingleCorpUser->User_Id,
					'Verify_Status' => ($CheckValue== true ? 1 :0)
			);
		}
		
		
		
		$query = $this->db->update_batch ( 'user', $UserArray,'User_Id'  );
		return 1 ;
	}
}
?>