<?php
class DoctorMaster extends CI_Model {
	function __construct() {
		// Call the Model constructor
		parent::__construct ();
	}
	
	function getDoctorsByCurrentUser() {
		$user = $this->session->userdata ( 'user' );
		$query = $this->db->query( 'select *,(select count(*) from cases where Doctor_Id=doctors.Doctor_Id and status=2) "assigned",(select count(*) from cases where Doctor_Id=doctors.Doctor_Id and status=5) "closed" from doctors where Created_By='.$user->User_Id ); // get_where('doctors', array('Created_By' => $user));
		return $query->result ();
	}

	function getDoctorsByUser() {
		$query = $this->db->get ( 'doctors' ); // get_where('doctors', array('Created_By' => $user));
		return $query->result ();
	}
	function getDoctorById($id) {
		$query = $this->db->get_where ( 'doctors', array (
				'Doctor_Id' => $id 
		) );
		
		if ($query->num_rows () > 0) {
			return $query->row ();
		} else {
			return;
		}
	}
	function add($ProfilePicName, $passhash) {
		// TODO: load inputs from what you have in your view
		$FName = $this->input->post ( 'Fname' );
		$LName = $this->input->post ( 'Lname' );
		
		$GeneratedId = 0;
		
		$user = $this->session->userdata ( 'user' );

		$this->db->trans_start ();
		$userDetails = array (
				'First_name' => $FName,
				'Last_Name' => $LName,
				'email' => $this->input->post ( 'email' ),
				'mobile_number' => $this->input->post ( 'phone' ),
				'password' => $passhash,
				'User_Type' => DOCTORS,
				'Verify_Status' => 1,
				'Verification_Code'=> '',
				'Created_By'=> $user->User_Id,
				'Creator'=> $user->First_name.' '.$user->Last_Name
		);

		
		$UserId = $this->createUser ( $userDetails );
		
		if ($UserId != NULL) {
			$this->User_Id = $UserId->User_Id;
		}
		$this->DName = $FName . ' ' . $LName;
		$this->Gender = $this->input->post ( 'gender' );
		$this->ReferraltoGO = $this->input->post ( 'referraltoGO' );
		$this->PayoutOpinion = $this->input->post ( 'payoutOpinion' );
		$this->PayoutConsult = $this->input->post ( 'payoutConsult' );
		$this->Qualification = $this->input->post ( 'qualification' );
		$this->Speciality = $this->input->post ( 'speciality' );
		$this->Email = $this->input->post ( 'email' );
		$this->Phone = $this->input->post ( 'phone' );
		$this->DImagePath = $ProfilePicName;
		$user = $this->session->userdata ( 'user' );
		$this->Created_By = $user->User_Id;
		
		$this->db->insert ( 'doctors', $this );
		$GeneratedId = $this->db->insert_id ();
		
		$this->db->trans_complete ();
		
		return $UserId->User_Id; // we want the user ID returned not $GeneratedId;
	}
	function createUser($userDetails) {
		$this->db->insert ( 'user', $userDetails );
		
		$user = $this->get_user ( $this->db->insert_id () );
		
		return $user [0];
	}
	function get_user($id) {
		$query = $this->db->get_where ( 'user', array (
				'User_Id' => $id 
		) );
		return $query->result ();
	}
	function getAllSpecialities() {
		$query = $this->db->get ( 'doctor_specialization_master' );
		$QueryResult = $query->result ();
		
		$result = array ();
		foreach ( $QueryResult as $singlerecord ) {
			$result [] = array (
					'id' => $singlerecord->id,
					'name' => $singlerecord->name 
			);
		}
		
		return $result;
	}
	function EditDoctorDetail($id, $ProfilePicName,$DoctorsSplitName) {
		$this->DName = $this->input->post ( 'Dname' );
		$this->Email = $this->input->post ( 'email' );
		$this->Gender = $this->input->post ( 'gender' );
		$this->ReferraltoGO = $this->input->post ( 'referraltoGO' );
		$this->PayoutOpinion = $this->input->post ( 'payoutOpinion' );
		$this->PayoutConsult = $this->input->post ( 'payoutConsult' );

		$this->Phone = $this->input->post ( 'phone' );
		$this->Qualification = $this->input->post ( 'qualification' );
		$this->Speciality = $this->input->post ( 'special' );
		$this->DImagePath = $ProfilePicName;
		
		$UserArray=array(
				'User_Id' =>$this->input->post ( 'userid' ),
				'First_name' =>$DoctorsSplitName["FName"],
				'Last_Name' =>$DoctorsSplitName["LName"],
				'email' =>$this->input->post ( 'email' ),
				//'User_Image' =>$this->input->post ( 'DImagePath' ),
				'Gender' =>$this->input->post ( 'gender' ),
				'Mobile_Number' =>$this->input->post ( 'phone' )
		);
		
		$this->updateDoctorInUser($UserArray);
		
		$query = $this->db->update ( 'doctors', $this, array (
				'Doctor_Id' => $id 
		) );
		
		return $query;
	}
	
	function updateDoctorInUser($UserArray)
	{
		
		$query = $this->db->update ( 'user', $UserArray, array ('User_Id' => $UserArray["User_Id"]) );
		
		return $query;
	}
	
	
	function getAllDoctors() {
		$query = $this->db->get ( 'doctors' );
		$QueryResult = $query->result ();
		
		$result = array ();
		foreach ( $QueryResult as $singlerecord ) {
			$result [] = array (
					'Doctor_Id' => $singlerecord->Doctor_Id,
					'DName' => $singlerecord->DName,
					'Qualification' => $singlerecord->Qualification,
					'Speciality' => $singlerecord->Speciality,
					'DImagePath' => $singlerecord->DImagePath,
					'Email' => $singlerecord->Email,
					'ReferraltoGO' => $singlerecord->ReferraltoGO,
					'PayoutOpinion' => $singlerecord->PayoutOpinion,
					'PayoutConsult' => $singlerecord->PayoutConsult 
			)
			;
		}
		
		return $result;
	}
	
	function getCasesForCoordinator(){
		// $user1=3;
		$user = $this->session->userdata ( 'user' );

		$query = $this->db->query ('select * from cases where Doctor_Id in (select doctor_id from doctors where user_id in (select user_id from user where created_by='.$user->User_Id.') or Doctor_Id = (select doctor_id from doctors where user_id='.$user->User_Id.'))');

		$QueryResult = $query->result ();
		
		$result = array ();
		foreach ( $QueryResult as $singlerecord ) {
			$result [] = array (
					'Case_Id' => $singlerecord->id,
					'medical_query' => $singlerecord->medical_query,
					'Patient_Id' => $singlerecord->Patient_Id,
					'type' => $singlerecord->type,
					'Case_Date' => $singlerecord->Case_Date,
					'status' => $singlerecord->status 
			)
			;
		}
		
		$AllRecords = $result;
		
		return $AllRecords;
	}
	
	function getAllCasesForDoctor($user) {
		// $user1=3;
		$query = $this->db->get_where ( 'cases', array (
				'Doctor_Id' => $user 
		) );
		$QueryResult = $query->result ();
		
		$result = array ();
		foreach ( $QueryResult as $singlerecord ) {
			$result [] = array (
					'Case_Id' => $singlerecord->id,
					'medical_query' => $singlerecord->medical_query,
					'Patient_Id' => $singlerecord->Patient_Id,
					'type' => $singlerecord->type,
					'Case_Date' => $singlerecord->Case_Date,
					'status' => $singlerecord->status 
			)
			;
		}
		
		$AllRecords = $result;
		// This to Get Refernce Case
		$this->db->select ( 'Case_Id' );
		$queryReferal = $this->db->get_where ( 'doctor_referal_history', array (
				'Referred_Doctor_Id' => $user 
		) );
		$QueryResultReferal = $queryReferal->result ();
		
		if ($QueryResultReferal != NULL) {
			$CasesIdList = array ();
			foreach ( $QueryResultReferal as $singlerecord ) {
				$CasesIdList = array (
						$singlerecord->Case_Id 
				);
			}
			
			$this->db->where_in ( 'id', $CasesIdList );
			$queryGetRefCases = $this->db->get ( 'cases' );
			
			$QueryResultRef = $queryGetRefCases->result ();
			
			$result1 = array ();
			foreach ( $QueryResultRef as $singlerecord ) {
				$result1 [] = array (
						'Case_Id' => $singlerecord->id,
						'medical_query' => $singlerecord->medical_query,
						'Patient_Id' => $singlerecord->Patient_Id,
						'type' => $singlerecord->type,
						'Case_Date' => $singlerecord->Case_Date,
						'status' => $singlerecord->status 
				)
				;
			}
			
			$AllRecords = array_merge ( $result, $result1 );
			// $AllRecords=$result+$result1;
		}
		
		return $AllRecords;
	}
	function getAllDoctorAssignedCases() {
		$this->where ( 'Doctor_Id !=', NULL );
		$this->or_where ( 'Doctor_Id !=', '' );
		$query = $this->db->get ( 'cases' );
		$QueryResult = $query->result ();
		
		$result = array ();
		foreach ( $QueryResult as $singlerecord ) {
			$result [] = array (
					'Case_Id' => $singlerecord->id,
					'medical_query' => $singlerecord->medical_query,
					'Patient_Id' => $singlerecord->Patient_Id,
					'type' => $singlerecord->type,
					'Case_Date' => $singlerecord->Case_Date 
			)
			;
		}
		
		return $result;
	}
	function getAllCommentsOnCase($caseid) {
		$this->db->order_by ( "TimeStamp", "desc" );
		$query = $this->db->get_where ( 'case_comments', array (
				'Case_Id' => $caseid 
		) );
		$QueryResult = $query->result ();
		
		$result = array ();
		foreach ( $QueryResult as $singlerecord ) {
			$result [] = array (
					'Case_Id' => $singlerecord->Case_Id,
					'Doctor_Id' => $singlerecord->Doctor_Id,
					'Comment' => $singlerecord->Comment,
					'Recommendation' => $singlerecord->Recommendation,
					'Case_Date' => $singlerecord->TimeStamp,
					'Comment_Id' => $singlerecord->Id 
			)
			;
		}
		
		return $result;
	}
	function EditCommentsDetail($caseArray) {
		$this->Comment = $this->input->post ( 'comment' );
		$this->Case_Id = $caseArray ["Case_Id"];
		$this->Doctor_Id = $caseArray ["Doctor_Id"];
		$this->Recommendation = $this->input->post ( 'recommend' );
		
		$SubmitValue = $this->input->post ( 'submit' );
		if ($SubmitValue == "submit") {
			$caseid = $caseArray ["Case_Id"];
			$casearray = array (
					'status' => 3 
			);
			$Result = $this->updateCaseStatus ( $casearray, $caseid );
		}
		
		$CommentId = $this->input->post ( 'commentid' );
		$TodayDate = date ( 'Y-m-d' );
		$this->TimeStamp = $TodayDate;
		
		$query = $this->db->update ( 'case_comments', $this, array (
				'Id' => $CommentId 
		) );
		
		return $query;
	}
	function getDoctorsByUserId($id) {
		$query = $this->db->get_where ( 'doctors', array (
				'User_Id' => $id 
		) );
		
		if ($query->num_rows () > 0) {
			return $query->row ();
		} else {
			return;
		}
	}
	function addComments($caseArray) {
		// TODO: load inputs from what you have in your view
		$this->Comment = $this->input->post ( 'comment' );
		$this->Case_Id = $caseArray ["Case_Id"];
		$this->Doctor_Id = $caseArray ["Doctor_Id"];
		$this->Recommendation = $this->input->post ( 'recommend' );
		
		$TodayDate = date ( 'Y-m-d' );
		$this->TimeStamp = $TodayDate;
		
		$this->db->insert ( 'case_comments', $this );
		
		return $this->db->insert_id ();
	}
	function updateCaseStatus($casearray, $caseid) {
		$query = $this->db->update ( 'cases', $casearray, array (
				'id' => $caseid 
		) );
		
		return $query;
	}
	function addreferal($caseArray) {
		$this->Case_Id = $caseArray ["Case_Id"];
		$this->Refering_Doctor_Id = $caseArray ["Doctor_Id"];
		$this->Referred_Doctor_Id = $this->input->post ( 'referdocid' );
		
		$TodayDate = date ( 'Y-m-d H:i:s' );
		$this->Referal_Date = $TodayDate;
		
		$this->db->insert ( 'doctor_referal_history', $this );
		
		return $this->db->insert_id ();
	}
	function getDoctorsSearchByUser($keyword) {
		$this->db->like ( 'Doctor_Id', $keyword );
		$this->db->or_like ( 'DName', $keyword );
		$query = $this->db->get ( 'doctors' );
		return $query->result ();
	}
	function getAllSubmittedCasesForDoctor($user) {
		// $user1=3;
		$query = $this->db->get_where ( 'cases', array (
				'Doctor_Id' => $user,
				'status' => 3 
		) );
		$QueryResult = $query->result ();
		
		$result = array ();
		foreach ( $QueryResult as $singlerecord ) {
			$result [] = array (
					'Case_Id' => $singlerecord->id,
					'medical_query' => $singlerecord->medical_query,
					'Patient_Id' => $singlerecord->Patient_Id,
					'type' => $singlerecord->type,
					'Case_Date' => $singlerecord->Case_Date,
					'status' => $singlerecord->status 
			)
			;
		}
		
		$AllRecords = $result;
		// This to Get Refernce Case
		$this->db->select ( 'Case_Id' );
		$queryReferal = $this->db->get_where ( 'doctor_referal_history', array (
				'Referred_Doctor_Id' => $user 
		) );
		$QueryResultReferal = $queryReferal->result ();
		
		if ($QueryResultReferal != NULL) {
			$CasesIdList = array ();
			foreach ( $QueryResultReferal as $singlerecord ) {
				$CasesIdList = array (
						$singlerecord->Case_Id 
				);
			}
			
			$this->db->where_in ( 'id', $CasesIdList );
			$this->db->where ( 'status', 3 );
			$queryGetRefCases = $this->db->get ( 'cases' );
			
			$QueryResultRef = $queryGetRefCases->result ();
			
			$result1 = array ();
			foreach ( $QueryResultRef as $singlerecord ) {
				$result1 [] = array (
						'Case_Id' => $singlerecord->id,
						'medical_query' => $singlerecord->medical_query,
						'Patient_Id' => $singlerecord->Patient_Id,
						'type' => $singlerecord->type,
						'Case_Date' => $singlerecord->Case_Date,
						'status' => $singlerecord->status 
				)
				;
			}
			
			// $AllRecords=array_merge($result,$result1);
			$AllRecords = $result + $result1;
		}
		
		return $AllRecords;
	}
	function addDoctorProfile($DocData) {
		$this->db->trans_start ();
		
		$this->db->where ( 'Doctor_Id', $DocData ["Doctor_Id"] );
		$this->db->delete ( 'doctor_profile' );
		
		$this->Doctor_Id = $DocData ["Doctor_Id"];
		$this->Speciality = $this->input->post ( 'SpTitle' );
		$this->Summary = $this->input->post ( 'Summary' );
		$this->Short_Summary = $this->input->post ( 'ShortSummary' );
		
		$VisibleValue = $this->input->post ( 'Visiblity' );
		if ($VisibleValue != NULL && $VisibleValue != '') {
			$this->Visible = 1;
		} else {
			$this->Visible = 0;
		}
		
		$this->addEducationDetails ( $DocData ["Education"], $DocData ["Doctor_Id"] );
		$this->addExperienceDetails ( $DocData ["Prof_Exp"], $DocData ["Doctor_Id"] );
		$this->addCertificatesDetails ( $DocData ["Certificates"], $DocData ["Doctor_Id"] );
		$this->addAwardDetails ( $DocData ["Awards"], $DocData ["Doctor_Id"] );
		$this->addPublicationDetails ( $DocData ["Publication"], $DocData ["Doctor_Id"] );
		
		$user = $this->session->userdata ( 'user' );
		$this->Created_By = $user->User_Id;
		
		$this->db->insert ( 'doctor_profile', $this );
		$this->db->trans_complete ();
		
		return $this->db->insert_id ();
	}
	function addDoctorProfileNew($DocData) {
		$this->db->trans_start ();
		
		$this->db->where ( 'Doctor_Id', $DocData ["Doctor_Id"] );
		$this->db->delete ( 'doctor_profile' );
		
		$this->Doctor_Id = $DocData ["Doctor_Id"];
		$this->Speciality = $this->input->post ( 'SpTitle' );
		$this->Summary = $this->input->post ( 'Summary' );
		$this->Short_Summary = $this->input->post ( 'ShortSummary' );
		
		$VisibleValue = $this->input->post ( 'Visiblity' );
		if ($VisibleValue != NULL && $VisibleValue != '') {
			$this->Visible = 1;
		} else {
			$this->Visible = 0;
		}
		
		$this->addEducationDetailsNew ( $DocData ["Education"], $DocData ["Doctor_Id"] );
		$this->addExperienceDetailsNew ( $DocData ["Prof_Exp"], $DocData ["Doctor_Id"] );
		$this->addCertificatesDetailsNew ( $DocData ["Certificates"], $DocData ["Doctor_Id"] );
		$this->addAwardDetailsNew ( $DocData ["Awards"], $DocData ["Doctor_Id"] );
		$this->addPublicationDetailsNew ( $DocData ["Publication"], $DocData ["Doctor_Id"] );
		
		$user = $this->session->userdata ( 'user' );
		$this->Created_By = $user->User_Id;
		
		$this->db->insert ( 'doctor_profile', $this );
		$this->db->trans_complete ();
		
		return $this->db->insert_id ();
	}
	
	// Add Educatin Details
	function addEducationDetails($EducationDetailsArray, $DoctorId) {
		$this->db->where ( 'Doctor_Id', $DoctorId );
		$this->db->delete ( 'doctor_education' );
		
		if ($EducationDetailsArray != NULL && $EducationDetailsArray != '') {
			$this->db->insert_batch ( 'doctor_education', $EducationDetailsArray );
		}
	}
	
	// Add Experience
	function addExperienceDetails($ExperienceDetailsArray, $DoctorId) {
		$this->db->where ( 'Doctor_Id', $DoctorId );
		$this->db->delete ( 'doctor_experience' );
		
		if ($ExperienceDetailsArray != NULL && $ExperienceDetailsArray != '') {
			$this->db->insert_batch ( 'doctor_experience', $ExperienceDetailsArray );
		}
	}
	
	// Add Certificates
	function addCertificatesDetails($CertificatesDetailsArray, $DoctorId) {
		$this->db->where ( 'Doctor_Id', $DoctorId );
		$this->db->delete ( 'doctor_certificates' );
		
		if ($CertificatesDetailsArray != NULL && $CertificatesDetailsArray != '') {
			$this->db->insert_batch ( 'doctor_certificates', $CertificatesDetailsArray );
		}
	}
	
	// Add Awards
	function addAwardDetails($AwardDetailsArray, $DoctorId) {
		$this->db->where ( 'Doctor_Id', $DoctorId );
		$this->db->delete ( 'doctor_awards' );
		
		if ($AwardDetailsArray != NULL && $AwardDetailsArray != '') {
			$this->db->insert_batch ( 'doctor_awards', $AwardDetailsArray );
		}
	}
	
	// Add Publication
	function addPublicationDetails($PublicationDetailsArray, $DoctorId) {
		$this->db->where ( 'Doctor_Id', $DoctorId );
		$this->db->delete ( 'doctor_publication' );
		
		if ($PublicationDetailsArray != NULL && $PublicationDetailsArray != '') {
			$this->db->insert_batch ( 'doctor_publication', $PublicationDetailsArray );
		}
	}
	function getDoctorProfileDetails($DoctorId) {
		$query = $this->db->get_where ( 'doctor_profile', array (
				'Doctor_Id' => $DoctorId 
		) );
		
		if ($query->num_rows () > 0) {
			return $query->row ();
		} else {
			return;
		}
	}
	
	// Doctor Education Details
	function getDoctorEducationDetails($DoctorId) {
		$query = $this->db->get_where ( 'doctor_education', array (
				'Doctor_Id' => $DoctorId 
		) );
		
		$QueryResultRef = $query->result ();
		$result = array ();
		foreach ( $QueryResultRef as $singlerecord ) {
			$result [] = array (
					'Id' => $singlerecord->Id,
					'Doctor_Id' => $singlerecord->Doctor_Id,
					'Created_By' => $singlerecord->Created_By,
					'Header' => $singlerecord->Header,
					'Edu_Details' => $singlerecord->Edu_Details 
			)
			;
		}
		
		return $result;
	}
	
	// Doctor Exp Details
	function getDoctorExperienceDetails($DoctorId) {
		$query = $this->db->get_where ( 'doctor_experience', array (
				'Doctor_Id' => $DoctorId 
		) );
		
		$QueryResultRef = $query->result ();
		$result = array ();
		foreach ( $QueryResultRef as $singlerecord ) {
			$result [] = array (
					'Id' => $singlerecord->Id,
					'Doctor_Id' => $singlerecord->Doctor_Id,
					'Created_By' => $singlerecord->Created_By,
					'Header' => $singlerecord->Header,
					'Exp_Details' => $singlerecord->Exp_Details 
			)
			;
		}
		
		return $result;
	}
	
	// Doctor Certificate Details
	function getDoctorCertificateDetails($DoctorId) {
		$query = $this->db->get_where ( 'doctor_certificates', array (
				'Doctor_Id' => $DoctorId 
		) );
		
		$QueryResultRef = $query->result ();
		$result = array ();
		foreach ( $QueryResultRef as $singlerecord ) {
			$result [] = array (
					'Id' => $singlerecord->Id,
					'Doctor_Id' => $singlerecord->Doctor_Id,
					'Created_By' => $singlerecord->Created_By,
					'Header' => $singlerecord->Header,
					'Certi_Details' => $singlerecord->Certi_Details 
			)
			;
		}
		
		return $result;
	}
	
	// Award Details
	function getDoctorAwardDetails($DoctorId) {
		$query = $this->db->get_where ( 'doctor_awards', array (
				'Doctor_Id' => $DoctorId 
		) );
		
		$QueryResultRef = $query->result ();
		$result = array ();
		foreach ( $QueryResultRef as $singlerecord ) {
			$result [] = array (
					'Id' => $singlerecord->Id,
					'Doctor_Id' => $singlerecord->Doctor_Id,
					'Created_By' => $singlerecord->Created_By,
					'Header' => $singlerecord->Header,
					'Award_Details' => $singlerecord->Award_Details 
			)
			;
		}
		
		return $result;
	}
	
	// Doctor Publication
	function getDoctorPublicationDetails($DoctorId) {
		$query = $this->db->get_where ( 'doctor_publication', array (
				'Doctor_Id' => $DoctorId 
		) );
		
		$QueryResultRef = $query->result ();
		$result = array ();
		foreach ( $QueryResultRef as $singlerecord ) {
			$result [] = array (
					'Id' => $singlerecord->Id,
					'Doctor_Id' => $singlerecord->Doctor_Id,
					'Created_By' => $singlerecord->Created_By,
					'Header' => $singlerecord->Header,
					'Pub_Details' => $singlerecord->Pub_Details 
			)
			;
		}
		
		return $result;
	}
	function addDoctorByAdmin($DoctorDetails, $UserId) {
		$rtnValue = 0;
		
		$query = $this->db->get_where ( 'doctors', array (
				'User_Id' => $UserId,
				'Email' => $DoctorDetails ["email"] 
		) );
		
		if ($query->result () == NULL) {
			$this->db->trans_start ();
			
			$this->User_Id = $UserId;
			$this->DName = $DoctorDetails ["First_name"] . ' ' . $DoctorDetails ["Last_Name"];
			$this->Gender = $DoctorDetails ["Gender"];
		
		$this->ReferraltoGO = $DoctorDetails[ 'ReferraltoGO' ];
		$this->PayoutOpinion = $DoctorDetails[ 'PayoutOpinion' ];
		$this->PayoutConsult = $DoctorDetails[ 'PayoutConsult' ];

			$this->Email = $DoctorDetails ["email"];
			$this->Phone = $DoctorDetails ["Mobile_Number"];
			
			// $this->DImagePath = $this->input->post('dimg');
			// $this->Qualification = $this->input->post('qualification');
			// $this->Speciality = $this->input->post('speciality');
			$user = $this->session->userdata ( 'user' );
			$this->Created_By = $user->User_Id;
			
			$this->db->insert ( 'doctors', $this );
			
			$rtnValue = $this->db->insert_id ();
			
			$this->db->trans_complete ();
		}
		return $rtnValue;
	}
	
	// Add New Educatin Details
	function addEducationDetailsNew($EducationDetailsArray, $DoctorId) {
		$this->db->where ( 'Doctor_Id', $DoctorId );
		$this->db->delete ( 'doctor_education' );
		
		if ($EducationDetailsArray != NULL && $EducationDetailsArray != '') {
			$user = $this->session->userdata ( 'user' );
			
			$Data = array (
					'Doctor_Id' => $DoctorId,
					'Edu_Details' => $EducationDetailsArray,
					'Created_By' => $user->User_Id 
			);
			
			$this->db->insert ( 'doctor_education', $Data );
		}
	}
	
	// Add new Experience
	function addExperienceDetailsNew($ExperienceDetailsArray, $DoctorId) {
		$this->db->where ( 'Doctor_Id', $DoctorId );
		$this->db->delete ( 'doctor_experience' );
		
		if ($ExperienceDetailsArray != NULL && $ExperienceDetailsArray != '') {
			$user = $this->session->userdata ( 'user' );
			$Data = array (
					'Doctor_Id' => $DoctorId,
					'Exp_Details' => $ExperienceDetailsArray,
					'Created_By' => $user->User_Id 
			);
			
			$this->db->insert ( 'doctor_experience', $Data );
		}
	}
	
	// Add new Certificates
	function addCertificatesDetailsNew($CertificatesDetailsArray, $DoctorId) {
		$this->db->where ( 'Doctor_Id', $DoctorId );
		$this->db->delete ( 'doctor_certificates' );
		
		if ($CertificatesDetailsArray != NULL && $CertificatesDetailsArray != '') {
			$user = $this->session->userdata ( 'user' );
			
			$Data = array (
					'Doctor_Id' => $DoctorId,
					'Certi_Details' => $CertificatesDetailsArray,
					'Created_By' => $user->User_Id 
			);
			
			$this->db->insert ( 'doctor_certificates', $Data );
		}
	}
	
	// Add new Awards
	function addAwardDetailsNew($AwardDetailsArray, $DoctorId) {
		$this->db->where ( 'Doctor_Id', $DoctorId );
		$this->db->delete ( 'doctor_awards' );
		
		if ($AwardDetailsArray != NULL && $AwardDetailsArray != '') {
			$user = $this->session->userdata ( 'user' );
			
			$Data = array (
					'Doctor_Id' => $DoctorId,
					'Award_Details' => $AwardDetailsArray,
					'Created_By' => $user->User_Id 
			);
			
			$this->db->insert ( 'doctor_awards', $Data );
		}
	}
	
	// Add new Publication
	function addPublicationDetailsNew($PublicationDetailsArray, $DoctorId) {
		$this->db->where ( 'Doctor_Id', $DoctorId );
		$this->db->delete ( 'doctor_publication' );
		
		if ($PublicationDetailsArray != NULL && $PublicationDetailsArray != '') {
			$user = $this->session->userdata ( 'user' );
			
			$Data = array (
					'Doctor_Id' => $DoctorId,
					'Pub_Details' => $PublicationDetailsArray,
					'Created_By' => $user->User_Id 
			);
			
			$this->db->insert ( 'doctor_publication', $Data );
		}
	}
	
	// New Doctor Education Details
	function getDoctorEducationDetailsNew($DoctorId) {
		$query = $this->db->get_where ( 'doctor_education', array (
				'Doctor_Id' => $DoctorId 
		) );
		
		if ($query->num_rows () > 0) {
			$singlerecord = $query->row ();
			$result = array (
					'Id' => $singlerecord->Id,
					'Doctor_Id' => $singlerecord->Doctor_Id,
					'Created_By' => $singlerecord->Created_By,
					'Header' => $singlerecord->Header,
					'Edu_Details' => $singlerecord->Edu_Details 
			)
			;
			return $result;
		} else {
			return;
		}
	}
	
	// New Doctor Exp Details
	function getDoctorExperienceDetailsNew($DoctorId) {
		$query = $this->db->get_where ( 'doctor_experience', array (
				'Doctor_Id' => $DoctorId 
		) );
		
		if ($query->num_rows () > 0) {
			$singlerecord = $query->row ();
			$result = array (
					'Id' => $singlerecord->Id,
					'Doctor_Id' => $singlerecord->Doctor_Id,
					'Created_By' => $singlerecord->Created_By,
					'Header' => $singlerecord->Header,
					'Exp_Details' => $singlerecord->Exp_Details 
			)
			;
			return $result;
		} else {
			return;
		}
	}
	
	// New Doctor Certificate Details
	function getDoctorCertificateDetailsNew($DoctorId) {
		$query = $this->db->get_where ( 'doctor_certificates', array (
				'Doctor_Id' => $DoctorId 
		) );
		
		if ($query->num_rows () > 0) {
			$singlerecord = $query->row ();
			$result = array (
					'Id' => $singlerecord->Id,
					'Doctor_Id' => $singlerecord->Doctor_Id,
					'Created_By' => $singlerecord->Created_By,
					'Header' => $singlerecord->Header,
					'Certi_Details' => $singlerecord->Certi_Details 
			)
			;
			return $result;
		} else {
			return;
		}
	}
	
	// New Award Details
	function getDoctorAwardDetailsNew($DoctorId) {
		$query = $this->db->get_where ( 'doctor_awards', array (
				'Doctor_Id' => $DoctorId 
		) );
		
		if ($query->num_rows () > 0) {
			$Row = $query->row ();
			$result = array (
					'Id' => $Row->Id,
					'Doctor_Id' => $Row->Doctor_Id,
					'Created_By' => $Row->Created_By,
					'Header' => $Row->Header,
					'Award_Details' => $Row->Award_Details 
			)
			;
			return $result;
		} else {
			return;
		}
	}
	
	// New Doctor Publication
	function getDoctorPublicationDetailsNew($DoctorId) {
		$query = $this->db->get_where ( 'doctor_publication', array (
				'Doctor_Id' => $DoctorId 
		) );
		
		if ($query->num_rows () > 0) {
			$Row = $query->row ();
			$result = array (
					'Id' => $Row->Id,
					'Doctor_Id' => $Row->Doctor_Id,
					'Created_By' => $Row->Created_By,
					'Header' => $Row->Header,
					'Pub_Details' => $Row->Pub_Details 
			)
			;
			return $result;
		} else {
			return;
		}
	}
	
	
	function getAllDoctorsAlphabetically() {
	
		$this->db->order_by("DName", "asc");
		$query = $this->db->get ( 'doctors' );
		$QueryResult = $query->result ();
	
		$result = array ();
		foreach ( $QueryResult as $singlerecord ) {
			$result [] = array (
					'Doctor_Id' => $singlerecord->Doctor_Id,
					'DName' => $singlerecord->DName,
					'Qualification' => $singlerecord->Qualification,
					'Speciality' => $singlerecord->Speciality,
					'DImagePath' => $singlerecord->DImagePath,
					'Email' => $singlerecord->Email
			)
			;
		}
	
		return $result;
	}
	
}

?>