<?php
class PatientMaster extends CI_Model {
	function __construct() {
		// Call the Model constructor
		parent::__construct ();
	}
	function getPatientsByUser($user) {
		$query = $this->db->get_where ( 'patients', array (
				'created_by' => $user 
		) );
		return $query->result ();
	}
	function getAllPatients() {
		$query = $this->db->get ( 'patients' );
		return $query->result ();
	}
	function getCorpPatientsByIds($PatientList) {
		$this->db->where_in ( 'Patient_Id', $PatientList );
		$query = $this->db->get ( 'patients' );
		return $query->result ();
	}
	function getPatientById($id) {
		$query = $this->db->get_where ( 'patients', array (
				'Patient_Id' => $id 
		) );
		
		if ($query->num_rows () > 0) {
			return $query->row ();
		} else {
			return;
		}
	}
	function add() {
		// TODO: load inputs from what you have in your view
		$this->FName = $this->input->post ( 'fname' );
		$this->LName = $this->input->post ( 'lname' );
		$this->Email = $this->input->post ( 'email' );
		$this->Gender = $this->input->post ( 'gender' );
		$this->Phone = $this->input->post ( 'phone' );
		
		$BirthDate = date ( 'Y-m-d', strtotime ( $this->input->post ( 'dob' ) ) );
		$this->DOB = $BirthDate;
		$this->Relation = $this->input->post ( 'relation' );
		// $this->Country =$this->input->post('country');
		$user = $this->session->userdata ( 'user' );
		$this->Created_By = $user->User_Id;
		$TodayDate = date ( 'Y-m-d' );
		$this->Created_Date= $TodayDate;
		
		$this->db->insert ( 'patients', $this );
		
		return $this->db->insert_id ();
	}
	function getRelations() {
		$query = $this->db->get ( 'relation_master' );
		return $query->result ();
	}
	function EditPatientDetail($id) {
		$this->FName = $this->input->post ( 'fname' );
		$this->LName = $this->input->post ( 'lname' );
		$this->Email = $this->input->post ( 'email' );
		$this->Gender = $this->input->post ( 'gender' );
		$this->Phone = $this->input->post ( 'phone' );
		$this->DOB = date ( 'Y-m-d', strtotime ( $this->input->post ( 'dob' ) ) );
		$this->Relation = $this->input->post ( 'relation' );
		$this->Country = $this->input->post ( 'country' );
		
		$query = $this->db->update ( 'patients', $this, array (
				'Patient_Id' => $id 
		) );
		
		return $query;
	}
	function getPatientsSearchByUser($keyword, $user) {
		$this->db->like ( 'Patient_Id', $keyword );
		$this->db->or_like ( 'FName', $keyword );
		$this->db->or_like ( 'LName', $keyword );
		$this->db->or_like ( 'Phone', $keyword );
		$this->db->or_like ( 'Email', $keyword );
		$this->db->or_like ( 'Gender', $keyword );
		$query = $this->db->get_where ( 'patients', array (
				'Created_By' => $user 
		) );
		return $query->result ();
	}
	function getPatientsSearchAll($keyword) {
		$this->db->like ( 'Patient_Id', $keyword );
		$this->db->or_like ( 'FName', $keyword );
		$this->db->or_like ( 'LName', $keyword );
		$this->db->or_like ( 'Phone', $keyword );
		$this->db->or_like ( 'Email', $keyword );
		$this->db->or_like ( 'Gender', $keyword );
		$query = $this->db->get ( 'patients' );
		return $query->result ();
	}
	function getPatientByEmail($email) {
		$query = $this->db->get_where ( 'patients', array (
				'Email' => $email 
		) );
		return $query->result ();
	}
}
?>