<?php
class PaymentMaster extends CI_Model {
	function __construct() {
		// Call the Model constructor
		parent::__construct ();
	}
	function getPaymentsByUser($user) {
		$this->db->order_by ( 'Payment_Status asc, TimeStamp desc' );
		$query = $this->db->get_where ( 'payment_details', array (
				'created_by' => $user 
		) );
		return $query->result ();
	}
	function getAllPayments() {
		$this->db->order_by ( 'Payment_Status asc, TimeStamp desc' );
		$query = $this->db->get ( 'payment_details' );
		return $query->result ();
	}
	function getPaymentByCase($caseId) {
		$query = $this->db->get_where ( 'payment_details', array (
				'case_id' => $caseId 
		) );
		
		if ($query->num_rows () > 0) {
			return $query->row ();
		} else {
			return;
		}
	}
	function addWithDetail($CaseAmount) 
	{
		$this->Amount = $CaseAmount["Amount"];
		$this->PromoCode = $CaseAmount["promo"]; //$this->input->post ( 'promo' );
		$this->Currency = $CaseAmount["Currency"];
		$this->PaymentMode = $CaseAmount["paymentmode"]; //$this->input->post ( 'paymentmode' );
		
		$PlanDetail = $this->session->userdata ( 'PlanDetails' );
		if($PlanDetail != NULL && $PlanDetail != '')
		{
			$this->Plan_Id = $PlanDetail->Plan_Id;
		}
		
		$case = $this->session->userdata ( 'case' );
		if($case != NULL && $case != '')
		{
			$this->case_id = $case->id;
		}
		
		
		$user = $this->session->userdata ( 'user' );
		$this->Created_By = $user->User_Id;
		$this->TimeStamp = date ( "Y-m-d H:i:s" );
		
		$this->db->insert ( 'payment_details', $this );
		
		return $this->db->insert_id ();
	}
	function add($CaseAmount) 
	{
		$this->Amount = $CaseAmount["Amount"];
		$this->PromoCode = $this->input->post ( 'promo' );
		$this->Currency = $CaseAmount["Currency"];
		$this->PaymentMode = $this->input->post ( 'paymentmode' );
		
		$PlanDetail = $this->session->userdata ( 'PlanDetails' );
		if($PlanDetail != NULL && $PlanDetail != '')
		{
			$this->Plan_Id = $PlanDetail->Plan_Id;
		}
		
		$case = $this->session->userdata ( 'case' );
		if($case != NULL && $case != '')
		{
			$this->case_id = $case->id;
		}
		
		
		$user = $this->session->userdata ( 'user' );
		$this->Created_By = $user->User_Id;
		$this->TimeStamp = date ( "Y-m-d H:i:s" );
		
		$this->db->insert ( 'payment_details', $this );
		
		return $this->db->insert_id ();
	}
	function markPaymentStatus($PaymentId, $TransactionId) {
		$case = $this->session->userdata ( 'case' );
		$CurrentTimeStamp = date ( "Y-m-d H:i:s" );
		
		$Paymentdata = array (
				'Payment_Status' => 1,
				'TimeStamp' => $CurrentTimeStamp,
				'Transaction_Id' => $TransactionId 
		);
		
		$this->db->where ( 'Payment_Id', $PaymentId );
		$qresultPayments = $this->db->update ( 'payment_details', $Paymentdata );
		
		$data = array (
				'is_paid' => 1 
		);
		
		$this->db->where ( 'id', $case->id );
		$queryresult = $this->db->update ( 'cases', $data );
		
		return $qresultPayments;
	}
	function getPlanDetails($PlanId) {
		$query = $this->db->get_where ( 'plan_features', array (
				'Plan_Id' => $PlanId 
		) );
		
		return $query->result ();
	}
	function getPaymentByID($PaymentId) {
		$query = $this->db->get_where ( 'payment_details', array (
				'Payment_Id' => $PaymentId 
		) );
		
		if ($query->num_rows () > 0) {
			return $query->row ();
		} else {
			return;
		}
	}
    
    function addmojo($Payments)
    {
    	$this->Amount   = $Payments["Amount"];
    	$this->PromoCode   = $Payments["Promocode"];
    	$this->Currency   = $Payments["Currency"];
    	$this->PaymentMode   = $Payments["PayMode"];
    	$this->Transaction_Id   = $Payments["Transaction_Id"];
    
    	$PlanDetail = $this->session->userdata ( 'PlanDetails' );
		if($PlanDetail != NULL && $PlanDetail != '')
		{
			$this->Plan_Id = $PlanDetail->Plan_Id;
		}
		
		$case = $this->session->userdata ( 'case' );
		if($case != NULL && $case != '')
		{
			$this->case_id = $case->id;
		}
		
    
    	$user = $this->session->userdata('user');
    	$this->Created_By   = $user->User_Id;
    	$this->TimeStamp   = date("Y-m-d H:i:s");
    		
    	$this->db->insert('payment_details', $this);
    
    
    	return $this->db->insert_id();
    }
    
    
    function markPlanPaymentStatus($PaymentId, $TransactionId)
     {
    	$CurrentTimeStamp = date ( "Y-m-d H:i:s" );
    
    	$Paymentdata = array (
    			'Payment_Status' => 1,
    			'TimeStamp' => $CurrentTimeStamp,
    			'Transaction_Id' => $TransactionId
    	);
    
    	$this->db->where ( 'Payment_Id', $PaymentId );
    	$qresultPayments = $this->db->update ( 'payment_details', $Paymentdata );
    
    	return $qresultPayments;
    }
    
    function getPromoCodeDetails($Promocode)
     {
    	$query = $this->db->get_where ( 'plan_features', array ('Promocode' => $Promocode) );
    
    	return $query->result ();
    }
    
    
    function getAllPlans() {
    	$query = $this->db->get ( 'plan' );
    
    	return $query->result ();
    }
}
?>