<?php
class PHRMaster extends CI_Model {
	function __construct() {
		// Call the Model constructor
		parent::__construct ();
	}
	function getPatientsByUser($user) {
		$query = $this->db->get_where ( 'patients', array (
				'Created_By' => $user 
		) );
		return $query->result ();
	}
	function getFamilyHistoryRecordsByUser($user) {
		$query = $this->db->get_where ( 'family_medical_history', array (
				'Created_By' => $user 
		) );
		return $query->result ();
	}
	function getHospitalAdmissionRecordsByUser($user) {
		$query = $this->db->get_where ( 'hospital_admission', array (
				'Created_By' => $user 
		) );
		return $query->result ();
	}
	function getPatientById($id) {
		$query = $this->db->get_where ( 'patients', array (
				'Patient_Id' => $id 
		) );
		
		if ($query->num_rows () > 0) {
			return $query->row ();
		} else {
			return;
		}
	}
	function getFamilyHistoryRecordByPatientId($id) {
		$query = $this->db->get_where ( 'family_medical_history', array (
				'Member_Id' => $id 
		) );
		
		if ($query->num_rows () > 0) {
			return $query->row ();
		} else {
			return;
		}
	}
	function getHospitalAdmissionRecordByPatientId($id) {
		$query = $this->db->get_where ( 'hospital_admission', array (
				'Patient_Id' => $id 
		) );
		
		if ($query->num_rows () > 0) {
			return $query->row ();
		} else {
			return;
		}
	}
	function add() {
		$this->db->trans_start ();
		$this->addFamilyMedicHistory ();
		$this->addAlergies ();
		$this->addFamilyMedicHistory ();
		$this->addHospitalAddmission ();
		$this->addPersonalMedicalHistory ();
		$this->addCurrentPatientCondition ();
		$this->db->trans_complete ();
	}
	function addFamilyMedicHistory() {
		$PatientId = $this->input->post ( 'PhrFor' );
		$user = $this->session->userdata ( 'user' );
		
		$this->db->where ( 'Patient_Id', $PatientId );
		$this->db->delete ( 'family_medical_history' );
		
		$illnesses = $this->input->post ( 'familyHistory' );
		
		if ($illnesses != NULL) {
			$illnessInserts = array ();
			foreach ( $illnesses as $illness ) {
				$illnessInserts [] = array (
						'Patient_Id' => $PatientId,
						'Created_By' => $user->User_Id,
						'illness' => $illness,
						'Type' => 0 
				);
			}
			$this->db->insert_batch ( 'family_medical_history', $illnessInserts );
		}
	}
	function addAlergies() {
		$PatientId = $this->input->post ( 'PhrFor' );
		$user = $this->session->userdata ( 'user' );
		
		$this->db->where ( 'Patient_Id', $PatientId );
		$this->db->delete ( 'alergy_history' );
		
		$AllergiesList = $this->input->post ( 'AllergiesList' );
		
		if ($AllergiesList != NULL) {
			$allergies = array ();
			foreach ( $AllergiesList as $allergy ) {
				$allergies [] = array (
						'Patient_Id' => $PatientId,
						'Created_By' => $user->User_Id,
						'Allergies' => $allergy,
						'Type' => 1 
				);
			}
			$this->db->insert_batch ( 'alergy_history', $allergies );
		}
	}
	function addPersonalMedicalHistory() {
		$PatientId = $this->input->post ( 'PhrFor' );
		$user = $this->session->userdata ( 'user' );
		
		$this->db->where ( 'Patient_Id', $PatientId );
		$this->db->delete ( 'patient_medical_history' );
		
		$illnesses = $this->input->post ( 'PersonalHistory' );
		if ($illnesses != NULL) {
			$illnessInserts = array ();
			foreach ( $illnesses as $illness ) {
				$illnessInserts [] = array (
						'Patient_Id' => $PatientId,
						'Created_By' => $user->User_Id,
						'MedicalHistory' => $illness,
						'Type' => 0 
				);
			}
			$this->db->insert_batch ( 'patient_medical_history', $illnessInserts );
		}
	}
	function addHospitalAddmission() {
		$PatientId = $this->input->post ( 'PhrFor' );
		$user = $this->session->userdata ( 'user' );
		
		$this->db->where ( 'Patient_Id', $PatientId );
		$this->db->delete ( 'hospital_admission' );
		
		$Dates = $this->input->post ( 'HADate' );
		$Reasons = $this->input->post ( 'HAReason' );
		
		if ($Dates != NULL && $Reasons != NULL) {
			$dbAnswers = array ();
			for($i = 0; $i < count ( $Dates ); $i ++) {
				$dbAnswers [] = array (
						'Patient_Id' => $PatientId,
						'Created_By' => $user->User_Id,
						'Reason' => $Reasons [$i],
						'Admit_Date' => date ( 'Y-m-d', strtotime ( $Dates [$i] ) ) 
				);
			}
			$this->db->insert_batch ( 'hospital_admission', $dbAnswers );
		}
	}
	function addCurrentPatientCondition() {
		$PatientId = $this->input->post ( 'PhrFor' );
		$user = $this->session->userdata ( 'user' );
		
		$this->db->where ( 'Patient_Id', $PatientId );
		$this->db->delete ( 'current_patient_state' );
		
		$Answers = $this->input->post ( 'QuestionState' );
		if ($Answers != NULL) {
			$dbAnswers = array ();
			foreach ( $Answers as $answer ) {
				$dbAnswers [] = array (
						'Patient_Id' => $PatientId,
						'Created_By' => $user->User_Id,
						'State' => $answer 
				);
			}
			$this->db->insert_batch ( 'current_patient_state', $dbAnswers );
		}
	}
	
	
	function getFlyMedicalConditions() {
		$this->db->where ( 'ConditionType', '0' );
		$this->db->or_where ( 'ConditionType', '1' );
		$query = $this->db->get ( 'condition_medical_history' );
		return $query->result ();
	}
	function getPatientsFlyMedicalHistory($patientId) {
		$this->db->select ( 'illness' );
		$this->db->where ( 'Patient_Id', $patientId );
		$query = $this->db->get ( 'family_medical_history' );
		return $query->result ();
	}
	function getMedicalConditions() {
		$this->db->where ( 'ConditionType', '0' );
		$this->db->or_where ( 'ConditionType', '2' );
		$query = $this->db->get ( 'condition_medical_history' );
		return $query->result ();
	}
	function getPatientsMedicalHistory($patientId) {
		$this->db->select ( 'MedicalHistory' );
		$this->db->where ( 'Patient_Id', $patientId );
		$query = $this->db->get ( 'patient_medical_history' );
		return $query->result ();
	}
	function getAllAlergies() {
		$query = $this->db->get ( 'alergies' );
		return $query->result ();
	}
	function getPatientsAlergies($patientId) {
		$this->db->select ( 'Allergies' );
		$this->db->where ( 'Patient_Id', $patientId );
		$query = $this->db->get ( 'alergy_history' );
		return $query->result ();
	}
	function getDistinctAlergyType() {
		$this->db->distinct ( "AlegryType" );
		$this->db->group_by ( "AlegryType" );
		$query = $this->db->get ( 'alergies' );
		return $query->result ();
	}
	function getAllQuestions() {
		$query = $this->db->get ( 'feeling_question' );
		return $query->result ();
	}
	function getPatientsAnswers($patientId) {
		$this->db->select ( 'State' );
		$this->db->where ( 'Patient_Id', $patientId );
		$query = $this->db->get ( 'current_patient_state' );
		return $query->result ();
	}
	function getPatientsHospitalAdmissions($patientId) {
		// $this->db->select('Reason, Admit_Date');
		$this->db->where ( 'Patient_Id', $patientId );
		$query = $this->db->get ( 'hospital_admission' );
		return $query->result ();
	}
	
	
	
	function addForms($FormData)
	{
		$PatientId = $this->input->post ( 'PhrFor' );
		$user = $this->session->userdata ( 'user' );
	
		$this->db->where ( 'Patient_Id', $PatientId );
		$this->db->delete ( 'patient_form' );
	
		$this->Patient_Id=$PatientId;
		$this->Created_By=$user->User_Id;
		$this->Authorization_Form=$FormData['Auth'];
		$this->Hippa_Form=$FormData['Hippa'];
	
		$this->db->insert( 'patient_form', $this );
	
	}
	
	
	
	function getFormDetials($patientId) 
	{
		
		$query = $this->db->get_where ( 'patient_form', array ('Patient_Id' => $patientId) );
		
		if ($query->num_rows () > 0) 
		{
			return $query->row ();
		} 
		else 
		{
			return;
		}
	}
}
?>