<?php
class ReportMaster extends CI_Model {
	function __construct() {
		// Call the Model constructor
		parent::__construct ();
	}
	function getCasesByUserByDate($Values) {
		if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER) {
			$this->db->where ( 'created_by', $Values ["UserId"] );
		}
		$this->db->where ( 'Case_Date >=', $Values ["FromDate"] );
		$this->db->where ( 'Case_Date <=', $Values ["ToDate"] );
		$query = $this->db->get ( 'cases' );
		return $query->result ();
	}
	function getLeadsByUser($user) {
		$query = $this->db->get_where ( 'leads', array (
				'created_by' => $user 
		) );
		return $query->result ();
	}
	function getPatientById($id) {
		$query = $this->db->get_where ( 'patients', array (
				'Patient_Id' => $id 
		) );
		
		if ($query->num_rows () > 0) {
			return $query->row ();
		} else {
			return;
		}
	}
	function getPaymentByCase($caseId) {
		$query = $this->db->get_where ( 'payment_details', array (
				'case_id' => $caseId 
		) );
		
		if ($query->num_rows () > 0) {
			return $query->row ();
		} else {
			return;
		}
	}
	function getDoctorPaymentDetails($Values) {
		if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER) {
			$this->db->where ( 'Doctor_Id', $Values ["Doctor_Id"] );
		}
		$this->db->where ( 'TimeStamp >=', $Values ["FromDate"] );
		$this->db->where ( 'TimeStamp <=', $Values ["ToDate"] );
		$query = $this->db->get ( 'doctor_payment_history' );
		return $query->result ();
	}
	function getCasesByUser($Values) {
		if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER) {
			$this->db->where ( 'created_by', $Values ["UserId"] );
		}
		$query = $this->db->get ( 'cases' );
		return $query->result ();
	}
	function getPaymentHistoryByUser($Values) {
		if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER) {
			$this->db->where ( 'created_by', $Values ["UserId"] );
		}
		$this->db->where ( 'TimeStamp >=', $Values ["FromDate"] );
		$this->db->where ( 'TimeStamp <=', $Values ["ToDate"] );
		$query = $this->db->get ( 'payment_details' );
		return $query->result ();
	}
	function getByCaseId($caseId) {
		$query = $this->db->get_where ( 'cases', array (
				'id' => $caseId 
		) );
		
		if ($query->num_rows () > 0) {
			return $query->row ();
		} else {
			return;
		}
	}
	function getCorpDetailsById($UserID) {
		$query = $this->db->get_where ( 'corporate_details', array (
				'User_Id' => $UserID 
		) );
		
		if ($query->num_rows () > 0) {
			return $query->row ();
		} else {
			return;
		}
	}
	function getCasesByPromocode($Values) {
		if ($this->session->userdata ( 'user_type' ) != ADMIN && $this->session->userdata ( 'user_type' ) != ADMINUSER) {
			$this->db->where ( 'Corp_Code', $Values ["Promocode"] );
		}
		$this->db->where ( 'Case_Date >=', $Values ["FromDate"] );
		$this->db->where ( 'Case_Date <=', $Values ["ToDate"] );
		$query = $this->db->get ( 'cases' );
		$QueryResultReferal = $query->result ();
		return $QueryResultReferal;
	}
	function getCaseReportByID($CaseID) {
		$query = $this->db->get_where ( 'cases_report', array (
				'Case_Id' => $CaseID 
		) );
		
		if ($query->num_rows () > 0) {
			return $query->row ();
		} else {
			return;
		}
	}
	function addReport($CaseArray) {
		$this->db->where ( 'Case_Id', $CaseArray ['Case_Id'] );
		$this->db->delete ( 'cases_report' );
		
		$GeneratedCaseId = '';
		$this->db->trans_start ();
		
		$this->Medical_Query = $this->input->post ( 'MQuery' );
		$this->Medical_History = $this->input->post ( 'MedHistory' );
		$this->Doc_Comment = $this->input->post ( 'DocComment' );
		$this->Doc_Recommendation = $this->input->post ( 'DocRecommend' );
		$this->Online_Resource = $this->input->post ( 'Online' );
		$this->Add_Services = $this->input->post ( 'AddService' );
		$this->Go_Recommend = $this->input->post ( 'GORec' );
		$this->Case_Id = $CaseArray ['Case_Id'];
		$this->Doctor_Id = $CaseArray ['Doctor_Id'];
		$this->Patient_Id = $CaseArray ['Patient_Id'];
		
		$user = $this->session->userdata ( 'user' );
		$this->created_by = $user->User_Id;
		
		$this->db->insert ( 'cases_report', $this );
		$GeneratedCaseId = $this->db->insert_id ();
		$this->db->trans_complete ();
		
		return $GeneratedCaseId;
	}
	function getCasesByCorpCode($Values) {
		$this->db->where ( 'Corp_Code', $Values ["Promocode"] );
		$query = $this->db->get ( 'cases' );
		$QueryResultReferal = $query->result ();
		return $QueryResultReferal;
	}
	function getCasesByUserCount($UserId) {
		$this->db->where ( 'created_by', $UserId );
		$this->db->from ( 'cases' );
		$CountNotification = $this->db->count_all_results ();
		
		return $CountNotification;
	}
}
?>