<?php
tcpdf ();


// Extend the TCPDF class to create custom Header and Footer
class MYPDF extends TCPDF {

	//Page header
	public function Header() {
		
		// get the current page break margin
		$bMargin = $this->getBreakMargin();
		// get current auto-page-break mode
		$auto_page_break = $this->AutoPageBreak;
		// disable auto-page-break
		$this->SetAutoPageBreak(false, 0);
		// set bacground image
		$img_file = FCPATH.'images/backlogowatermark.gif';
		$this->Image($img_file, 0, 0, 210, 297, '', '', '', false, 300, '', false, false, 0);
		// restore auto-page-break status
		$this->SetAutoPageBreak($auto_page_break, $bMargin);
		// set the starting point for the page content
		$this->setPageMark();
		
		$HeaderHtml='<table >
      <tr>
        <td ><br>
          <img src="'.FCPATH.'images/go-logo.png" alt="img"></td>
        <td><h2><br>
          <span>Medical Consultation</span></h2></td>
      </tr>  		
    </table>';
		//$this->SetFont('helvetica', 'B', 20);
		// Title
		//$this->Cell(0, 15, '<< TCPDF Example 003 >>', 0, false, 'C', 0, '', 0, false, 'M', 'M');
		$this->writeHTMLCell($w = 0, $h = 0, $x = '', $y = '', $HeaderHtml, $border = "B", $ln = 1, $fill = 0, $reseth = true, $align = 'top', $autopadding = true);
	}

	// Page footer
	public function Footer() {
		// Position at 15 mm from bottom
		$this->SetY(-15);
		$FooterHtml='<table class="footer push table1width">
		<tr>
			<td><table width="100%">
					<tr>
						<td align=left style="text-align:left;"><h3>+1 352 414 5270, Fax: +1 888 288 6531</h3>
						</td>
						<td align=right style="text-align:right;"><h3>
								support@grandopinion.com<br>
								<a href="http://www.grandopinion.com">http://www.grandopinion.com</a><br>
							</h3></td>
					</tr>
				</table></td>
		</tr>
	</table>';
		// Set font
		$this->SetFont('helvetica', 'I', 8);
		// Page number
		//$this->Cell(0, 10, 'Page '.$this->getAliasNumPage().'/'.$this->getAliasNbPages(), 0, false, 'C', 0, '', 0, false, 'T', 'M');
		$this->writeHTMLCell($w = 0, $h = 0, $x = '', $y = '', $FooterHtml, $border = "T", $ln = 1, $fill = 0, $reseth = true, $align = 'bottom', $autopadding = true);
	}
}

// create new PDF document
$obj_pdf = new MYPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);

//$obj_pdf = new TCPDF ( 'P', PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false );

$obj_pdf->SetCreator ( PDF_CREATOR );
$title = $Report ["Title"];
$obj_pdf->SetTitle ( $title );
$obj_pdf->SetHeaderData ( PDF_HEADER_LOGO, PDF_HEADER_LOGO_WIDTH, $title, PDF_HEADER_STRING );
$obj_pdf->setHeaderFont ( Array (
		PDF_FONT_NAME_MAIN,
		'',
		PDF_FONT_SIZE_MAIN 
) );
$obj_pdf->setFooterFont ( Array (
		PDF_FONT_NAME_DATA,
		'',
		PDF_FONT_SIZE_DATA 
) );
$obj_pdf->SetDefaultMonospacedFont ( 'helvetica' );
$obj_pdf->SetHeaderMargin ( PDF_MARGIN_HEADER );
$obj_pdf->SetFooterMargin ( PDF_MARGIN_FOOTER );
$obj_pdf->SetMargins ( PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT );
$obj_pdf->SetAutoPageBreak ( TRUE, PDF_MARGIN_BOTTOM );
$obj_pdf->SetFont ( 'helvetica', '', 9, '', true );
$obj_pdf->setFontSubsetting ( false );
$obj_pdf->AddPage ();
ob_start ();
// we can have any view part here like HTML, PHP etc
$content = $this->load->view ( 'reportpreview', $Report, true );
ob_end_clean ();

try {
$obj_pdf->writeHTML ( $content, true, false, true, false, '' );

$obj_pdf->Output ( FCPATH . 'documents/TempPDF/' . $Report ["FileName"] . '.pdf', 'I' );

} catch(Exception $e) {
// 	var_dump($e);
}

//var_dump($content);
// var_dump($Report);
//die();