<?php

if (! defined ( 'BASEPATH' ))
	exit ( 'No direct script access allowed' );
/**
 * CodeIgniter
 *
 * An open source application development framework for PHP 5.1.6 or newer
 *
 * @package CodeIgniter
 * @author EllisLab Dev Team
 * @copyright Copyright (c) 2008 - 2014, EllisLab, Inc.
 * @copyright Copyright (c) 2014 - 2015, British Columbia Institute of Technology (http://bcit.ca/)
 * @license http://codeigniter.com/user_guide/license.html
 * @link http://codeigniter.com
 * @since Version 1.0
 * @filesource
 *
 */
	
// ------------------------------------------------------------------------

/**
 * Postgre Utility Class
 *
 * @category Database
 * @author EllisLab Dev Team
 * @link http://codeigniter.com/user_guide/database/
 */
class CI_DB_postgre_utility extends CI_DB_utility {
	
	/**
	 * List databases
	 *
	 * @access private
	 * @return bool
	 */
	function _list_databases() {
		return "SELECT datname FROM pg_database";
	}
	
	// --------------------------------------------------------------------
	
	/**
	 * Optimize table query
	 *
	 * Is table optimization supported in Postgre?
	 *
	 * @access private
	 * @param
	 *        	string the table name
	 * @return object
	 */
	function _optimize_table($table) {
		return FALSE;
	}
	
	// --------------------------------------------------------------------
	
	/**
	 * Repair table query
	 *
	 * Are table repairs supported in Postgre?
	 *
	 * @access private
	 * @param
	 *        	string the table name
	 * @return object
	 */
	function _repair_table($table) {
		return FALSE;
	}
	
	// --------------------------------------------------------------------
	
	/**
	 * Postgre Export
	 *
	 * @access private
	 * @param
	 *        	array Preferences
	 * @return mixed
	 */
	function _backup($params = array()) {
		// Currently unsupported
		return $this->db->display_error ( 'db_unsuported_feature' );
	}
}


/* End of file postgre_utility.php */
/* Location: ./system/database/drivers/postgre/postgre_utility.php */